Ext.define('App.proxy.Destinations', {
    extend: 'App.proxy.AbstractProxy',
    read: function(sql, sqlTotal, operation, callback, scope) {
        console.log('READ PROTOTYPE: ', sql, sqlTotal);

        var controller = function(users, total) {
            var i, result, destinations = new Array(), reader, id, uid, type, name;

            for( i=0; i < users.length; i++ ) {
                id = users[i]['SOURCE'] +'.'+ users[i]['ID'];
                uid = users[i]['ID']
                type = users[i]['SOURCE']
                name = users[i]['NAME'];
                destinations.push( { id: id, uid: uid , type: type, name: name } );
            }

            total = parseInt(total);

            reader = this.getReader();
            result = reader.read(destinations);
            result.total = total;
            result.count = destinations.length;

            console.log('Total loaded', total);
            console.log('Destinations total', destinations.length);

            operation.setCompleted();
            operation.setSuccessful();

            Ext.apply(operation, { resultSet: result } );
            Ext.callback(callback, scope || this, [operation]);
        }

        // Batch
        this.getStorage().batch(
            [App.storage.Storage.METHOD_FETCH, sql],
            [App.storage.Storage.METHOD_FETCHONE, sqlTotal],
            controller,
            this
        );
	},
    getFilterConditions: function(filters) {
        var filter, conditions = new Array(), statments = new Array(), i;

        for( i=0; i < filters.length; i++ ) {
            filter = filters[i];

            switch( filter.property ) {
                case 'name':
                    conditions.push(this.getFilterNameCondition(filter.value));
                break;
            }
        }

        for( i=0; i < conditions.length; i++ ) {
            if( conditions[i] ) {
                statments.push( "(" + conditions[i] + ")" );
            }
        }

        if( statments.length > 0 ) {
            return statments.join(" AND ");
        }

        return null;
    },
    getFilterNameCondition: function(value) {
        var names = value.toLowerCase().replace(/\s\s+/g, ' ').trim().split(' ');
        names.forEach(function(val,i,names){
            var perc = val.indexOf('%')>-1?"":"%";
            names[i] = this.escape(perc + val + perc);
        },this);

        return "`SEARCH` LIKE "+ names.join(" AND `SEARCH` LIKE  ") +"";
    }
});
