Ext.define('App.proxy.Synchronization', {
    extend: 'App.proxy.AbstractProxy',
    singleton: true,
    constructor	: function() {
        this.callParent(arguments);
    },
    readBackend: function(callback, scope) {
        scope = scope || this;

        var sql = "SELECT `VALUE` FROM `SETTINGS` WHERE `KEY` = 'BACKEND'";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchOneAsync(sql, controller);
    },
    readAllStatistics: function(callback, scope) {
        scope = scope || this;

        var sql = "SELECT * FROM `EVENTS_STATS` ORDER BY `DATE` ASC";
        var controller = function() {
            callback.apply(scope, arguments);
        };

        this.getStorage().fetchAsync(sql, controller);
    },
    readStatistics: function(minDate, maxDate, callback, scope) {
        scope = scope || this;

        var sql = "SELECT * FROM `EVENTS_STATS` WHERE `DATE` >= '"+ minDate +"' AND `DATE` <= '"+ maxDate +"' ORDER BY `DATE` ASC";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchAsync(sql, controller);
    },
    readStatisticsProper: function(dayFrom, dayTo, callback, scope) {
        scope = scope || this;

        var sql = "SELECT `DAY`, `COMPLETE` FROM `EVENTS_STATS` WHERE `DAY` >= "+ dayFrom +" AND `DAY` <= "+ dayTo +" ORDER BY `DAY` ASC";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchAsync(sql, controller);
    },
    readLastStatisticsRow: function(callback, scope) {
        scope = scope || this;

        var sql = "SELECT * FROM `EVENTS_STATS` WHERE `MAX_ID` > 0 and `MIN_ID` > 0 ORDER BY `DATE` DESC LIMIT 1";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchRowAsync(sql, controller);
    },
    updateBackend: function(backend, callback, scope) {
        scope = scope || this;

        var sqlTruncateEvents = "DELETE FROM `EVENTS`";
        var sqlTruncateStatistics = "DELETE FROM `EVENTS_STATS`";
        var sqlUpdateBackend = "UPDATE `SETTINGS` SET `VALUE` = "+ this.escape(backend) +" WHERE `KEY` = 'BACKEND'";
        var sqlVacuum = "VACUUM";
        var controller = function() {
            callback.apply(scope, arguments);
        }
        Promise.resolve().
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlTruncateEvents])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlTruncateStatistics])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlUpdateBackend])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlVacuum])).
            then(controller);
    },
    getUsersSettings: function(callback, scope) {
        var sql = "SELECT `VALUE`, `KEY` FROM `SETTINGS` WHERE `KEY` = 'LAST_USR_SYNC' OR `KEY` = 'LAST_USR_SYNC_PART'";
        var controller = function() {
            callback.apply(scope, arguments);
        }
        this.getStorage().fetchAsync(sql, controller);
    },
    getUsersSettingsLastUpdated: function(callback, scope) {
        var sql = "SELECT `VALUE` FROM `SETTINGS` WHERE `KEY` = 'LAST_USR_SYNC'";
        var controller = function() {
            callback.apply(scope, arguments);
        }
        this.getStorage().fetchOneAsync(sql, controller);
    },
    getUsersIdentifiers: function(callback, scope) {
        var sql = "SELECT `ID` FROM `USERS` WHERE `TYPE` = 1";
        var controller = function(rows) {
            var result = new Array(rows.length);
            for (var i=0; i < rows.length; i++) {
                result[i] = rows[i]["ID"];
            }

            callback.call(scope, result);
        }
        this.getStorage().fetchAsync(sql, controller);
    },
    removeUsers: function(ids,callback, scope) {
        var sequence = ids.join(", ");
        var sqlUpdateFromUsers = "UPDATE `EVENTS` SET `FROM_USER` = NULL, `FROM_GROUP` = NULL WHERE `FROM_USER` IN ("+ sequence +")";
        var sqlUpdateToUsers = "UPDATE `EVENTS` SET `TO_USER` = NULL, `TO_GROUP` = NULL WHERE `TO_USER` IN ("+ sequence +")";
        var sqlDeleteUsers = "DELETE FROM `USERS` WHERE `ID` IN ("+ sequence +")";
        Promise.resolve().
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlUpdateFromUsers])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlUpdateToUsers])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlDeleteUsers])).
            then(Ext.bind(callback,scope));
    },
    setUserSettingsPart: function(nextPart, callback) {
        var query = "UPDATE `SETTINGS` SET `VALUE` = '" + nextPart + "' WHERE `KEY` = 'LAST_USR_SYNC_PART'";
        callback = callback || function() {};
        var controller = function() {
            callback.apply(this, arguments);
        }

        this.getStorage().executeAsync(query, controller);
    },
    setUserSettingsLastUpdateDate: function(lastUpdate, callback) {
        var query = "UPDATE `SETTINGS` SET `VALUE` = '" + lastUpdate + "' WHERE `KEY` = 'LAST_USR_SYNC'";
        callback = callback || function() {};
        var controller = function() {
            callback.apply(this, arguments);
        }

        this.getStorage().executeAsync(query, controller);
    }
});
