Ext.define('App.view.bootstrap.ErrorConnection', {
    extend: 'Ext.Container',
    cls: 'w-error-connection',
    hidden: true,
    hideMode: 'display',
    constructor: function() {
        this.addEvents('refresh');
        this.refrId = 0;
        this.callParent(arguments);
    },
    initComponent: function() {
        this.renderTo = Ext.getBody();
        this.renderTpl = [
            //'<span class="message"></span> <a href="#" class="refresh">Try now</a>'
            sprintf('<span class="message"></span> <a href="#" class="refresh">%(tryNow)s</a>', { tryNow : _t('Try now') })
        ];
        this.renderSelectors = {
            messageEl: 'span.message',
            refreshEl: 'a.refresh'
        }
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.getEl().setStyle('z-index', 99000);
        this.refreshEl.on('click', this.onRefreshClick, this);
    },
    onRefreshClick: function() {
        this.onRefreshTimeout(this.refrId);
        this.sen(this.refrId);
        this.refreshEl.hide();
    },
    onRefreshTimeout: function(id) {
        var self = this;

        if (this.terminated || this.refrId != id) {
            return false;
        }

        this.terminated = true;

        setTimeout(function() {
            self.refrCallback.call(self.refrScope);
        }, 2000);
    },
    show: function() {
        Ext.EventManager.onWindowResize(this.align, this);
        
        this.align();
        this.callParent(arguments);
    },
    hide: function() {
        Ext.EventManager.removeResizeListener(this.align, this);

        this.callParent(arguments);
    },
    align: function() {
        this.setWidth(Ext.getBody().getWidth());
        this.setPosition(0, 0, false);
    },
    handle: function(seconds, callback, scope, silent) {
        var self = this;
        var id = ++this.refrId;
        
        this.steps = 0;
        this.terminated = false;
        this.refrSeconds = parseInt(seconds);
        this.refrCallback = callback;
        this.refrScope = scope || this;
        this.refrSilent = silent;

        setTimeout(function() { self.onRefreshTimeout.call(self, id) }, this.refrSeconds * 1000 + 2000);

        if (!this.refrSilent) {
            if (!this.isVisible() || !this.rendered) {
                this.show();
            }

            this.refreshEl.show();
        }

        this.sen(id);
    },
    sen: function(id) {
        if (this.refrId != id) {
            return;
        }

        var self = this;
        var left = this.refrSeconds - this.steps;

        if (left == 0 || this.terminated) {
            if (!this.refrSilent) {
                this.messageEl.update(_t('Not connected to PBX. Reconnecting...'));
            }
            return;
        }

        if (!this.refrSilent) {
            this.messageEl.update(sprintf(_t('Not connected to PBX. Reconnecting in %(seconds)s seconds...'), { seconds: left }));
        }

        this.steps++;

        setTimeout(function() { self.sen.call(self, id); }, 1000);
    }
});
