Ext.define('App.view.filter.CostEditor', {
    extend: 'App.view.filter.MinMaxEditor',
    mark: _t('Cost'),
    defaultFieldConfig : {
        allowDecimals: true,
        decimalPrecision: 2,
        step: 0.1
    },
    getCostDescription: function(state) {
        var s = state;

        if( s['leftEnabled'] && s['rightEnabled'] ) {
            return sprintf(_t('%(lvalue)s < Cost < %(rvalue)s'), { lvalue : s['leftValue'], rvalue: s['rightValue']});
        } else if ( s['leftEnabled'] ) {
            return sprintf(_t('Cost > %(value)s'), { value : s['leftValue'] });
        } else if ( s['rightEnabled'] ) {
            return sprintf(_t('Cost < %(value)s'), { value : s['rightValue'] });
        }
        
        return null;
    },
    getDescription: function(state) {
        var desc = this.getCostDescription(state);
        
        if (desc) {
            return sprintf('%(description)s', { description : desc });
        }
        
        return this.getAnyDescription();
    },
    getFieldDescription: function(state) {
        var desc = this.getCostDescription(state);
        
        if (desc) {
            return sprintf('%(description)s', { description : desc });
        }
        
        return this.getAnyFieldDescription();
    },
    getFilterDescription: function() {
        var desc = this.getCostDescription(this.state);
        
        if (desc) {
            return desc;
        }
        
        return null;
    }
});
