Ext.define('App.view.filter.PbxesEditor', {
    extend: 'App.view.filter.Editor',
    width: 400,
    onRenderContent: function(state) {
        this.pbxesField = Ext.create('App.view.filter.field.Pbx', {
            fieldLabel: _t('Pbxes'),
            labelAlign: 'left',
            labelWidth: 100,
            arrayValue: state['pbxes'],
            anchor: '100%'
        });
        
        this.containerEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            layout: 'anchor',
            items: [
                this.pbxesField
            ]
        });
        
        this.pbxesField.on('change', this.onTrunksFieldChange, this);
        this.callParent(arguments);
    },
    onTrunksFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['pbxes'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    setState: function(s) {
        this.state = s;
        this.conditionEl.update(this.getDescription(s));
        
        if (!this.contentRendered) {
            return;
        }
        
        this.ignoreStateEvents = true;
        this.pbxesField.setArrayValue(s['pbxes']);
        this.ignoreStateEvents = false;
    },
    getDefaultState: function() {
        var s = {
            'pbxes': new Array()
        }
        
        return s;
    },
    
    getPbxesDescription: function(pbxes) {
        var i, result = new Array();
        
        if( pbxes.length == 0 ) {
            return undefined;
        }
        
        for( i=0; i < pbxes.length; i++ ) {
            result.push(pbxes[i]['serial']);
        }
        
        if ( result.length > 0 ) {
            return result.join(', ');
        } else {
            return undefined;
        }      
    },
    
    getDescription: function(state) {
        var desc = this.getPbxesDescription(state['pbxes']);
        
        if (desc) {
            return desc;
        }
        
        return this.getAnyDescription();
    },
    
    getFieldDescription: function(state) {
        var desc = this.getPbxesDescription(state['pbxes']);
        
        if (desc) {
            return desc;
        }
        
        return this.getAnyFieldDescription();
    },
    
    getFilterDescription: function() {
        var desc = this.getPbxesDescription(this.state);
        
        if (desc) {
            return desc;
        }
        
        return null;
    }
});