Ext.define('App.view.filter.field.Destination', {
    extend: 'App.view.filter.field.Combo',
    createPicker: function(fieldEl, store, selectedStore, selectedView) {
        var picker = Ext.create('App.view.filter.field.combo.Picker', {
            fieldEl: fieldEl,
            store: store,
            selectedStore: selectedStore,
            selectedView: selectedView
        });
        
        return picker;
    },
    createSelectedStore: function(data) {
        var selectionStore = Ext.create('Ext.data.Store', {
            model: 'App.model.Destination',
            data: data,
            proxy: {
                type: 'memory',
                reader: {
                    type: 'json'
                }
            }
        });
        
        return selectionStore;
    },
    createSelectedView: function(containerEl, store) {
        var tpl = new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="w-dst-selection-item">',
                    '<div class="name">{name}</div>',
                    '<div class="close"></div>',
                '</div>',
            '</tpl>'
        );

        var selectionView = Ext.create('Ext.view.View', {
            store: store,
            tpl: tpl,
            cls: 'w-dst-selection',
            itemSelector: 'div.w-dst-selection-item',
            overItemCls: 'w-dst-selection-item-over',
            emptyText: sprintf('<div class="w-dst-selection-empty">%(any)s</div>', { any : _t('Any')}),
            deferEmptyText: false,
            hidden: true,
            hideMode: 'display',
            renderTo: containerEl
        });
        
        return selectionView;
    }
} );
