Ext.define('App.view.filter.field.Pbx', {
    extend: 'App.view.filter.field.SimpleCombo',
    createStore: function() {
        return Ext.create('App.store.Pbxes');
    },
    createSelectedStore: function(data) {
        var selectionStore = Ext.create('Ext.data.Store', {
            model: 'App.model.Pbx',
            data: data,
            proxy: {
                type: 'memory',
                reader: {
                    type: 'json'
                }
            }
        });
        
        return selectionStore;
    },
    createSelectedView: function(containerEl, store) {
        var tpl = new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="w-dst-selection-item">',
                    '<div class="name">{serial}</div>',
                    '<div class="close"></div>',
                '</div>',
            '</tpl>'
        );

        var selectionView = Ext.create('Ext.view.View', {
            store: store,
            tpl: tpl,
            cls: 'w-dst-selection',
            itemSelector: 'div.w-dst-selection-item',
            overItemCls: 'w-dst-selection-item-over',
            emptyText: sprintf('<div class="w-dst-selection-empty">%(any)s</div>', { any : _t('Any')}),
            deferEmptyText: false,
            hidden: true,
            hideMode: 'display',
            renderTo: containerEl
        });
        
        return selectionView;
    },
    createPicker: function(fieldEl, store, selectedStore, selectedView) {
        var picker = Ext.create('App.view.filter.field.combo.SimplePicker', {
            fieldEl: fieldEl,
            store: store,
            selectedStore: selectedStore,
            selectedView: selectedView,
            selectionViewConfig: {
                columns: [
                    {
                        header: 'Serial',
                        dataIndex: 'name',
                        flex: 1
                    }
                ]
            }
        });
        
        return picker;
    },
    getPlainValue: function(range) {
        var i, plain = new Array();

        if (range) {
            for (i=0; i < range.length; i++) {
                plain.push(range[i]['serial']);
            }

            if (plain.length > 0) {
                return plain.join(', ');
            }
        }
        
        return _t('Any')
    }
} );
