Ext.define('App.view.filter.field.SimpleCombo', {
    extend: 'App.view.filter.field.Combo',
    createSelectedView: function(containerEl, store) {
        var tpl = new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="w-dst-selection-item">',
                    '<div class="name">{name}</div>',
                    '<div class="close"></div>',
                '</div>',
            '</tpl>'
        );

        var selectionView = Ext.create('Ext.view.View', {
            store: store,
            tpl: tpl,
            cls: 'w-dst-selection',
            itemSelector: 'div.w-dst-selection-item',
            overItemCls: 'w-dst-selection-item-over',
            emptyText: sprintf('<div class="w-dst-selection-empty">%(any)s</div>', { any : _t('Any')}),
            deferEmptyText: false,
            hidden: true,
            hideMode: 'display',
            renderTo: containerEl
        });
        
        return selectionView;
    },
    createPicker: function(fieldEl, store, selectedStore, selectedView) {
        var picker = Ext.create('App.view.filter.field.combo.SimplePicker', {
            fieldEl: fieldEl,
            store: store,
            selectedStore: selectedStore,
            selectedView: selectedView,
            selectionViewConfig: {
                columns: [
                    {
                        header: 'Name',
                        dataIndex: 'name',
                        flex: 1
                    }
                ]
            }
        });
        
        return picker;
    }
} );
