Ext.define('App.view.filter.field.combo.Picker', {
    extend: 'App.view.filter.field.combo.AbstractPicker',
    initComponent: function() {
        this.searchCmp = Ext.create('App.view.filter.field.combo.Search', {
            selectedStore: this.selectedStore,
            selectedView: this.selectedView,
            pickerCmp: this
        } );
        this.listCmp = Ext.create('App.view.filter.field.combo.List', {
            store: this.store,
            selectedStore: this.selectedStore,
            selectedView: this.selectedView,
            selectionViewConfig: {
                columns: [
                    {
                        header: 'Name',
                        dataIndex: 'name',
                        flex: 1,
                        renderer: function(value, meta, record) {
                            var type = record.get('type');

                            if (type == 2) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(callClass)s</span>', { callClass : '('+ _t('Call Class') +')' });
                            } else if (type == 3) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(group)s</span>', { group : '('+ _t('Group') +')' });
                            } else if (type == 4) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(user)s</span>', { user : '('+ _t('User') +')' });
                            } else if (type == 5) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(businessPartner)s</span>', { businessPartner : '('+ _t('Business partner') +')' });
                            } else if (type == 6) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(company)s</span>', { company : '('+ _t('Company') +')' });
                            }
                            return value;
                        }
                    }
                ]
            },
            searchCmp: this.searchCmp,
            pickerCmp: this
        });
        
        this.items = [
            this.searchCmp,
            this.listCmp
        ]
        
        this.callParent(arguments);
    }
} );
