Ext.define('App.view.grouping.picker.Columns', {
    extend: 'Ext.view.View',
    floating: true,
    hidden: true,
    hideMode: 'display',
    cls: 'w-grouping-picker-selection',
    initComponent: function() {
        
        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                'id',
                'text',
                'active'
            ]
        });
        
        this.tpl = new Ext.XTemplate(
            '<div class="w-grouping-picker-selection-container">',
            '<tpl for=".">',
                '<div class="item ">',
                    '<div class="item-name <tpl if="active == true">grouping-item-active</tpl>">{text}</div>',
                '</div>',
            '</tpl>',
            '</div>'
        );
            
        this.itemSelector = 'div.item';
        this.callParent(arguments);
    },

    show: function(left, top, parentRecord, count) {
        var container,
            columns_data = new Array;
            
        this.parentRecord = parentRecord;
        
        // Clear pre settings
        this.setHeight('auto');
        
        if (this.getEl()) {
            container = this.getEl().first('div.w-grouping-picker-selection-container');
            container.setHeight('auto');
            container.setWidth(95);
            container.setWidth(96);
            
            if (container.hasCls('w-grouping-picker-selection-overflow')) {
                container.removeCls('w-grouping-picker-selection-overflow');
            }
        }
        
        for(var i = 1; i <= count; i++){
            columns_data.push({ id: i, text: i + ' '+_t('Column'), active: this.parentRecord.get('order') == i ? true : false });
        }
        
        this.store.loadData(columns_data);
        
        // Align
        this.align(left, top);
        this.callParent(arguments);
        
        var pos = this.getPosition();
        var offset = Ext.getBody().getHeight() - (pos[1] + this.getHeight());
        var height = Ext.getBody().getHeight() - pos[1] - 20;
        
        if (offset < 20) {
            this.setHeight(height);
            
            if (!container) {
                container = this.getEl().first('div.w-grouping-picker-selection-container');
            }
            
            container.setHeight(height - 2);
            container.addCls('w-grouping-picker-selection-overflow');
        }
    },
    hide: function() {
        this.callParent(arguments);
    },
    align: function(left, top) {
        this.setPosition(left, top, false);
    },
    onItemClick: function(record) {
        this.own.setItemOrder(this.parentRecord, record.get('id'));
        this.hide();
    }
});
