Ext.define('App.view.reports.Save', {
    extend: 'Ext.window.Window',
    title: '',
    width: 460,
    //height: 230,
    modal: true,
    resizable: false,
    closable: false,
    bodyStyle: 'background: transparent; border: 0px;',
    layout: {
        type: 'card',
        align: 'stretch'
    },
    activeItem: 0,
    padding: '5 10',
    constructor: function() {
        this.addEvents('submit', 'cancel');
        this.callParent(arguments);
    },
    initComponent: function() {
        
        // Prepare body components
        this.tipCt = Ext.create('Ext.container.Container', {
            //padding: '0 0 20 0',
        });
        
        this.formCmp = Ext.create('Ext.form.Panel', {
            labelAlign: 'top',
            layout: 'anchor',
            defaults: {
                anchor: '100%'
            },
            border: false,
            style: 'background: transparent;',
            bodyStyle: 'background: transparent;',
            items: [
                //this.tipCt,
                {
                    xtype: 'textfield',
                    itemId: 'nameField',
                    fieldLabel: _t('Name'),
                    allowBlank: false
                },
                {
                    xtype: 'textarea',
                    itemId: 'descriptionField',
                    fieldLabel: _t('Description'),
                    height: 60,
                    allowBlank: false
                },
                {
                    xtype: 'checkbox',
                    itemId: 'shareCheckbox',
                    fieldLabel: _t('Share')
                }
                /*{
                    xtype: 'container',
                    layout: 'hbox',
                    items: [
                        {
                            xtype: 'container',
                            width: 105
                        },
                        {
                            xtype: 'checkbox',
                            itemId: 'shareCheckbox'
                        },
                        {
                            xtype: 'container',
                            style: 'line-height: 19px; padding: 0 0 0 5px;'
                        }
                    ]
                }*/
            ]
        });
        
        this.savedCt = Ext.create('Ext.container.Container', {
            padding: '0 0 20 0',
            html: _t('You report has been successfully saved on a server. <br /> To use this report in future you should go to "Available Reports" > "Personal Reports".')
        });
        
        this.items = [
            this.formCmp,
            this.savedCt
        ]
        
        // Prepare action buttons
        this.submitButton = Ext.create('Ext.button.Button', {
            text: _t('Submit')
        });
        
        this.cancelButton = Ext.create('Ext.button.Button', {
            text: _t('Cancel')
        });
        
        this.buttons = [
            this.submitButton,
            this.cancelButton
        ]
        
        this.submitButton.on('click', this.onSubmitButtonClick, this);
        this.cancelButton.on('click', this.onCancelButtonClick, this);
        this.on('show', this.onSettingsWindowShow, this);
        this.on('hide', this.onSettingsWindowHide, this);

        this.callParent(arguments);
    },
    onSubmitButtonClick: function() {
        // Verify if input data is valid
        if (!this.formCmp.getForm().isValid()) {
            return;
        }
        
        // Prepare data for submit event
        var nameField = this.query('#nameField').pop();
        var descriptionField = this.query('#descriptionField').pop();
        var shareCheckbox = this.query('#shareCheckbox').pop();
        var config = {
            name: nameField.getValue(),
            description: descriptionField.getValue(),
            share: shareCheckbox.getValue()
        }
        
        this.fireEvent('submit', config);
    },
    onCancelButtonClick: function() {
        this.fireEvent('cancel');
    },

    onSettingsWindowShow: function() {
        if(!this.KeyMapOnEsc) {
            this.KeyMapOnEsc = new Ext.util.KeyMap(Ext.getBody(), [{
               key: Ext.EventObject.ESC,
               defaultEventAction: 'preventDefault',
               scope: this,
               fn: this.onCancelButtonClick
            }]);
        } else {
            this.KeyMapOnEsc.enable();
        }
    },

    onSettingsWindowHide: function() {
        this.KeyMapOnEsc.disable();
    },

    showSavingState: function() {
        this.getEl().mask(_t('Please wait...')+' '+_t('Saving...'));
    },
    /**
    showSavedState: function() {
        this.getEl().unmask();
        this.getLayout().setActiveItem(1);
        this.submitButton.hide();
        this.cancelButton.setText('close');
        this.setHeight(160);
        this.center();
    },
    **/
    showErrorState: function(message){
        this.getEl().unmask();
    }
});
