Ext.define('App.view.viewer.Error', {
    extend: 'Ext.panel.Panel',
    alias : 'widget.viewerError',
    frame: true,
    layout: {
        type: 'card',
        align : 'stretch'
    },
    activeItem: 0,
    initComponent: function() {
        this.emptyResultsCt = Ext.create('App.view.viewer.error.EmptyResults');
        //Chart errors
        this.noData = Ext.create('App.view.viewer.error.NoData');
        this.notChosenGrouping = Ext.create('App.view.viewer.error.NotChosenGrouping');
        this.notSupportedGrouping = Ext.create('App.view.viewer.error.NotSupportedGrouping');
        this.tooMuchData = Ext.create('App.view.viewer.error.TooMuchData');
        this.notEnoughData = Ext.create('App.view.viewer.error.NotEnoughData');
        this.notSupportedMetric = Ext.create('App.view.viewer.error.NotSupportedMetric');

        this.items = [
            this.emptyResultsCt,            
            /*  Chart errors */
            this.noData,
            this.notChosenGrouping,
            this.notSupportedGrouping,
            this.tooMuchData,
            this.notEnoughData,
            this.notSupportedMetric
        ];

        this.callParent(arguments);
    },
    setError: function(type, config) {
        switch (type) {
            case 'ERR_EMPTYRESULTS':
                this.getLayout().setActiveItem(this.emptyResultsCt);
                break;
            case 'NO_DATA':
                this.getLayout().setActiveItem(this.noData);
                break;
            case 'NO_GROUPING':
                this.getLayout().setActiveItem(this.notChosenGrouping);
                break;
            case 'NOT_SUPPORTED_GROUPING':
                this.getLayout().setActiveItem(this.notSupportedGrouping);
                if (config && config.groupingStateName)
                this.notSupportedGrouping.setGroupingStateName(config ? config.groupingStateName||'':'');
                this.getLayout().setActiveItem(this.notSupportedGrouping);
                break;
            case 'TOO_MANY_RECORDS':
                this.getLayout().setActiveItem(this.tooMuchData);
                break;
            case 'NOT_SUPPORTED_METRIC':
                this.getLayout().setActiveItem(this.notSupportedMetric);
                break;
        }
    }
});