Ext.define('App.view.viewer.Grouping', {
    extend: 'App.view.viewport.PickerButton',
    alias : 'widget.viewerGrouping',
    text: _t('Grouping by'),
    width: 160,
    margin: '0 0 0 10',
    initComponent: function() {
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);

        // Attach picker
        this.picker = Ext.create('App.view.grouping.Picker', {
            target: this.getEl()
        });
        this.picker.on('change', this.onGroupingsPickerChange, this);
    },
    onGroupingsPickerChange: function(state) {
        this.fireEvent('change', state);
        this.updateText(state);
    },
    updateText: function(state){
        //Set additional button title
        var title = _t('Grouping by');
        this.picker.store.each(function(rec) {
            if(state.indexOf(rec.get('name')) != -1 ){
                title += ' ' + rec.get('text');
            }
        });
        this.setText(title);

    },
    setState: function(state){        
        this.picker.setState(state);
        this.updateText(state);
    },
    getPicker: function() {
        return this.picker;
    },
    onClick: function() {
        this.picker.show();
    }
});
