/**
 * Factory for creating Charts instances.
 * API:
 *
 *
 * User: Artyom Trityak
 * Date: 1/4/12
 * Time: 3:19 PM
 */
Ext.define('App.view.viewer.chart.ChartView', {

    singleton: true,

    constructor: function() {

    },

    create: function(options) {
        options = options || {
            chartType: 'CHART_COLUMN',
            data: []
        };

        var chartIns = false;
        switch(options.chartType) {
            case 'CHART_LINE':
                chartIns = Ext.create('App.view.viewer.chart.type.LineChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
            case 'CHART_AREA':
                chartIns = Ext.create('App.view.viewer.chart.type.AreaChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
            case 'CHART_PIE':
                chartIns = Ext.create('App.view.viewer.chart.type.PieChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
            case 'CHART_BAR':
                chartIns = Ext.create('App.view.viewer.chart.type.BarChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
            case 'CHART_COLUMN':
                chartIns = Ext.create('App.view.viewer.chart.type.ColumnChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
        }
        console.log(options);

        return chartIns;
    }
});