/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.AreaChart', {
    extend: 'App.view.viewer.chart.type.DefaultChart',

    requires: [
        'App.view.viewer.chart.type.DefaultChart'
    ],

    legend: {
        position: 'right'
    },

    options: false,

    checkPossibilityToDraw: function() {
        var draw = true;
        var drawReason = "";
        if (this.options.records.length < 2) {
            draw = false;
            drawReason = "NO_DATA";
        }

        this.options.draw = draw;
        this.options.drawReason = drawReason;
    },

    createSeries: function(fields, pointsCount) {
        var series = [],
            self = this;
        var elem = {
            type: 'area',
            axis: 'left',
            highlight: true,
            xField: fields.xGroupField,
            yField: fields.yFields,
            tips: this.createTip(),
            title: this.getFormattedLegend(),
            /*  -------Override ------ */
         renderLabels: function() {
                var me = this,
                    chart = me.chart,
                    gradients = chart.gradients,
                    items = me.items? ( me.items[0]? me.items[0].pointsUp:[] ) : [],
                    animate = chart.animate,
                    config = me.label,
                    display = config.display,
                    color = config.color,
                    field = [].concat(config.field),
                    group = me.labelsGroup,
                    store = me.chart.store,
                    len = store.getCount(),
                    itemLength = (items || 0) && items.length,
                    ratio = me.items.length,
                    gradientsCount = (gradients || 0) && gradients.length,
                    Color = Ext.draw.Color,
                    gradient, i, count, index, j, k, colorStopTotal, colorStopIndex, colorStop, item, label,
                    storeItem, sprite, spriteColor, spriteBrightness, labelColor, colorString;

                if (display == 'none') {
                    return;
                }

                for (i = 0, count = 0; i < len; i++) {
                    index = 0;
                    for (j = 0; j < ratio; j++) {
                        if (!me.items[j])
                            continue;
                        item = me.items[j].pointsUp[i];
                        label = group.getAt(count);
                        storeItem = store.getAt(i);

                        //check the excludes
                        while(this.__excludes && this.__excludes[index]) {
                            index++;
                        }

                        if (!item && label) {
                            label.hide(true);
                        }

                        if (item && field[j]) {
                            if (!label) {
                                label = me.onCreateLabel(storeItem, item, i, display, j, index);
                            }
                            me.onPlaceLabel(label, storeItem, item, i, display, animate, j, index);
                            //label.show(true);
                        }
                        count++;
                        index++;
                    }
                }
                me.hideLabels(count);
        },
        onCreateLabel: function(storeItem, item, i, display) {
            var me = this,
            group = me.labelsGroup,
            config = me.label,
            bbox = me.bbox,
            endLabelStyle = Ext.apply(config, me.seriesLabelStyle);

            return me.chart.surface.add(Ext.apply({
                'type': 'text',
                'text-anchor': 'middle',
                'group': group,
                'x': item[0],
                'y': bbox.y + bbox.height / 2
            }, endLabelStyle || {}));
        },
        onPlaceLabel: function(label, storeItem, item, i, display, animate, index) {
                var me = this,
                    chart = me.chart,
                    resizing = chart.resizing,
                    config = me.label,
                    format = config.renderer,
                    field = config.field,
                    bbox = me.bbox,
                    x = item[0],
                    y = item[1],
                    bb, width, height;

                label.setAttributes({
                    text: format(storeItem.get(field[index])),
                    hidden: true
                }, true);

                bb = label.getBBox();
                width = bb.width / 2;
                height = bb.height / 2;

                x = x - width < bbox.x? bbox.x + width : x;
                x = (x + width > bbox.x + bbox.width) ? (x - (x + width - bbox.x - bbox.width)) : x;
                y = y - height < bbox.y? bbox.y + height : y;
                y = (y + height > bbox.y + bbox.height) ? (y - (y + height - bbox.y - bbox.height)) : y;

                //Check for overlap
                if (!this.imposion)
                     this.imposion = [];
                x = parseFloat(x);
                y = parseFloat(y);
                var isOverlap = false;
                for (var i = 0; i<me.imposion.length; i++){
                    if (
                            (x < me.imposion[i][0] + me.imposion[i][2]) && (x+bb.width > me.imposion[i][0])
                            &&
                            (y < me.imposion[i][1] + me.imposion[i][3]) && (y+bb.height > me.imposion[i][1])
                       ){
                        isOverlap = true;
                    }
                }
                
                if (!isOverlap)
                    me.imposion.push([x,y,bb.width,bb.height])

                if (me.chart.animate && !me.chart.resizing) {
                    if (!isOverlap)
                    label.show(true);
                    me.onAnimate(label, {
                        to: {
                            x: x,
                            y: y
                        }
                    });
                } else {
                    label.setAttributes({
                        x: x,
                        y: y
                    }, true);
                    if (!isOverlap)
                    label.show(true);

                }

            },
            hideLabels: function(index) {
                this.imposion = [];

                var labelsGroup = this.labelsGroup, len;
                if (labelsGroup) {
                    len = labelsGroup.getCount();
                    while (len-->index) {
                        labelsGroup.getAt(len).hide(true);
                    }
                }
            },
            hideAll: function() {
                this.imposion = [];
                if (!isNaN(this._index)) {
                    this.__excludes[this._index] = true;
                    this.areas[this._index].hide(true);
                    this.drawSeries();
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    series.renderLabels();
                });
            },
            showAll: function() {
                this.imposion = [];
                if (!isNaN(this._index)) {
                    this.__excludes[this._index] = false;
                    this.areas[this._index].show(true);
                    this.drawSeries();
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    series.renderLabels();
                });
            },
        /*  ------Override------- */
            label: {
                display: self.options.isLabelVisible?'under':'none',
                contrast: false,
                field: fields.yFields,
                renderer: function(v) {
                    if (!v)
                        return '';
                    else
                        return self._formatTipData(v);
                },
                orientation: 'horizontal',
                color: '#333',
                'text-anchor': 'middle',
                font: '8px Helvetica,sans-serif'
            }
        };
        series.push(elem);
        return series;
    },

    createAxes: function(fields) {
        var self = this;
        var axes = [];
        //TODO: set type check: Time, Number or Category
        var axeVals = {
            type: 'Numeric',
            minimum: 0,
            position: 'left',
            fields: fields.yFields,
            title: false
        };
        axes.push(axeVals);

        //TODO: set type check: Time, Number or Category
        var axeGrouping = {
            type: 'Category',
            position: 'bottom',
            fields: fields.xGroupField,
            title: false,
            label: {
                rotate: {
                    degrees: 315
                },
                renderer: function(name) {
                    return self.getFormattedField(name);
                }
            }
        };
        axes.push(axeGrouping);

        return axes;
    },

    createTip: function() {
        var self = this;
        var tip = {
            trackMouse: true,
            minWidth: 250,
            renderer: function(storeItem, item) {
                var title = App.utility.NamesFormatter.formatText(item.storeField);
                var itemVal = self._formatTipData(storeItem.get(item.storeField));
                var tooltip = self.getFormattedField(storeItem.get(self.options.fields.xGroupField)) + ' <br/> ' + itemVal;
                this.setTitle(title);
                this.update(tooltip);
            }
        };
        return tip;
    }

});