Ext.define('App.view.viewer.error.NotSupportedMetric', {
    extend: 'Ext.container.Container',
    layout: {
        type: 'vbox',
        align : 'stretch'
    },
    constructor: function() {
        this.callParent(arguments);
        this.addEvents('action');
        this.enableBubble('action');
    },
    initComponent: function() {

        this.tpl = new Ext.XTemplate(
            '<ul class="e-offers-list">',
                '<tpl for=".">',
                    '<li>',
                        '<a class="e-offers-list-link" name="{name}">{text}</a>',
                    '</li>',
                '</tpl>',
            '</ul>'
        );

        this.items = [
            {
                xtype: 'container',
                flex: 1
            },
            {
                xtype: 'container',
                layout: 'column',
                items: [
                    {
                        xtype: 'container',
                        cls: 'w-error-title',
                        style: 'text-align: right;',
                        columnWidth: 0.5,
                        html: _t('Please select metric supported by this chart:')
                    },
                    {
                        xtype: 'container',
                        padding: '0 0 0 10',
                        columnWidth: 0.5,
                        cls: 'w-error-metric-list'
                    }
                ]
            },
            {
                xtype: 'container',
                flex: 1
            }
        ]
            
        this.groupColumns = [
            { id: '1', name: 'COUNT', text: _t('Count'), group: 'count', active: true },
            { id: '5', name: 'COST', text: _t('Cost'), group: 'cost', active: true },
            { id: '8', name: 'BILL', text: _t('Talk time'), group: 'bill', active: true }
        ]

        this.callParent(arguments);
    },

    afterRender: function() {
        this.callParent(arguments);

        this.periodEl = this.getEl().down('div.w-error-metric-list');
        this.printOffersList(this.groupColumns);
        this.linkEl = this.getEl().down('.e-offers-list');
        this.linkEl.on('click', this.onLinkClick, this);

    },

    onLinkClick: function(e) {
        var targetName = e.getTarget().getAttribute('name');
        if(targetName) {
            this.fireEvent('action', this, 'metricclick', [targetName]);
        }
    },

    printOffersList: function(offers) {
        this.tpl.overwrite(this.periodEl, offers);
    }
});
