Ext.define('App.view.viewer.table.View', {
    extend: 'Ext.view.Table',
    alias : 'widget.viewerTableView',
    /**
    refresh: function() {
        if (!this.rendered || this.isDestroyed) {
            return;
        }
        
        if (this.store.getCount() == 0) {
            this.el.update(this.emptyText);
            this.el.setStyle();
        }

        this.callParent(arguments);
    },
    **/
    setNewTemplate: function() {
        var columns = this.headerCt.getColumnsForTpl(true);

        this.tpl = this.getTableChunker().getTableTpl({
            columns: columns,
            columnsItems: this.headerCt.items,
            features: this.features
        });
    },
    collectData: function() {
        var result = this.callParent(arguments);
        var columns = this.headerCt.items;
        var groupedColumns = new Array();
        var column;
        var i, c, s;

        for (i=0; i < columns.length; i++) {
            column = columns.get(i);
            if (column['grouped']) {
                groupedColumns.push(column);
            }
        }

        if (groupedColumns.length == 0) {
            return result;
        }

        var rows = result.rows;
        var id, sid, span;

        for (c=0; c < groupedColumns.length; c++) {
            column = groupedColumns[c];
            id = column.getId();
            sid = id + '-rowspan';
            span = 0;

            for (i=0; i < rows.length; i++) {
                if (span == 1) {
                    span = 0;
                }
                if (span > 0) {
                    span--;
                    rows[i][sid] = 0;
                    continue;
                }

                for (s = i; s < rows.length; s++) {
                    if (rows[i][id] != rows[s][id]) {
                        break;
                    }

                    span++;
                }

                rows[i][sid] = span;
            }
        }

        return result;
    },
    onItemMouseEnter: function(record, item, index, event) {
        var target = Ext.get(event.target);

        if (target.hasCls('x-grid-cell-grouped')) {
            if (this.trackOver) {
                this.clearHighlight();
            }
            return false;
        }
        if (target.hasCls('x-grid-cell-inner')) {
            var parent = target.parent('td')

            if (parent.hasCls('x-grid-cell-grouped')) {
                if (this.trackOver) {
                    this.clearHighlight();
                }
                return false;
            }
        }

        return this.callParent(arguments);
    },
    onItemMouseDown: function(record, item, index, event) {
        var target = Ext.get(event.target);

        if (target.hasCls('x-grid-cell-grouped')) {
            if (this.trackOver) {
                this.clearHighlight();
            }
            return false;
        }
        if (target.hasCls('x-grid-cell-inner')) {
            var parent = target.parent('td')

            if (parent.hasCls('x-grid-cell-grouped')) {
                if (this.trackOver) {
                    this.clearHighlight();
                }
                return false;
            }
        }

        return this.callParent(arguments);
    }
});