Ext.define('App.view.viewport.PickerButton', {
    extend: 'Ext.Container',
    alias : 'widget.viewportPickerButton',
    cls: 'w-button w-button-picker',
    text: 'Viewport Picker Button',
    constructor: function() {
        this.addEvents('click');
        this.callParent(arguments);
    },
    initComponent: function() {
        this.renderTpl = [
            '<div class="w-button-left"><div class="w-button-right">',
                '<div class="w-button-picker-arrow">{text}</div>',
            '</div></div>'
        ];
        this.renderData = {
            text: this.text
        }
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.getEl().on('click', this.onClick, this);
    },
    onClick: function() {
        this.fireEvent('click');
    },
    setText: function(text){
        this.renderData ={
            text: text
        };
        var renderTpl = this.initRenderTpl();
        if (renderTpl) {
            var renderData = this.initRenderData();
            renderTpl.overwrite(this.getTargetEl(), renderData);
        }
        this.doComponentLayout();
    }
});
