// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/override.js
Ext.override(Ext.chart.axis.Axis, {
    calcEnds: function() {
        var me = this,
            math = Math,
            mmax = math.max,
            mmin = math.min,
            store = me.chart.substore || me.chart.store,
            series = me.chart.series.items,
            fields = me.fields,
            ln = fields.length,
            min = isNaN(me.minimum) ? Infinity : me.minimum,
            max = isNaN(me.maximum) ? -Infinity : me.maximum,
            prevMin = me.prevMin,
            prevMax = me.prevMax,
            aggregate = false,
            total = 0,
            excludes = [],
            outfrom, outto,
            i, l, values, rec, out;

        //if one series is stacked I have to aggregate the values
        //for the scale.
        for (i = 0, l = series.length; !aggregate && i < l; i++) {
            aggregate = aggregate || series[i].stacked;
            excludes = series[i].__excludes || excludes;
        }
        store.each(function(record) {
            if (aggregate) {
                if (!isFinite(min)) {
                    min = 0;
                }
                for (values = [0, 0], i = 0; i < ln; i++) {
                    if (excludes[i]) {
                        continue;
                    }
                    rec = record.get(fields[i]);
                    values[+(rec > 0)] += math.abs(rec);
                }
                max = mmax(max, -values[0], values[1]);
                min = mmin(min, -values[0], values[1]);
            }
            else {
                for (i = 0; i < ln; i++) {
                    if (excludes[i]) {
                        continue;
                    }
                    value = record.get(fields[i]);
                    max = mmax(max, value);
                    min = mmin(min, value);
                }
            }
        });
        if (!isFinite(max)) {
            max = me.prevMax || 0;
        }
        if (!isFinite(min)) {
            min = me.prevMin || 0;
        }
        //normalize min max for snapEnds.
        if (min != max && (max != (max >> 0))) {
            max = (max >> 0) + 1;
        }
        /*FIX: ADDED BY ARTYOM TO FIX CHART 0 PROBLEM*/
        if(max == min) {
            max += 1;
        }

        if (me.chart.series.items && me.chart.series.items[0]) {
            var series = me.chart.series.items[0];

            if (me.chart.series.items[0].label.display == 'center' && series.bbox && series.imposion){
                var scale = (series.column ? series.bbox.height - series.yPadding * 2 : series.bbox.width - series.xPadding * 2) / (max - min);
                if (series.xyLabelMargin){
                    max += Math.ceil(series.xyLabelMargin / scale);
                    this.xyLabelMargin = null;
                }
            }
        }
        /*-FIX*/
        out = Ext.draw.Draw.snapEnds(min, max, me.majorTickSteps !== false ?  (me.majorTickSteps +1) : me.steps);
        outfrom = out.from;
        outto = out.to;
        if (me.forceMinMax) {
            if (!isNaN(max)) {
                out.to = max;
            }
            if (!isNaN(min)) {
                out.from = min;
            }
        }
        if (!isNaN(me.maximum)) {
            //TODO(nico) users are responsible for their own minimum/maximum values set.
            //Clipping should be added to remove lines in the chart which are below the axis.
            out.to = me.maximum;
        }
        if (!isNaN(me.minimum)) {
            //TODO(nico) users are responsible for their own minimum/maximum values set.
            //Clipping should be added to remove lines in the chart which are below the axis.
            out.from = me.minimum;
        }

        //Adjust after adjusting minimum and maximum
        out.step = (out.to - out.from) / (outto - outfrom) * out.step;

        if (me.adjustMaximumByMajorUnit) {
            out.to += out.step;
        }
        if (me.adjustMinimumByMajorUnit) {
            out.from -= out.step;
        }
        me.prevMin = min == max? 0 : min;
        me.prevMax = max;
        return out;
    }
});


Ext.override(Ext.chart.series.Line, {
    drawSeries: function() {
        var me = this,
            chart = me.chart,
            store = chart.substore || chart.store,
            surface = chart.surface,
            chartBBox = chart.chartBBox,
            bbox = {},
            group = me.group,
            gutterX = chart.maxGutter[0],
            gutterY = chart.maxGutter[1],
            showMarkers = me.showMarkers,
            markerGroup = me.markerGroup,
            enableShadows = chart.shadow,
            shadowGroups = me.shadowGroups,
            shadowAttributes = me.shadowAttributes,
            smooth = me.smooth,
            lnsh = shadowGroups.length,
            dummyPath = ["M"],
            path = ["M"],
            markerIndex = chart.markerIndex,
            axes = [].concat(me.axis),
            shadowGroup,
            shadowBarAttr,
            xValues = [],
            yValues = [],
            storeIndices = [],
            numericAxis = true,
            axisCount = 0,
            onbreak = false,
            markerStyle = me.markerStyle,
            seriesStyle = me.seriesStyle,
            seriesLabelStyle = me.seriesLabelStyle,
            colorArrayStyle = me.colorArrayStyle,
            colorArrayLength = colorArrayStyle && colorArrayStyle.length || 0,
            posHash = {
                'left': 'right',
                'right': 'left',
                'top': 'bottom',
                'bottom': 'top'
            },
            isNumber = Ext.isNumber,
            seriesIdx = me.seriesIdx, shadows, shadow, shindex, fromPath, fill, fillPath, rendererAttributes,
            x, y, prevX, prevY, firstY, markerCount, i, j, ln, axis, ends, marker, markerAux, item, xValue,
            yValue, coords, xScale, yScale, minX, maxX, minY, maxY, line, animation, endMarkerStyle,
            endLineStyle, type, props, firstMarker, count, smoothPath, renderPath;

        //if store is empty then there's nothing to draw.
        if (!store || !store.getCount()) {
            return;
        }

        //prepare style objects for line and markers
        endMarkerStyle = Ext.apply(markerStyle, me.markerConfig);
        type = endMarkerStyle.type;
        delete endMarkerStyle.type;
        endLineStyle = Ext.apply(seriesStyle, me.style);
        //if no stroke with is specified force it to 0.5 because this is
        //about making *lines*
        if (!endLineStyle['stroke-width']) {
            endLineStyle['stroke-width'] = 0.5;
        }
        //If we're using a time axis and we need to translate the points,
        //then reuse the first markers as the last markers.
        if (markerIndex && markerGroup && markerGroup.getCount()) {
            for (i = 0; i < markerIndex; i++) {
                marker = markerGroup.getAt(i);
                markerGroup.remove(marker);
                markerGroup.add(marker);
                markerAux = markerGroup.getAt(markerGroup.getCount() - 2);
                marker.setAttributes({
                    x: 0,
                    y: 0,
                    translate: {
                        x: markerAux.attr.translation.x,
                        y: markerAux.attr.translation.y
                    }
                }, true);
            }
        }

        me.unHighlightItem();
        me.cleanHighlights();

        me.setBBox();
        bbox = me.bbox;

        me.clipRect = [bbox.x, bbox.y, bbox.width, bbox.height];

        chart.axes.each(function(axis) {
            //only apply position calculations to axes that affect this series
            //this means the axis in the position referred by this series and also
            //the axis in the other coordinate for this series. For example: (left, top|bottom),
            //or (top, left|right), etc.
            if (axis.position == me.axis || axis.position != posHash[me.axis]) {
                axisCount++;
                if (axis.type != 'Numeric') {
                    numericAxis = false;
                    return;
                }
                numericAxis = (numericAxis && axis.type == 'Numeric');
                if (axis) {
                    ends = axis.calcEnds();
                    if (axis.position == 'top' || axis.position == 'bottom') {
                        minX = ends.from;
                        maxX = ends.to;
                    }
                    else {
                        minY = ends.from;
                        maxY = ends.to;
                    }
                }
            }
        });

        //If there's only one axis specified for a series, then we set the default type of the other
        //axis to a category axis. So in this case numericAxis, which would be true if both axes affecting
        //the series are numeric should be false.
        if (numericAxis && axisCount == 1) {
            numericAxis = false;
        }

        // If a field was specified without a corresponding axis, create one to get bounds
        //only do this for the axis where real values are bound (that's why we check for
        //me.axis)
        if (me.xField && !isNumber(minX)) {
            if (me.axis == 'bottom' || me.axis == 'top') {
                axis = Ext.create('Ext.chart.axis.Axis', {
                    chart: chart,
                    fields: [].concat(me.xField)
                }).calcEnds();
                minX = axis.from;
                maxX = axis.to;
            } else if (numericAxis) {
                axis = Ext.create('Ext.chart.axis.Axis', {
                    chart: chart,
                    fields: [].concat(me.xField),
                    forceMinMax: true
                }).calcEnds();
                minX = axis.from;
                maxX = axis.to;
            }
        }

        if (me.yField && !isNumber(minY)) {
            if (me.axis == 'right' || me.axis == 'left') {
                axis = Ext.create('Ext.chart.axis.Axis', {
                    chart: chart,
                    fields: [].concat(me.yField)
                }).calcEnds();
                minY = axis.from;
                maxY = axis.to;
            } else if (numericAxis) {
                axis = Ext.create('Ext.chart.axis.Axis', {
                    chart: chart,
                    fields: [].concat(me.yField),
                    forceMinMax: true
                }).calcEnds();
                minY = axis.from;
                maxY = axis.to;
            }
        }

        if (isNaN(minX)) {
            minX = 0;
            xScale = bbox.width / (store.getCount() - 1);
        }
        else {
            //In case some person decides to set an axis' minimum and maximum
            //configuration properties to the same value, then fallback the
            //denominator to a > 0 value.
            xScale = bbox.width / ((maxX - minX) || (store.getCount() - 1));
        }

        if (isNaN(minY)) {
            minY = 0;
            yScale = bbox.height / (store.getCount() - 1);
        }
        else {
            //In case some person decides to set an axis' minimum and maximum
            //configuration properties to the same value, then fallback the
            //denominator to a > 0 value.
            yScale = bbox.height / ((maxY - minY) || (store.getCount() - 1));
        }

        store.each(function(record, i) {
            xValue = record.get(me.xField);
            yValue = record.get(me.yField);
            //skip undefined values
            if (typeof yValue == 'undefined' || (typeof yValue == 'string' && !yValue)) {
                //<debug warn>
                if (Ext.isDefined(Ext.global.console)) {
                    Ext.global.console.warn("[Ext.chart.series.Line]  Skipping a store element with an undefined value at ", record, xValue, yValue);
                }
                //</debug>
                return;
            }
            // Ensure a value
            if (typeof xValue == 'string' || typeof xValue == 'object'
                //set as uniform distribution if the axis is a category axis.
                || (me.axis != 'top' && me.axis != 'bottom' && !numericAxis)) {
                xValue = i;
            }
            if (typeof yValue == 'string' || typeof yValue == 'object'
                //set as uniform distribution if the axis is a category axis.
                || (me.axis != 'left' && me.axis != 'right' && !numericAxis)) {
                yValue = i;
            }
            storeIndices.push(i);
            xValues.push(xValue);
            yValues.push(yValue);
        }, me);

        ln = xValues.length;
        if (ln > bbox.width) {
            coords = me.shrink(xValues, yValues, bbox.width);
            xValues = coords.x;
            yValues = coords.y;
        }

        me.items = [];

        count = 0;
        ln = xValues.length;
        for (i = 0; i < ln; i++) {
            xValue = xValues[i];
            yValue = yValues[i];
            if (yValue === false) {
                if (path.length == 1) {
                    path = [];
                }
                onbreak = true;
                me.items.push(false);
                continue;
            } else {
                x = (bbox.x + (xValue - minX) * xScale).toFixed(2);
                y = ((bbox.y + bbox.height) - (yValue - minY) * yScale).toFixed(2);
                if (onbreak) {
                    onbreak = false;
                    path.push('M');
                }
                path = path.concat([x, y]);
            }
            if ((typeof firstY == 'undefined') && (typeof y != 'undefined')) {
                firstY = y;
            }
            // If this is the first line, create a dummypath to animate in from.
            if (!me.line || chart.resizing) {
                dummyPath = dummyPath.concat([x, bbox.y + bbox.height / 2]);
            }

            // When resizing, reset before animating
            if (chart.animate && chart.resizing && me.line) {
                me.line.setAttributes({
                    path: dummyPath
                }, true);
                if (me.fillPath) {
                    me.fillPath.setAttributes({
                        path: dummyPath,
                        opacity: 0.2
                    }, true);
                }
                if (me.line.shadows) {
                    shadows = me.line.shadows;
                    for (j = 0, lnsh = shadows.length; j < lnsh; j++) {
                        shadow = shadows[j];
                        shadow.setAttributes({
                            path: dummyPath
                        }, true);
                    }
                }
            }
            if (showMarkers) {
                marker = markerGroup.getAt(count++);
                if (!marker) {
                    marker = Ext.chart.Shape[type](surface, Ext.apply({
                        group: [group, markerGroup],
                        x: 0, y: 0,
                        translate: {
                            x: prevX || x,
                            y: prevY || (bbox.y + bbox.height / 2)
                        },
                        value: '"' + xValue + ', ' + yValue + '"'
                    }, endMarkerStyle));
                    marker._to = {
                        translate: {
                            x: x,
                            y: y
                        }
                    };
                } else {
                    marker.setAttributes({
                        value: '"' + xValue + ', ' + yValue + '"',
                        x: 0, y: 0,
                        hidden: false
                    }, true);
                    marker._to = {
                        translate: {
                            x: x, y: y
                        }
                    };
                }
            }

            me.items.push({
                series: me,
                value: [xValue, yValue],
                point: [x, y],
                sprite: marker,
                storeItem: store.getAt(storeIndices[i])
            });
            prevX = x;
            prevY = y;
        }

        if (path.length <= 1) {
            //nothing to be rendered
            return;
        }

        if (smooth) {
            smoothPath = Ext.draw.Draw.smooth(path, isNumber(smooth) ? smooth : me.defaultSmoothness);
        }

        renderPath = smooth ? smoothPath : path;

        //Correct path if we're animating timeAxis intervals
        if (chart.markerIndex && me.previousPath) {
            fromPath = me.previousPath;
            if (!smooth) {
                Ext.Array.erase(fromPath, 1, 2);
            }
        } else {
            fromPath = path;
        }

        // Only create a line if one doesn't exist.
        if (!me.line) {
            me.line = surface.add(Ext.apply({
                type: 'path',
                group: group,
                path: dummyPath,
                stroke: endLineStyle.stroke || endLineStyle.fill
            }, endLineStyle || {}));
            //unset fill here (there's always a default fill withing the themes).
            me.line.setAttributes({
                fill: 'none'
            });
            if (!endLineStyle.stroke && colorArrayLength) {
                me.line.setAttributes({
                    stroke: colorArrayStyle[seriesIdx % colorArrayLength]
                }, true);
            }
            if (enableShadows) {
                //create shadows
                shadows = me.line.shadows = [];
                for (shindex = 0; shindex < lnsh; shindex++) {
                    shadowBarAttr = shadowAttributes[shindex];
                    shadowBarAttr = Ext.apply({}, shadowBarAttr, { path: dummyPath });
                    shadow = chart.surface.add(Ext.apply({}, {
                        type: 'path',
                        group: shadowGroups[shindex]
                    }, shadowBarAttr));
                    shadows.push(shadow);
                }
            }
        }
        if (me.fill) {
            fillPath = renderPath.concat([
                ["L", x, bbox.y + bbox.height],
                ["L", bbox.x, bbox.y + bbox.height],
                ["L", bbox.x, firstY]
            ]);
            if (!me.fillPath) {
                me.fillPath = surface.add({
                    group: group,
                    type: 'path',
                    opacity: endLineStyle.opacity || 0.3,
                    fill: endLineStyle.fill || colorArrayStyle[seriesIdx % colorArrayLength],
                    path: dummyPath
                });
            }
        }
        markerCount = showMarkers && markerGroup.getCount();
        if (chart.animate) {
            fill = me.fill;
            line = me.line;
            //Add renderer to line. There is not unique record associated with this.
            rendererAttributes = me.renderer(line, false, { path: renderPath }, i, store);
            Ext.apply(rendererAttributes, endLineStyle || {}, {
                stroke: endLineStyle.stroke || endLineStyle.fill
            });
            //fill should not be used here but when drawing the special fill path object
            delete rendererAttributes.fill;
            if (chart.markerIndex && me.previousPath) {
                me.animation = animation = me.onAnimate(line, {
                    to: rendererAttributes,
                    from: {
                        path: fromPath
                    }
                });
            } else {
                me.animation = animation = me.onAnimate(line, {
                    to: rendererAttributes
                });
            }
            //animate shadows
            if (enableShadows) {
                shadows = line.shadows;
                for(j = 0; j < lnsh; j++) {
                    if (chart.markerIndex && me.previousPath) {
                        me.onAnimate(shadows[j], {
                            to: { path: renderPath },
                            from: { path: fromPath }
                        });
                    } else {
                        me.onAnimate(shadows[j], {
                            to: { path: renderPath }
                        });
                    }
                }
            }
            //animate fill path
            if (fill) {
                me.onAnimate(me.fillPath, {
                    to: Ext.apply({}, {
                        path: fillPath,
                        fill: endLineStyle.fill || colorArrayStyle[seriesIdx % colorArrayLength]
                    }, endLineStyle || {})
                });
            }
            //animate markers
            if (showMarkers) {
                count = 0;
                for(i = 0; i < ln; i++) {
                    if (me.items[i]) {
                        item = markerGroup.getAt(count++);
                        if (item) {
                            rendererAttributes = me.renderer(item, store.getAt(i), item._to, i, store);
                            me.onAnimate(item, {
                                to: Ext.apply(rendererAttributes, endMarkerStyle || {})
                            });
                        }
                    }
                }
                for(; count < markerCount; count++) {
                    item = markerGroup.getAt(count);
                    item.hide(true);
                }
            }
        } else {

            //Set hidden to true
            rendererAttributes = me.renderer(me.line, false, { path: renderPath, hidden: true }, i, store);
            Ext.apply(rendererAttributes, endLineStyle || {}, {
                stroke: endLineStyle.stroke || endLineStyle.fill
            });
            //fill should not be used here but when drawing the special fill path object
            delete rendererAttributes.fill;
            me.line.setAttributes(rendererAttributes, true);
            //set path for shadows
            if (enableShadows) {
                shadows = me.line.shadows;
                for(j = 0; j < lnsh; j++) {
                    shadows[j].setAttributes({
                        path: renderPath
                    }, true);
                }
            }
            if (me.fill) {
                me.fillPath.setAttributes({
                    path: fillPath
                }, true);
            }
            if (showMarkers) {
                count = 0;
                for(i = 0; i < ln; i++) {
                    if (me.items[i]) {
                        item = markerGroup.getAt(count++);
                        if (item) {
                            rendererAttributes = me.renderer(item, store.getAt(i), item._to, i, store);
                            item.setAttributes(Ext.apply(endMarkerStyle || {}, rendererAttributes || {}), true);
                        }
                    }
                }
                for(; count < markerCount; count++) {
                    item = markerGroup.getAt(count);
                    item.hide(true);
                }
            }
        }

        if (chart.markerIndex) {
            if (me.smooth) {
                Ext.Array.erase(path, 1, 2);
            } else {
                Ext.Array.splice(path, 1, 0, path[1], path[2]);
            }
            me.previousPath = path;
        }
        me.renderLabels();
        me.renderCallouts();
    }
});

Ext.override(Ext.chart.series.Bar, {
     getPaths: function() {
        var me = this,
            chart = me.chart,
            store = chart.substore || chart.store,
            bounds = me.bounds = me.getBounds(),
            items = me.items = [],
            gutter = me.gutter / 100,
            groupGutter = me.groupGutter / 100,
            animate = chart.animate,
            column = me.column,
            group = me.group,
            enableShadows = chart.shadow,
            shadowGroups = me.shadowGroups,
            shadowAttributes = me.shadowAttributes,
            shadowGroupsLn = shadowGroups.length,
            bbox = bounds.bbox,
            xPadding = me.xPadding,
            yPadding = me.yPadding,
            stacked = me.stacked,
            barsLen = bounds.barsLen,
            colors = me.colorArrayStyle,
            colorLength = colors && colors.length || 0,
            math = Math,
            mmax = math.max,
            mmin = math.min,
            mabs = math.abs,
            j, yValue, height, totalDim, totalNegDim, bottom, top, hasShadow, barAttr, attrs, counter,
            shadowIndex, shadow, sprite, offset, floorY;

        store.each(function(record, i, total) {
            bottom = bounds.zero;
            top = bounds.zero;
            totalDim = 0;
            totalNegDim = 0;
            hasShadow = false;
            for (j = 0, counter = 0; j < barsLen; j++) {
                // Excluded series
                if (me.__excludes && me.__excludes[j]) {
                    continue;
                }
                yValue = record.get(bounds.bars[j]);
                height = Math.round((yValue - ((bounds.minY < 0) ? 0 : bounds.minY)) * bounds.scale);
                barAttr = {
                    fill: colors[(barsLen > 1 ? j : 0) % colorLength]
                };
                if (column) {
                    Ext.apply(barAttr, {
                        height: height,
                        width: mmax(bounds.groupBarWidth, 0),
                        x: (bbox.x + xPadding + i * bounds.barWidth * (1 + gutter) + counter * bounds.groupBarWidth * (1 + groupGutter) * !stacked),
                        y: bottom - height
                    });
                }
                else {
                    // draw in reverse order
                    offset = (total - 1) - i;
                    Ext.apply(barAttr, {
                        height: mmax(bounds.groupBarWidth, 0),
                        width: height + (bottom == bounds.zero),
                        x: bottom + (bottom != bounds.zero),
                        y: (bbox.y + yPadding + offset * bounds.barWidth * (1 + gutter) + counter * bounds.groupBarWidth * (1 + groupGutter) * !stacked + 1)
                    });
                }
                if (height < 0) {
                    if (column) {
                        barAttr.y = top;
                        barAttr.height = mabs(height);
                    } else {
                        barAttr.x = top + height;
                        barAttr.width = mabs(height);
                    }
                }
                if (stacked) {
                    if (height < 0) {
                        top += height * (column ? -1 : 1);
                    } else {
                        bottom += height * (column ? -1 : 1);
                    }
                    totalDim += mabs(height);
                    if (height < 0) {
                        totalNegDim += mabs(height);
                    }
                }
                barAttr.x = Math.floor(barAttr.x) + 1;
                floorY = Math.floor(barAttr.y);
                if (!Ext.isIE9 && barAttr.y > floorY) {
                    floorY--;
                }
                barAttr.y = floorY;
                barAttr.width = Math.floor(barAttr.width);
                barAttr.height = Math.floor(barAttr.height);
                items.push({
                    series: me,
                    storeItem: record,
                    value: [record.get(me.xField), yValue],
                    attr: barAttr,
                    point: column ? [barAttr.x + barAttr.width / 2, yValue >= 0 ? barAttr.y : barAttr.y + barAttr.height] :
                                    [yValue >= 0 ? barAttr.x + barAttr.width : barAttr.x, barAttr.y + barAttr.height / 2],
                    _yField: bounds.bars[j]
                });
                // When resizing, reset before animating
                if (animate && chart.resizing) {
                    attrs = column ? {
                        x: barAttr.x,
                        y: bounds.zero,
                        width: barAttr.width,
                        height: 0
                    } : {
                        x: bounds.zero,
                        y: barAttr.y,
                        width: 0,
                        height: barAttr.height
                    };
                    if (enableShadows && (stacked && !hasShadow || !stacked)) {
                        hasShadow = true;
                        //update shadows
                        for (shadowIndex = 0; shadowIndex < shadowGroupsLn; shadowIndex++) {
                            shadow = shadowGroups[shadowIndex].getAt(stacked ? i : (i * barsLen + j));
                            if (shadow) {
                                shadow.setAttributes(attrs, true);
                            }
                        }
                    }
                    //update sprite position and width/height
                    sprite = group.getAt(i * barsLen + j);
                    if (sprite) {
                        sprite.setAttributes(attrs, true);
                    }
                }
                counter++;
            }
            if (stacked && items.length) {
                items[i * counter].totalDim = totalDim;
                items[i * counter].totalNegDim = totalNegDim;
            }
        }, me);
    },

    onPlaceLabel: function(label, storeItem, item, i, display, animate, j, index) {
                // Determine the label's final position. Starts with the configured preferred value but
                // may get flipped from inside to outside or vice-versa depending on space.
                var me = this,
                    opt = me.bounds,
                    groupBarWidth = opt.groupBarWidth,
                    column = me.column,
                    chart = me.chart,
                    chartBBox = chart.chartBBox,
                    resizing = chart.resizing,
                    xValue = item.value[0],
                    yValue = item.value[1],
                    attr = item.attr,
                    config = me.label,
                    rotate = config.orientation == 'vertical',
                    field = [].concat(config.field),
                    format = config.renderer,
                    text = format(storeItem.get(field[index])),
                    size = me.getLabelSize(text),
                    width = size.width,
                    height = size.height,
                    zero = opt.zero,
                    outside = 'outside',
                    insideStart = 'insideStart',
                    insideEnd = 'insideEnd',
                    center = 'center',
                    offsetX = 10,
                    offsetY = 6,
                    signed = opt.signed,
                    x, y, finalAttr;

                label.setAttributes({
                    text: text,
                    hidden: true
                }, true);

                label.isOutside = false;
                if (column) {
                    if (display == outside) {
                        if (height + offsetY + attr.height > (yValue >= 0 ? zero - chartBBox.y : chartBBox.y + chartBBox.height - zero)) {
                            display = insideEnd;
                        }
                    } else {
                        if (height + offsetY > attr.height) {
                            display = outside;
                            label.isOutside = true;
                        }
                    }
                    x = attr.x + groupBarWidth / 2;
                    y = display == insideStart ?
                            (zero + ((height / 2 + 3) * (yValue >= 0 ? -1 : 1))) :
                            (yValue >= 0 ? (attr.y + ((height / 2 + 3) * (display == outside ? -1 : 1))) :
                                           (attr.y + attr.height + ((height / 2 + 3) * (display === outside ? 1 : -1))));
                    if (display == center) {
                        y = (  attr.y + attr.height/2  );
                    }
                }
                else {
                    if (display == outside) {
                        if (width + offsetX + attr.width > (yValue >= 0 ? chartBBox.x + chartBBox.width - zero : zero - chartBBox.x)) {
                            display = insideEnd;
                        }
                    }
                    else {
                        if (width + offsetX > attr.width) {
                            display = outside;
                            label.isOutside = true;
                        }
                    }
                    x = display == insideStart ?
                        (zero + ((width / 2 + 5) * (yValue >= 0 ? 1 : -1))) :
                        (yValue >= 0 ? (attr.x + attr.width + ((width / 2 + 5) * (display === outside ? 1 : -1))) :
                        (attr.x + ((width / 2 + 5) * (display === outside ? -1 : 1))));
                    y = attr.y + groupBarWidth / 2;
                    if (display == center) {
                        x = ( attr.x + attr.width/2 );
                    }
                }
                //first check for imposition & posible to put staked labels
                if (!this.imposion)
                     this.imposion = [];
                var tryingStaked = 5,
                    isOverlap,
                    impositionLastX,
                    impositionLastY,
                    impositionLastW;
                while (!!(--tryingStaked) ) {
                    isOverlap = false;
                    for (var i = 0; i<me.imposion.length; i++){
                        if (
                                (x < me.imposion[i][0] + me.imposion[i][2] + (column?0:offsetX)) && (x+width > me.imposion[i][0])
                                &&
                                (y < me.imposion[i][1] + me.imposion[i][3]) && (y+height > me.imposion[i][1])
                           ){
                            isOverlap = true;
                            impositionLastX = me.imposion[i][0];
                            impositionLastY = me.imposion[i][1];
                            impositionLastW = me.imposion[i][2];
                        }
                    }
                    if (!isOverlap) {
                        break;
                    } else {
                        if (column)
                            y = impositionLastY - height - 1;
                        else
                            x = impositionLastX + impositionLastW/2 + offsetX + width/2 + 1;
                    }

                }
                //set position
                finalAttr = {
                    x: x,
                    y: y,
                    hidden: false
                };
                //rotate
                if (rotate) {
                    finalAttr.rotate = {
                        x: x,
                        y: y,
                        degrees: 270
                    };
                }
                //check for resizing
                if (animate && resizing) {
                    if (column) {
                        x = attr.x + attr.width / 2;
                        y = zero;
                    } else {
                        x = zero;
                        y = attr.y + attr.height / 2;
                    }
                    label.setAttributes({
                        x: x,
                        y: y
                    }, true);
                    if (rotate) {
                        label.setAttributes({
                            rotate: {
                                x: x,
                                y: y,
                                degrees: 270
                            }
                        }, true);
                    }
                }
                //Check for overlap                
                x = parseFloat(x);
                y = parseFloat(y);
                var isOverlap = false;
                for (var i = 0; i<me.imposion.length; i++){
                    if (
                            (x < me.imposion[i][0] + me.imposion[i][2]) && (x+width > me.imposion[i][0])
                            &&
                            (y < me.imposion[i][1] + me.imposion[i][3]) && (y+height > me.imposion[i][1])
                       ){
                        isOverlap = true;
                    }
                }
                //sometimes values are outside of the column chart screen on the top
                if (chartBBox.y > y-5 || chartBBox.x + chartBBox.width < x - offsetX){
                    if (column)
                        this.xyLabelMargin = Math.max(chartBBox.y - y + height + offsetY, this.xyLabelMargin||0);
                    else
                        this.xyLabelMargin = Math.max(x - chartBBox.x + chartBBox.width + width + offsetX, this.xyLabelMargin||0);

                    //do not show labels which out of the chart screen box
                    return label.setAttributes({hidden: true}, true);
                }

                if (!isOverlap)
                    me.imposion.push([x,y,width,height]);

                //handle animation
                if (animate) {
                    if (!isOverlap)
                    me.onAnimate(label, { to: finalAttr });
                }
                else {
                    if (!isOverlap)
                    label.setAttributes(Ext.apply(finalAttr, {
                        hidden: false
                    }), true);
                }
    }
    
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/utility/Date.js
Ext.define('App.utility.Date', {
    singleton: true,

    TODAY: 1,
    YESTERDAY: 2,
    WEEK: 3,
    LAST_2_DAYS: 4,
    LAST_7_DAYS: 5,
    PREV_WEEK: 6,
    LAST_2_WEEKS: 7,
    MONTH: 8,
    LAST_30_DAYS: 9,
    PREV_MONTH: 10,
    LAST_60_DAYS: 11,
    LAST_3_MONTH: 12,
    LAST_6_MONTH: 13,
    LAST_12_MONTH: 14,
    YEAR: 15,
    PREV_YEAR: 16,
    CUSTOM: 99,

    /*Private*/
    _getCurrentServerDate: function() {
        return get_current_time();
    },

    /*Public*/
    getToday: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getYesterday: function() {
        var time = this._getCurrentServerDate();
        time = time - 60 * 60 * 24;
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getThisWeek: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        var numberDayInWeek =  Ext.Date.format(date, "w");

        time = time - 60 * 60 * 24 * (numberDayInWeek - 1);
        date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getLastNDays: function(days) {
        var time = this._getCurrentServerDate();
            time = time - 60 * 60 * 24 * days;
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getPrevWeek: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        var numberDayInWeek =  Ext.Date.format(date, "w");
        time = time - 60 * 60 * 24 * (numberDayInWeek - 0 + 6);
        date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getThisMonth: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-01");
    },

    getPrevNMonth: function(monthsCount) {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        var toDate = Ext.Date.parse(Ext.Date.format(date, "Y-m-01 00:00:00"), "Y-m-d H:i:s");
        var fromDate = Ext.Date.add(toDate, Ext.Date.MONTH, (-1 * monthsCount));
        return Ext.Date.format(fromDate, "Y-m-01");
    },

    getThisYear: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-01-01");
    },

    getPrevNYears: function(yearsCount) {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        var toDate = Ext.Date.parse(Ext.Date.format(date, "Y-01-01 00:00:00"), "Y-m-d H:i:s");
        var fromDate = Ext.Date.add(toDate, Ext.Date.YEAR, (-1 * yearsCount));
        return Ext.Date.format(fromDate, "Y-01-01");
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/utility/NamesFormatter.js
Ext.define('App.utility.NamesFormatter', {
    singleton: true,

    formatSeconds: function(timeleft) {
        var hh = Math.floor(timeleft / 3600);
        if (hh > 0) {
            var mm = Math.floor((timeleft % 3600) / 60);
            var ss = mm > 0 ? (timeleft % 3600) % 60 : timeleft % 3600;
            timeleft = sprintf(_t('%(hours)sh %(minutes)smin %(seconds)ssec '), { hours : hh, minutes : mm, seconds : ss });
        } else {
            mm = Math.floor(timeleft / 60);
            if (mm > 0){
                ss = timeleft % 60;
                timeleft = sprintf(_t('%(minutes)smin %(seconds)ssec '), { minutes : mm, seconds : ss });
            }else{
                timeleft = sprintf(_t('%(seconds)ssec '), { seconds : timeleft });
            }
        }
        return timeleft;
    },

    /**
     * Used in chart
     */
    formatSecondsShort: function(timeleft) {
        var mm = Math.floor(timeleft / 60);
        if (mm > 0){
            return sprintf("%(minutes)sm", { minutes : mm });
        }else{
            return sprintf("%(seconds)ss", { seconds : timeleft });
        }
    },

    formatNumber: function(number) {
        if (!number) {
            number = 0;
        }
        return Ext.util.Format.number(number, '0,000');
    },

    formatFloat: function(number) {
        if (!number) {
            number = 0;
        }
        return Ext.util.Format.number(number, '0,000.00');
    },

    formatWithAccuracyGrade: function(number, grade) {
        if (!number) {
            number = 0;
        }
        grade = parseInt(grade) ? parseInt(grade) : 2;
        return number.toFixed(grade);
    },

    formatGroupDirection: function(value) {
        switch(parseInt(value)) {
            case 1:
                return _t('Unknown');
            case 2:
                return _t('Incoming');
            case 3:
                return _t('Outgoing');
            case 4:
                return _t('Local');
            default:
                return _t('Other');
        }
    },

    formatBill: function(value) {
        if (!value || value === 'other') {
            var secs = 0;
        } else {
            secs = parseInt(value);
        }
        return sprintf('%(time)s', {time: secs});
    },

    formatDirection: function(value, skipTags) {
        switch(parseInt(value)) {
            case 1:
                return _t('Other');
            case 2:
                return skipTags? _t('Inc.') :sprintf('<span style="color:orange;">%(inc)s</span>', { inc : _t('Inc.') });
            case 3:
                return skipTags? _t('Out.') :sprintf('<span style="color:navy;">%(out)s</span>', { out : _t('Out.') });
            case 4:
                return skipTags? _t('Local') :sprintf('<span style="color:green;">%(local)s</span>', { local : _t('Local') });
            default:
                return _t('Other');
        }
    },

    formatService: function(value) {
        switch (parseInt(value)) {
            case 1:
                return _t('Call');
            case 2:
                return _t('Fax');
            case 3:
                return _t('Voicemail');
            default:
                return _t('Unknown');
        }
    },

    formatStatus: function(value, skipTags) {
        if (!value || value === 'other') {
            return skipTags? _t('Unansw.') : sprintf('<span style="color:red;">%(unansw)s</span>', { unansw : _t('Unansw.') });
        } else {
            value = parseInt(value);
            if (value > 0) {
                return skipTags? _t('Answ.') : sprintf('<span style="color:green;">%(answ)s</span>', { answ : _t('Answ.') });
            } else {
                return skipTags? _t('Unansw.') : sprintf('<span style="color:red;">%(unansw)s</span>', { unansw : _t('Unansw.') });
            }
        }
    },

    formatHoursTime: function(secs) {
        if (secs) {
            secs = parseInt(secs);
        } else {
            secs = 0;
        }
        var hours = Math.floor(secs / (60 * 60));
        var divisor_for_minutes = secs % (60 * 60);
        var minutes = Math.floor(divisor_for_minutes / 60);
        var divisor_for_seconds = divisor_for_minutes % 60;
        var seconds = Math.ceil(divisor_for_seconds);

        if (hours < 10) {
            hours = "0" + hours;
        }
        if (minutes < 10) {
            minutes = "0" + minutes;
        }
        if (seconds < 10) {
            seconds = "0" + seconds;
        }
        return hours +':'+ minutes +':'+ seconds;
    },

    formatGroupingByHour: function(value) {
        if (!value || value === 'other') {
            return _t('Other');
        }

        if (!this.timeOffset) {
            this.timeOffset = parseInt(Ext.Date.format(new Date(), "Z"), 10);
        }

        var date = Ext.Date.parse(parseInt(value) * 3600 - this.timeOffset, 'U');

        return Ext.Date.format(date, 'd/m/Y H:i');
    },

    formatGroupingByDay: function(value) {
        if (!value || value === 'other') {
            return _t('Other');
        }
        value = parseInt(value, 10);
        if (!this.timeOffset) {
            this.timeOffset = parseInt(Ext.Date.format(new Date(), "Z"));
        }

        var date = Ext.Date.parse(value * 86400 - this.timeOffset, 'U');

        return Ext.Date.format(date, 'd/m/Y');
    },

    formatHourOfDay: function(value) {
        if (!value || value === 'other') {
            return _t('Other');
        }
        value = parseInt(value, 10);
        if (value < 10) {
            value = "0" + value;
        }
        return value + ":00";
    },

    formatDayOfWeek: function(value) {
        value = parseInt(value, 10);
        var result = _t('Other');
        switch(value) {
            case 0:
                result = _t('Sunday');
                break;
            case 1:
                result = _t('Monday');
                break;
            case 2:
                result = _t('Tuesday');
                break;
            case 3:
                result = _t('Wednesday');
                break;
            case 4:
                result = _t('Thursday');
                break;
            case 5:
                result = _t('Friday');
                break;
            case 6:
                result = _t('Saturday');
                break;
        }
        return result;
    },

    formatGroupingByWeek: function(value) {
        if (!value || value === 'other') {
            return _t('Other');
        }
        value = parseInt(value, 10);
        if (!this.timeOffset) {
            this.timeOffset = parseInt(Ext.Date.format(new Date(), "Z"));
        }

        var dateFrom = Ext.Date.parse(value * 86400 - this.timeOffset, 'U'),
            dateTo = Ext.Date.add(dateFrom, Ext.Date.DAY, 6);

        return Ext.Date.format(dateFrom, 'd/m/Y')+' - '+Ext.Date.format(dateTo, 'd/m/Y');
    },

    formatByMonth: function(value) {
        try {
            value = value.toString();
            if (!value || value === 'other') {
                return _t('Other');
            }
            var year = value.substr(0, 4);
            var month = value.substr(4, 6);
            return month +'/'+ year;
        } catch (e){
            console.error(e, 'for value',value);
        }
    },

    formatMonthOfYear: function(value) {
        value = parseInt(value, 10);
        var result = _t('Other');
        switch(value) {
            case 0:
                result = _t('January');
                break;
            case 1:
                result = _t('February');
                break;
            case 2:
                result = _t('March');
                break;
            case 3:
                result = _t('April');
                break;
            case 4:
                result = _t('May');
                break;
            case 5:
                result = _t('June');
                break;
            case 6:
                result = _t('July');
                break;
            case 7:
                result = _t('August');
                break;
            case 8:
                result = _t('September');
                break;
            case 9:
                result = _t('October');
                break;
            case 10:
                result = _t('November');
                break;
            case 11:
                result = _t('December');
                break;
        }
        return result;
    },

    formatCallClass: function(value) {
        switch (parseInt(value)) {
            case 1:
                return _t('Internal');
            case 2:
                return _t('Local');
            case 3:
                return _t('National');
            case 4:
                return _t('Mobile');
            case 5:
                return _t('Emergency');
            case 6:
                return _t('Free');
            case 7:
                return _t('Premium1');
            case 8:
                return _t('Premium2');
            case 9:
                return _t('Premium3');
            case 10:
                return _t('Premium4');
            case 11:
                return _t('Northamerica');
            case 12:
                return _t('Africa');
            case 13:
                return _t('Europe1');
            case 14:
                return _t('Europe2');
            case 15:
                return _t('Southamerica');
            case 16:
                return _t('Oceania');
            case 17:
                return _t('Russia');
            case 18:
                return _t('Asia1');
            case 19:
                return _t('Asia2');
            default:
                return _t('Other');
        }
    },

    formatText: function(value) {
        var result = value;
        switch (value) {
            case 'TOTAL_EVENTS_CHART_VAL':
                result = _t('Total events');
                break;
            case 'TOTAL_COST_CHART_VAL':
                result = _t('Total cost');
                break;
            case 'TOTAL_BILL_CHART_VAL':
                result = _t('Total talk time');
                break;
            case 'TOTAL_LOCAL_BILL_CHART_VAL':
                result = _t('Total local talk time');
                break;
            case 'TOTAL_INCOMING_BILL_CHART_VAL':
                result = _t('Total incoming talk time');
                break;
            case 'TOTAL_OUTGOING_BILL_CHART_VAL':
                result = _t('Total outgoing talk time');
                break;
            case 'TOTAL_RING_CHART_VAL':
                result = _t('Total ring time');
                break;
            case 'TOTAL_ANSWERED_EVENTS_CHART_VAL':
                result = _t('Total answered');
                break;
            case 'TOTAL_ANSWERED_WITHIN_XX_EVENTS_CHART_VAL':
                result = sprintf(_t('Total answered within %(seconds)s'),{seconds:User.sla_period});
                break;
            case 'TOTAL_ANSWERED_OVER_XX_EVENTS_CHART_VAL':
                result = sprintf(_t('Total answered over %(seconds)s'),{seconds:User.sla_period});
                break;
            case 'TOTAL_NOT_ANSWERED_EVENTS_CHART_VAL':
                result = _t('Total not answered');
                break;
            case 'TOTAL_LOCAL_EVENTS_CHART_VAL':
                result = _t('Total local');
                break;
            case 'TOTAL_INCOMING_EVENTS_CHART_VAL':
                result = _t('Total incoming');
                break;
            case 'TOTAL_OUTGOING_EVENTS_CHART_VAL':
                result = _t('Total outgoing');
                break;
            case 'AVG_COST_CHART_VAL':
                result = _t('Avg. Cost');
                break;
            case 'AVG_BILL_CHART_VAL':
                result = _t('Avg. Talk time');
                break;
            case 'AVG_LOCAL_BILL_CHART_VAL':
                result = _t('Avg. Local Talk time');
                break;
            case 'AVG_INCOMING_BILL_CHART_VAL':
                result = _t('Avg. Inc. Talk time');
                break;
            case 'AVG_OUTGOING_BILL_CHART_VAL':
                result = _t('Avg. Out. Talk time');
                break;
            case 'AVG_RING_CHART_VAL':
                result = _t('Avg. Ring Time');
                break;

            case 'COUNT':
                result = _t('Count');
                break;
            case 'COUNT_BY_SERVICE':
                result = _t('Count by service');
                break;
            case 'COUNT_BY_STATUS':
                result = _t('Count by status');
                break;
            case 'COUNT_BY_DIRECTION':
                result = _t('Count by direction');
                break;
            case 'COUNT_BY_SLA':
                result = _t('Count by SLA');
                break;
            case 'COST':
                result = _t('Cost');
                break;
            case 'COST_BY_SERVICE':
                result = _t('Cost by service');
                break;
            case 'COST_AVG_BY_SERVICE':
                result = _t('Avg. Cost by service');
                break;
            case 'BILL':
                result = _t('Talk time');
                break;
            case 'BILL_BY_DIRECTION':
                result = _t('Talk time by direction');
                break;
            case 'BILL_AVG_BY_DIRECTION':
                result = _t('Avg. talk time by direction');
                break;

            case 'TOTAL_CALL_EVENTS_CHART_VAL':
                result = _t('Call events');
                break;
            case 'TOTAL_FAX_EVENTS_CHART_VAL':
                result = _t('Fax events');
                break;
            case 'TOTAL_VOICEMAIL_EVENTS_CHART_VAL':
                result = _t('Voicemail events');
                break;
            case 'TOTAL_CALL_COST_CHART_VAL':
                result = _t('Call cost');
                break;
            case 'TOTAL_FAX_COST_CHART_VAL':
                result = _t('Fax cost');
                break;
            case 'AVG_CALL_COST_CHART_VAL':
                result = _t('Avg. Call Cost');
                break;
            case 'AVG_FAX_COST_CHART_VAL':
                result = _t('Avg. Fax Cost');
                break;
        }
        return result;
    }

});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/utility/ImageExporter.js

Ext.define('App.utility.ImageExporter', {
    singleton: true,

    statics: (function(){

        return {
            generate: function(config, surface){
                var node = surface.el.dom;
                var svg = new Blob([new XMLSerializer().serializeToString(node)], {type: "image/svg+xml;charset=utf-8"});
                var canvas = document.createElement( 'canvas' );
                canvas.width = node.clientWidth;
                canvas.height = node.clientHeight;
                var ctx = canvas.getContext("2d");
                var img = new Image;

                img.onload = function() {
                    ctx.drawImage( img, 0, 0 );
                    var a = document.createElement('a');
                    a.download = 'Chart';
                    a.href = canvas.toDataURL('image/png');
                    a.click();
                };
                img.src = URL.createObjectURL(svg);
            }
        };
    }())

});

Ext.define('App.utility.SvgExporter', {
    singleton: true,

    statics: (function(){
        var surface, len, width,
        height,
        init = function(s){
            surface = s;
            len = surface.length;
            width = surface.width;
            height = surface.height;
        },
        spriteProcessor = {
            path: function(sprite){

                var attr = sprite.attr,
                    path = attr.path,
                    pathString = '',
                    props, p, pLen;

                if(Ext.isArray(path[0])){
                    pLen = path.length;
                    for (p = 0; p < pLen; p++) {
                        pathString += path[p].join(' ');
                    }
                }else if(Ext.isArray(path)){
                    pathString = path.join(' ');
                }else{
                    pathString = path.replace(/,/g,' ');
                }

                props = toPropertyString({
                    d: pathString,
                    fill: attr.fill || 'none',
                    stroke: attr.stroke,
                    'fill-opacity': attr.opacity,
                    'stroke-width': attr['stroke-width'],
                    'stroke-opacity': attr['stroke-opacity'],
                    "z-index": attr.zIndex,
                    transform: sprite.matrix.toSvg()
                });

                return '<path ' + props + '/>';
            },
            text: function(sprite){

                // TODO
                // implement multi line support (@see Svg.js tuneText)

                var attr = sprite.attr,
                    fontRegex = /(-?\d*\.?\d*){1}(em|ex|px|in|cm|mm|pt|pc|%)\s('*.*'*)/,
                    match = fontRegex.exec(attr.font),
                    size = (match && match[1]) || "12",
                    // default font family is Arial
                    family = (match && match[3]) || 'Arial',
                    text = attr.text,
                    factor = (Ext.isFF3_0 || Ext.isFF3_5) ? 2 : 4,
                    tspanString = '',
                    props;

                sprite.getBBox();
                //Sanitize
                text = (Ext.htmlEncode(text)+'').replace('"',"&quot;").replace("'","&#39;");

                tspanString += '<tspan x="' + (attr.x || '') + '" dy="';
                tspanString += (size/factor)+'">';
                tspanString += text + '</tspan>';


                props = toPropertyString({
                        x: attr.x,
                        y: attr.y,
                        'font-size': size,
                        'font-family': family,
                        'font-weight': attr['font-weight'],
                        'text-anchor': attr['text-anchor'],
                        // if no fill property is set it will be black
                        fill: attr.fill || '#000',
                        'fill-opacity': attr.opacity,
                        transform: sprite.matrix.toSvg()
                });



                return '<text '+ props + '>' +  tspanString + '</text>';
            },
            rect: function(sprite){

                var attr = sprite.attr,
                    props =  toPropertyString({
                        x: attr.x,
                        y: attr.y,
                        rx: attr.rx,
                        ry: attr.ry,
                        width: attr.width,
                        height: attr.height,
                        fill: attr.fill || 'none',
                        'fill-opacity': attr.opacity,
                        stroke: attr.stroke,
                        'stroke-opacity': attr['stroke-opacity'],
                        'stroke-width':attr['stroke-width'],
                        transform: sprite.matrix && sprite.matrix.toSvg()
                    });

                return '<rect ' + props + '/>';
            },
            circle: function(sprite){

                var attr = sprite.attr,
                    props = toPropertyString({
                        cx: attr.x,
                        cy: attr.y,
                        r: attr.radius,
                        fill: attr.translation.fill || attr.fill || 'none',
                        'fill-opacity': attr.opacity,
                        stroke: attr.stroke,
                        'stroke-opacity': attr['stroke-opacity'],
                        'stroke-width':attr['stroke-width'],
                        transform: sprite.matrix.toSvg()
                    });

                return '<circle ' + props + ' />';
            },
            image: function(sprite){

                var attr = sprite.attr,
                    props = toPropertyString({
                        x: attr.x - (attr.width/2 >> 0),
                        y: attr.y - (attr.height/2 >> 0),
                        width: attr.width,
                        height: attr.height,
                        'xlink:href': attr.src,
                        transform: sprite.matrix.toSvg()
                    });

                return '<image ' + props + ' />';
            }
        },
        svgHeader = function(){
            var svg = '<?xml version="1.0" standalone="yes"?>';
            svg += '<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">';
            return svg;
        },
        svgContent = function(){
            var svg = '<svg width="'+width+'px" height="'+height+'px" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1">',
                defs = '', item, itemsLen, items, gradient,
                getSvgString, colorstops, stop,
                coll, keys, colls, k, kLen, key, collI, i, j, stopsLen, sortedItems, za, zb;

            items = surface.items.items;
            itemsLen = items.length;


            getSvgString = function(node){

                var childs = node.childNodes,
                    childLength = childs.length,
                    i = 0,
                    attrLength,
                    j,
                    svgString = '', child, attr, tagName, attrItem;

                    for(; i < childLength; i++){
                        child = childs[i];
                        attr = child.attributes;
                        tagName = child.tagName;

                        svgString += '<' +tagName;

                        for(j = 0, attrLength = attr.length; j < attrLength; j++){
                            attrItem = attr.item(j);
                            svgString += ' '+attrItem.name+'="'+attrItem.value+'"';
                        }

                        svgString += '>';

                        if(child.childNodes.length > 0){
                            svgString += getSvgString(child);
                        }

                        svgString += '</' + tagName + '>';

                    }
                return svgString;
            };


            if(surface.getDefs){
                defs = getSvgString(surface.getDefs());
            }else{
                // IE
                coll = surface.gradientsColl;
                if (coll) {
                    keys  = coll.keys;
                    colls = coll.items;
                    k     = 0;
                    kLen  = keys.length;
                }

                for (; k < kLen; k++) {
                    key   = keys[k];
                    collI = colls[k];

                    gradient = surface.gradientsColl.getByKey(key);
                    defs += '<linearGradient id="' + key + '" x1="0" y1="0" x2="1" y2="1">';

                    var color = gradient.colors.replace(/rgb\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\)/g, 'rgb($1|$2|$3)');
                    color = color.replace(/rgba\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,([\d\.]+)\)/g, 'rgba($1|$2|$3|$4)')
                    colorstops = color.split(',');
                    for(i=0, stopsLen = colorstops.length; i < stopsLen; i++){
                        stop = colorstops[i].split(' ');
                        color = Ext.draw.Color.fromString(stop[1].replace(/\|/g,','));
                        defs += '<stop offset="'+stop[0]+'" stop-color="' + color.toString() + '" stop-opacity="1"></stop>';
                    }
                    defs += '</linearGradient>';
                }
            }

            svg += '<defs>' + defs + '</defs>';

            // thats the background rectangle
            svg += spriteProcessor.rect({
                attr: {
                        width: '100%',
                        height: '100%',
                        fill: '#fff',
                        stroke: 'none',
                        opacity: '0'
                }
            });

            // Sort the items (stable sort guaranteed)
            sortedItems = new Array(itemsLen);
            for(i = 0; i < itemsLen; i++){
                sortedItems[i] = i;
            }
            sortedItems.sort(function (a, b) {
                za = items[a].attr.zIndex || 0;
                zb = items[b].attr.zIndex || 0;
                if (za == zb) {
                    return a - b;
                }
                return za - zb;
            });

            for(i = 0; i < itemsLen; i++){
                item = items[sortedItems[i]];
                if(!item.attr.hidden){
                    svg += spriteProcessor[item.type](item);
                }
            }

            svg += '</svg>';

            return svg;
        },
        toPropertyString = function(obj){
            var propString = '',
                key;

            for(key in obj){

                if(obj.hasOwnProperty(key) && obj[key] != null){
                    propString += key +'="'+ obj[key]+'" ';
                }

            }

            return propString;
        };

        return {
            generate: function(config, surface){
                init(surface);
                return svgHeader() + svgContent();
            }
        };
    }())

});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/utility/File.js
Ext.define('App.utility.File', {
    singleton: true,
    downloadAsXLSX: function (struct, fileName) {
        this.self._downloadAsXLSX(struct, fileName);
    },
    downloadAsCSV: function (struct, fileName) {
        this.self._downloadAsCSV(struct, fileName);
    },
    faxDataLink: function(record){
        return this.self._faxDataLink(record);
    },
    userDataLink: function(record){
        return this.self._userDataLink(record);
    },
    parseRecordings: function (value) {
        return this.self._parseRecordings(value);
    },
    statics: (function () {

        function datenum(v, date1904) {
            if (date1904)
                v += 1462;
            var epoch = Date.parse(v);
            return (epoch - new Date(Date.UTC(1899, 11, 30))) / (24 * 60 * 60 * 1000);
        }
        function sheet_from_array_of_arrays(data, opts) {
            var ws = {};
            var range = {s: {c: 10000000, r: 10000000}, e: {c: 0, r: 0}};
            for (var R = 0; R != data.length; ++R) {
                for (var C = 0; C != data[R].length; ++C) {
                    if (range.s.r > R)
                        range.s.r = R;
                    if (range.s.c > C)
                        range.s.c = C;
                    if (range.e.r < R)
                        range.e.r = R;
                    if (range.e.c < C)
                        range.e.c = C;
                    var cell = {v: data[R][C]};
                    if (cell.v == null)
                        continue;
                    var cell_ref = XLSX.utils.encode_cell({c: C, r: R});

                    if (typeof cell.v === 'number')
                        cell.t = 'n';
                    else if (typeof cell.v === 'boolean')
                        cell.t = 'b';
                    else if (cell.v instanceof Date) {
                        cell.t = 'n';
                        cell.z = XLSX.SSF._table[14];
                        cell.v = datenum(cell.v);
                    } else
                        cell.t = 's';

                    ws[cell_ref] = cell;
                }
            }
            data = null;
            if (range.s.c < 10000000)
                ws['!ref'] = XLSX.utils.encode_range(range);
            return ws;
        }
        function Workbook() {
            if (!(this instanceof Workbook))
                return new Workbook();
            this.SheetNames = [];
            this.Sheets = {};
        }
        function s2ab(s) {
            var buf = new ArrayBuffer(s.length);
            var view = new Uint8Array(buf);
            for (var i = 0; i != s.length; ++i)
                view[i] = s.charCodeAt(i) & 0xFF;
            return buf;
        }
        function _ConvertToCSV(obj) {
            var separator = ";";
            var div = document.createElement('div');
            var array = [];
            if (obj.headers) {
                array.push(obj.headers);
            }
            if (obj.rows) {
                array = array.concat(obj.rows);
            }
            if (obj.summaries) {
                array.push(obj.summaries);
            }
            var str = '';
            var line = '';

            for (var i = 0; i < array.length; i++) {
                var line = '';
                for (var index in array[i]) {
                    var value = array[i][index] + "";
                    line += '"' + value.replace(/"/g, '""') + '"' + separator;
                }

                line = line.slice(0, -1);
                str += line + '\r\n';
            }
            return str;
        }

        //2015.06.05-10.45.16-111-333-128011243-{n}.wav|1;
        var recordRegExp = /^(\d+)\.(\d+)\.(\d+)-(\d+)\.(\d+)\.(\d+)-([^-]+)-([^-]+)-.*?\|(\d+)$/;
        //2015.06.05/13/49/2015.06.05-13.49.04-111-333-205284820-{n}.wav|1;
        var newRecordRegExp = /^.*?\/(\d+)\.(\d+)\.(\d+)-(\d+)\.(\d+)\.(\d+)-([^-]+)-([^-]+)-.*?\|(\d+)$/;


        return {
            _downloadAsCSV: function (data, fileName) {

                var a = document.createElement('a');
                var mimeType = 'text/csv';
                var content = _ConvertToCSV(data);

                App.utility.File.self.download(content, mimeType, fileName);
            },
            _downloadAsXLSX: function (struct, fileName) {
                var data = [struct.headers].concat(struct.rows).concat([struct.summaries]);
                struct = null;
                var ws_name = "TabSheet1",
                        wb = new Workbook(),
                        ws = sheet_from_array_of_arrays(data);

                /* add worksheet to workbook */
                wb.SheetNames.push(ws_name);
                wb.Sheets[ws_name] = ws;
                var wbout = XLSX.write(wb, {bookType: 'xlsx', bookSST: false, type: 'binary'});
                var content = s2ab(wbout);
                var mimeType = 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet';

                App.utility.File.self.download(content, mimeType, fileName);
            },
            download: function (content, mimeType, fileName) {
                var a = document.createElement('a');

                //var mimeType = 'attachment/file';


                if (navigator.msSaveBlob) { // IE10


                    return navigator.msSaveBlob(new Blob([content], {type: mimeType}), fileName);
                } else if (URL && URL.createObjectURL && Ext.isSafari) {


                    var reader = new FileReader();
                    reader.onloadend = function () {
                        var base64Data = reader.result;
                        window.location.href = "data:attachment/file" + base64Data.slice(base64Data.search(/[,;]/));
                    };
                    reader.readAsDataURL(new Blob([content]));
                    return;//For now file name want work in Safari
                    a.href = URL.createObjectURL(new Blob([content], {type: mimeType}));
                    ;
                    a.setAttribute('download', fileName);
                    a.setAttribute('target', '_blank');
                    document.body.appendChild(a);
                    if (window.MouseEvent) {
                        var clk = document.createEvent("MouseEvent");
                        clk.initEvent("click", true, true);
                        a.dispatchEvent(clk);
                    } else {
                        a.click();
                    }
                    setTimeout(function () {
                        document.body.removeChild(a);
                    }, 66);
                    return true;
                } else if (URL && URL.createObjectURL) {


                    a.href = URL.createObjectURL(new Blob([content], {type: mimeType}));
                    a.setAttribute('download', fileName);
                    document.body.appendChild(a);
                    if (window.MouseEvent) {
                        var clk = document.createEvent("MouseEvent");
                        clk.initEvent("click", true, true);
                        a.dispatchEvent(clk);
                    } else {
                        a.click();
                    }
                    setTimeout(function () {
                        document.body.removeChild(a);
                    }, 66);
                    return true;
                } else if ('download' in a) { //html5 A[download]


                    a.href = 'data:' + mimeType + ',' + encodeURIComponent(content);
                    a.setAttribute('download', fileName);
                    document.body.appendChild(a);
                    setTimeout(function () {
                        a.click();
                        document.body.removeChild(a);
                    }, 66);
                    return true;
                } else { //do iframe dataURL download (old ch+FF):


                    var f = document.createElement('iframe');
                    document.body.appendChild(f);
                    f.src = 'data:' + mimeType + ',' + encodeURIComponent(content);

                    setTimeout(function () {
                        document.body.removeChild(f);
                    }, 333);
                    return true;
                }
            },

            _parseRecordings: function(recordStr){
                var records = [];
                var values = (''+recordStr).split(";");
                for (var i=0; i < values.length; i++) {
                    if(values[i]!==''){
                        var filename = values[i].replace(/\|\d+/, '');
                        var m = recordRegExp.exec(values[i]);

                        if (!m){
                            m = newRecordRegExp.exec(values[i]);
                        }

                        if (m && m[7]){
                            records.push({
                                filename: filename,
                                date: new Date(m[1], m[2]-1, m[3], m[4], m[5], m[6]),
                                source: m[7],
                                destination: m[8],
                                files:  m[9]
                            });
                        }
                    }
                }
                return records;
            },
            _userDataLink: function(record){
                var records = [],
                    value = record.get('USERFIELD') ;
                var pbxid = record.get('PBX');
                if (pbxid){
                    pbxid = pbxid.replace(/.*\((\w+)\)/,'$1').trim();
                }

                if (value === null) {
                    value = '';
                }

                if(value.substr(0, 2) == 'R:'){
                    value = value.replace('R:', '');
                    records = App.utility.File.self._parseRecordings(value);
                    if(records && records.length > 0){
                        if(records.length > 1 || records[0].files > 1){
                            return '<a class="w-download-attach w-recording morerecords fa fa-file-audio-o" href="javascript:void(0)" title="'+_t('Download recording')+'" records="'+value+'"></a>';
                        }else if(records.length == 1 && records[0].files == 1){
                            var url = null;
                            if(records[0].filename.indexOf('-{n}') > -1){
                                url = '/spoolview/recordings/'+records[0].filename.replace('{n}', 0);
                            }else{
                                url = '/spoolview/recordings/'+records[0].filename+'-0.wav';
                            }
                            if (pbxid && Serial != pbxid){
                                //Download data from another pbx
                                url = '/collaboration/lua/fileproxy.lua?serial='+pbxid+'&path='+url;
                            }
                            return '<a class="w-download-attach w-recording fa fa-file-audio-o" href="../..' + url + '" target="_blank" title="'+_t('Download recording')+'"></a>';
                        }
                    }
                }
                return '';
            },
            _faxDataLink: function(record){
                var faxdata = record.get('FAXDATA');
                var incoming = record.get('DIRECTION') == 2;
                var pbxid = record.get('PBX');
                if (pbxid){
                    pbxid = pbxid.replace(/.*\((\w+)\)/,'$1').trim();
                }
                if (User.faxAvailable != true) {
                    return '';
                }
                //faxdata = 'OK|202/fax-222-+390733565560-1302881328034504470-1-4.tiff';
                //faxdata = "ERR|F:345/report-345-3453453454-1407328941444897990-14.pdf|3453453454|CHANUNAVA"

                if (faxdata === null) {
                    faxdata = '';
                }

                if (typeof(faxdata) !=' undefined' && faxdata!='') {

                    var pathToFax = '';
                    var folder = incoming ? 'faxin':'faxout';
                    var fax = faxdata.split("|");
                    if(!fax[1] || fax[1].trim() == ''){
                        return '';
                    }
                    if(fax[1].substr(0,2) == 'F:'){
                        pathToFax = '/spoolview/'+folder+'/'+fax[1].substr(2);
                    } else if (fax[0] == 'OK' || fax[0] == 'ERR'){
                        var fax_url = fax[1];

                        var matching = faxdata.match(/\|fax-([0-9]+)-/);

                        if (folder == 'faxout' && matching != null && matching[1] != undefined && matching[1].length > 0) {
                            pathToFax = '/spoolview/'+folder+'/' + matching[1] + '/' + fax_url;
                        } else {
                            matching = fax_url.match(/(tmp\/)/);
                            if (folder == 'faxin' && matching != undefined && matching != null && matching[1] != undefined) {
                                fax_url = fax_url.replace('/tmp/', this.userPhone + '/');
                            }
                            pathToFax = '/spoolview/'+folder+'/'+fax_url;
                        }
                    }
                    if (pathToFax){
                        if (pbxid && Serial != pbxid){
                            //Download fax from another pbx
                            pathToFax = '/collaboration/lua/fileproxy.lua?serial='+pbxid+'&path='+pathToFax;
                        }

                        var urls = '';
                        if(folder == 'faxout'){
                    		var pathToReport = pathToFax.replace("/fax-", '/report-')
                    		urls += '<a class="w-download-attach fa fa-file-pdf-o" href="../..'+ pathToReport +'" target="_blank" title="'+_t('Download fax report')+'"></a>';
                    	}
                        urls += '<a class="w-download-attach fa fa-file-pdf-o" href="../..'+ pathToFax +'" target="_blank" title="'+_t('Download fax')+'"></a>';

                        return urls
                    }

                }

                return '';
            }
        };
    }())

});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/AbstractProxy.js
Ext.define('App.proxy.AbstractProxy', {
    extend: 'Ext.data.proxy.Server',
    constructor: function () {
        this.callParent(arguments);
    },
    getStorage: function () {
        return App.storage.Storage;
    },
    escape: function (value) {
        var str = new String(value);

        if (!str || str == '') {
            return "''";
        }

        return "'" + str.replace(/'/g, "''") + "'";
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/AbstractEvents.js
Ext.define('App.proxy.AbstractEvents', {
    extend: 'App.proxy.AbstractProxy',
    alias: 'proxy.events',
    read: function(operation, callback, scope) {
        if (this.getTargetStore().getBuilderType() == 1) {
            return this.readSimple(operation, callback, scope);
        } else {
            return this.readGrouped(operation, callback, scope);
        }
	},
    readSimple: function(operation, callback, scope) {
        var self = this;
        var limit = operation.limit;
        var start = operation.start;

        // build results query
        var resultsQuery = {
            filters: this.getTargetStore().getBuilderFilters(),
            columns: this.getTargetStore().getBuilderColumns(),
            sort: this.getTargetStore().getBuilderSorters(),
            limit: {
                limit: limit,
                offset: start
            }
        }
        var resultsSql = App.storage.Storage.getBuilder().build(resultsQuery);

        // here we allready have summaries, and should just laod results
        if (this.reportId == this.getTargetStore().getReportId()) {
            this.getStorage().batch(
                [App.storage.Storage.METHOD_FETCH, resultsSql],
                function(results) {
                    self.onReadedSimpleWithoutSummaries.call(self, results, operation, callback, scope);
                }
            );
            return;
        }

        // build summary query
        var sumQuery = {
            filters: this.getTargetStore().getBuilderFilters(),
            columns: this.getTargetStore().getBuilderSummaries()
        }
        var sumSql = App.storage.Storage.getBuilder().build(sumQuery);

        // executing
        this.getStorage().batch(
            [App.storage.Storage.METHOD_FETCH, resultsSql],
            [App.storage.Storage.METHOD_FETCHROW, sumSql],
            function(results, summaries) {
                self.onReadedSimple.call(self, results, summaries, operation, callback, scope);
            }
        );

        this.reportId = this.getTargetStore().getReportId();
    },
    onReadedSimple: function(results, summaries, operation, callback, scope) {
        var total, result, reader;

        this.simplePreviosSummaries = summaries;
        this.getTargetStore().setSummaries(summaries);

        if (summaries['TOTAL_EVENTS']) {
            total = parseInt(summaries['TOTAL_EVENTS']);
        }

        reader = this.getReader();
        result = reader.read(results);
        result.total = total;
        result.count = results.length;

        operation.setCompleted();
        operation.setSuccessful();

        Ext.apply(operation, { resultSet: result } );
        Ext.callback(callback, scope || this, [operation]);
    },
    onReadedSimpleWithoutSummaries: function(results, operation, callback, scope) {
        var total, result, reader, summaries = this.simplePreviosSummaries;

        if (summaries['TOTAL_EVENTS']) {
            total = parseInt(summaries['TOTAL_EVENTS']);
        }

        reader = this.getReader();
        result = reader.read(results);
        result.total = total;
        result.count = results.length;

        operation.setCompleted();
        operation.setSuccessful();

        Ext.apply(operation, { resultSet: result } );
        Ext.callback(callback, scope || this, [operation]);
    },
    readGrouped: function(operation, callback, scope) {
        var self = this;
        var limit = operation.limit;
        var start = operation.start;

        // build results query
        var resultsQuery = {
            filters: this.getTargetStore().getBuilderFilters(),
            columns: this.getTargetStore().getBuilderColumns(),
            grouping: this.getTargetStore().getBuilderGroupings(),
            sort: this.getTargetStore().getBuilderSorters(),
            limit: {
                limit: limit,
                offset: start
            }
        }
        var resultsSql = App.storage.Storage.getBuilder().build(resultsQuery);

        // here we allready have summaries, and should just laod results
        if (this.reportId == this.getTargetStore().getReportId()) {
            this.getStorage().batch(
                [App.storage.Storage.METHOD_FETCH, resultsSql],
                function(results) {
                    self.onReadedGroupedWithoutSummaries.call(self, results, operation, callback, scope);
                }
            );
            return;
        }

        // build total rows query
        var totalQuery = {
            filters: this.getTargetStore().getBuilderFilters(),
            grouping: this.getTargetStore().getBuilderGroupings(),
            getTotalRows: true
        }
        var totalSql = App.storage.Storage.getBuilder().build(totalQuery);

        // build summary query
        var sumQuery = {
            filters: this.getTargetStore().getBuilderFilters(),
            columns: this.getTargetStore().getBuilderSummaries()
        }

        if (this.getTargetStore().getBuilderSummariesType() == 'extended') {
            sumQuery['grouping'] = this.getTargetStore().getBuilderGroupings();
            sumQuery['getSumRows'] = true;
        }

        var sumSql = App.storage.Storage.getBuilder().build(sumQuery);

        // executing
        this.getStorage().batch(
            [App.storage.Storage.METHOD_FETCH, resultsSql],
            [App.storage.Storage.METHOD_FETCHONE, totalSql],
            [App.storage.Storage.METHOD_FETCHROW, sumSql],
            function(results, total, summaries) {
                self.onReadedGrouped.call(self, results, total, summaries, operation, callback, scope);
            }
        );

        this.reportId = this.getTargetStore().getReportId();
    },
    onReadedGrouped: function(results, total, summaries, operation, callback, scope) {
        var result, reader;

        this.groupedPreviosSummaries = summaries;
        this.groupedPreviosTotal = total;
        this.getTargetStore().setSummaries(summaries);

        total = parseInt(total);
        reader = this.getReader();
        result = reader.read(results);
        result.total = total;
        result.count = results.length;

        operation.setCompleted();
        operation.setSuccessful();

        Ext.apply(operation, { resultSet: result } );
        Ext.callback(callback, scope || this, [operation]);
    },
    onReadedGroupedWithoutSummaries: function(results, operation, callback, scope) {
        var result, reader, summaries = this.groupedPreviosSummaries, total = this.groupedPreviosTotal;

        this.getTargetStore().setSummaries(summaries);

        total = parseInt(total);
        reader = this.getReader();
        result = reader.read(results);
        result.total = total;
        result.count = results.length;

        operation.setCompleted();
        operation.setSuccessful();

        Ext.apply(operation, { resultSet: result } );
        Ext.callback(callback, scope || this, [operation]);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/Trunks.js
Ext.define('App.proxy.Trunks', {
    extend: 'App.proxy.AbstractProxy',
    alias: 'proxy.trunks',
    read: function(operation, callback, scope) {
        var sql = "SELECT * FROM `TRUNKS` ORDER BY `NAME` ASC";
        var controller = function(records) {
            var i, result, trunks, reader;

            trunks = new Array();

            for( i=0; i < records.length; i++ ) {
                trunks.push( { id: records[i]['ID'], name: records[i]['NAME'] } );
            }

            reader = this.getReader();
            result = reader.read(trunks);

            operation.setCompleted();
            operation.setSuccessful();

            Ext.apply(operation, { resultSet: result } );
            Ext.callback(callback, scope || this, [operation]);
        }

        this.getStorage().batch(
            [App.storage.Storage.METHOD_FETCH, sql],
            controller,
            this
        );
    },
    readCount: function(callback, scope) {
        scope = scope || this;
        if (this._dbTrunks != null)
            return callback.apply(scope, [this._dbTrunks.length]);
        var sql = "SELECT COUNT(*) FROM `TRUNKS`";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchOneAsync(sql, controller);
    },
    pushTrunksPromises: function(operations){
        var self = this,
            esc = this.escape,
            storage = this.getStorage(),
            seq = Promise.resolve();
        var inserts = [],updatesIgnore = [],updatesDisIgnore = [];
        for (var i=0; i<operations.length; i++){
            switch (operations[i].type){
                case 'insert': inserts.push(operations[i].data);break;
                case 'ignore': updatesIgnore.push(operations[i].data);break;
                case 'disIgnore': updatesDisIgnore.push(operations[i].data);break;
            }
        }
        if (inserts.length>0){
            var insertSql = 'INSERT INTO TRUNKS(ID,NAME,NAME_LOWER,`IGNORE`) \n\
                             VALUES ';
            for (var i=0; i < inserts.length; i++) {
                var d = inserts[i];
                insertSql += '(null,'+ esc(d['NAME'])+','+esc(d['NAME_LOWER'])+','+esc(d['IGNORE'])+') , ';
            }
            insertSql = insertSql.substr(0,insertSql.length-2) + '; ';
            //
            seq = seq.then(function(){
                return storage.executePromise(insertSql);
            });
        }
        if (updatesIgnore.length>0){
            var ids = [];
            for (var i=0; i < updatesIgnore.length; i++) {
                if (Ext.Array.indexOf(ids,updatesIgnore[i]['ID'])==-1)
                    ids.push( updatesIgnore[i]['ID'] );
            }
            var updateIgnoreSql = 'UPDATE TRUNKS SET `IGNORE` = 1 WHERE ID IN ('+ids.join(',')+')';
            //
            seq = seq.then(function(){
                return storage.executePromise(updateIgnoreSql);
            });
        }
        if (updatesDisIgnore.length>0){
            var ids = [];
            for (var i=0; i < updatesDisIgnore.length; i++) {
                if (Ext.Array.indexOf(ids,updatesDisIgnore[i]['ID'])==-1)
                    ids.push( updatesDisIgnore[i]['ID'] );
            }
            var updateDisIgnoreSql = 'UPDATE TRUNKS SET `IGNORE` = 0 WHERE ID IN ( '+ids.join(',')+')';
            //
            seq = seq.then(function(){
                return storage.executePromise(updateDisIgnoreSql);
            });
        }

        seq = seq.then(function(){


            if (inserts.length>0 || updatesIgnore.length>0 || updatesDisIgnore.length>0){
                return storage.fetchPromise('SELECT ID,NAME,NAME_LOWER,`IGNORE` FROM TRUNKS').
                        then(function(availableTrunks){
                            self._dbTrunks = availableTrunks;
                            storage.proxyEvents.setTrunksModel(availableTrunks);
                        });
            }
            return;
        });
        return seq;
    },
    _dbTrunks: null,
    pushTrunks: function(items, callback){
        var self = this,
            esc = self.escape,
            storage = self.getStorage();


        if (items.length==0)
            callback();
        Promise.resolve().then(function(){
                if (self._dbTrunks == null)
                    return storage.fetchPromise('SELECT ID,NAME,NAME_LOWER,`IGNORE` FROM TRUNKS');
                else
                    return self._dbTrunks;
            }).
            then(function(availableTrunks){
                self._dbTrunks = availableTrunks;
                var operations = [];
                var numbers = [];
                var availableTrunkInDb;
                for (var i=0; i < items.length; i++) {
                    availableTrunkInDb = false;
                    for (var c=0; c < availableTrunks.length; c++) {
                        if (availableTrunks[c]['NAME'] ==  items[i]) {
                            availableTrunkInDb = availableTrunks[c];
                            break;
                        }
                    }

                    if (availableTrunkInDb){
                        //@todo check - in old realisation in applet compared getTrunkIgnore() != 1 Why?
                        if (availableTrunkInDb['IGNORE'] == 1) {
                            operations.push({type:'disIgnore',data:{
                                    ID:availableTrunkInDb['ID']
                            }});
                        }
                    } else {
                        operations.push({type:'insert',data:{
                                NAME:items[i],
                                NAME_LOWER:(items[i]||'').toLowerCase(),
                                IGNORE:0
                        }});

                    }
                }
                for (var i=0; i < availableTrunks.length; i++) {
                    availableTrunkInDb = false;
                    for (c=0; c < items.length; c++) {
                        if (availableTrunks[i]['NAME'] ==  items[c]) {
                            availableTrunkInDb = true;
                        }
                    }
                    if (availableTrunks[i]['IGNORE'] == 0 && !availableTrunkInDb) {
                        operations.push({type:'ignore',data:{
                            ID:availableTrunks[i]['ID']
                        }});
                    }
                }
                return self.pushTrunksPromises(operations);
            }).then(callback)



    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/Destinations.js
Ext.define('App.proxy.Destinations', {
    extend: 'App.proxy.AbstractProxy',
    read: function(sql, sqlTotal, operation, callback, scope) {



        var controller = function(users, total) {
            var i, result, destinations = new Array(), reader, id, uid, type, name;

            for( i=0; i < users.length; i++ ) {
                id = users[i]['SOURCE'] +'.'+ users[i]['ID'];
                uid = users[i]['ID']
                type = users[i]['SOURCE']
                name = users[i]['NAME'];
                destinations.push( { id: id, uid: uid , type: type, name: name } );
            }

            total = parseInt(total);

            reader = this.getReader();
            result = reader.read(destinations);
            result.total = total;
            result.count = destinations.length;






            operation.setCompleted();
            operation.setSuccessful();

            Ext.apply(operation, { resultSet: result } );
            Ext.callback(callback, scope || this, [operation]);
        }

        // Batch
        this.getStorage().batch(
            [App.storage.Storage.METHOD_FETCH, sql],
            [App.storage.Storage.METHOD_FETCHONE, sqlTotal],
            controller,
            this
        );
	},
    getFilterConditions: function(filters) {
        var filter, conditions = new Array(), statments = new Array(), i;

        for( i=0; i < filters.length; i++ ) {
            filter = filters[i];

            switch( filter.property ) {
                case 'name':
                    conditions.push(this.getFilterNameCondition(filter.value));
                break;
            }
        }

        for( i=0; i < conditions.length; i++ ) {
            if( conditions[i] ) {
                statments.push( "(" + conditions[i] + ")" );
            }
        }

        if( statments.length > 0 ) {
            return statments.join(" AND ");
        }

        return null;
    },
    getFilterNameCondition: function(value) {
        var names = value.toLowerCase().replace(/\s\s+/g, ' ').trim().split(' ');
        names.forEach(function(val,i,names){
            var perc = val.indexOf('%')>-1?"":"%";
            names[i] = this.escape(perc + val + perc);
        },this);

        return "`SEARCH` LIKE "+ names.join(" AND `SEARCH` LIKE  ") +"";
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/DestinationsExt.js
Ext.define('App.proxy.DestinationsExt', {
    extend: 'App.proxy.Destinations',
    alias: 'proxy.destinationsExt',
    read: function(operation, callback, scope) {
        var limit, start, sql, sqlTotal;
        var condition = this.getFilterConditions(operation.filters);
        var seeAll = '';
        if(!User.canSeeAll) {
            seeAll = 'WHERE `number` IS NULL';
            if(condition) {
                condition += ' AND `number` IS NULL';
            } else {
                condition = '`number` IS NULL';
            }
        }

        limit = operation.limit;
        start = operation.start;

        if (condition) {
            sql = 'SELECT `ID`, `NAME`, `SOURCE` FROM `DESTINATIONS_EXT` WHERE '+ condition +' ORDER BY `SOURCE` ASC, `NAME_LOWER` ASC LIMIT '+ start +', '+ limit +'';
        } else {
            sql = 'SELECT `ID`, `NAME`, `SOURCE` FROM `DESTINATIONS_EXT` '+ seeAll +' ORDER BY `SOURCE` ASC, `NAME_LOWER` ASC LIMIT '+ start +', '+ limit +'';
        }

        if (condition) {
            sqlTotal = 'SELECT COUNT(*) AS `count` FROM `DESTINATIONS_EXT` WHERE '+ condition +'';
        } else {
            sqlTotal = 'SELECT COUNT(*) AS `count` FROM `DESTINATIONS_EXT` '+ seeAll;
        }

        this.callParent([sql, sqlTotal, operation, callback, scope]);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/DestinationsInt.js
Ext.define('App.proxy.DestinationsInt', {
    extend: 'App.proxy.Destinations',
    alias: 'proxy.destinationsInt',
    read: function(operation, callback, scope) {
        var limit, start, sql, sqlTotal;
        var condition = this.getFilterConditions(operation.filters);

        limit = operation.limit;
        start = operation.start;

        if (condition) {
            sql = 'SELECT `ID`, `NAME`, `SOURCE` FROM `DESTINATIONS_INT` WHERE '+ condition +' ORDER BY `SOURCE` ASC, `NAME_LOWER` ASC LIMIT '+ start +', '+ limit +'';
        } else {
            sql = 'SELECT `ID`, `NAME`, `SOURCE` FROM `DESTINATIONS_INT` ORDER BY `SOURCE` ASC, `NAME_LOWER` ASC LIMIT '+ start +', '+ limit +'';
        }

        if (condition) {
            sqlTotal = 'SELECT COUNT(*) AS `count` FROM `DESTINATIONS_INT` WHERE '+ condition +'';
        } else {
            sqlTotal = 'SELECT COUNT(*) AS `count` FROM `DESTINATIONS_INT`';
        }

        this.callParent([sql, sqlTotal, operation, callback, scope]);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/SimpleEvents.js
Ext.define('App.proxy.SimpleEvents', {
    extend: 'App.proxy.AbstractEvents',
    alias: 'proxy.simpleEvents',
    getTargetStore: function() {
        if (!this.targetStore) {
            this.targetStore = Ext.data.StoreManager.lookup('SimpleEvents');
        }
        
        return this.targetStore;
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/GroupedEvents.js
Ext.define('App.proxy.GroupedEvents', {
    extend: 'App.proxy.AbstractEvents',
    alias: 'proxy.groupedEvents',
    getTargetStore: function() {
        if (!this.targetStore) {
            this.targetStore = Ext.data.StoreManager.lookup('GroupedEvents');
        }
        
        return this.targetStore;
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/Filters.js
Ext.define('App.proxy.Filters', {
	extend: 'App.proxy.AbstractProxy',
	alias: 'proxy.filters',
	constructor	: function(config) {
		this.callParent(arguments);
	},
	read: function(operation, callback, scope) {
        var sql;

        sql = "SELECT * FROM `FILTERS` ORDER BY `NAME` ASC";

        // Prepare callback
        var controller = function(records) {
            var i, result, filters, reader;

            filters = new Array();

            for( i=0; i < records.length; i++ ) {
                filters.push( { id: records[i]['ID'], name: records[i]['NAME'], state: records[i]['STATE'] } );
            }

            reader = this.getReader();
            result = reader.read(filters);

            operation.setCompleted();
            operation.setSuccessful();

            Ext.apply(operation, { resultSet: result } );
            Ext.callback(callback, scope || this, [operation]);
        }

        // Batch
        App.storage.Storage.batch(
            [App.storage.Storage.METHOD_FETCH, sql],
            controller,
            this
        );
	},
	readCount: function() {
        var s = App.storage.Storage;
        var c = s.featchOne("SELECT COUNT(*) FROM `FILTERS`");

        return c;
	},
    create: function(operation, callback, scope) {
        var sql, i, name, state, keys, key, records, batches, record, result = new Array();

        var controller = function() {
            for( i=0; i < arguments.length; i++ ) {
                keys = arguments[i]['keys'];
                key = keys.pop();

                operation.records[i].set('id', key);
            }

            operation.setCompleted();
            operation.setSuccessful();

            Ext.callback(callback, scope || this, [operation]);
        }

        records = operation.records;
        batches = new Array();

        for( i=0; i < records.length; i++ ) {
            name = records[i].get('name');
            name = this.escape(name);
            state = records[i].get('state');
            state = this.escape(state);
            sql = "INSERT INTO `FILTERS` (`ID`, `NAME`, `STATE`) VALUES (NULL, "+ name +", "+ state +")";

            batches.push([App.storage.Storage.METHOD_EXECUTE, sql]);
        }

        batches.push(controller);
        batches.push(this);

        // Batch

        App.storage.Storage.batch.apply(App.storage.Storage, batches);
    },
    update: function(operation, callback, scope) {
        throw Error("Not implemented");
    },
    destroy: function(operation, callback, scope) {
        throw Error("Not implemented");
    },
    truncate: function() {
        var s = App.storage.Storage;
        s.execute("TRUNCATE TABLE `FILTERS`");

        return true;
    },
    sync: function(records) {
        var s = App.storage.Storage, q, i, id, name, state;

        for( i=0; i < records.length; i++ ) {
            id = records[i]['id'];
            name = this.escape(records[i]['name']);
            state = this.escape(records[i]['state']);

            q = "INSERT INTO `FILTERS` (`ID`, `NAME`, `STATE`) VALUES ("+ id +", "+ name +", "+ state +")"
            s.execute(q);
        }

        return true;
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/Users.js
Ext.define('App.proxy.Users', {
	extend: 'App.proxy.AbstractProxy',
	alias: 'proxy.users',
	constructor	: function(config) {
		this.callParent(arguments);
	},
	read: function(operation, callback, scope) {


	},
	readCount: function() {
        var s = App.storage.Storage;
        var c = s.featchOne("SELECT COUNT(*) FROM `CDR`.`USERS`");

        return c;
	},

    _insertedUsersIds: [],
    /**
     * Synchronize users to local db (insertUsers applet analog)
     * @param array data Array of objects {id,name,type,number,mobile_number,fax_number,office,home,home_mobile,phone,organization}
     * @param callable callback
     */
    pushUsers: function(users, isFirstTimeSync, callback){
        var self = this,
            esc = self.escape,
            storage = self.getStorage();
        if (users.length==0)
            callback();
        Promise.resolve()
            .then(function(){
                if (storage.proxyGroups._dbGroups == null)
                    return storage.fetchPromise('SELECT ID,UID,NAME,NAME_LOWER,TYPE,`IGNORE` FROM GROUPS');
                else
                    return storage.proxyGroups._dbGroups;
            })
            .then(function(groups){
                storage.proxyGroups._dbGroups = groups;


                var operations = [];
                for (var i=0; i < users.length; i++) {
                    var organizationLower = (users[i].organization||'').toLowerCase();
                    if (organizationLower == '')
                        continue;
                    var presentInDb = false;
                    for (var g=0; g < groups.length; g++) {
                        if (groups[g]['TYPE'] == 2 && organizationLower == groups[g]['NAME_LOWER']){
                            if (groups[g]['IGNORE'] == 1){
                                operations.push({type:'disIgnore',data:{ID:groups[g]['ID']}});
                            }
                            presentInDb = true;
                            break;
                        }
                    }
                    if (!presentInDb) {
                        groups.push({ID:null,UID:'-',NAME:users[i].organization,NAME_LOWER:organizationLower,TYPE:2,IGNORE:0});
                        operations.push({type:'insert',data:{ID:null,UID:'-',NAME:users[i].organization,NAME_LOWER:organizationLower,TYPE:2,IGNORE:0}});
                    }
                }

                return storage.proxyGroups.pushGroupsPromises(operations);
            })
            .then(function(){
                if (isFirstTimeSync){
                    var isNeedToDelete = false;
                    for (var i=0; i < users.length; i++)
                        if (self._insertedUsersIds.indexOf(users[i].id)!==-1){
                            isNeedToDelete = true;
                            break;
                        }
                    if (!isNeedToDelete)
                        return null;
                }
                //Here we delete all users with specified IDs
                var usersIds = [];
                for (var i=0; i < users.length; i++)
                    usersIds.push(users[i].id);
                return storage.executePromise('DELETE FROM USERS WHERE ID IN ('+(usersIds.join(','))+')');
            })
            .then(function(){
                if (storage.proxyGroups._dbGroups == null)
                    return storage.fetchPromise('SELECT ID,UID,NAME,NAME_LOWER,TYPE,`IGNORE` FROM GROUPS');
                else
                    return storage.proxyGroups._dbGroups;
            })
            .then(function(groups){
                storage.proxyGroups._dbGroups = groups;
                //Here we ensured that all groups which have users in db and we can get IDs
                //prepare insert data
                var insertRows = [];
                for (var i=0; i < users.length; i++) {
                    var d = users[i];
                    var organizationLower = (d.organization||'').toLowerCase();
                    if (organizationLower)
                        for (var g=0; g < groups.length; g++)
                            if (groups[g]['TYPE'] == 2 && organizationLower == groups[g]['NAME_LOWER']){
                                d.groupId = groups[g]['ID'];
                                break;
                            }
                    var nameLower = (d.name||'').toLowerCase();
                    var search = nameLower+'|'+d.number+'|'+d.mobile_number
                               +'|'+d.fax_number +'|'+d.office+'|'+d.home
                               +'|'+d.home_mobile +'|'+d.phone;

                    insertRows.push({
                        ID: d.id,
                        GROUP_ID: d.groupId,
                        NAME: d.name,
                        NAME_LOWER: nameLower,
                        NAME_SEARCH: search,
                        'TYPE': d['type'],
                        NUMBER: d.number,
                        MOBILE_NUMBER: d.mobile_number,
                        FAX_NUMBER: d.fax_number,
                        OFFICE_NUMBER: d.office,
                        HOME_NUMBER: d.home,
                        HOME_MOBILE_NUMBER: d.home_mobile,
                        PHONE_NUMBER: d.phone
                    });
                }
                //multiple insert
                return storage.bulkInsertPromise('USERS',insertRows).then(function(){
                    //When update button pressed new entity of users have to be merged with existen in eventsProxy
                    if (storage.proxyEvents._dirrectoryUsers.length>0)
                        for (var i=0;i<insertRows.length;i++){
                            storage.proxyEvents.addUserModel(insertRows[i]);
                        }
                });
            })
            .then(function(){
                for (var i=0; i < users.length; i++)
                    self._insertedUsersIds.push(users[i].id);
            })
            .then(callback)


    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/Groups.js
Ext.define('App.proxy.Groups', {
    extend: 'App.proxy.AbstractProxy',
    alias: 'proxy.groups',
    constructor	: function(config) {
		this.callParent(arguments);
    },
    pushGroupsPromises: function(operations){
        var self = this,
            esc = this.escape,
            storage = this.getStorage(),
            seq = Promise.resolve();
        var inserts = [],updatesIgnore = [],updatesDisIgnore = [],
            deletes = [],updateGroupUsers = [],insertWthUserNumbers = [];
        for (var i=0; i<operations.length; i++){
            switch (operations[i].type){
                case 'insert': inserts.push(operations[i].data);break;
                case 'ignore': updatesIgnore.push(operations[i].data);break;
                case 'disIgnore': updatesDisIgnore.push(operations[i].data);break;
                case 'delete': deletes.push(operations[i].data);break;
                case 'updateGroupUsers': updateGroupUsers.push(operations[i].data);break;
                case 'insertWthUserNumbers': insertWthUserNumbers.push(operations[i].data);break;
            }
        }

        if (inserts.length>0){
            var insertRows = [];
            for (var i=0; i < inserts.length; i++) {
                var d = inserts[i];
                insertRows.push({
                        ID: null,
                        UID: (d['UID']||'-'),
                        NAME: d['NAME'],
                        NAME_LOWER: d['NAME_LOWER'],
                        TYPE: d['TYPE'],
                        IGNORE: d['IGNORE']
                });
            }
            seq = seq.then(function(){
                return storage.bulkInsertPromise('GROUPS',insertRows);
            });
        }
        if (updatesIgnore.length>0){
            var ids = [];
            for (var i=0; i < updatesIgnore.length; i++) {
                if (Ext.Array.indexOf(ids,updatesIgnore[i]['ID'])==-1)
                    ids.push( updatesIgnore[i]['ID'] );
            }
            var updateIgnoreSql = 'UPDATE GROUPS SET `IGNORE` = 1 WHERE ID IN ('+ids.join(',')+')';
            var updateUsersSql = 'UPDATE `USERS` SET `GROUP_ID` = NULL WHERE `GROUP_ID` IN ( '+ids.join(',')+')';
            //
            seq = seq.then(function(){
                return storage.executePromise(updateIgnoreSql).then(function(){
                    return storage.executePromise(updateUsersSql);
                });
            });
        }
        if (updatesDisIgnore.length>0){
            var ids = [];
            for (var i=0; i < updatesDisIgnore.length; i++) {
                if (Ext.Array.indexOf(ids,updatesDisIgnore[i]['ID'])==-1)
                    ids.push( updatesDisIgnore[i]['ID'] );
            }
            var updateDisIgnoreSql = 'UPDATE GROUPS SET `IGNORE` = 0 WHERE ID IN ( '+ids.join(',')+')';
            //
            seq = seq.then(function(){
                return storage.executePromise(updateDisIgnoreSql);
            });
        }
        if (deletes.length>0){
            var ids = [];
            for (var i=0; i < deletes.length; i++) {
                if (Ext.Array.indexOf(ids,deletes[i]['ID'])==-1)
                    ids.push( deletes[i]['ID'] );
            }
            var deleteSql = 'DELETE FROM GROUPS WHERE ID IN ( '+ids.join(',')+')';
            //
            seq = seq.then(function(){
                return storage.executePromise(deleteSql);
            });
        }
        if (updateGroupUsers.length>0){


            var inUsersNumbers,groupId;
            for (var i=0; i < updateGroupUsers.length; i++) {
                inUsersNumbers = updateGroupUsers[i]['numbers'].reduce(function(numbers,n){
                    if (n)
                        return  (numbers? numbers + ',':'')+esc(n);
                    else
                        return  numbers;
                },'');
                groupId = esc(updateGroupUsers[i]['ID']);

                (function(){
                    var updateOldUsersSql = "UPDATE `USERS` SET `GROUP_ID` = NULL WHERE `GROUP_ID` = "+groupId;
                    var updateNewUsersSql = "UPDATE `USERS` SET `GROUP_ID` = "+groupId+" WHERE `NUMBER` IN ("+inUsersNumbers+")";
                    seq = seq.then(function(){
                        return storage.executePromise(updateOldUsersSql).then(function(){
                            return storage.executePromise(updateNewUsersSql);
                        });
                    });
                })();

            }
        }
        if (insertWthUserNumbers.length>0){
            for (var i=0; i < insertWthUserNumbers.length; i++) {
                (function(){
                    var inUsersNumbers = insertWthUserNumbers[i]['numbers'].reduce(function(numbers,n){
                        if (n)
                            return  (numbers? numbers + ',':'')+esc(n);
                        else
                            return  numbers;
                    },'');
                    var d = insertWthUserNumbers[i];
                    seq = seq.then(function(){
                        return storage.bulkInsertPromise('GROUPS',[{
                                ID: null,
                                UID: (d['UID']||'-'),
                                NAME: d['NAME'],
                                NAME_LOWER: d['NAME_LOWER'],
                                TYPE: d['TYPE'],
                                IGNORE: d['IGNORE']
                        }]).then(function(response){
                            var groupId = esc(response.lastInsertId);
                            var updateNewUsersSql = "UPDATE `USERS` SET `GROUP_ID` = "+groupId+" WHERE `NUMBER` IN ("+inUsersNumbers+")";
                            return storage.executePromise(updateNewUsersSql);
                        });
                    });
                })();
            }
        }

        seq = seq.then(function(){


            if (inserts.length || updatesIgnore.length || updatesDisIgnore.length ||
                deletes.length || updateGroupUsers.length || insertWthUserNumbers.length ){
                storage.fetchPromise('SELECT ID,UID,NAME,NAME_LOWER,TYPE,`IGNORE` FROM GROUPS').
                        then(function(availableGroups){
                            self._dbGroups = availableGroups;
                        });

            }
            return;
        });
        return seq;
    },
    _dbGroups:null,
    pushGroups: function(items, callback){
        var self = this,
            esc = self.escape,
            storage = self.getStorage();


        if (items.length==0)
            callback();
        Promise.resolve().then(function(){
                if (self._dbGroups == null)
                    return storage.fetchPromise('SELECT ID,UID,NAME,NAME_LOWER,TYPE,`IGNORE` FROM GROUPS');
                else
                    return self._dbGroups;
            }).
            then(function(availableGroups){
                self._dbGroups = availableGroups;
                var operations = [];
                var numbers = [];
                var availableGroupInDb;
                for (var i=0; i < items.length; i++) {
                    availableGroupInDb = false;
                    for (var c=0; c < availableGroups.length; c++) {
                        if (availableGroups[c]['TYPE'] == 1 && availableGroups[c]['UID'] ==  items[i][0]) {
                            availableGroupInDb = availableGroups[c];
                            break;
                        }
                    }
                    numbers = items[i][2];
                    if (availableGroupInDb){
                        //@todo check - in old realisation in applet compared group.getGroupIgnore() != 1 Why?
                        if (availableGroupInDb['IGNORE'] == 1) {
                            operations.push({type:'disIgnore',data:{
                                    ID:availableGroupInDb['ID']
                            }});
                        }

                        operations.push({type:'updateGroupUsers',data:{
                                ID:availableGroupInDb['ID'],numbers:numbers
                        }});
                    } else {
                        operations.push({type:'insertWthUserNumbers',data:{
                                UID:items[i][0],
                                NAME:items[i][1],
                                NAME_LOWER:(items[i][1]||'').toLowerCase(),
                                TYPE:1,
                                IGNORE:0,
                                numbers:numbers
                        }});

                    }
                }
                for (var i=0; i < availableGroups.length; i++) {
                    availableGroupInDb = false;
                    for (c=0; c < items.length; c++) {
                        if (availableGroups[i]['TYPE'] == 1 && availableGroups[i]['UID'] ==  items[c][0]) {
                            availableGroupInDb = true;
                        }
                    }
                    if (availableGroups[i]['TYPE'] == 1 && availableGroups[i]['IGNORE'] == 0 && !availableGroupInDb) {
                        operations.push({type:'ignore',data:{
                            ID:availableGroups[i]['ID']
                        }});
                    }
                }
                return self.pushGroupsPromises(operations);
            }).then(callback)



    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/Synchronization.js
Ext.define('App.proxy.Synchronization', {
    extend: 'App.proxy.AbstractProxy',
    singleton: true,
    constructor	: function() {
        this.callParent(arguments);
    },
    readBackend: function(callback, scope) {
        scope = scope || this;

        var sql = "SELECT `VALUE` FROM `SETTINGS` WHERE `KEY` = 'BACKEND'";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchOneAsync(sql, controller);
    },
    readAllStatistics: function(callback, scope) {
        scope = scope || this;

        var sql = "SELECT * FROM `EVENTS_STATS` ORDER BY `DATE` ASC";
        var controller = function() {
            callback.apply(scope, arguments);
        };

        this.getStorage().fetchAsync(sql, controller);
    },
    readStatistics: function(minDate, maxDate, callback, scope) {
        scope = scope || this;

        var sql = "SELECT * FROM `EVENTS_STATS` WHERE `DATE` >= '"+ minDate +"' AND `DATE` <= '"+ maxDate +"' ORDER BY `DATE` ASC";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchAsync(sql, controller);
    },
    readStatisticsProper: function(dayFrom, dayTo, callback, scope) {
        scope = scope || this;

        var sql = "SELECT `DAY`, `COMPLETE` FROM `EVENTS_STATS` WHERE `DAY` >= "+ dayFrom +" AND `DAY` <= "+ dayTo +" ORDER BY `DAY` ASC";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchAsync(sql, controller);
    },
    readLastStatisticsRow: function(callback, scope) {
        scope = scope || this;

        var sql = "SELECT * FROM `EVENTS_STATS` WHERE `MAX_ID` > 0 and `MIN_ID` > 0 ORDER BY `DATE` DESC LIMIT 1";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchRowAsync(sql, controller);
    },
    updateBackend: function(backend, callback, scope) {
        scope = scope || this;

        var sqlTruncateEvents = "DELETE FROM `EVENTS`";
        var sqlTruncateStatistics = "DELETE FROM `EVENTS_STATS`";
        var sqlUpdateBackend = "UPDATE `SETTINGS` SET `VALUE` = "+ this.escape(backend) +" WHERE `KEY` = 'BACKEND'";
        var sqlVacuum = "VACUUM";
        var controller = function() {
            callback.apply(scope, arguments);
        }
        Promise.resolve().
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlTruncateEvents])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlTruncateStatistics])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlUpdateBackend])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlVacuum])).
            then(controller);
    },
    getUsersSettings: function(callback, scope) {
        var sql = "SELECT `VALUE`, `KEY` FROM `SETTINGS` WHERE `KEY` = 'LAST_USR_SYNC' OR `KEY` = 'LAST_USR_SYNC_PART'";
        var controller = function() {
            callback.apply(scope, arguments);
        }
        this.getStorage().fetchAsync(sql, controller);
    },
    getUsersSettingsLastUpdated: function(callback, scope) {
        var sql = "SELECT `VALUE` FROM `SETTINGS` WHERE `KEY` = 'LAST_USR_SYNC'";
        var controller = function() {
            callback.apply(scope, arguments);
        }
        this.getStorage().fetchOneAsync(sql, controller);
    },
    getUsersIdentifiers: function(callback, scope) {
        var sql = "SELECT `ID` FROM `USERS` WHERE `TYPE` = 1";
        var controller = function(rows) {
            var result = new Array(rows.length);
            for (var i=0; i < rows.length; i++) {
                result[i] = rows[i]["ID"];
            }

            callback.call(scope, result);
        }
        this.getStorage().fetchAsync(sql, controller);
    },
    removeUsers: function(ids,callback, scope) {
        var sequence = ids.join(", ");
        var sqlUpdateFromUsers = "UPDATE `EVENTS` SET `FROM_USER` = NULL, `FROM_GROUP` = NULL WHERE `FROM_USER` IN ("+ sequence +")";
        var sqlUpdateToUsers = "UPDATE `EVENTS` SET `TO_USER` = NULL, `TO_GROUP` = NULL WHERE `TO_USER` IN ("+ sequence +")";
        var sqlDeleteUsers = "DELETE FROM `USERS` WHERE `ID` IN ("+ sequence +")";
        Promise.resolve().
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlUpdateFromUsers])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlUpdateToUsers])).
            then(Ext.bind(this.getStorage().executePromise,this.getStorage(),[sqlDeleteUsers])).
            then(Ext.bind(callback,scope));
    },
    setUserSettingsPart: function(nextPart, callback) {
        var query = "UPDATE `SETTINGS` SET `VALUE` = '" + nextPart + "' WHERE `KEY` = 'LAST_USR_SYNC_PART'";
        callback = callback || function() {};
        var controller = function() {
            callback.apply(this, arguments);
        }

        this.getStorage().executeAsync(query, controller);
    },
    setUserSettingsLastUpdateDate: function(lastUpdate, callback) {
        var query = "UPDATE `SETTINGS` SET `VALUE` = '" + lastUpdate + "' WHERE `KEY` = 'LAST_USR_SYNC'";
        callback = callback || function() {};
        var controller = function() {
            callback.apply(this, arguments);
        }

        this.getStorage().executeAsync(query, controller);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/Pbxes.js
Ext.define('App.proxy.Pbxes', {
    extend: 'App.proxy.AbstractProxy',
    alias: 'proxy.pbxes',
    read: function(operation, callback, scope) {
        var sql = "SELECT `ID`, `SERIAL`, `NAME` FROM `PBXES` ORDER BY `SERIAL` ASC";
        var controller = function(records) {
            var i, result, pbxes, reader;

            pbxes = new Array();

            for( i=0; i < records.length; i++ ) {
                pbxes.push( { id: records[i]['ID'], serial: records[i]['SERIAL'], name: records[i]['NAME'] } );
            }

            reader = this.getReader();
            result = reader.read(pbxes);

            operation.setCompleted();
            operation.setSuccessful();

            Ext.apply(operation, { resultSet: result } );
            Ext.callback(callback, scope || this, [operation]);
        }

        this.getStorage().batch(
            [App.storage.Storage.METHOD_FETCH, sql],
            controller,
            this
        );
    },
    readCount: function(callback, scope) {
        scope = scope || this;

        var sql = "SELECT COUNT(*) FROM `PBXES`";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchOneAsync(sql, controller);
    },
    pushPbxesPromises: function(operations){
        var self = this,
            esc = this.escape,
            storage = this.getStorage(),
            seq = Promise.resolve();
        var inserts = [],updates = [],updatesIgnore = [],updatesDisIgnore = [];
        for (var i=0; i<operations.length; i++){
            switch (operations[i].type){
                case 'insert': inserts.push(operations[i].data);break;
                case 'update': updates.push(operations[i].data);break;
                case 'ignore': updatesIgnore.push(operations[i].data);break;
                case 'disIgnore': updatesDisIgnore.push(operations[i].data);break;
            }
        }
        if (inserts.length>0){
            var insertSql = 'INSERT INTO PBXES(ID,SERIAL,NAME,NAME_LOWER,`IGNORE`) \n\
                             VALUES ';
            for (var i=0; i < inserts.length; i++) {
                var d = inserts[i];
                insertSql += '(null,'+ esc(d['SERIAL'])+','+ esc(d['NAME'])+','+esc(d['NAME_LOWER'])+','+esc(d['IGNORE'])+') , ';
            }
            insertSql = insertSql.substr(0,insertSql.length-2) + '; ';
            //
            seq = seq.then(function(){
                return storage.executePromise(insertSql);
            });
        }
        if (updates.length>0){
            for (var i=0; i < updates.length; i++) {
                var d = updates[i];
                var updateSql = 'UPDATE PBXES SET NAME = '+ esc(d['NAME'])+', '
                                +' NAME_LOWER = '+esc(d['NAME_LOWER'])
                                +' WHERE ID = '+d['ID'];
                //
                seq = seq.then(Ext.bind(function(updateSql){
                    return storage.executePromise(updateSql);
                },storage,[updateSql]));
            }
        }
        if (updatesIgnore.length>0){
            var ids = [];
            for (var i=0; i < updatesIgnore.length; i++) {
                if (Ext.Array.indexOf(ids,updatesIgnore[i]['ID'])==-1)
                    ids.push( updatesIgnore[i]['ID'] );
            }
            var updateIgnoreSql = 'UPDATE PBXES SET `IGNORE` = 1 WHERE ID IN ('+ids.join(',')+')';
            //
            seq = seq.then(function(){
                return storage.executePromise(updateIgnoreSql);
            });
        }
        if (updatesDisIgnore.length>0){
            var ids = [];
            for (var i=0; i < updatesDisIgnore.length; i++) {
                if (Ext.Array.indexOf(ids,updatesDisIgnore[i]['ID'])==-1)
                    ids.push( updatesDisIgnore[i]['ID'] );
            }
            var updateDisIgnoreSql = 'UPDATE PBXES SET `IGNORE` = 0 WHERE ID IN ( '+ids.join(',')+')';
            //
            seq = seq.then(function(){
                return storage.executePromise(updateDisIgnoreSql);
            });
        }

        seq = seq.then(function(){


            if (inserts.length>0 || updatesIgnore.length>0 || updatesDisIgnore.length>0){
                return storage.fetchPromise('SELECT ID,SERIAL,NAME,NAME_LOWER,`IGNORE` FROM PBXES').
                        then(function(availablePbxes){
                            storage.proxyEvents.setPbxesModel(availablePbxes);
                        });
            }
            return;
        });
        return seq;
    },
    pushPbxes: function(items, callback){
        var self = this,
            esc = self.escape,
            storage = self.getStorage();
        function getPbxName(serial, domain){
            if (serial && domain)
                return domain+' ('+serial+')';
            if (domain)
                return domain;
            return serial;
        }


        if (items.length==0)
            callback();
        storage.fetchPromise('SELECT ID,SERIAL,NAME,NAME_LOWER,`IGNORE` FROM PBXES').
            then(function(availablePbxes){
                var operations = [];
                var numbers = [];
                var availablePbxeInDb;
                for (var i=0; i < items.length; i++) {
                    availablePbxeInDb = false;
                    for (var c=0; c < availablePbxes.length; c++) {
                        if (availablePbxes[c]['SERIAL'] ==  items[i][0]) {
                            availablePbxeInDb = availablePbxes[c];
                            break;
                        }
                    }

                    if (availablePbxeInDb){
                        if (availablePbxeInDb['IGNORE'] == 1) {
                            operations.push({type:'disIgnore',data:{
                                    ID:availablePbxeInDb['ID']
                            }});
                        }
                        if (availablePbxeInDb['NAME'] != getPbxName(items[i][0], items[i][1])) {
                            operations.push({type:'update',data:{
                                    ID:availablePbxeInDb['ID'],
                                    NAME:getPbxName(items[i][0], items[i][1]),
                                    NAME_LOWER:(items[i][1]||'').toLowerCase()
                            }});
                        }
                    } else {
                        operations.push({type:'insert',data:{
                                SERIAL:items[i][0],
                                NAME:getPbxName(items[i][0], items[i][1]),
                                NAME_LOWER:(items[i][1]||'').toLowerCase(),
                                IGNORE:0
                        }});

                    }
                }
                for (var i=0; i < availablePbxes.length; i++) {
                    availablePbxeInDb = false;
                    for (c=0; c < items.length; c++) {
                        if (availablePbxes[i]['SERIAL'] ==  items[c][0]) {
                            availablePbxeInDb = true;
                        }
                    }
                    if (availablePbxes[i]['IGNORE'] == 0 && !availablePbxeInDb) {
                        operations.push({type:'ignore',data:{
                            ID:availablePbxes[i]['ID']
                        }});
                    }
                }
                return self.pushPbxesPromises(operations);
            }).then(callback)



    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/Tags.js
Ext.define('App.proxy.Tags', {
    extend: 'App.proxy.AbstractProxy',
    alias: 'proxy.tags',
    read: function(operation, callback, scope) {
        var sql = "SELECT * FROM `TAGS` ORDER BY `NAME` ASC";
        var controller = function(records) {
            var i, result, tags, reader;

            tags = new Array();

            for( i=0; i < records.length; i++ ) {
                tags.push( { id: records[i]['ID'], name: records[i]['NAME'] } );
            }

            reader = this.getReader();
            result = reader.read(tags);

            operation.setCompleted();
            operation.setSuccessful();

            Ext.apply(operation, { resultSet: result } );
            Ext.callback(callback, scope || this, [operation]);
        }

        this.getStorage().batch(
            [App.storage.Storage.METHOD_FETCH, sql],
            controller,
            this
        );
    },
    readCount: function(callback, scope) {
        scope = scope || this;

        var sql = "SELECT COUNT(*) FROM `TAGS`";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchOneAsync(sql, controller);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/proxy/Events.js
Ext.define('App.proxy.Events', {
    extend: 'App.proxy.AbstractProxy',

    eventsQueue: [],
    _dropIndexRequested: false,
    _dropIndexRequestRecordCount: 499,
    _dirrectoryFetched: false,
    _dirrectoryUsers:[],
    _dirrectoryTruncs:[],
    _dirrectoryAreas:[],
    _dirrectoryTags:[],
    _dirrectoryPbxes: new Map(),
    _dirrectoryUsersMapLocalNUMBER: new Map(),
    _dirrectoryUsersMapRemoteNUMBER: new Map(),
    _dirrectoryUsersMapMOBILE_NUMBER: new Map(),
    _dirrectoryUsersMapFAX_NUMBER: new Map(),
    _dirrectoryUsersMapOFFICE_NUMBER: new Map(),
    _dirrectoryUsersMapHOME_NUMBER: new Map(),
    _dirrectoryUsersMapHOME_MOBILE_NUMBER: new Map(),
    _dirrectoryUsersMapPHONE_NUMBER: new Map(),
    _dirrectoryAreasMap:{},
    _userIds: new Set(),

    /**
     * Synchronize events to the local db
     * @param params {events, minDate, maxDate, minId, maxId}
     * event has fields: id,from,fromChannel,to,toChannel,type,class,direction,date,duration,billsec,cost,tags
     * @param {type} callback
     * @returns {undefined}
     */
    pushEvents: function(params, callback){
        var self = this,
            esc = self.escape,
            storage = self.getStorage(),
            items = params.events,
            minDate = params.minDate,
            maxDate = params.maxDate,
            isFirstPageOfEvents = !self._dirrectoryFetched,
            isLastPageOfEvents = items.length === 0;

        if (isFirstPageOfEvents){
            //First time
            if (items.length >= self._dropIndexRequestRecordCount){
                self._dropIndexRequested = true;
            }
        }
        if (isLastPageOfEvents){
            //Skip dirrectories loading if no events for insert
            self._dirrectoryFetched = true;
        } else if (!isLastPageOfEvents){
            if (self._dirrectoryFetched && self._dirrectoryUsers.length == 0){
                self._dirrectoryFetched = false;
            }
        }

        var externalUsers = [];
        var externalUsersNumbers = new Set();

        this.getDirrectories()
            .then(function(){
                if (self._dropIndexRequested && isFirstPageOfEvents){
                    return storage.dropIndexPromise();
                }
            })
            .then(function(){
                var d, userFrom, userTo, trunk, area, pbx, eventTags, tag;
                var stats = [];
                var statDay = 0,
                    statMinId = 0,
                    statMaxId = 0;
                var seq = Promise.resolve();
                for (var i=0; i<items.length; i++){
                    d = {};
                    // Set ID
                    d['ID'] = parseInt(items[i].id);
                    /**
                     * API returns destType
                     * dest_type = 2 (incoming call from trunk or remote trunk from wms network)
                     * dest_type = 4 (incoming call from local user)
                     * dest_type = 3 (outgoing call to trunk/wms network)
                     * dest_type = 0 (outgoing call to local user)
                     *
                     * calls from the trunk can be local eg
                     * the user is calling from his mobile to a local user (WMS-1452)
                     *
                     * callclass = 5 (outgoing call to emergency number)
                     *
                     * to protect wrong assotiations short numbers with local users we introduce logic with isEmergencyCall
                     * if isEmergencyCall we dont associate c_to with short number of colleagues    (WMS-1093)
                     */

                    var isEmergencyCall = items[i]['class'] == 5;
                    // Set FROM, FROM_USER, FROM_GROUP, TO, TO_USER, TO_GROUP
                    userFrom = self.getUserModelByNumber(items[i].from, false);
                    userTo = self.getUserModelByNumber(items[i].to, isEmergencyCall);

                    var userData = null;
                    var numberFrom = items[i].from.replace('+','');
                    var numberTo = items[i].to.replace('+','');

                    if (!userFrom && !externalUsersNumbers.has(numberFrom)) {
                        externalUsersNumbers.add(numberFrom);
                        userData = self.generateUserData(items[i].from, items[i].fromName);
                    } else if (!userTo && !externalUsersNumbers.has(numberTo)) {
                        externalUsersNumbers.add(numberTo);
                        userData = self.generateUserData(items[i].to, items[i].toName);
                    }

                    if (userData) {
                        self.addExternalUserModel(userData);
                        externalUsers.push(userData);
                    }

                    d['FROM'] = items[i].from;
                    d['FROM_USER'] = userFrom ? userFrom['ID'] : (userData ? userData.id : null);
                    d['FROM_GROUP'] = userFrom?userFrom['GROUP_ID']:null;
                    d['TO'] = items[i].to;
                    d['TO_USER'] = userTo ? userTo['ID'] : (userData ? userData.id : null);
                    d['TO_GROUP'] = userTo?userTo['GROUP_ID']:null;
                    d['FROM_NAME'] = items[i].fromName;
                    d['TO_NAME'] = items[i].toName;
                    // Set TYPE, CLASS, DIRECTION
                    d['TYPE'] = items[i].type;
                    d['CLASS'] = items[i]['class'];
                    d['DIRECTION'] = items[i].direction;
                    // Set DATE
                    d['DATE'] = items[i].date;
                    // Set HOUR, DAY, MONTH, YEAR
                    d['HOUR'] = self.getHour(items[i].date);
                    d['DAY'] = self.getDay(items[i].date);
                    d['MONTH'] = self.getMonth(items[i].date);
                    d['YEAR'] = self.getYear(items[i].date);
                    // Set DURATION, BILL, COST
                    d['DURATION'] = items[i].duration;
                    d['BILL'] = parseInt(items[i].billsec);
                    d['COST'] = items[i].cost || 0;
                    // Set TRUNK
                    if (items[i].direction == 2) {
                        trunk = self.getTrunkModel( items[i].fromChannel );

                        if (trunk != null) {
                            d['TRUNK'] = trunk['ID'];
                        } else {
                            d['TRUNK'] = null;
                        }
                    } else if (items[i].direction == 3) {
                        trunk = self.getTrunkModel( items[i].toChannel );

                        if (trunk != null) {
                            d['TRUNK'] = trunk['ID'];
                        } else {
                            d['TRUNK'] = null;
                        }
                    } else {
                        d['TRUNK'] = null;
                    }

                    // SET PBX commented in applet, so skip here too
                    pbx = self.getPbxModel(items[i].pbx);
                    d['PBX'] = pbx ? pbx['ID'] : null;
                    // Set COUNTRY, COUNTRY_AREA
                    if (items[i].direction == 2) {
                        area = self.getAreaModel(items[i].from);
                        if (area != null) {
                            d['COUNTRY'] = area['COUNTRY_ID'];
                            d['COUNTRY_AREA'] = area['ID'];
                        } else {
                            d['COUNTRY'] = null;
                            d['COUNTRY_AREA'] = null;
                        }
                    } else if (items[i].direction == 3) {
                        area = self.getAreaModel(items[i].to);

                        if (area != null) {
                            d['COUNTRY'] = area['COUNTRY_ID'];
                            d['COUNTRY_AREA'] = area['ID'];
                        } else {
                            d['COUNTRY'] = null;
                            d['COUNTRY_AREA'] = null;
                        }
                    } else {
                        d['COUNTRY'] = null;
                        d['COUNTRY_AREA'] = null;
                    }
                    // Set EVENT_LOCAL - 23, EVENT_INCOMING - 24, EVENT_OUTGOING - 25, EVENT_ANSWERED - 26, EVENT_UNANSWERED - 27
                    if (items[i].direction == 2) {
                        d['EVENT_LOCAL'] = 0;
                        d['EVENT_INCOMING'] = 1;
                        d['EVENT_OUTGOING'] = 0;
                    } else if (items[i].direction == 3) {
                        d['EVENT_LOCAL'] = 0;
                        d['EVENT_INCOMING'] = 0;
                        d['EVENT_OUTGOING'] = 1;
                    } else if (items[i].direction == 4) {
                        d['EVENT_LOCAL'] = 1;
                        d['EVENT_INCOMING'] = 0;
                        d['EVENT_OUTGOING'] = 0;
                    } else {
                        d['EVENT_LOCAL'] = 0;
                        d['EVENT_INCOMING'] = 0;
                        d['EVENT_OUTGOING'] = 0;
                    }

                    if (items[i]['type'] == 3) {
                        d['EVENT_ANSWERED'] = 0;
                        d['EVENT_UNANSWERED'] = 1;
                    } else {
                        if (items[i].billsec > 0) {
                            d['EVENT_ANSWERED'] = 1;
                            d['EVENT_UNANSWERED'] = 0;
                        } else {
                            d['EVENT_ANSWERED'] = 0;
                            d['EVENT_UNANSWERED'] = 1;
                        }
                    }
                    // Set DURATION_LOCAL - 28, DURATION_INCOMING - 29, DURATION_OUTGOING - 30
                    if (items[i].direction == 2) {
                        d['DURATION_LOCAL'] = 0;
                        d['DURATION_INCOMING'] = items[i].duration;
                        d['DURATION_OUTGOING'] = 0;
                    } else if (items[i].direction == 3) {
                        d['DURATION_LOCAL'] = 0;
                        d['DURATION_INCOMING'] = 0;
                        d['DURATION_OUTGOING'] = items[i].duration;
                    } else if (items[i].direction == 4) {
                        d['DURATION_LOCAL'] = items[i].duration;
                        d['DURATION_INCOMING'] = 0;
                        d['DURATION_OUTGOING'] = 0;
                    } else {
                        d['DURATION_LOCAL'] = 0;
                        d['DURATION_INCOMING'] = 0;
                        d['DURATION_OUTGOING'] = 0;
                    }
                    // Set BILL_LOCAL - 31, BILL_INCOMING - 32, BILL_OUTGOING - 33
                    if (items[i].direction == 2) {
                        d['BILL_LOCAL'] = 0;
                        d['BILL_INCOMING'] = items[i].billsec;
                        d['BILL_OUTGOING'] = 0;
                    } else if (items[i].direction == 3) {
                        d['BILL_LOCAL'] = 0;
                        d['BILL_INCOMING'] = 0;
                        d['BILL_OUTGOING'] = items[i].billsec;
                    } else if (items[i].direction == 4) {
                        d['BILL_LOCAL'] = items[i].billsec;
                        d['BILL_INCOMING'] = 0;
                        d['BILL_OUTGOING'] = 0;
                    } else {
                        d['BILL_LOCAL'] = 0;
                        d['BILL_INCOMING'] = 0;
                        d['BILL_OUTGOING'] = 0;
                    }
                    // Set RING - 34
                    d['RING'] = items[i].duration - items[i].billsec;
                    // Set HOUR_OF_DAY - 35
                    var date = new Date((items[i].date || '').replace(' ','T'));
                    d['HOUR_OF_DAY'] = self.getHourOfDay(date);
                    // Set DAY_OF_WEEK - 36
                    d['DAY_OF_WEEK'] = self.getDayOfWeek(date);
                    // Set MONTH_OF_YEAR - 37
                    d['MONTH_OF_YEAR'] = self.getMonthOfYear(date);
                    // Set EVENT_CALL - 38, EVENT_VOICEMAIL - 39, EVENT_FAX - 40
                    if (items[i]['type'] == 1) {
                        d['EVENT_CALL'] = 1;
                        d['EVENT_VOICEMAIL'] = 0;
                        d['EVENT_FAX'] = 0;
                    } else if (items[i]['type'] == 3) {
                        d['EVENT_CALL'] = 0;
                        d['EVENT_VOICEMAIL'] = 1;
                        d['EVENT_FAX'] = 0;
                    } else if (items[i]['type'] == 2) {
                        d['EVENT_CALL'] = 0;
                        d['EVENT_VOICEMAIL'] = 0;
                        d['EVENT_FAX'] = 1;
                    } else {
                        d['EVENT_CALL'] = 0;
                        d['EVENT_VOICEMAIL'] = 0;
                        d['EVENT_FAX'] = 0;
                    }
                    // Set COST_CALL - 41, COST_VOICEMAIL - 42, COST_FAX - 43
                    if (items[i]['type'] == 1) {
                        d['COST_CALL'] = items[i].cost || 0;
                        d['COST_VOICEMAIL'] = 0;
                        d['COST_FAX'] = 0;
                    } else if (items[i]['type'] == 3) {
                        d['COST_CALL'] = 0;
                        d['COST_VOICEMAIL'] = items[i].cost || 0;
                        d['COST_FAX'] = 0;
                    } else if (items[i]['type'] == 2) {
                        d['COST_CALL'] = 0;
                        d['COST_VOICEMAIL'] = 0;
                        d['COST_FAX'] = items[i].cost || 0;
                    } else {
                        d['COST_CALL'] = 0;
                        d['COST_VOICEMAIL'] = 0;
                        d['COST_FAX'] = 0;
                    }
                    // Add tags for those event
                    eventTags = self.parseTags(items[i].tags);
                    if (eventTags.length>0){
                        for (var t=0;t<eventTags.length;t++){
                            tag = self.getTagModel(eventTags[t]);
                            if (!tag) {
                                tag = self.addTagModel(eventTags[t]);
                                seq = seq.then(Ext.bind(function(tagModel){
                                    return storage.bulkInsertPromise('TAGS',[{
                                            ID: null,
                                            NAME: tagModel['NAME']
                                    }]).then(function(result){
                                        tagModel['ID'] = result.lastInsertId;
                                    });
                                },self,[tag]));
                            }
                            if (!tag.eventIds)
                                tag.eventIds = [];
                            tag.eventIds.push(items[i].id);
                        }
                        d['TAGS'] = eventTags.join(', ');
                    } else {
                        d['TAGS'] = null;
                    }

                    d['USERFIELD'] = items[i].userfield;
                    d['FAXDATA'] = items[i].faxdata;

                    self.eventsQueue.push(d);
                    //collect statistics
                    if (statDay == 0) {
                        statDay = d['DAY'];
                        statMinId = d['ID'];
                        statMaxId = d['ID'];
                    } else {
                        if (statDay != d['DAY']) {
                            stats.push({
                                DAY:statDay,
                                MIN_ID:statMinId,
                                MAX_ID:statMaxId
                            });

                            statDay = 0;
                            statMinId = 0;
                            statMaxId = 0;
                        }

                        if (statDay != d['DAY']) {
                            statDay = d['DAY'];
                        }
                        if (d['ID'] < statMinId || statMinId == 0) {
                            statMinId = d['ID'];
                        }
                        if (d['ID'] > statMaxId || statMaxId == 0) {
                            statMaxId = d['ID'];
                        }
                    }

                }//end loop for new events
                //insert last statistic record after loop completed
                stats.push({
                    DAY:statDay,
                    MIN_ID:statMinId,
                    MAX_ID:statMaxId
                });

                seq = seq
                    .then(function(){
                        //Insert events
                        storage.bulkInsertPromise('EVENTS', self.eventsQueue);
                        if (externalUsers.length) {
                            return storage.pushUsers(externalUsers, false);
                        }
                    })
                    .then(function(){
                        //Ensert link between Event and Tag
                        var eventTagsInserts = [];
                        for (var i=0,l=self._dirrectoryTags.length;i<l;i++){
                            if (self._dirrectoryTags[i].eventIds){
                                self._dirrectoryTags[i].eventIds.reduce(function(eventTagsInserts, eventId){
                                    eventTagsInserts.push({EVENT_ID:eventId, TAG_ID: self._dirrectoryTags[i]['ID']});
                                    return eventTagsInserts;
                                },eventTagsInserts);
                            }
                            delete self._dirrectoryTags[i].eventIds;
                        }
                        return storage.bulkInsertPromise('EVENTS_TAGS',eventTagsInserts);
                    })
                    .then(function(){
                        //Get all previous stats
                        return storage.fetchPromise('SELECT ID, DAY ,DATE , MIN_ID , MAX_ID , COMPLETE FROM EVENTS_STATS');
                    })
                    .then(function(dbStats){
                        var statSeq = Promise.resolve();
                        var stat;
                        var needInsert, needUpdate;
                        var i, c, day;

                        var date;

                        //
                        var minDay =  self.getDay(minDate);
                        var maxDay =  self.getDay(maxDate);

                        // dbStats -- fetched from DB stats
                        // Verify that all days present in db
                        // if not we will add with null id and after we simle can decide if null than insert
                        for (day = minDay; day <= maxDay; day++) {

                            needInsert = true;
                            for (c=0; c < dbStats.length; c++) {
                                if (dbStats[c]['DAY'] == day) {
                                    needInsert = false;
                                    break;
                                }
                            }




                            if (needInsert) {
                                var time = new Date( day * 86400 * 1000);
                                date = time.getUTCFullYear()+'-'+sprintf('%02d',time.getUTCMonth()+1)+'-'+ sprintf('%02d',time.getUTCDate());
                                stat = {
                                    ID: null,
                                    MIN_ID: 0,
                                    MAX_ID: 0,
                                    DAY: day,
                                    DATE: date,
                                    COMPLETE:0
                                };




                                dbStats.push(stat);
                            }
                        }

                        // Apply min and max ids
                        // Now if ID is null statistic will inserted with correct min and max id
                        // if not null we just update it
                        for (i=0; i < stats.length; i++) {

                            for (c=0; c < dbStats.length; c++) {
                                if (dbStats[c]['DAY'] == stats[i]['DAY']) {
                                    needUpdate = false;
                                    if (dbStats[c]['MIN_ID'] > stats[i]['MIN_ID'] || dbStats[c]['MIN_ID'] == 0) {
                                        dbStats[c]['MIN_ID'] = stats[i]['MIN_ID'];
                                        needUpdate = true;
                                    }

                                    if (dbStats[c]['MAX_ID'] < stats[i]['MAX_ID'] || dbStats[c]['MAX_ID'] == 0) {
                                        dbStats[c]['MAX_ID'] = stats[i]['MAX_ID'];
                                        needUpdate = true;
                                    }

                                    //updateEventStat
                                    if (needUpdate && dbStats[c]['ID'] != null){
                                        statSeq = statSeq.then(Ext.bind(storage.executePromise,storage,
                                            ['UPDATE `EVENTS_STATS` SET `MAX_ID`='+ esc( dbStats[c]['MAX_ID'] ) + ', '+
                                            ' `MIN_ID` = '+esc( dbStats[c]['MIN_ID'] )+' WHERE `ID` = '+ esc( dbStats[c]['ID'] )]));
                                    } else {
                                        //it will inserted with correct max & min ids
                                    }

                                    break;
                                }
                            }
                        }
                        //insert new one
                        //we are not wait for ID ! because next block will fetch from scratch
                        statSeq = statSeq.then(function(){
                            return storage.bulkInsertPromise('EVENTS_STATS',dbStats.filter(function(statistic){
                                    return statistic['ID'] == null;
                            }));
                        }).then(function(){
                            return storage.fetchPromise('SELECT ID, DAY ,DATE , MIN_ID , MAX_ID , COMPLETE FROM EVENTS_STATS');
                        }).then(function(dbStats){

                            // Set complete to all items, if client is insert an empty statistics.


                            if (isLastPageOfEvents) {
                                //Last fetched events always empty
                                var eventStatIds = [];
                                for (day = minDay; day <= maxDay; day++) {
                                    for (c=0; c < dbStats.length; c++) {
                                        if (dbStats[c]['DAY'] == day) {
                                            eventStatIds.push(esc( dbStats[c]['ID'] ));
                                        }
                                    }
                                }
                                if (eventStatIds.length>0){
                                    return storage.executePromise('UPDATE `EVENTS_STATS` SET `COMPLETE`= 1 WHERE `ID` IN ( '+ eventStatIds.join(',') +' )');
                                }
                            }
                            return;
                        });


                        return statSeq;
                    });
                return seq;
            })
            .then(function(){
                if (self._dropIndexRequested && isLastPageOfEvents){
                    return storage.createIndexPromise()
                        .then(function(){
                            self._dropIndexRequested = false;
                        });
                }
            })
            .then(callback)
            ['catch'](function(e){
                console.error('pushEvents error', self.getStorage()._lockedDbCounter, e);
                callback();
             });
    },
    addTagModel: function(name){
        var tagModel = {NAME: name};
        this._dirrectoryTags.push(tagModel);
        return tagModel;
    },
    getTagModel: function(name){
        return this._dirrectoryTags.find(function (item){return item.NAME === name});
    },
    getAreaModelOrig: function(number){
        var da, plus, prefix;
        if (!number)
            return null;
        if (number.indexOf("+")===0)
            plus = true;
        else
            plus = false;
        if (plus && number.length < 7)
            return null;
        else if (number.length < 6)
            return null;

        for(var i=0,l=this._dirrectoryAreas.length;i<l;i++){
            da = this._dirrectoryAreas[i];

            if ((plus && da['LENGTH'] > number.length - 1) || (!plus && da['LENGTH'] > number.length)) {
                continue;
            }

            if (plus) {
                prefix = number.substring(1, da['LENGTH'] + 1);
            } else {
                prefix = number.substring(0, da['LENGTH']);
            }

            if (prefix == da['NUMBER']) {
                return da;
            }
        }
        return null;
    },
    getAreaModel: function(number){
        var prefix;
        if (!number)
            return null;
        if (typeof number !== 'string')
            return ''+number;
        if (number.indexOf("+")===0)
            number = number.substring(1);
        if (number.length < 6)
            return null;
        for (var length=9;length>=1;length--){
            if (length > number.length) {
                continue;
            }
            prefix = number.substring(0, length);
            if (this._dirrectoryAreasMap[length]!==undefined && this._dirrectoryAreasMap[length][prefix]!==undefined){
                return this._dirrectoryAreas[this._dirrectoryAreasMap[length][prefix]];
            }
        }
        return null;
    },
    getTrunkModel: function(channel){
    		// if trunk name contain space need decode %20 to space
    	    channel = decodeURIComponent(channel);
        var dt, identy;

        for(var i=0,l=this._dirrectoryTruncs.length;i<l;i++){
            identy = "/" + this._dirrectoryTruncs[i]['NAME'];
            if (channel && channel.indexOf(identy)!==-1){
                return this._dirrectoryTruncs[i];
            }
        }
        return null;
    },
    getPbxModel: function(serial){
        return serial && this._dirrectoryPbxes.has(serial) ? this._dirrectoryPbxes.get(serial) :  null;
    },
    getHour: function (dateStr) {
        /* HANDS UP! loss offset between PBX timezone and UTC! */
        var seconds = Date.parse((dateStr + "Z" || '').replace(' ', 'T')) / 1000;

        return isNaN(seconds) ? 0 : parseInt((seconds - (seconds % 3600)) / 3600);
    },
    getDay: function(dateStr){
        //var seconds = Date.parse((dateStr||'').replace(' ','T'))/1000;

        if (navigator.userAgent.indexOf("Firefox") !== -1 && dateStr.indexOf(':') === -1) {
            dateStr = dateStr + ' 00:00';
        }

        var seconds = new Date(dateStr + "Z" || '').getTime() / 1000;
        var result = parseInt( (seconds - (seconds % 86400)) / 86400 ) || 0;

        if (!isNaN(seconds)) {
            return result;
        }
        else {
            return 0;
        }
    },
    getMonth: function(dateStr){
        // YEAR concatenation with month
        return parseInt(dateStr.substring(0, 4)+dateStr.substring(5, 7)) || 0;
    },
    getYear: function(dateStr){
        return parseInt(dateStr.substring(0, 4)) || 0;
    },
    getHourOfDay: function(date){
        return date.getHours();
    },
    getDayOfWeek: function(date){
        return date.getDay();
    },
    getMonthOfYear: function(date){
        return date.getMonth();
    },
    parseTags: function(data){
        var tags = [];
        if (data && data.indexOf('tags:')===0 ){
            var splits = data.substring(5).split(",");
            var tag;
            for (var i=0;i<splits.length;i++) {
                tag = splits[i].trim().toLowerCase();
                if (tag) {
                    tags.push(tag);
                }
            }
        }
        return tags;
    },
    getUserModel: function(number, isEmergencyCall){
        if (!number){
        	return null;
        }

        if (!isEmergencyCall && this._dirrectoryUsersMapLocalNUMBER.has(number)) {
            return this._dirrectoryUsersMapLocalNUMBER.get(number);
        }
        if (this._dirrectoryUsersMapRemoteNUMBER.has(number)) {
            return this._dirrectoryUsersMapRemoteNUMBER.get(number);
        }
        if (this._dirrectoryUsersMapMOBILE_NUMBER.has(number)) {
            return this._dirrectoryUsersMapMOBILE_NUMBER.get(number);
        }
        if (this._dirrectoryUsersMapFAX_NUMBER.has(number)) {
            return this._dirrectoryUsersMapFAX_NUMBER.get(number);
        }
        if (this._dirrectoryUsersMapOFFICE_NUMBER.has(number)) {
            return this._dirrectoryUsersMapOFFICE_NUMBER.get(number);
        }
        if (this._dirrectoryUsersMapHOME_NUMBER.has(number)) {
            return this._dirrectoryUsersMapHOME_NUMBER.get(number);
        }
        if (this._dirrectoryUsersMapHOME_MOBILE_NUMBER.has(number)) {
            return this._dirrectoryUsersMapHOME_MOBILE_NUMBER.get(number);
        }
        if (this._dirrectoryUsersMapPHONE_NUMBER.has(number)) {
            return this._dirrectoryUsersMapPHONE_NUMBER.get(number);
        }
        return null;
    },

    addUserModel: function(model){
        this._dirrectoryUsers.push(model);

        if (model['TYPE']==1){
            if (model['NUMBER']) {
                this._dirrectoryUsersMapLocalNUMBER.set(model['NUMBER'], model);
            }
        } else {
            if (model['NUMBER']) {
                this._dirrectoryUsersMapRemoteNUMBER.set(model['NUMBER'], model);
            }
        }
        if (model['MOBILE_NUMBER']) {
            this._dirrectoryUsersMapMOBILE_NUMBER.set(model['MOBILE_NUMBER'], model);
        }
        if (model['FAX_NUMBER']) {
            this._dirrectoryUsersMapFAX_NUMBER.set(model['FAX_NUMBER'], model);
        }
        if (model['OFFICE_NUMBER']) {
            this._dirrectoryUsersMapOFFICE_NUMBER.set(model['OFFICE_NUMBER'], model);
        }
        if (model['HOME_NUMBER']) {
            this._dirrectoryUsersMapHOME_NUMBER.set(model['HOME_NUMBER'], model);
        }
        if (model['HOME_MOBILE_NUMBER']) {
            this._dirrectoryUsersMapHOME_MOBILE_NUMBER.set(model['HOME_MOBILE_NUMBER'], model);
        }
        if (model['PHONE_NUMBER']) {
            this._dirrectoryUsersMapPHONE_NUMBER.set(model['PHONE_NUMBER'], model);
        }
    },

    setTrunksModel: function(models){
        this._dirrectoryTruncs = models;
    },

    setPbxesModel: function(models){
        var self = this;
        models.forEach(function(item) {
            self._dirrectoryPbxes.set(item.SERIAL, item);
        });
    },

    getDirrectories: function(){
        var self = this,
            storage = this.getStorage(),
            seq = Promise.resolve();
        if (!this._dirrectoryFetched){
            seq = seq
                .then(function(){
                    return storage.fetchPromise('SELECT \n\
                    ID,GROUP_ID,TYPE,NAME,NAME_LOWER,NUMBER,MOBILE_NUMBER,FAX_NUMBER,OFFICE_NUMBER,HOME_NUMBER,HOME_MOBILE_NUMBER,PHONE_NUMBER\n\
                    FROM `USERS` ORDER BY `TYPE` ASC')
                        .then(function(result){
                            for (var i=0;i<result.length;i++){
                                self.addUserModel(result[i]);
                            }
                        });
                })
                .then(function(){
                    return storage.fetchPromise('SELECT ID,NAME FROM `TRUNKS`')
                        .then(function(result){
                            self.setTrunksModel(result);
                        });
                })
                .then(function(){
                    return storage
                        .fetchPromise('SELECT ID,COUNTRY_ID,NUMBER,`LENGTH` FROM `COUNTRIES_AREAS` ORDER BY `LENGTH` DESC')
                        .then(function(result){
                            self._dirrectoryAreas = result;
                            for (var i=0;i<result.length;i++){
                                if (self._dirrectoryAreasMap[result[i]['LENGTH']] === undefined)
                                    self._dirrectoryAreasMap[result[i]['LENGTH']] = {};
                                if (self._dirrectoryAreasMap[result[i]['LENGTH']][result[i]['NUMBER']] === undefined)
                                    self._dirrectoryAreasMap[result[i]['LENGTH']][result[i]['NUMBER']] = i;
                            }
                        });
                })
                .then(function(){
                    return storage.fetchPromise('SELECT ID,NAME FROM `TAGS`').then(function(result){
                        self._dirrectoryTags = result;
                    });
                })
                .then(function(){
                    return storage.fetchPromise('SELECT ID,SERIAL FROM `PBXES`').then(function(result){
                        self.setPbxesModel(result);
                    });
            });
        }

        seq = seq.then(function(){
            self._dirrectoryFetched = true;
            return;
        });
        return seq;
    },
    getUserModelByNumber: function(number, isEmergencyCall) {
        number = number.replace('+', '');

        // trying find user with number with a plus
        var user = this.getUserModel('+' + number, isEmergencyCall);

        if (!user) {
            // trying find user with number without a plus
            user = this.getUserModel(number, isEmergencyCall);
        }

        return user;
    },
    addExternalUserModel: function (user) {
        this.addUserModel({
            ID: user.id,
            GROUP_ID: user.groupId,
            TYPE: user.type,
            NAME: user.name,
            NAME_LOWER: user.name.toLowerCase(),
            NUMBER: user.number,
            MOBILE_NUMBER: user.mobile_number,
            FAX_NUMBER: user.fax_number,
            OFFICE_NUMBER: user.office,
            HOME_NUMBER: user.home,
            HOME_MOBILE_NUMBER: user.home_mobile,
            PHONE_NUMBER: user.phone
        });
    },
    generateUserData: function (number, name) {
        if(!this._userIds.size) {
            for (var i =0; i < this._dirrectoryUsers.length; i++) {
                this._userIds.add(this._dirrectoryUsers[i]['ID']);
            }
        }

        var id = this.generateId();

        while (this._userIds.has(id)) {
            id = this.generateId();
        }

        this._userIds.add(id);

        return {
            id: id,
            name: name,
            phone: number,
            number: '',
            fax_number: '',
            groupId: null,
            home: '',
            home_mobile: '',
            mobile_number: '',
            office: '',
            organization: '',
            type: 2 // external user
        }
    },
    generateId: function () {
        var min = 100000000000;
        var max = 900000000000;
        return Math.floor(Math.random() * (max - min + 1) + min);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/Notification.js
Ext.define('App.view.bootstrap.Notification', {
    extend: 'Ext.Container',
    cls: 'w-boot-dialog',
    floating: true,
    width: 400,
    initComponent: function() {
        this.renderTo = Ext.getBody();
        Ext.getBody().query('.w-boot-dialog').forEach(function(el){
            if (el && el.id && Ext.ComponentManager.get(el.id)){
                Ext.ComponentManager.get(el.id).destroy();
            }
        });
        this.renderTpl = [
            '<div class="w-boot-dialog-tt"><div class="w-boot-dialog-tl"><div class="w-boot-dialog-tr"></div></div></div>',
            '<div class="w-boot-dialog-cl"><div class="w-boot-dialog-cr"><div class="w-boot-dialog-cc">',
                '<div class="w-boot-title">{title}</div>',
                '<div class="w-boot-contents"></div>',
            '</div></div></div>',
            '<div class="w-boot-dialog-bb"><div class="w-boot-dialog-bl"><div class="w-boot-dialog-br"></div></div></div>'
        ];
        this.renderSelectors = {
            titleEl: 'div.w-boot-title',
            formEl: 'div.w-boot-contents'
        }
        this.renderData = {
            title: this.title
        }
        
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.show();
    },
    destroy: function() {
        Ext.EventManager.removeResizeListener(this.align, this);
        this.callParent(arguments);
    },
    show: function() {
        Ext.EventManager.onWindowResize(this.align, this);
        
        this.align();
        this.callParent(arguments);
    },
    hide: function() {
        Ext.EventManager.removeResizeListener(this.align, this);
        
        this.callParent(arguments);
    },
    align: function() {
        var width = Ext.getBody().getWidth();
        var height = Ext.getBody().getHeight();
        var left = parseInt(width / 2) - parseInt(this.getWidth() / 2);
        var top = parseInt(height / 2) - parseInt(this.getHeight() / 2) - parseInt(height * 0.1);
        
        this.setPosition( left, top, false);
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/Sync.js
Ext.define('App.view.bootstrap.Sync', {
    extend: 'App.view.bootstrap.Notification',
    title: '',
    width: 394,
    initComponent: function() {
        this.addEvents(
            'сancelButtonClick'
        );
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        
        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description'
        });
        
        this.progressActiveEl = Ext.create('Ext.container.Container', {
            cls: 'w-boot-progress-active',
            width: 25
        });
        
        this.progressDescriptionEl = Ext.create('Ext.container.Container', {
            cls: 'w-boot-progress-description'
        });
        
        this.progressEl = Ext.create('Ext.container.Container', {
            cls: 'w-boot-progress',
            items: [
                this.progressActiveEl
            ]
        });

        this.cancelButton = Ext.create('Ext.button.Button', {
            text: _t('Cancel'),
            disabled: true
        });

        this.cancelEl = Ext.create('Ext.container.Container', {
            cls: 'w-boot-cancel',
//            hidden: true,
            items: [
                this.cancelButton
            ]
        });

        this.progressContainerEl = Ext.create('Ext.container.Container', {
            xtype: 'container',
            renderTo: this.formEl,
            items: [
                {
                    xtype: 'container',
                    layout: 'hbox',
                    padding: '0 0 0 0',
                    items: [
                        {
                            xtype: 'container',
                            width: 24,
                            cls: 'w-boot-loader'
                        },
                        {
                            xtype: 'container',
                            width: 340,
                            padding: '0 0 0 10',
                            items: [
                                this.progressEl,
                                this.progressDescriptionEl
                            ]
                        }
                    ]
                },
                {
                    xtype: 'container',
                    height: 32,
                    padding: '10 0 0 0',
                    layout: {
                        type: 'vbox',
                        align: 'center'
                    },
                    items: [
                        this.cancelEl
                    ]
                }
            ]
        });
        this.cancelButton.on('click', this.onCancelButtonClick, this);
    },
    setProgress: function(percent) {
        var width = (330 / 100) * percent;
        var animation = {
            to: {
                width: width
            }
        }
        
        this.progressActiveEl.stopAnimation();
        this.progressActiveEl.animate(animation);
    },
    setRelateProgress: function(percent, offset, percentTo) {
        var area = percentTo - offset;
        var point = area / percentTo;
        var total = offset + Math.ceil(percent * point);
        
        if (total > percentTo) {
            total = percentTo;
        }
        
        this.setProgress(total);
    },
    setDescription: function(text) {
        this.progressDescriptionEl.getEl().update(text);
    },
    markUsersSync: function(percent, timeleft) {
        if (!percent) {
            this.setProgress(12);
            this.setDescription(_t('Loading users...'));
            return;
        }

        if (percent > 0) {
            this.setRelateProgress(percent, 12, 44);
        }

        if (timeleft<0) timeleft = 0;
        timeleft = App.utility.NamesFormatter.formatSeconds(Math.round(timeleft));

        this.setDescription(_t('Loading users...') +  sprintf(_t('(remaining ~ %(timeleft)s)'), { timeleft : timeleft }));
    },
    markExtraSync: function() {
        this.setProgress(44);
        this.setDescription(_t('Loading groups, trunks, pbxes...'));
    },
    markBackendSync: function() {
        this.setProgress(49);
        this.setDescription(_t('Loading backend...'));
    },
    markEventsSync: function(percent, timeleft) {
        this.cancelButton.enable();
        if (!percent && !timeleft) {
            this.setRelateProgress(0, 50, 100);
            this.setDescription(_t('Loading events...'));
            return;
        }
        
        if (percent > 0) {
            this.setRelateProgress(percent, 50, 100);
        }
        if (timeleft<0) timeleft = 0;
        timeleft = App.utility.NamesFormatter.formatSeconds(Math.round(timeleft));
        
        this.setDescription(sprintf(_t('Loading events... (remaining ~ %(timeleft)s)'), { timeleft : timeleft }));
    },

    markTerminating: function() {
        this.description = _t('Terminating');
        this.setDescription(this.description);
    },
    markTerminated: function() {
        this.description = _t('Terminated');
        this.setDescription(this.description);
    },
    
    onCancelButtonClick: function(btn) {
        btn.disable();
        this.fireEvent('сancelButtonClick');
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorCritical.js
Ext.define('App.view.bootstrap.ErrorCritical', {
    extend: 'App.view.bootstrap.Notification',
    title: _t('Error'),
    response: '-',
    width: 560,
    afterRender: function() {
        this.callParent(arguments);

        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description',
            padding: '5 0 0 0',
            renderTpl: [
                '<div class="w-boot-critical">{response}</div>',
                '<div>', 
                sprintf('%(criticalErr)s', { criticalErr : _t('Please <a href="javascript:location.reload(true)">reload</a> the page. If the problem persists contact your system administrator.') }),
                '</div>'
            ],
            renderData: {
                response: this.response
            }
        });
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorConnection.js
Ext.define('App.view.bootstrap.ErrorConnection', {
    extend: 'Ext.Container',
    cls: 'w-error-connection',
    hidden: true,
    hideMode: 'display',
    constructor: function() {
        this.addEvents('refresh');
        this.refrId = 0;
        this.callParent(arguments);
    },
    initComponent: function() {
        this.renderTo = Ext.getBody();
        this.renderTpl = [
            //'<span class="message"></span> <a href="#" class="refresh">Try now</a>'
            sprintf('<span class="message"></span> <a href="#" class="refresh">%(tryNow)s</a>', { tryNow : _t('Try now') })
        ];
        this.renderSelectors = {
            messageEl: 'span.message',
            refreshEl: 'a.refresh'
        }
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.getEl().setStyle('z-index', 99000);
        this.refreshEl.on('click', this.onRefreshClick, this);
    },
    onRefreshClick: function() {
        this.onRefreshTimeout(this.refrId);
        this.sen(this.refrId);
        this.refreshEl.hide();
    },
    onRefreshTimeout: function(id) {
        var self = this;

        if (this.terminated || this.refrId != id) {
            return false;
        }

        this.terminated = true;

        setTimeout(function() {
            self.refrCallback.call(self.refrScope);
        }, 2000);
    },
    show: function() {
        Ext.EventManager.onWindowResize(this.align, this);
        
        this.align();
        this.callParent(arguments);
    },
    hide: function() {
        Ext.EventManager.removeResizeListener(this.align, this);

        this.callParent(arguments);
    },
    align: function() {
        this.setWidth(Ext.getBody().getWidth());
        this.setPosition(0, 0, false);
    },
    handle: function(seconds, callback, scope, silent) {
        var self = this;
        var id = ++this.refrId;
        
        this.steps = 0;
        this.terminated = false;
        this.refrSeconds = parseInt(seconds);
        this.refrCallback = callback;
        this.refrScope = scope || this;
        this.refrSilent = silent;

        setTimeout(function() { self.onRefreshTimeout.call(self, id) }, this.refrSeconds * 1000 + 2000);

        if (!this.refrSilent) {
            if (!this.isVisible() || !this.rendered) {
                this.show();
            }

            this.refreshEl.show();
        }

        this.sen(id);
    },
    sen: function(id) {
        if (this.refrId != id) {
            return;
        }

        var self = this;
        var left = this.refrSeconds - this.steps;

        if (left == 0 || this.terminated) {
            if (!this.refrSilent) {
                this.messageEl.update(_t('Not connected to PBX. Reconnecting...'));
            }
            return;
        }

        if (!this.refrSilent) {
            this.messageEl.update(sprintf(_t('Not connected to PBX. Reconnecting in %(seconds)s seconds...'), { seconds: left }));
        }

        this.steps++;

        setTimeout(function() { self.sen.call(self, id); }, 1000);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorConnected.js
Ext.define('App.view.bootstrap.ErrorConnected', {
    extend: 'App.view.bootstrap.Notification',
    title: _t('CDR Database connection problem'),
    afterRender: function() {
        this.callParent(arguments);
        
        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description',
            html: _t('Can not connect to CDR Database. May be it\'s is corrupted.')+ ' ' +
                  _t('Please <a href="javascript:location.reload(true)">reload</a> the page. If the problem persists contact your system administrator.')
        });
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorLocked.js
Ext.define('App.view.bootstrap.ErrorLocked', {
    extend: 'App.view.bootstrap.Notification',
    afterRender: function() {
        this.callParent(arguments);
        
        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description',
            html: '<center>' + sprintf(
                _t('Another %(CDRView)s InstanceIsOpenOnThisPC.'),
                {CDRView:_t('CDR-View')}
            )
                    + '</center>'
        });
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorUnSupportedBrowser.js
Ext.define('App.view.bootstrap.ErrorUnSupportedBrowser', {
    extend: 'App.view.bootstrap.Notification',
    title: sprintf(
            _t('%(CDRView)s does not support your browser'),
            {CDRView:_t('CDR-View')}
           ),
    width: 560,
    constructor: function() {
        this.addEvents('try');
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        
        this.descriptionCt = Ext.create('Ext.container.Container', {
            renderTpl: [
                sprintf('<div class="w-boot-description">%(notification)s</div>', { notification : '' })
            ]
        });
        
        this.browsersCt = Ext.create('Ext.container.Container', {
            layout: 'hbox',
            height: 100,
            items: [
                {
                    xtype: 'container',
                    height: 100,
                    flex: 0.25,
                    items: [
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'img',
                                    src: 'misc/icons/chrome.png'
                                }
                            }
                        },
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'a',
                                    href: 'http://www.google.com/chrome/',
                                    html: 'Google Chrome'
                                }
                            }
                        }
                    ]
                },
                {
                    xtype: 'container',
                    flex: 0.25,
                    items: [
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'img',
                                    src: 'misc/icons/firefox.png'
                                }
                            }
                        },
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'a',
                                    href: 'http://www.mozilla.com/firefox/',
                                    html: 'Firefox 3.6+'
                                }
                            }
                        }
                    ]
                },
                /*{
                    xtype: 'container',
                    height: 100,
                    flex: 0.25,
                    items: [
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'img',
                                    src: 'misc/icons/ie.png'
                                }
                            }
                        },
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'a',
                                    href: 'http://windows.microsoft.com/en-US/internet-explorer/products/ie/home',
                                    html: 'Internet Explorer 7+'
                                }
                            }
                        }
                    ]
                },*/
                {
                    xtype: 'container',
                    height: 100,
                    flex: 0.25,
                    hidden: navigator.platform.indexOf('Win') !==-1,
                    items: [
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'img',
                                    src: 'misc/icons/safari.png'
                                }
                            }
                        },
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'a',
                                    href: 'http://www.apple.com/safari/download/',
                                    html: 'Safari'
                                }
                            }
                        }
                    ]
                }
            ]
        });
        
        this.tryButton = Ext.create('Ext.button.Button', {
            hidden: true,
            align: 'right'
        });
        this.tryButton.on('click', this.onTryButtonClick, this);
        
        this.tryCt = Ext.create('Ext.container.Container', {
            layout: {
                type: 'auto'
            },
            items: [
                this.tryButton
            ]
        });
        
        this.containerCt = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            padding: '5 0 0 0',
            items: [
                this.descriptionCt,
                this.browsersCt,
                this.tryCt
            ]
        });
    },
    onTryButtonClick: function() {
        this.fireEvent('try');
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorNotAllowed.js
Ext.define('App.view.bootstrap.ErrorNotAllowed', {
    extend: 'App.view.bootstrap.Notification',
    title: _t('Error'),
    response: '-',
    width: 560,
    afterRender: function() {
        this.callParent(arguments);

        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description',
            padding: '5 0 0 0',
            renderTpl: [                
                '<div class="w-boot-critical">{reason}</div>',
                '<div>', 
                sprintf('%(criticalErr)s', { criticalErr : _t('Please <a href="javascript:location.reload(true)">reload</a> the page. If the problem persists contact your system administrator.') }),
                '</div>'
            ],
            renderData: {
                reason: this.reason
            }
        });
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorWISNotInstalled.js
Ext.define('App.view.bootstrap.ErrorWISNotInstalled', {
    extend: 'App.view.bootstrap.Notification',
    title: _t('Integration Service'),
    afterRender: function() {
        this.callParent(arguments);
        
        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description',
            html: sprintf(
                    _t('%(IntegrationService)s not available. Please install it using <a class="w-boot-link" href="%(url)s">link</a>.'),
                    {IntegrationService:_t('Integration Service'), url:this.installUrl})
        });
        this.descriptionEl.getEl().first('.w-boot-link').on('click',this.onDownloadStarted);
    },
    onDownloadStarted:function(){
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorWISNotResponding.js
Ext.define('App.view.bootstrap.ErrorWISNotResponding', {
    extend: 'App.view.bootstrap.Notification',
    title: _t('Integration Service'),
    afterRender: function() {
        this.callParent(arguments);
        
        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description',
            html: sprintf(
                    _t('%(IntegrationService)s not responding. Please reinstall it using <a id="w-boot-download-link" class="w-boot-link" href="%(url)s">link</a>.'),
                    {IntegrationService:_t('Integration Service'),url:this.installUrl})
        });
        this.descriptionEl.getEl().first('.w-boot-link').on('click',this.onDownloadStarted);
    },
    onDownloadStarted:function(){
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorDownloadStarted.js
Ext.define('App.view.bootstrap.ErrorDownloadStarted', {
    extend: 'App.view.bootstrap.Notification',
    title: _t('Integration Service'),
    afterRender: function() {
        this.callParent(arguments);
        
        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description',
            html: sprintf(
                _t('Download started. Install %(IntegrationService)s and after that <a class="w-boot-link" onclick="window.location.reload()">refresh</a> the page.'),
                {IntegrationService:_t('Integration Service')}
            )
        });
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorWISNotAppropriateVersion.js
Ext.define('App.view.bootstrap.ErrorWISNotAppropriateVersion', {
    extend: 'App.view.bootstrap.Notification',
    title: _t('Integration Service'),
    afterRender: function() {
        this.callParent(arguments);

        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description',
            html: sprintf(
                    _t('New version available. Please install it using <a class="w-boot-link" href="%(url)s">link</a>.'),
                    {url:this.installUrl})
        });
        this.descriptionEl.getEl().first('.w-boot-link').on('click',this.onDownloadStarted);
    },
    onDownloadStarted:function(){
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/bootstrap/ErrorOSNotSupported.js
Ext.define('App.view.bootstrap.ErrorOSNotSupported', {
    extend: 'App.view.bootstrap.Notification',
    title: _t('Integration Service'),
    afterRender: function() {
        this.callParent(arguments);

        this.descriptionEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            cls: 'w-boot-description',
            html: sprintf(
                _t('Your operating system is not supported by %(CDRView)s.'),
                {CDRView:_t('CDR-View')}
            )
        });
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/storage/QueryConstructor.js
Ext.define('App.storage.QueryConstructor', {
    singleton: true,
    requires: [
        'App.utility.Date'
    ],

    dateUtility: false,

    constructor: function() {
        this.dateUtility = App.utility.Date;
    },

    /*
    * Exapmle object {
    *     filters: {
    *         bill,
    *         cost,
    *         destination,
    *         duration,
    *         period,
    *         trunks,
    *         tags,
    *         types
    *     },
    *     grouping: ['DATE_DAY', 'SERVICE', 'PBX'] or empty array,
    *     sort: {
    *         field: 'FIELD_NAME',
    *         order: 'ASC / DESC'
    *     },
    *     columns: [
    *       {
    *           name: '',
    *           as: ''
    *       }
    *     ],
    *     limit: {
    *         limit: num,
    *         offset: num
    *     }
    * }
    */
    build: function(queryObject) {
        var queryBuilder = new this.QueryBuilder(this);

        var filters = queryObject['filters'];
        for (var key in filters) {
            if (this.decorators.hasOwnProperty(key)) {
                queryBuilder.decorate(key, filters[key]);
            }
        }

        var columns = queryObject['columns'];
        for (var key in columns) {
            if (this.decorators.hasOwnProperty(columns[key].name)) {
                queryBuilder.decorate(columns[key].name, columns[key]);
            }
        }

        var grouping = queryObject['grouping'];
        for (var key in grouping) {
            if (this.decorators.hasOwnProperty(grouping[key].name)) {
                queryBuilder.decorate(grouping[key].name, grouping[key]);
            }
        }

        if (queryObject['limit'] !== undefined) {
            queryBuilder.decorate('limits', queryObject['limit']);
        }

        if (queryObject['sort'] !== undefined) {
            queryBuilder.decorate('sort', queryObject['sort']);
        }

        return queryBuilder.make(queryObject['getTotalRows'], queryObject['getSumRows']);
    },

    /*Query builder. Pattern: Decorator*/
    QueryBuilder: function(scope) {
        var decoratorsList = [];
        var parent = scope;
        var lazyDecorators = [];

        var queryData = {
            where: [],
            fields: [],
            unionFields: [],
            from: ['`EVENTS` as events_main'],
            joins: [],
            order: '',
            grouping: [],
            limit: '',
            assocForSuperSelect: []
        }

        var decorate = function(decoratorName, data) {
            decoratorsList.push({
                name: decoratorName,
                data: data
            });
        }

        var make = function(getTotalRows, getSumRows) {
            for (var i in decoratorsList) {
                if (decoratorsList[i].name === 'GROUP_BY_USER' || decoratorsList[i].name === 'GROUP_BY_CLIENT' || decoratorsList[i].name === 'GROUP_BY_NUMBER' || decoratorsList[i].name === 'GROUP_BY_GROUP'
                    || decoratorsList[i].name === 'GROUP_BY_COMMUNICATION_OF_USERS' || decoratorsList[i].name === 'GROUP_BY_COMMUNICATION_OF_GROUPS') {

                    lazyDecorators.push(decoratorsList[i]);
                    continue;
                }
                queryData = parent.decorators[decoratorsList[i].name].call(parent, decoratorsList[i].data, queryData);
            }

            var resultQuery = '';

            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT " + queryData.fields.join(',');
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (queryData.grouping.length > 0) {
                resultQuery += " GROUP BY " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += " ) ";
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }
            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            for (var i in lazyDecorators) {
                resultQuery = parent.decorators[lazyDecorators[i].name].call(parent, lazyDecorators[i].data, queryData, getTotalRows, getSumRows);
            }
            return resultQuery;
        }

        return {
            decorate: decorate,
            make: make
        };
    },

    /*Decorators*/
    decorators: {
        /*Filter decorators */
        bill: function(data, queryData) {
            var query = [];

            if (data.leftEnabled === true && data.rightEnabled === true && data.leftValue === data.rightValue) {
                query.push(" events_main.bill = " + data.leftValue);
            } else {
                if (data.leftEnabled === true) {
                    query.push(" events_main.bill > " + data.leftValue);
                }
                if (data.rightEnabled === true) {
                    query.push(" events_main.bill < " + data.rightValue + " ");
                }
            }
            if (query.length > 0) {
                query = "(" + query.join(' AND ') + ")";
                queryData.where.push(query);
            }

            return queryData;
        },

        cost: function(data, queryData) {
            var query = [];

            if (data.leftEnabled === true && data.rightEnabled === true && data.leftValue === data.rightValue) {
                query.push(" events_main.cost = " + data.leftValue);
            } else {
                if (data.leftEnabled === true) {
                    query.push(" events_main.cost > " + data.leftValue);
                }
                if (data.rightEnabled === true) {
                    query.push(" events_main.cost < " + data.rightValue + " ");
                }
            }
            if (query.length > 0) {
                query = "(" + query.join(' AND ') + ")";
                queryData.where.push(query);
            }

            return queryData;
        },

        duration: function(data, queryData) {
            var query = [];

            if (data.leftEnabled === true && data.rightEnabled === true && data.leftValue === data.rightValue) {
                query.push(" events_main.duration = " + data.leftValue);
            } else {
                if (data.leftEnabled === true) {
                    query.push(" events_main.duration > " + data.leftValue);
                }
                if (data.rightEnabled === true) {
                    query.push(" events_main.duration < " + data.rightValue + " ");
                }
            }
            if (query.length > 0) {
                query = "(" + query.join(' AND ') + ")";
                queryData.where.push(query);
            }

            return queryData;
        },

        destination: function(data, queryData) {
            var query = [];

            var subFilters = [
                {
                    keyCheck: 'extToIntEnabled',
                    from: 'extToIntFrom',
                    to: 'extToIntTo',
                    direction: 2
                },
                {
                    keyCheck: 'intToExtEnabled',
                    from: 'intToExtFrom',
                    to: 'intToExtTo',
                    direction: 3
                },
                {
                    keyCheck: 'intToIntEnabled',
                    from: 'intToIntFrom',
                    to: 'intToIntTo',
                    direction: 4
                }
            ];

            for (var i in subFilters) {
                if (!data.hasOwnProperty(subFilters[i].keyCheck) || data[subFilters[i].keyCheck] !== true) {
                    continue;
                }
                var rowQuery = [];
                rowQuery.push(
                    " events_main.direction = " + subFilters[i].direction + " "
                );

                if (data.hasOwnProperty(subFilters[i].from) && data[subFilters[i].from].length > 0) {
                    var elementsQueryFrom = [];
                    for (var j in data[subFilters[i].from]) {
                        //Generate from query element
                        switch (parseInt(data[subFilters[i].from][j].type, 10)) {
                            case 1:
                                //custom phone number
                                var customNumber = data[subFilters[i].from][j].name;
                                elementsQueryFrom.push(
                                    " events_main.`from` " +
                                    ( customNumber && customNumber.indexOf('%')>-1? "like" : "=" ) +
                                    " '" + customNumber + "' "
                                );
                                break;
                            case 2:
                                //call class
                                elementsQueryFrom.push(
                                    " events_main.`class` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                            case 3:
                                //group
                                elementsQueryFrom.push(
                                    " events_main.`from_group` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                            case 4:
                                //local user
                                //TODO: optimization: add type of user
                                elementsQueryFrom.push(
                                    " events_main.`from_user` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                            case 5:
                                //phonebook user
                                //TODO: optimization: add type of user
                                elementsQueryFrom.push(
                                    " events_main.`from_user` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                            case 6:
                                //phonebook company
                                elementsQueryFrom.push(
                                    " events_main.`from_group` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                        }
                    }
                    //Push to array subqueries
                    if (elementsQueryFrom.length > 0) {
                        rowQuery.push(
                            " ( " + elementsQueryFrom.join(" OR ") + " ) "
                        );
                    }
                }

                if (data.hasOwnProperty(subFilters[i].to) && data[subFilters[i].to].length > 0) {
                    var elementsQueryTo = [];
                    for (var j in data[subFilters[i].to]) {
                        //Generate to query element
                        switch (parseInt(data[subFilters[i].to][j].type, 10)) {
                            case 1:
                                //custom phone number
                                var customToNumber = data[subFilters[i].to][j].name;
                                elementsQueryTo.push(
                                    " events_main.`to` " +
                                    ( customToNumber && customToNumber.indexOf('%')>-1? "like" : "=" ) +
                                    " '" + customToNumber + "' "
                                );
                                break;
                            case 2:
                                //call class
                                elementsQueryTo.push(
                                    " events_main.`class` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                            case 3:
                                //group
                                elementsQueryTo.push(
                                    " events_main.`to_group` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                            case 4:
                                //local user
                                //TODO: optimization: add type of user
                                elementsQueryTo.push(
                                    " events_main.`to_user` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                            case 5:
                                //phonebook user
                                //TODO: optimization: add type of user
                                elementsQueryTo.push(
                                    " events_main.`to_user` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                            case 6:
                                // phonebook company
                                elementsQueryTo.push(
                                    " events_main.`to_group` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                        }
                    }
                    //Push to array subqueries
                    if (elementsQueryTo.length > 0) {
                        rowQuery.push(
                            " ( " + elementsQueryTo.join(" OR ") + " ) "
                        );
                    }
                }
                query.push(
                    " ( " + rowQuery.join(" AND ") + " ) "
                );
            }

            if (query.length > 0) {
                query = "(" + query.join(' OR ') + ")";
                queryData.where.push(query);
            }

            return queryData;
        },

        period: function(data, queryData) {
            var query = [];

            switch (parseInt(data.type, 10)) {
                case App.utility.Date.TODAY:
                    //today
                    var today = this.dateUtility.getToday();
                    query.push(" events_main.`date` >= '" + today + "' ");
                    break;
                case App.utility.Date.YESTERDAY:
                    //yesterday
                    today = this.dateUtility.getToday();
                    var yesterday = this.dateUtility.getYesterday();
                    query.push(" events_main.`date` >= '" + yesterday + "' AND events_main.`date` <= '" + today + "' ");
                    break;
                case App.utility.Date.WEEK:
                    //This week
                    var thisWeek = this.dateUtility.getThisWeek();
                    query.push(" events_main.`date` >= '" + thisWeek + "' ");
                    break;
                case App.utility.Date.LAST_2_DAYS:
                    //Last 2 days
                    var last2Days = this.dateUtility.getLastNDays(2);
                    query.push(" events_main.`date` >= '" + last2Days + "' ");
                    break;
                case App.utility.Date.LAST_7_DAYS:
                    //Last 7 days
                    var last7Days = this.dateUtility.getLastNDays(7);
                    query.push(" events_main.`date` >= '" + last7Days + "' ");
                    break;
                case App.utility.Date.PREV_WEEK:
                    //Prev week
                    var prevWeek = this.dateUtility.getPrevWeek();
                    thisWeek = this.dateUtility.getThisWeek();
                    query.push(" events_main.`date` >= '" + prevWeek + "' AND events_main.`date` < '" + thisWeek + " 00:00:00'");
                    break;
                case App.utility.Date.LAST_2_WEEKS:              // LAST_2_WEEKS
                    //Last 2 weeks
                    var last2Weeks = this.dateUtility.getPrevWeek();
                    today = this.dateUtility.getToday();
                    query.push(" events_main.`date` >= '" + last2Weeks + "' AND events_main.`date` <= '" + today + " 23:59:59'");
                    break;
                case App.utility.Date.MONTH:
                    //This month
                    var thisMonth = this.dateUtility.getThisMonth();
                    query.push(" events_main.`date` >= '" + thisMonth + "' ");
                    break;
                case App.utility.Date.LAST_30_DAYS:
                    //Last 30 days
                    var last30Days = this.dateUtility.getLastNDays(30);
                    query.push(" events_main.`date` >= '" + last30Days + "' ");
                    break;
                case App.utility.Date.PREV_MONTH:
                    //Prev month
                    thisMonth = this.dateUtility.getThisMonth();
                    var prevMonth = this.dateUtility.getPrevNMonth(1);
                    query.push(" events_main.`date` >= '" + prevMonth + "' AND events_main.`date` < '" + thisMonth + " 00:00:00'");
                    break;
                case App.utility.Date.LAST_60_DAYS:
                    //Last 60 days
                    var last60Days = this.dateUtility.getLastNDays(60);
                    query.push(" events_main.`date` >= '" + last60Days + "' ");
                    break;
                case App.utility.Date.LAST_3_MONTH:
                    //Last 3 months
                    var last3Months = this.dateUtility.getPrevNMonth(3);
                    query.push(" events_main.`date` >= '" + last3Months + "' ");
                    break;
                case App.utility.Date.LAST_6_MONTH:      // LAST_6_MONTH
                    //Last 6 months
                    var last6Months = this.dateUtility.getPrevNMonth(6);
                    query.push(" events_main.`date` >= '" + last6Months + "' ");
                    break;
                case App.utility.Date.LAST_12_MONTH:
                    //Last 12 months
                    var last12Months = this.dateUtility.getPrevNMonth(12);
                    query.push(" events_main.`date` >= '" + last12Months + "' ");
                    break;
                case App.utility.Date.YEAR:
                    //This year
                    var thisYear = this.dateUtility.getThisYear();
                    query.push(" events_main.`date` >= '" + thisYear + "' ");
                    break;
                case App.utility.Date.PREV_YEAR:
                    //Prev year
                    thisYear = this.dateUtility.getThisYear();
                    var prevYear = this.dateUtility.getPrevNYears(1);
                    query.push(" events_main.`date` >= '" + prevYear + "' AND events_main.`date` <= '" + thisYear + " 23:59:59' ");
                    break;
                case App.utility.Date.CUSTOM:
                    //Custom
                    query.push(" events_main.`date` >= '" + data['fromDate'] + " " + data['fromTime'] + "' AND events_main.`date` <= '" + data['toDate'] + " " + data['toTime'] + "'  ");
                    break;
            }

            queryData.where.push("(" + query.join(' AND ') + ")");

            return queryData;
        },

        trunks: function(data, queryData) {
            if (!data.hasOwnProperty('trunks') || data.trunks.length === 0) {
                return queryData;
            }
            var query = [];
            for (var i in data.trunks) {
                query.push(
                    " events_main.trunk = " + data.trunks[i].id +  " "
                );
            }
            queryData.where.push(" ( " + query.join(" OR ") + " ) ");
            return queryData;
        },

        pbxes: function(data, queryData) {
            if (!data.hasOwnProperty('pbxes') || data.pbxes.length === 0) {
                return queryData;
            }
            var query = [];
            for (var i in data.pbxes) {
                query.push(
                    " events_main.pbx = " + data.pbxes[i].id +  " "
                );
            }
            queryData.where.push(" ( " + query.join(" OR ") + " ) ");
            return queryData;
        },

        tags: function(data, queryData) {
            if (!data.hasOwnProperty('tags') || data.tags.length === 0) {
                return queryData;
            }

            // var tagsEventsTable = 'INNER JOIN `EVENTS_TAGS` as events_tags_join ON events_tags_join.event_id = events_main.id';
            // var tagsTable = 'LEFT JOIN `TAGS` as tags_join ON tags_join.id = events_tags_join.tag_id';

//            if (Ext.Array.indexOf(queryData.joins, tagsEventsTable) === -1) {
//                queryData.joins.push(tagsEventsTable);
//            }
//            if (Ext.Array.indexOf(queryData.joins, tagsTable) === -1) {
//                queryData.joins.push(tagsTable);
//            }

            var names = [];
            for (var i in data.tags) {
                names.push(data.tags[i].name);
            }
            queryData.where.push("(SELECT `tag_id` FROM `EVENTS_TAGS` WHERE `EVENTS_TAGS`.`event_id` = events_main.id AND `EVENTS_TAGS`.`tag_id` IN (SELECT `ID` FROM `TAGS` WHERE `NAME` IN ('"+ names.join("', '") +"')) LIMIT 1) IS NOT NULL");
            // queryData.where.push(" ( " + ids.join(", ") + " ) ");
            return queryData;
        },

        types: function(data, queryData) {
            if (data.call === false && data.fax === false && data.voicemail === false) {
                return queryData;
            }
            var query = [];
            if (data.call === true) {
                query.push(" events_main.type = 1 ")
            }
            if (data.fax === true) {
                query.push(" events_main.type = 2 ")
            }
            if (data.voicemail === true) {
                query.push(" events_main.type = 3 ")
            }
            queryData.where.push(" ( " + query.join(" OR ") + " ) ");
            return queryData;
        },

        miss_call_sec_period: function(data, queryData) {
            if (parseInt( data )>0) {
                queryData.where.push(" ( events_main.bill != 0 or events_main.ring > "+ parseInt( data ) +" ) ");
            }
            return queryData;
        },

        /*Columns decorators*/
        COLUMN_ID: function(data, queryData) {
            queryData.fields.push(
                " events_main.`id` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_RING: function(data, queryData) {
            queryData.fields.push(
                " (events_main.`ring`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_DATE: function(data, queryData) {
            queryData.fields.push(
                " events_main.`date` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_DURATION: function(data, queryData) {
            queryData.fields.push(
                " events_main.`duration` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_FROM: function(data, queryData) {
            var tableName = 'LEFT JOIN `USERS` as usr ON usr.id = events_main.from_user';
            if (Ext.Array.indexOf(queryData.joins, tableName) === -1) {
                queryData.joins.push(tableName);
            }

            queryData.fields.push(
                " events_main.`from` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_FROM_USER: function(data, queryData) {
            var tableName = 'LEFT JOIN `USERS` as usr ON usr.id = events_main.from_user';
            if (Ext.Array.indexOf(queryData.joins, tableName) === -1) {
                queryData.joins.push(tableName);
            }

            queryData.fields.push(
                " usr.`name` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_FROM_NAME: function(data, queryData) {

            queryData.fields.push(
                " events_main.`from_name` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TO: function(data, queryData) {

            queryData.fields.push(
                " events_main.`to` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TO_USER: function(data, queryData) {
            var tableName = 'LEFT JOIN `USERS` as usr2 ON usr2.id = events_main.to_user';
            if (Ext.Array.indexOf(queryData.joins, tableName) === -1) {
                queryData.joins.push(tableName);
            }

            queryData.fields.push(
                " usr2.`name` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TO_NAME: function(data, queryData) {

            queryData.fields.push(
                " events_main.`to_name` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COUNTRY: function(data, queryData) {
            var tableName = 'LEFT JOIN `COUNTRIES` as country_join ON country_join.id = events_main.country';
            if (Ext.Array.indexOf(queryData.joins, tableName) === -1) {
                queryData.joins.push(tableName);
            }

            queryData.fields.push(
                " country_join.`name` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COUNTRY_AREA: function(data, queryData) {
            var tableName = 'LEFT JOIN `COUNTRIES_AREAS` as country_area_join ON country_area_join.id = events_main.country_area';
            if (Ext.Array.indexOf(queryData.joins, tableName) === -1) {
                queryData.joins.push(tableName);
            }

            queryData.fields.push(
                " country_area_join.`name` as `" + data.as +  "` "
            );

            return queryData;
        },

        COLUMN_CLASS: function(data, queryData) {

            queryData.fields.push(
                " events_main.`class` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_DEST_TYPE: function(data, queryData) {

            queryData.fields.push(
                " events_main.`class` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_BILL: function(data, queryData) {

            queryData.fields.push(
                " events_main.`bill` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COST: function(data, queryData) {

            queryData.fields.push(
                " events_main.`cost` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COST_CALL: function(data, queryData) {

            queryData.fields.push(
                " events_main.`cost_call` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COST_FAX: function(data, queryData) {

            queryData.fields.push(
                " events_main.`cost_fax` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TRUNK: function(data, queryData) {
            var tableName = 'LEFT JOIN `TRUNKS` as trunks_join ON trunks_join.id = events_main.trunk';
            if (Ext.Array.indexOf(queryData.joins, tableName) === -1) {
                queryData.joins.push(tableName);
            }

            queryData.fields.push(
                " trunks_join.`name` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_PBX: function(data, queryData) {
            var tableName = 'LEFT JOIN `PBXES` as pbxes_join ON pbxes_join.id = events_main.pbx';
            if (Ext.Array.indexOf(queryData.joins, tableName) === -1) {
                queryData.joins.push(tableName);
            }

            queryData.fields.push(
                " pbxes_join.`name` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TAG: function(data, queryData) {
//            var tagsEventsTable = 'LEFT JOIN `EVENTS_TAGS` as events_tags_join ON events_tags_join.event_id = events_main.id';
//            var tagsTable = 'LEFT JOIN `TAGS` as tags_join ON tags_join.id = events_tags_join.tag_id';
//
//            if (Ext.Array.indexOf(queryData.joins, tagsEventsTable) === -1) {
//                queryData.joins.push(tagsEventsTable);
//            }
//            if (Ext.Array.indexOf(queryData.joins, tagsTable) === -1) {
//                queryData.joins.push(tagsTable);
//            }

            queryData.fields.push(
                " events_main.`tags` as `" + data.as + "` "
            );

//            queryData.fields.push(
//                " (SELECT GROUP_CONCAT(`tg`.`name`) FROM PUBLIC.EVENTS_TAGS as `et` INNER JOIN PUBLIC.TAGS as `tg` ON `et`.`tag_id` = `tg`.`id` WHERE `et`.`event_id` = `events_main`.`id`) `" + data.as + "` "
//            );
//            queryData.fields.push(
//                " GROUP_CONCAT(`tags_join`.`name`) `" + data.as + "` "
//            );
//            queryData.grouping.push(
//                "`events_main`.`id`"
//            );

            return queryData;
        },

        COLUMN_SERVICE: function(data, queryData) {

            queryData.fields.push(
                " events_main.`type` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_USERFIELD: function(data, queryData) {

            queryData.fields.push(
                " events_main.`userfield` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_FAXDATA: function(data, queryData) {

            queryData.fields.push(
                " events_main.`faxdata` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_FROM_GROUP: function(data, queryData) {
            var tableName = 'LEFT JOIN `GROUPS` as groups_join ON groups_join.id = events_main.from_group';
            if (Ext.Array.indexOf(queryData.joins, tableName) === -1) {
                queryData.joins.push(tableName);
            }

            queryData.fields.push(
                " groups_join.`name` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TO_GROUP: function(data, queryData) {
            var tableName = 'LEFT JOIN `GROUPS` as groups_join2 ON groups_join2.id = events_main.to_group';
            if (Ext.Array.indexOf(queryData.joins, tableName) === -1) {
                queryData.joins.push(tableName);
            }

            queryData.fields.push(
                " groups_join2.`name` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_HOUR: function(data, queryData) {

            queryData.fields.push(
                " events_main.`hour` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_HOUR_OF_DAY: function(data, queryData) {

            queryData.fields.push(
                " events_main.`hour_of_day` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_DAY: function(data, queryData) {

            queryData.fields.push(
                " events_main.`day` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_DAY_OF_WEEK: function(data, queryData) {

            queryData.fields.push(
                " events_main.`day_of_week` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_WEEK: function(data, queryData) {

            // Attention! in sqlite after dividing the integer field we get INTEGER result!
            // Example select 9 / 6; result 1
            queryData.fields.push(
                " (events_main.`day`-4) / 7 * 7 + 4 as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_MONTH: function(data, queryData) {

            queryData.fields.push(
                " events_main.`month` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_MONTH_OF_YEAR: function(data, queryData) {

            queryData.fields.push(
                " events_main.`month_of_year` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_YEAR: function(data, queryData) {

            queryData.fields.push(
                " events_main.`year` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },


        COLUMN_DIRECTION: function(data, queryData) {

            queryData.fields.push(
                " events_main.`direction` as `" + data.as + "` "
            );

            return queryData;
        },

        /*Custom fields*/
        COLUMN_TOTAL_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " count(events_main.id) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_LOCAL_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.event_local) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_LOCAL_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.event_local) * 100 / count(events_main.id) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_INCOMING_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.event_incoming) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_INCOMING_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.event_incoming) * 100 / count(events_main.id) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_OUTGOING_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.event_outgoing) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_OUTGOING_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.event_outgoing) * 100 / count(events_main.id) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_ANSWERED_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.event_answered) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_ANSWERED_WITHIN_XX_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(case when events_main.ring < "+User.sla_period+" then events_main.event_answered end) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_ANSWERED_OVER_XX_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(case when events_main.ring >= "+User.sla_period+" then events_main.event_answered end) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_ANSWERED_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.event_answered) * 100 / count(events_main.id) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_NOT_ANSWERED_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.event_unanswered) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_NOT_ANSWERED_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.event_unanswered) * 100 / count(events_main.id) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_DURATION: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.duration) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_DURATION: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.duration),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_LOCAL_DURATION: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.duration_local) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_LOCAL_DURATION: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.duration_local),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_INCOMING_DURATION: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.duration_incoming) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_INCOMING_DURATION: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.duration_incoming),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_OUTGOING_DURATION: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.duration_outgoing) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_OUTGOING_DURATION: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.duration_outgoing),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_RING: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.ring) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_RING: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.ring),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },


        COLUMN_TOTAL_BILL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.bill) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_BILL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.bill),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_LOCAL_BILL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.bill_local) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_LOCAL_BILL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.bill_local),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_INCOMING_BILL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.bill_incoming) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_INCOMING_BILL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.bill_incoming),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_OUTGOING_BILL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.bill_outgoing) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_OUTGOING_BILL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.bill_outgoing),2) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_COST: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.cost) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_COST: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.cost),2) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_COST_CALL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`cost_call`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_COST_CALL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.`cost_call`),2) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_COST_FAX: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`cost_fax`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_COST_FAX: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.`cost_fax`),2) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_EVENTS_CALL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`event_call`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_EVENTS_VOICEMAIL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`event_voicemail`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_EVENTS_FAX: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`event_fax`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },


        /*Limit decorator*/
        limits: function(data, queryData) {
            queryData.limit = " LIMIT " + data.offset + ", " + data.limit + " ";
            return queryData;
        },

        /*Grouping decorators */
        GROUP_BY_CUSTOM_EVENTS_FIELD: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_HOUR: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`hour` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_HOUR_OF_DAY: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`hour_of_day` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_DAY: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`day` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_DAY_OF_WEEK: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`day_of_week` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_WEEK: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " (events_main.`day`-4) / 7 * 7 + 4 as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_MONTH: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`month` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_MONTH_OF_YEAR: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`month_of_year` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_YEAR: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`year` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_SERVICE: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(events_main.`type`,'' ) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_DIRECTION: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(events_main.`direction`,'' ) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_TRUNK: function(data, queryData) {
            var tableName = 'LEFT JOIN `TRUNKS` as sys_trunks ON sys_trunks.id = events_main.`trunk`';
            queryData.joins.push(tableName);

            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(events_main.`trunk`,'' ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull(sys_trunks.`name`,'' ) as `" + data.as + "_NAME` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");
            queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");

            return queryData;
        },

        GROUP_BY_PBX: function(data, queryData) {
            var tableName = 'LEFT JOIN `PBXES` as sys_pbxes ON sys_pbxes.id = events_main.`pbx`';
            queryData.joins.push(tableName);

            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(events_main.`pbx`,'' ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull(sys_pbxes.`name`,'' ) as `" + data.as + "_NAME` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");
            queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");

            return queryData;
        },

        GROUP_BY_TAG: function(data, queryData) {
            queryData.joins.push('LEFT JOIN `EVENTS_TAGS` as sys_events_tags ON sys_events_tags.event_id = events_main.id');
            queryData.joins.push('LEFT JOIN `TAGS` as sys_tags ON sys_tags.id = sys_events_tags.tag_id');

            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                "  ifnull( sys_tags.`id`,'' ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull( sys_tags.`name`,'' ) as `" + data.as + "_NAME` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");
            queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");

            return queryData;
        },

        GROUP_BY_COUNTRY: function(data, queryData) {
            var tableName = 'LEFT JOIN `COUNTRIES` as sys_country ON sys_country.id = events_main.country';
            queryData.joins.push(tableName);

            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(events_main.`country`,'' ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull(sys_country.`name`,'' ) as `" + data.as + "_NAME` "
            );

            queryData.assocForSuperSelect.push("`" + data.as + "`");
            queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");

            return queryData;
        },

        GROUP_BY_CLASS: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(events_main.`class`,'' ) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_COMPANY: function(data, queryData) {
            var tableName = "INNER JOIN `GROUPS` as sys_groups_company ON sys_groups_company.`type` = 2 AND (sys_groups_company.id = events_main.`from_group` OR sys_groups_company.id = events_main.`to_group`)";
            queryData.joins.push(tableName);

            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(sys_groups_company.`id`,'' ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull(sys_groups_company.`name`,'' ) as `" + data.as + "_NAME` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            //queryData.where.push("sys_usr.`type` = " + userType);

            return queryData;
        },

        GROUP_BY_USER: function(data, queryData, getTotalRows, getSumRows, userType) {
            if (userType == undefined) {
                userType = 1;
            }

            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as + "`");
                queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");
            }


            queryData.where.push("sys_usr.`type` = " + userType);

            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            resultQuery += getSumRows !== true ? "SELECT events_main.`from_user` as `" + data.as + "`, sys_usr.`name` as `" + data.as + "_NAME` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? ',' : '';
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " INNER JOIN `USERS` as sys_usr ON sys_usr.id = events_main.`from_user` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ";

            resultQuery += getSumRows !== true ? "SELECT events_main.`to_user` as `" + data.as + "`, sys_usr.`name` as `" + data.as + "_NAME` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? ',' : '';
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " INNER JOIN `USERS` as sys_usr ON sys_usr.id = events_main.`to_user` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) ";

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
                if (queryData.grouping.length > 0) {
                    resultQuery += " , " + queryData.grouping.join(',') + " ";
                }
            }

            if (getTotalRows === true) {
                resultQuery += ' ) ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;
        },

        GROUP_BY_CLIENT: function(data, queryData, getTotalRows, getSumRows) {
            return this.decorators.GROUP_BY_USER(data, queryData, getTotalRows, getSumRows, 2);
        },

        GROUP_BY_GROUP: function(data, queryData, getTotalRows, getSumRows) {

            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as + "`");
                queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");
            }

            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            resultQuery += getSumRows !== true ? " SELECT events_main.`from_group` as `" + data.as + "`, sys_groups.`name` as `" + data.as + "_NAME` " : " SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " INNER JOIN `GROUPS` as sys_groups ON sys_groups.id = events_main.`from_group` AND sys_groups.`type` = 1 ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ";

            resultQuery += getSumRows !== true ? " SELECT events_main.`to_group` as `" + data.as + "`, sys_groups.`name` as `" + data.as + "_NAME` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " INNER JOIN `GROUPS` as sys_groups ON sys_groups.id = events_main.`to_group` AND sys_groups.`type` = 1 ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) ";

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }

            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += ' ) ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;
        },
        GROUP_BY_NUMBER: function(data, queryData, getTotalRows, getSumRows) {
            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as + "`");
            }

            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            resultQuery += getSumRows !== true ? " SELECT events_main.`from` as `" + data.as + "` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ";

            resultQuery += getSumRows !== true ? " SELECT events_main.`to` as `" + data.as + "` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) ";

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += ' ) ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;

        },

        GROUP_BY_COMMUNICATION_OF_USERS: function(data, queryData, getTotalRows, getSumRows) {
            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as['from'] + "`");
                queryData.assocForSuperSelect.push("`" + data.as['to'] + "`");
                queryData.assocForSuperSelect.push("`" + data.as['from'] + "_NAME`");
                queryData.assocForSuperSelect.push("`" + data.as['to'] + "_NAME`");
            }
            queryData.where.push("sys_usr1.`type` = 1");
            queryData.where.push("sys_usr2.`type` = 1");


            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            if (getSumRows !== true) {
                resultQuery += " SELECT events_main.`from_user` as `" + data.as['from'] + "`, events_main.`to_user` as `" + data.as['to'] + "`, "
                            + " sys_usr1.name as `" + data.as['from'] + "_NAME`, sys_usr2.name as `" + data.as['to'] + "_NAME` ";
            } else {
                resultQuery += " SELECT ";
            }
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " INNER JOIN `USERS` as sys_usr1 ON sys_usr1.id = events_main.`from_user` ";
            resultQuery += " INNER JOIN `USERS` as sys_usr2 ON sys_usr2.id = events_main.`to_user` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['to'] + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ";

            if (getSumRows !== true) {
                resultQuery += " SELECT events_main.`to_user` as `" + data.as['from'] + "`, events_main.`from_user` as `" + data.as['to'] + "`, "
                            + " sys_usr1.name as `" + data.as['from'] + "_NAME`, sys_usr2.name as `" + data.as['to'] + "_NAME` ";
            } else {
                resultQuery += " SELECT ";
            }
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " INNER JOIN `USERS` as sys_usr1 ON sys_usr1.id = events_main.`to_user` ";
            resultQuery += " INNER JOIN `USERS` as sys_usr2 ON sys_usr2.id = events_main.`from_user` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['to'] + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) ";

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['to'] + "` ";
            }

            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += ' ) ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;
        },

        GROUP_BY_COMMUNICATION_OF_GROUPS: function(data, queryData, getTotalRows, getSumRows) {
            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as['from'] + "`");
                queryData.assocForSuperSelect.push("`" + data.as['to'] + "`");
                queryData.assocForSuperSelect.push("`" + data.as['from'] + "_NAME`");
                queryData.assocForSuperSelect.push("`" + data.as['to'] + "_NAME`");
            }

            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            if (getSumRows !== true) {
                resultQuery += " SELECT events_main.`from_group` as `" + data.as['from'] + "`, events_main.`to_group` as `" + data.as['to'] + "`, ";
                resultQuery += " sys_grp1.name as `" + data.as['from'] + "_NAME`, sys_grp2.name as `" + data.as['to'] + "_NAME` ";
            } else {
                resultQuery += "SELECT ";
            }

            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " INNER JOIN `GROUPS` as sys_grp1 ON sys_grp1.id = events_main.`from_group` ";
            resultQuery += " INNER JOIN `GROUPS` as sys_grp2 ON sys_grp2.id = events_main.`to_group` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['to'] + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ";

            if (getSumRows !== true) {
                resultQuery += " SELECT events_main.`to_group` as `" + data.as['from'] + "`, events_main.`from_group` as `" + data.as['to'] + "`, ";
                resultQuery += " sys_grp1.name as `" + data.as['from'] + "_NAME`, sys_grp2.name as `" + data.as['to'] + "_NAME` ";
            } else {
                resultQuery += "SELECT ";
            }
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " INNER JOIN `GROUPS` as sys_grp1 ON sys_grp1.id = events_main.`to_group` ";
            resultQuery += " INNER JOIN `GROUPS` as sys_grp2 ON sys_grp2.id = events_main.`from_group` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['to'] + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) ";

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['to'] + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += ' ) ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;
        },

        /*Sort decorators */
        sort: function(data, queryData) {
            if (Ext.isArray(data)) {
                var orders = new Array();

                for (var i=0; i < data.length; i++) {
                    if (data[i]['field'] === 'ID') {
                        orders.push("events_main.`ID` " + data[i]['dest'] + " ");
                    } else {
                        orders.push("`" + data[i]['field'] + "` " + data[i]['dest'] +" ");
                    }
                }

                queryData.order = " ORDER BY " + orders.join(', ') +" ";
            } else if (Ext.isObject(data)) {
                queryData.order = " ORDER BY `" + data['field'] + "` " + data['dest'] +" ";
            }

            return queryData;
        }

    }





});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/storage/QueryConstructorClickHouse.js
Ext.define('App.storage.QueryConstructorClickHouse', {
    singleton: true,
    requires: [
        'App.utility.Date'
    ],

    dateUtility: false,
    _tmpTableNumber: 0,

    constructor: function() {
        this.dateUtility = App.utility.Date;

        this.tmpTableName = function() {
            this._tmpTableNumber++;
            return 'tmp_' + this._tmpTableNumber;
        };
    },

    /*
    * Exapmle object {
    *     filters: {
    *         bill,
    *         cost,
    *         destination,
    *         duration,
    *         period,
    *         trunks,
    *         tags,
    *         types
    *     },
    *     grouping: ['DATE_DAY', 'SERVICE', 'PBX'] or empty array,
    *     sort: {
    *         field: 'FIELD_NAME',
    *         order: 'ASC / DESC'
    *     },
    *     columns: [
    *       {
    *           name: '',
    *           as: ''
    *       }
    *     ],
    *     limit: {
    *         limit: num,
    *         offset: num
    *     }
    * }
    */
    build: function(queryObject) {
        var queryBuilder = new this.QueryBuilder(this);

        var filters = queryObject['filters'];
        for (var key in filters) {
            if (this.decorators.hasOwnProperty(key)) {
                queryBuilder.decorate(key, filters[key]);
            }
        }

        var columns = queryObject['columns'];
        for (var key in columns) {
            if (this.decorators.hasOwnProperty(columns[key].name)) {
                queryBuilder.decorate(columns[key].name, columns[key]);
            }
        }

        var grouping = queryObject['grouping'];
        for (var key in grouping) {
            if (this.decorators.hasOwnProperty(grouping[key].name)) {
                queryBuilder.decorate(grouping[key].name, grouping[key]);
            }
        }

        if (queryObject['limit'] !== undefined) {
            queryBuilder.decorate('limits', queryObject['limit']);
        }

        if (queryObject['sort'] !== undefined) {
            queryBuilder.decorate('sort', queryObject['sort']);
        }

        return queryBuilder.make(queryObject['getTotalRows'], queryObject['getSumRows']);
    },

    /*Query builder. Pattern: Decorator*/
    QueryBuilder: function(scope) {
        var decoratorsList = [];
        var parent = scope;
        var lazyDecorators = [];

        var queryData = {
            where: [],
            fields: [],
            unionFields: [],
            from: ['`EVENTS` as events_main'],
            joins: [],
            order: '',
            grouping: [],
            limit: '',
            assocForSuperSelect: []
        }

        var decorate = function(decoratorName, data) {
            decoratorsList.push({
                name: decoratorName,
                data: data
            });
        }

        var make = function(getTotalRows, getSumRows) {
            for (var i in decoratorsList) {
                if (decoratorsList[i].name === 'GROUP_BY_USER' || decoratorsList[i].name === 'GROUP_BY_CLIENT' || decoratorsList[i].name === 'GROUP_BY_NUMBER' || decoratorsList[i].name === 'GROUP_BY_GROUP'
                    || decoratorsList[i].name === 'GROUP_BY_COMMUNICATION_OF_USERS' || decoratorsList[i].name === 'GROUP_BY_COMMUNICATION_OF_GROUPS') {

                    lazyDecorators.push(decoratorsList[i]);
                    continue;
                }
                queryData = parent.decorators[decoratorsList[i].name].call(parent, decoratorsList[i].data, queryData);
            }

            var resultQuery = '';

            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT " + queryData.fields.join(',');
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (queryData.grouping.length > 0) {
                resultQuery += " GROUP BY " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += " ) " + parent.tmpTableName() + ' ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }
            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            for (var i in lazyDecorators) {
                resultQuery = parent.decorators[lazyDecorators[i].name].call(parent, lazyDecorators[i].data, queryData, getTotalRows, getSumRows);
            }
            return resultQuery;
        }

        return {
            decorate: decorate,
            make: make
        };
    },

    /*Decorators*/
    decorators: {
        /*Filter decorators */
        bill: function(data, queryData) {
            var query = [];

            if (data.leftEnabled === true && data.rightEnabled === true && data.leftValue === data.rightValue) {
                query.push(" events_main.BILL = " + data.leftValue);
            } else {
                if (data.leftEnabled === true) {
                    query.push(" events_main.BILL > " + data.leftValue);
                }
                if (data.rightEnabled === true) {
                    query.push(" events_main.BILL < " + data.rightValue + " ");
                }
            }
            if (query.length > 0) {
                query = "(" + query.join(' AND ') + ")";
                queryData.where.push(query);
            }

            return queryData;
        },

        cost: function(data, queryData) {
            var query = [];

            if (data.leftEnabled === true && data.rightEnabled === true && data.leftValue === data.rightValue) {
                query.push(" events_main.COST = " + data.leftValue);
            } else {
                if (data.leftEnabled === true) {
                    query.push(" events_main.COST > " + data.leftValue);
                }
                if (data.rightEnabled === true) {
                    query.push(" events_main.COST < " + data.rightValue + " ");
                }
            }
            if (query.length > 0) {
                query = "(" + query.join(' AND ') + ")";
                queryData.where.push(query);
            }

            return queryData;
        },

        duration: function(data, queryData) {
            var query = [];

            if (data.leftEnabled === true && data.rightEnabled === true && data.leftValue === data.rightValue) {
                query.push(" events_main.DURATION = " + data.leftValue);
            } else {
                if (data.leftEnabled === true) {
                    query.push(" events_main.DURATION > " + data.leftValue);
                }
                if (data.rightEnabled === true) {
                    query.push(" events_main.DURATION < " + data.rightValue + " ");
                }
            }
            if (query.length > 0) {
                query = "(" + query.join(' AND ') + ")";
                queryData.where.push(query);
            }

            return queryData;
        },

        destination: function(data, queryData) {
            var query = [];

            var subFilters = [
                {
                    keyCheck: 'extToIntEnabled',
                    from: 'extToIntFrom',
                    to: 'extToIntTo',
                    direction: 2
                },
                {
                    keyCheck: 'intToExtEnabled',
                    from: 'intToExtFrom',
                    to: 'intToExtTo',
                    direction: 3
                },
                {
                    keyCheck: 'intToIntEnabled',
                    from: 'intToIntFrom',
                    to: 'intToIntTo',
                    direction: 4
                }
            ];

            for (var i in subFilters) {
                if (!data.hasOwnProperty(subFilters[i].keyCheck) || data[subFilters[i].keyCheck] !== true) {
                    continue;
                }
                var rowQuery = [];
                rowQuery.push(
                    " events_main.DIRECTION = " + subFilters[i].direction + " "
                );

                if (data.hasOwnProperty(subFilters[i].from) && data[subFilters[i].from].length > 0) {
                    var elementsQueryFrom = [];
                    for (var j in data[subFilters[i].from]) {
                        //Generate from query element
                        switch (parseInt(data[subFilters[i].from][j].type, 10)) {
                            case 1:
                                //custom phone number
                                var customNumber = data[subFilters[i].from][j].name;
                                elementsQueryFrom.push(
                                    " events_main.`FROM` " +
                                    ( customNumber && customNumber.indexOf('%')>-1? "like" : "=" ) +
                                    " '" + customNumber + "' "
                                );
                                break;
                            case 2:
                                //call class
                                elementsQueryFrom.push(
                                    " events_main.`CLASS` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                            case 3:
                                //group
                                elementsQueryFrom.push(
                                    " events_main.`FROM_GROUP` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                            case 4:
                                //local user
                                //TODO: optimization: add type of user
                                elementsQueryFrom.push(
                                    " events_main.`FROM_USER` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                            case 5:
                                //phonebook user
                                //TODO: optimization: add type of user
                                elementsQueryFrom.push(
                                    " events_main.`FROM_USER` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                            case 6:
                                //phonebook company
                                elementsQueryFrom.push(
                                    " events_main.`FROM_GROUP` = " + data[subFilters[i].from][j].uid + " "
                                );
                                break;
                        }
                    }
                    //Push to array subqueries
                    if (elementsQueryFrom.length > 0) {
                        rowQuery.push(
                            " ( " + elementsQueryFrom.join(" OR ") + " ) "
                        );
                    }
                }

                if (data.hasOwnProperty(subFilters[i].to) && data[subFilters[i].to].length > 0) {
                    var elementsQueryTo = [];
                    for (var j in data[subFilters[i].to]) {
                        //Generate to query element
                        switch (parseInt(data[subFilters[i].to][j].type, 10)) {
                            case 1:
                                //custom phone number
                                var customToNumber = data[subFilters[i].to][j].name;
                                elementsQueryTo.push(
                                    " events_main.`TO` " +
                                    ( customToNumber && customToNumber.indexOf('%')>-1? "like" : "=" ) +
                                    " '" + customToNumber + "' "
                                );
                                break;
                            case 2:
                                //call class
                                elementsQueryTo.push(
                                    " events_main.`CLASS` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                            case 3:
                                //group
                                elementsQueryTo.push(
                                    " events_main.`TO_GROUP` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                            case 4:
                                //local user
                                //TODO: optimization: add type of user
                                elementsQueryTo.push(
                                    " events_main.`TO_USER` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                            case 5:
                                //phonebook user
                                //TODO: optimization: add type of user
                                elementsQueryTo.push(
                                    " events_main.`TO_USER` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                            case 6:
                                // phonebook company
                                elementsQueryTo.push(
                                    " events_main.`TO_GROUP` = " + data[subFilters[i].to][j].uid + " "
                                );
                                break;
                        }
                    }
                    //Push to array subqueries
                    if (elementsQueryTo.length > 0) {
                        rowQuery.push(
                            " ( " + elementsQueryTo.join(" OR ") + " ) "
                        );
                    }
                }
                query.push(
                    " ( " + rowQuery.join(" AND ") + " ) "
                );
            }

            if (query.length > 0) {
                query = "(" + query.join(' OR ') + ")";
                queryData.where.push(query);
            }

            return queryData;
        },

        period: function(data, queryData) {
            var query = [];

            switch (parseInt(data.type, 10)) {
                case App.utility.Date.TODAY:
                    //today
                    var today = this.dateUtility.getToday();
                    query.push(" events_main.`DATE` >= '" + today + " 00:00:00' ");
                    break;
                case App.utility.Date.YESTERDAY:
                    //yesterday
                    today = this.dateUtility.getToday();
                    var yesterday = this.dateUtility.getYesterday();
                    query.push(" events_main.`DATE` >= '" + yesterday + " 00:00:00' AND events_main.`DATE` <= '" + today + " 00:00:00' ");
                    break;
                case App.utility.Date.WEEK:
                    //This week
                    var thisWeek = this.dateUtility.getThisWeek();
                    query.push(" events_main.`DATE` >= '" + thisWeek + " 00:00:00' ");
                    break;
                case App.utility.Date.LAST_2_DAYS:
                    //Last 2 days
                    var last2Days = this.dateUtility.getLastNDays(2);
                    query.push(" events_main.`DATE` >= '" + last2Days + " 00:00:00' ");
                    break;
                case App.utility.Date.LAST_7_DAYS:
                    //Last 7 days
                    var last7Days = this.dateUtility.getLastNDays(7);
                    query.push(" events_main.`DATE` >= '" + last7Days + " 00:00:00' ");
                    break;
                case App.utility.Date.PREV_WEEK:
                    //Prev week
                    var prevWeek = this.dateUtility.getPrevWeek();
                    thisWeek = this.dateUtility.getThisWeek();
                    query.push(" events_main.`DATE` >= '" + prevWeek + " 00:00:00' AND events_main.`DATE` < '" + thisWeek + " 00:00:00'");
                    break;
                case App.utility.Date.LAST_2_WEEKS:              // LAST_2_WEEKS
                    //Last 2 weeks
                    var last2Weeks = this.dateUtility.getPrevWeek();
                    today = this.dateUtility.getToday();
                    query.push(" events_main.`DATE` >= '" + last2Weeks + " 00:00:00' AND events_main.`DATE` <= '" + today + " 23:59:59'");
                    break;
                case App.utility.Date.MONTH:
                    //This month
                    var thisMonth = this.dateUtility.getThisMonth();
                    query.push(" events_main.`DATE` >= '" + thisMonth + " 00:00:00' ");
                    break;
                case App.utility.Date.LAST_30_DAYS:
                    //Last 30 days
                    var last30Days = this.dateUtility.getLastNDays(30);
                    query.push(" events_main.`DATE` >= '" + last30Days + " 00:00:00' ");
                    break;
                case App.utility.Date.PREV_MONTH:
                    //Prev month
                    thisMonth = this.dateUtility.getThisMonth();
                    var prevMonth = this.dateUtility.getPrevNMonth(1);
                    query.push(" events_main.`DATE` >= '" + prevMonth + " 00:00:00' AND events_main.`DATE` < '" + thisMonth + " 00:00:00'");
                    break;
                case App.utility.Date.LAST_60_DAYS:
                    //Last 60 days
                    var last60Days = this.dateUtility.getLastNDays(60);
                    query.push(" events_main.`DATE` >= '" + last60Days + " 00:00:00' ");
                    break;
                case App.utility.Date.LAST_3_MONTH:
                    //Last 3 months
                    var last3Months = this.dateUtility.getPrevNMonth(3);
                    query.push(" events_main.`DATE` >= '" + last3Months + " 00:00:00' ");
                    break;
                case App.utility.Date.LAST_6_MONTH:      // LAST_6_MONTH
                    //Last 6 months
                    var last6Months = this.dateUtility.getPrevNMonth(6);
                    query.push(" events_main.`DATE` >= '" + last6Months + " 00:00:00' ");
                    break;
                case App.utility.Date.LAST_12_MONTH:
                    //Last 12 months
                    var last12Months = this.dateUtility.getPrevNMonth(12);
                    query.push(" events_main.`DATE` >= '" + last12Months + " 00:00:00' ");
                    break;
                case App.utility.Date.YEAR:
                    //This year
                    var thisYear = this.dateUtility.getThisYear();
                    query.push(" events_main.`DATE` >= '" + thisYear + " 00:00:00' ");
                    break;
                case App.utility.Date.PREV_YEAR:
                    //Prev year
                    thisYear = this.dateUtility.getThisYear();
                    var prevYear = this.dateUtility.getPrevNYears(1);
                    query.push(" events_main.`DATE` >= '" + prevYear + " 00:00:00' AND events_main.`DATE` <= '" + thisYear + " 23:59:59' ");
                    break;
                case App.utility.Date.CUSTOM:
                    //Custom
                    query.push(" events_main.`DATE` >= '" + data['fromDate'] + " " + data['fromTime'] + "' AND events_main.`DATE` <= '" + data['toDate'] + " " + data['toTime'] + "'  ");
                    break;
            }

            queryData.where.push("(" + query.join(' AND ') + ")");

            return queryData;
        },

        trunks: function(data, queryData) {
            if (!data.hasOwnProperty('trunks') || data.trunks.length === 0) {
                return queryData;
            }
            var query = [];
            for (var i in data.trunks) {
                query.push(
                    " events_main.TRUNK = " + data.trunks[i].id +  " "
                );
            }
            queryData.where.push(" ( " + query.join(" OR ") + " ) ");
            return queryData;
        },

        pbxes: function(data, queryData) {
            if (!data.hasOwnProperty('pbxes') || data.pbxes.length === 0) {
                return queryData;
            }
            var query = [];
            for (var i in data.pbxes) {
                query.push(
                    " events_main.PBX = " + data.pbxes[i].id +  " "
                );
            }
            queryData.where.push(" ( " + query.join(" OR ") + " ) ");
            return queryData;
        },

        tags: function(data, queryData) {
            if (!data.hasOwnProperty('tags') || data.tags.length === 0) {
                return queryData;
            }

            var queryArr = [];
            for (var i in data.tags) {
                queryArr.push('events_main.TAGS_SEARCH LIKE (\'%|' + data.tags[i].name +'|%\')');
            }
            queryData.where.push('(' + queryArr.join(' OR ')+ ')');

            return queryData;
        },

        types: function(data, queryData) {
            if (data.call === false && data.fax === false && data.voicemail === false) {
                return queryData;
            }
            var query = [];
            if (data.call === true) {
                query.push(" events_main.TYPE = 1 ")
            }
            if (data.fax === true) {
                query.push(" events_main.TYPE = 2 ")
            }
            if (data.voicemail === true) {
                query.push(" events_main.TYPE = 3 ")
            }
            queryData.where.push(" ( " + query.join(" OR ") + " ) ");
            return queryData;
        },

        miss_call_sec_period: function(data, queryData) {
            if (parseInt( data )>0) {
                queryData.where.push(" ( events_main.BILL != 0 or events_main.RING > "+ parseInt( data ) +" ) ");
            }
            return queryData;
        },

        /*Columns decorators*/
        COLUMN_ID: function(data, queryData) {
            queryData.fields.push(
                " events_main.`ID` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_RING: function(data, queryData) {
            queryData.fields.push(
                " (events_main.`RING`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_DATE: function(data, queryData) {
            queryData.fields.push(
                " events_main.`DATE` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_DURATION: function(data, queryData) {
            queryData.fields.push(
                " events_main.`DURATION` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_FROM: function(data, queryData) {
            queryData.fields.push(
                " events_main.`FROM` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_FROM_USER: function(data, queryData) {
            queryData.fields.push(
                " events_main.`FROM_NAME` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TO: function(data, queryData) {

            queryData.fields.push(
                " events_main.`TO` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TO_USER: function(data, queryData) {

            queryData.fields.push(
                " events_main.`TO_NAME` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COUNTRY: function(data, queryData) {

            queryData.fields.push(
                " events_main.`COUNTRY_NAME` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COUNTRY_AREA: function(data, queryData) {

            queryData.fields.push(
                " events_main.`COUNTRY_AREA_NAME` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_CLASS: function(data, queryData) {

            queryData.fields.push(
                " events_main.`CLASS` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_DEST_TYPE: function(data, queryData) {

            queryData.fields.push(
                " events_main.`CLASS` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_BILL: function(data, queryData) {

            queryData.fields.push(
                " events_main.`BILL` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COST: function(data, queryData) {

            queryData.fields.push(
                " events_main.`COST` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COST_CALL: function(data, queryData) {

            queryData.fields.push(
                " events_main.`COST_CALL` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_COST_FAX: function(data, queryData) {

            queryData.fields.push(
                " events_main.`COST_FAX` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TRUNK: function(data, queryData) {

            queryData.fields.push(
                " events_main.`TRUNK_NAME` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_PBX: function(data, queryData) {
            queryData.fields.push(
                " events_main.`PBX_NAME` as `" + data.as + "` "
            );

            return queryData;
        },


        COLUMN_TAG: function(data, queryData) {
//            var tagsEventsTable = 'LEFT JOIN `EVENTS_TAGS` as events_tags_join ON events_tags_join.event_id = events_main.id';
//            var tagsTable = 'LEFT JOIN `TAGS` as tags_join ON tags_join.id = events_tags_join.tag_id';
//
//            if (Ext.Array.indexOf(queryData.joins, tagsEventsTable) === -1) {
//                queryData.joins.push(tagsEventsTable);
//            }
//            if (Ext.Array.indexOf(queryData.joins, tagsTable) === -1) {
//                queryData.joins.push(tagsTable);
//            }

            queryData.fields.push(
                " events_main.`TAGS` as `" + data.as + "` "
            );

//            queryData.fields.push(
//                " (SELECT GROUP_CONCAT(`tg`.`name`) FROM PUBLIC.EVENTS_TAGS as `et` INNER JOIN PUBLIC.TAGS as `tg` ON `et`.`tag_id` = `tg`.`id` WHERE `et`.`event_id` = `events_main`.`id`) `" + data.as + "` "
//            );
//            queryData.fields.push(
//                " GROUP_CONCAT(`tags_join`.`name`) `" + data.as + "` "
//            );
//            queryData.grouping.push(
//                "`events_main`.`id`"
//            );

            return queryData;
        },

        COLUMN_SERVICE: function(data, queryData) {

            queryData.fields.push(
                " events_main.`TYPE` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_USERFIELD: function(data, queryData) {

            queryData.fields.push(
                " events_main.`USERFIELD` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_FAXDATA: function(data, queryData) {

            queryData.fields.push(
                " events_main.`FAXDATA` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_FROM_GROUP: function(data, queryData) {

            queryData.fields.push(
                " events_main.`FROM_GROUP_NAME` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TO_GROUP: function(data, queryData) {

            queryData.fields.push(
                " events_main.`TO_GROUP_NAME` as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_HOUR: function(data, queryData) {

            queryData.fields.push(
                " events_main.`HOUR` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_HOUR_OF_DAY: function(data, queryData) {

            queryData.fields.push(
                " events_main.`HOUR_OF_DAY` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_DAY: function(data, queryData) {

            queryData.fields.push(
                " events_main.`DAY` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_DAY_OF_WEEK: function(data, queryData) {

            queryData.fields.push(
                " events_main.`DAY_OF_WEEK` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_WEEK: function(data, queryData) {

            queryData.fields.push(
                " floor((events_main.`DAY`-4) / 7) * 7 + 4 as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_MONTH: function(data, queryData) {

            queryData.fields.push(
                " events_main.`MONTH` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_MONTH_OF_YEAR: function(data, queryData) {

            queryData.fields.push(
                " events_main.`MONTH_OF_YEAR` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_YEAR: function(data, queryData) {

            queryData.fields.push(
                " events_main.`YEAR` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                " `" + data.as + "` "
            );

            return queryData;
        },


        COLUMN_DIRECTION: function(data, queryData) {

            queryData.fields.push(
                " events_main.`DIRECTION` as `" + data.as + "` "
            );

            return queryData;
        },

        /*Custom fields*/
        COLUMN_TOTAL_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " count(events_main.ID) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_LOCAL_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.EVENT_LOCAL) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_LOCAL_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.EVENT_LOCAL) * 100 / count(events_main.ID) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_INCOMING_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.EVENT_INCOMING) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_INCOMING_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.EVENT_INCOMING) * 100 / count(events_main.ID) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_OUTGOING_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.EVENT_OUTGOING) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_OUTGOING_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.EVENT_OUTGOING) * 100 / count(events_main.ID) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_ANSWERED_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.EVENT_ANSWERED) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_ANSWERED_WITHIN_XX_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(case when events_main.RING < "+User.sla_period+" then events_main.EVENT_ANSWERED end) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_ANSWERED_OVER_XX_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(case when events_main.RING >= "+User.sla_period+" then events_main.EVENT_ANSWERED end) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_ANSWERED_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.EVENT_ANSWERED) * 100 / count(events_main.ID) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_NOT_ANSWERED_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.EVENT_UNANSWERED) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_PERCENT_NOT_ANSWERED_EVENTS: function(data, queryData) {

            queryData.fields.push(
                " (SUM(events_main.EVENT_UNANSWERED) * 100 / count(events_main.ID) ) as `" + data.as + "` "
            );

            return queryData;
        },

        COLUMN_TOTAL_DURATION: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.DURATION) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_DURATION: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.DURATION),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_LOCAL_DURATION: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.DURATION_LOCAL) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_LOCAL_DURATION: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.DURATION_LOCAL),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_INCOMING_DURATION: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.DURATION_INCOMING) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_INCOMING_DURATION: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.DURATION_INCOMING),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_OUTGOING_DURATION: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.DURATION_OUTGOING) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_OUTGOING_DURATION: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.DURATION_OUTGOING),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_RING: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.RING) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_RING: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.RING),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },


        COLUMN_TOTAL_BILL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.BILL) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_BILL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.BILL),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_LOCAL_BILL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.BILL_LOCAL) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_LOCAL_BILL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.BILL_LOCAL),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_INCOMING_BILL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.BILL_INCOMING) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_INCOMING_BILL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.BILL_INCOMING),2) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_OUTGOING_BILL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.BILL_OUTGOING) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_OUTGOING_BILL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.BILL_OUTGOING),2) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_COST: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.COST) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_COST: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.COST),2) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_COST_CALL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`COST_CALL`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_COST_CALL: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.`COST_CALL`),2) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_COST_FAX: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`COST_FAX`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_AVG_COST_FAX: function(data, queryData) {

            queryData.fields.push(
                " ROUND(AVG(events_main.`COST_FAX`),2) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_EVENTS_CALL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`EVENT_CALL`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_EVENTS_VOICEMAIL: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`EVENT_VOICEMAIL`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },

        COLUMN_TOTAL_EVENTS_FAX: function(data, queryData) {

            queryData.fields.push(
                " SUM(events_main.`EVENT_FAX`) as `" + data.as + "` "
            );

            queryData.assocForSuperSelect.push(
                "SUM(`" + data.as + "`) as `" + data.as + "`"
            );

            return queryData;
        },


        /*Limit decorator*/
        limits: function(data, queryData) {
            queryData.limit = " LIMIT " + data.offset + ", " + data.limit + " ";
            return queryData;
        },

        /*Grouping decorators */
        GROUP_BY_CUSTOM_EVENTS_FIELD: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_HOUR: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`HOUR` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_HOUR_OF_DAY: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`HOUR_OF_DAY` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_DAY: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`DAY` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_DAY_OF_WEEK: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`DAY_OF_WEEK` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_WEEK: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " floor((events_main.`DAY`-4) / 7) * 7 + 4 as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_MONTH: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`MONTH` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_MONTH_OF_YEAR: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`MONTH_OF_YEAR` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_YEAR: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " events_main.`YEAR` as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_SERVICE: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(events_main.`TYPE`,'' ) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_DIRECTION: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(events_main.`DIRECTION`,'' ) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_TRUNK: function(data, queryData) {
            // var tableName = 'LEFT JOIN `TRUNKS` as sys_trunks ON sys_trunks.ID = events_main.`TRUNK`';
            // queryData.joins.push(tableName);

            queryData.grouping.push(
                " `" + data.as + "`, `" + data.as + "_NAME` "
            );

            queryData.fields.push(
                " ifnull(events_main.`TRUNK`, 0 ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull(events_main.`TRUNK_NAME`,'' ) as `" + data.as + "_NAME` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");
            queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");

            return queryData;
        },

        GROUP_BY_PBX: function(data, queryData) {
            // var tableName = 'LEFT JOIN `PBXES` as sys_pbxes ON sys_pbxes.ID = events_main.`PBX`';
            // queryData.joins.push(tableName);

            queryData.grouping.push(
                " `" + data.as + "`, `" + data.as + "_NAME` "
            );

            queryData.fields.push(
                " ifnull(events_main.`PBX`, 0 ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull(events_main.`PBX_NAME`,'' ) as `" + data.as + "_NAME` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");
            queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");

            return queryData;
        },

        GROUP_BY_TAG: function(data, queryData) {
            queryData.joins.push('LEFT JOIN `EVENTS_TAGS` as sys_events_tags ON sys_events_tags.EVENT_ID = events_main.ID');
            queryData.joins.push('LEFT JOIN `TAGS` as sys_tags ON sys_tags.ID = sys_events_tags.TAG_ID');

            queryData.grouping.push(
                " `" + data.as + "`, `" + data.as + "_NAME` "
            );

            queryData.fields.push(
                "  ifnull( sys_tags.`ID`,'' ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull( sys_tags.`NAME`,'' ) as `" + data.as + "_NAME` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");
            queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");

            return queryData;
        },

        GROUP_BY_COUNTRY: function(data, queryData) {
            // var tableName = 'LEFT JOIN `COUNTRIES` as sys_country ON sys_country.ID = events_main.COUNTRY';
            // queryData.joins.push(tableName);

            queryData.grouping.push(
                " `" + data.as + "`, `" + data.as + "_NAME` "
            );

            queryData.fields.push(
                " ifnull(events_main.`COUNTRY`, 0 ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull(events_main.`COUNTRY_NAME`,'' ) as `" + data.as + "_NAME` "
            );

            queryData.assocForSuperSelect.push("`" + data.as + "`");
            queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");

            return queryData;
        },

        GROUP_BY_CLASS: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "` "
            );

            queryData.fields.push(
                " ifnull(events_main.`CLASS`,'' ) as `" + data.as + "` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            return queryData;
        },

        GROUP_BY_COMPANY: function(data, queryData) {
            queryData.grouping.push(
                " `" + data.as + "`, `" + data.as + "_NAME` "
            );

            queryData.fields.push(
                " ifnull(events_main.`FROM_GROUP`, 0 ) as `" + data.as + "` "
            );
            queryData.fields.push(
                " ifnull(events_main.`FROM_GROUP_NAME`,'' ) as `" + data.as + "_NAME` "
            );
            queryData.assocForSuperSelect.push("`" + data.as + "`");

            queryData.where.push("events_main.`FROM_GROUP_TYPE` = 2");

            return queryData;
        },

        GROUP_BY_USER: function(data, queryData, getTotalRows, getSumRows, userType) {
            if (userType == undefined) {
                userType = 1;
            }

            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as + "`");
                queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");
            }


            var whereFrom = queryData.where.slice(0)
            whereFrom.push("events_main.`FROM_USER_TYPE` = " + userType);

            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            resultQuery += getSumRows !== true ? "SELECT events_main.`FROM_USER` as `" + data.as + "`, events_main.`FROM_NAME` as `" + data.as + "_NAME` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? ',' : '';
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            // resultQuery += " INNER JOIN `USERS` as sys_usr ON sys_usr.ID = events_main.`FROM_USER` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + whereFrom.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "`, `" + data.as + "_NAME` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ALL ";

            var whereTo = queryData.where.slice(0)
            whereTo.push("events_main.`TO_USER_TYPE` = " + userType);

            resultQuery += getSumRows !== true ? "SELECT events_main.`TO_USER` as `" + data.as + "`, events_main.`TO_NAME` as `" + data.as + "_NAME` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? ',' : '';
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            // resultQuery += " INNER JOIN `USERS` as sys_usr ON sys_usr.ID = events_main.`TO_USER` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + whereTo.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "`, `" + data.as + "_NAME` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) " + this.tmpTableName() + ' ';

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "`, `" + data.as + "_NAME` ";
                if (queryData.grouping.length > 0) {
                    resultQuery += " , " + queryData.grouping.join(',') + " ";
                }
            }

            if (getTotalRows === true) {
                resultQuery += ' ) as ' + this.tmpTableName() + ' ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;
        },

        GROUP_BY_CLIENT: function(data, queryData, getTotalRows, getSumRows) {
            return this.decorators.GROUP_BY_USER.call(this, data, queryData, getTotalRows, getSumRows, 2);
        },

        GROUP_BY_GROUP: function(data, queryData, getTotalRows, getSumRows) {

            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as + "`");
                queryData.assocForSuperSelect.push("`" + data.as + "_NAME`");
            }

            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            resultQuery += getSumRows !== true ? " SELECT events_main.`FROM_GROUP` as `" + data.as + "`, events_main.`FROM_GROUP_NAME` as `" + data.as + "_NAME` " : " SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            // resultQuery += " INNER JOIN `GROUPS` as sys_groups ON sys_groups.ID = events_main.`FROM_GROUP` AND sys_groups.`TYPE` = 1 ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "`, `" + data.as + "_NAME` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ALL ";

            resultQuery += getSumRows !== true ? " SELECT events_main.`TO_GROUP` as `" + data.as + "`, events_main.`TO_GROUP_NAME` as `" + data.as + "_NAME` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            // resultQuery += " INNER JOIN `GROUPS` as sys_groups ON sys_groups.ID = events_main.`TO_GROUP` AND sys_groups.`TYPE` = 1 ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "`, `" + data.as + "_NAME` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) " + this.tmpTableName() + ' ';

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "`, `" + data.as + "_NAME` ";
            }

            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += ' ) ' + this.tmpTableName() + ' ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;
        },
        GROUP_BY_NUMBER: function(data, queryData, getTotalRows, getSumRows) {
            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as + "`");
            }

            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            resultQuery += getSumRows !== true ? " SELECT events_main.`FROM` as `" + data.as + "` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ALL ";

            resultQuery += getSumRows !== true ? " SELECT events_main.`TO` as `" + data.as + "` " : "SELECT ";
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) " + this.tmpTableName() + ' ';

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as + "` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += ' ) ' + this.tmpTableName() + ' ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;

        },

        GROUP_BY_COMMUNICATION_OF_USERS: function(data, queryData, getTotalRows, getSumRows) {
            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as['from'] + "`");
                queryData.assocForSuperSelect.push("`" + data.as['to'] + "`");
                queryData.assocForSuperSelect.push("`" + data.as['from'] + "_NAME`");
                queryData.assocForSuperSelect.push("`" + data.as['to'] + "_NAME`");
            }
            queryData.where.push("events_main.`FROM_USER_TYPE` = 1");
            queryData.where.push("events_main.`TO_USER_TYPE` = 1");


            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            if (getSumRows !== true) {
                resultQuery += " SELECT events_main.`FROM_USER` as `" + data.as['from'] + "`, events_main.`TO_USER` as `" + data.as['to'] + "`, "
                            + " events_main.FROM_NAME as `" + data.as['from'] + "_NAME`, events_main.TO_NAME as `" + data.as['to'] + "_NAME` ";
            } else {
                resultQuery += " SELECT ";
            }
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            // resultQuery += " INNER JOIN `USERS` as sys_usr1 ON sys_usr1.ID = events_main.`FROM_USER` ";
            // resultQuery += " INNER JOIN `USERS` as sys_usr2 ON sys_usr2.ID = events_main.`TO_USER` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['from'] + "_NAME`, `" + data.as['to'] + "`, `" + data.as['to'] + "_NAME` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ALL ";

            if (getSumRows !== true) {
                resultQuery += " SELECT events_main.`TO_USER` as `" + data.as['from'] + "`, events_main.`FROM_USER` as `" + data.as['to'] + "`, "
                            + " events_main.TO_NAME as `" + data.as['from'] + "_NAME`, events_main.FROM_NAME as `" + data.as['to'] + "_NAME` ";
            } else {
                resultQuery += " SELECT ";
            }
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            // resultQuery += " INNER JOIN `USERS` as sys_usr1 ON sys_usr1.ID = events_main.`TO_USER` ";
            // resultQuery += " INNER JOIN `USERS` as sys_usr2 ON sys_usr2.ID = events_main.`FROM_USER` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['from'] + "_NAME`, `" + data.as['to'] + "`, `" + data.as['to'] + "_NAME` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) " + this.tmpTableName() + ' ';

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['from'] + "_NAME`, `" + data.as['to'] + "`, `" + data.as['to'] + "_NAME` ";
            }

            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += ' ) ' + this.tmpTableName() + ' ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;
        },

        GROUP_BY_COMMUNICATION_OF_GROUPS: function(data, queryData, getTotalRows, getSumRows) {
            if (getSumRows !== true) {
                queryData.assocForSuperSelect.push("`" + data.as['from'] + "`");
                queryData.assocForSuperSelect.push("`" + data.as['to'] + "`");
                queryData.assocForSuperSelect.push("`" + data.as['from'] + "_NAME`");
                queryData.assocForSuperSelect.push("`" + data.as['to'] + "_NAME`");
            }

            var resultQuery = '';
            if (getTotalRows === true) {
                resultQuery += ' SELECT COUNT(*) as TOTAL_ROWS FROM ( ';
            }

            resultQuery += " SELECT  " + queryData.assocForSuperSelect.join(',') + " FROM ( "

            if (getSumRows !== true) {
                resultQuery += " SELECT events_main.`FROM_GROUP` as `" + data.as['from'] + "`, events_main.`TO_GROUP` as `" + data.as['to'] + "`, ";
                resultQuery += " events_main.FROM_GROUP_NAME as `" + data.as['from'] + "_NAME`, events_main.TO_GROUP_NAME as `" + data.as['to'] + "_NAME` ";
            } else {
                resultQuery += "SELECT ";
            }

            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            // resultQuery += " INNER JOIN `GROUPS` as sys_grp1 ON sys_grp1.ID = events_main.`FROM_GROUP` ";
            // resultQuery += " INNER JOIN `GROUPS` as sys_grp2 ON sys_grp2.ID = events_main.`TO_GROUP` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['from'] + "_NAME`, `" + data.as['to'] + "`, `" + data.as['to'] + "_NAME` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " UNION ALL ";

            if (getSumRows !== true) {
                resultQuery += " SELECT events_main.`TO_GROUP` as `" + data.as['from'] + "`, events_main.`FROM_GROUP` as `" + data.as['to'] + "`, ";
                resultQuery += " events_main.TO_GROUP_NAME as `" + data.as['from'] + "_NAME`, events_main.FROM_GROUP_NAME as `" + data.as['to'] + "_NAME` ";
            } else {
                resultQuery += "SELECT ";
            }
            if (queryData.fields.length > 0) {
                resultQuery += getSumRows !== true ? "," : "";
                resultQuery += " " + queryData.fields.join(',');
            }
            resultQuery += " FROM " + queryData.from.join(',');
            // resultQuery += " INNER JOIN `GROUPS` as sys_grp1 ON sys_grp1.ID = events_main.`TO_GROUP` ";
            // resultQuery += " INNER JOIN `GROUPS` as sys_grp2 ON sys_grp2.ID = events_main.`FROM_GROUP` ";
            resultQuery += " " + queryData.joins.join(' ');
            resultQuery += " WHERE " + queryData.where.join(' AND ');
            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['from'] + "_NAME`, `" + data.as['to'] + "`, `" + data.as['to'] + "_NAME` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            resultQuery += " ) " + this.tmpTableName() + ' ';

            if (getSumRows !== true) {
                resultQuery += " GROUP BY `" + data.as['from'] + "`, `" + data.as['from'] + "_NAME`, `" + data.as['to'] + "`, `" + data.as['to'] + "_NAME` ";
            }
            if (queryData.grouping.length > 0) {
                resultQuery += " , " + queryData.grouping.join(',') + " ";
            }

            if (getTotalRows === true) {
                resultQuery += ' ) ' + this.tmpTableName() + ' ';
            }

            if (queryData.order !== '') {
                resultQuery += " " + queryData.order + " ";
            }

            if (queryData.limit !== '') {
                resultQuery += " " + queryData.limit + " ";
            }

            return resultQuery;
        },

        /*Sort decorators */
        sort: function(data, queryData) {
            if (Ext.isArray(data)) {
                var orders = new Array();

                for (var i=0; i < data.length; i++) {
                    if (data[i]['field'] === 'ID') {
                        orders.push("events_main.`ID` " + data[i]['dest'] + " ");
                    } else {
                        orders.push("`" + data[i]['field'] + "` " + data[i]['dest'] +" ");
                    }
                }

                queryData.order = " ORDER BY " + orders.join(', ') +" ";
            } else if (Ext.isObject(data)) {
                queryData.order = " ORDER BY `" + data['field'] + "` " + data['dest'] +" ";
            }

            return queryData;
        }

    }





});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/storage/Storage.js
Ext.define('App.storage.Storage', {
    singleton: true,
    mixins: {
        observable: 'Ext.util.Observable'
    },
    requires: [
        'App.utility.File'
    ],
    METHOD_EXECUTE: 1,
    METHOD_FETCH: 2,
    METHOD_FETCHROW: 3,
    METHOD_FETCHONE: 4,
    METHOD_PUSH_EVENTS: 5,
    METHOD_PUSH_USERS: 6,
    METHOD_PUSH_EXTRA: 7,
    METHOD_PUSH_GENERATE_XLS: 8,
    METHOD_PUSH_GENERATE_CSV: 9,
    METHOD_PUSH_OPEN_FILE: 10,

    _wildixIntegration: null,
    _isInitialized: false,
    _isLocked: false,
    installedVersion: '',
    appropriateVersion: '1.0.2',
    dbVersion: '11',

    _lockedDbCounter: 0,
    _lockedDbMaxAttempts: 10,
    _socketLimited: true,

    constructor: function() {
        this.getWildixIntegration().on('connecting', this._onConnectingWildixIntegration, this);
        this.getWildixIntegration().on('open', this._onOpenWildixIntegration, this);
        this.getWildixIntegration().on('error', this._onErrorWildixIntegration, this);
        this.getWildixIntegration().on('message', this._onMessageWildixIntegration, this);
        this.getWildixIntegration().on('response', this._onResponseWildixIntegration, this);
        this.getWildixIntegration().on('close', this._onCloseWildixIntegration, this);

        this.getWildixIntegration().on('requesttimeout', this._onErrorRequestTimeoutWildixIntegration, this);
        this.getWildixIntegration().on('response:cdr_view', this._onErrorResponseWildixIntegration, this);
        this.getWildixIntegration().on('message:cdr_view', this._onMessageWIService, this);

        this.proxyUsers  = Ext.create('App.proxy.Users');
        this.proxyGroups = Ext.create('App.proxy.Groups');
        this.proxyTrunks = Ext.create('App.proxy.Trunks');
        this.proxyPbxes  = Ext.create('App.proxy.Pbxes');
        this.proxyEvents = Ext.create('App.proxy.Events');

        this.addEvents('init');
        this.callParent(arguments);
    },

    /*************************************************
     * start local db specific methods
     *************************************************/

    getWildixIntegration: function(){
        if(this._wildixIntegration === null){
            //Rewrite default authorize settings for WService
            Wildix.Settings.app= "CDRView";
            Wildix.Settings.appVersion= CDRViewVersion;
            //Create instance
            this._wildixIntegration = Wildix.IntegrationService.getInstance();
        }
        return this._wildixIntegration;
    },
    isConnected: function(callback){
        if(this.getWildixIntegration().isConnected()){
                return true;
        }
        return false;
    },
    isOSSupported: function(){
        var platform = navigator.platform||'';
        return platform.indexOf('Win')!==-1||platform.indexOf('Mac')!==-1;
    },
    isInstalled: function(){
        return this.getWildixIntegration().isInstalled();
    },
    isLocked: function(){
        return this._isLocked;
    },
    isVersionReceived: function(){
        return !!this.installedVersion;
    },
    isAppropriateVersion: function(){
        if(this.installedVersion){
            var iVers = this.installedVersion.split('.');
            var aVers = this.appropriateVersion.split('.');
            for (var i=0;i<iVers.length;i++){
                if (parseInt(iVers[i]) < parseInt(aVers[i]))
                    return false;
                if (parseInt(iVers[i]) > parseInt(aVers[i]))
                    return true;
            }
            return true;//the same
        }
        return false;
    },
    alwaysTryingToConnect: function(){
        this.getWildixIntegration().getConnection().maxReconnectAttempts = null;
        //this.getWildixIntegration().refresh();
        //this.getWildixIntegration().open();
    },
    close: function(){
        this.getWildixIntegration().getConnection().close();
    },
    /*************************************************
     * end local db specific methods
     *************************************************/

    /***********************************************************
     * start local db events
     ************************************************************/
    _onConnectingWildixIntegration: function(event, wi){

    },
    _onOpenWildixIntegration: function(event, wi){
        var self = this;
        if (!this._isInitialized){
            setTimeout(function(){
                self.getWildixIntegration().send({'message' : 'M_CDR_VIEW','msgdata' : {'serial':Serial,'dbVersion':self.dbVersion,'command' : 'getversion'}}, function(res){
                    self.isBDInUse(function(isLocked){
                        self._isInitialized = true;
                        self._isLocked = isLocked;

                    });
                    if (res && ! res.error && typeof res == 'string' && res.split('.').length == 3)
                        self.installedVersion = res;


                });
            },10);
        }
    },
    _onErrorWildixIntegration: function(event, wi){

    },
    _onMessageWildixIntegration: function(event, message){
            //this.trigger(message.type+':'+message.application, this, message.msgdata);
    },
    _onResponseWildixIntegration: function(event, wi, response){
        console.error("_onResponseWildixIntegration", event, wi, response);
    },
    _onErrorResponseWildixIntegration: function(event, response){
        var errorMessage = response && response.msgdata && response.msgdata.error?response.msgdata.error:'';
        if (errorMessage)
            errorMessage = errorMessage.replace('LuaSQL: ','');
        if (['file is encrypted or is not a database','database disk image is malformed'].indexOf(errorMessage)!==-1 && sessionStorage.reinitializePerformed != '1'){
            sessionStorage.reinitializePerformed = '1';
            this.reinitializeDb();
        } else if (['database is locked'].indexOf(errorMessage) !== -1) {
            this._lockedDbCounter++;
            if (this._lockedDbCounter > this._lockedDbMaxAttempts) {
                this.showErrorDialog(response.msgdata.error)
            }
        } else if (response && response.msgdata && response.msgdata.error){
            this.showErrorDialog(response.msgdata.error)
        }
    },
    showErrorDialog: function(error) {
        this.errorDialog = Ext.create('App.view.bootstrap.ErrorCritical', {
            response: error
        });
        this.errorDialog.show();
    },
    _onErrorRequestTimeoutWildixIntegration:function(event, request){


        //check if was connected
        if (! this.installedVersion ){
            return;
        }
        this.errorDialog = Ext.create('App.view.bootstrap.ErrorCritical', {
            response: _t('Request timeout')
        });
        this.errorDialog.show();
    },
    _onCloseWildixIntegration: function(event, wi){

    },
    /***********************************************************
     * end local db events
     ************************************************************/
    getWIServiceUrl: function(){
        var platform = navigator.platform||'';
        if (platform.indexOf('Win')!==-1)
            return "https://files.wildix.com/integrations/win/wiservice/SetupWIService.exe";
        if (platform.indexOf('Mac')!==-1)
            return "https://files.wildix.com/integrations/osx/wiservice/WIService.pkg";
        if (platform.indexOf('Linux')!==-1)
            return "#";
        return "";
    },
    isBrowserSupported: function() {
        // Verify Internet Explorer
        if (navigator.userAgent.match(/MSIE/i) != null) {
            /*var versionOfIE = navigator.userAgent.match(/MSIE ([^ \.]+)/i);

            if (versionOfIE != null && parseFloat(versionOfIE[1]) > 6) {
                return true;
            }*/
            return false;
        }

        // Verify Google Chrome
        if (Ext.isChrome) {
            return true;
        }

        // Verify Safari
        if (Ext.isSafari && navigator.platform.indexOf('Win')===-1) {
            return true;
        }

        // Verify firefox
        if (navigator.userAgent.match(/Firefox/i) != null) {
            return true;
        }

        return false;
    },


    lookup: function(check) {
        var self = this;
        if (!check){
            this.alwaysTryingToConnect();
        }
        if (this._isInitialized){
            this.fireEvent('init');
            return;
        }
        if (check*100>5000){
            this._isInitialized = true;
        }


        setTimeout( function() { self.lookup(check?check+1:1); },100);
    },
    isBDInUse: function(callback){
        this.getWildixIntegration().broadcast({'message' : 'M_CDR_VIEW','msgdata':{command:'ping',serial:Serial,'dbVersion':this.dbVersion}}, function(responses){
            var sameDBClientsCount = 0;
            for (var i=0;i<responses.length;i++){
                if (responses[i].command == 'pong' && responses[i].serial == Serial){
                    sameDBClientsCount++;
                }
            }
            if (callback) callback(sameDBClientsCount>0);
        });
    },
    _onMessageWIService: function(event, response){
        if (response.msgdata && response.msgdata.command == 'ping' && response.msgdata.serial == Serial){
            this.getWildixIntegration().broadcast({'message' : 'M_CDR_VIEW','msgdata':{
                    command:'pong',
                    serial:Serial,
                    'dbVersion':this.dbVersion,
                    userAgent:navigator.userAgent,
                    userName:User.name
            },'id':response.id});
        }

    },
    reinitializeDb: function(){
        this.getWildixIntegration().send({'message' : 'M_CDR_VIEW','msgdata' : {'serial':Serial,'dbVersion':this.dbVersion,'command' : 'clear'}}, function(res){
            window.location.reload();
        });
    },
    bulkInsertPromise: function(tableName, values, stDt){
        var self = this;
        var seq = Promise.resolve();
        if (!values || !values.length || !values[0])
            return seq;
        var fields = Object.keys(values[0]);

        var sqlTableFields = 'INSERT OR REPLACE INTO \'' + tableName + '\' (\'' + fields.join('\', \'') +'\') VALUES ';

        var sql = '';
        var nextRow = '';
        var item = null;

        do {(function(){

            if (!sql){
                sql = sqlTableFields;
            } else {
                sql += ' , ';
            }

            item = values.shift();

            nextRow = '('+fields.map(function(field) {
                return  item[field] == null ? 'null' : self.escape(item[field]);
            }).join(',') + ')';


            sql = sql + nextRow;

        })();} while(values.length>0);

        seq = seq.then(Ext.bind(function (sql) {
            return self.executePromise(sql);
        }, seq, [sql])).then(function (result) {
            return result;
        });

        seq = seq.then(function(result){
            return result;
        });




        return seq;
    },
    __quoteRe: new RegExp("'",'g'),
    escape: function (value) {
        var str = ''+value;
        if (!str || str == '') {
            return "''";
        }
        return "'" + str.replace(this.__quoteRe, "''") + "'";
    },
    executePromise: function(sql, scope){
        var self = this;
        return new Promise(function(resolve, reject) {
            self.executeAsync(sql, function(response){
                if (response && response.error){
                    if (self.needShowDbError(response.error)) {
                        reject(Error(response.error));
                    } else {
                        resolve(response);
                    }
                } else {
                    self.resetLockedDbErrorCounter();
                    resolve(response);
                }
            }, scope);
        });
    },
    fetchPromise: function(sql, scope){
        var self = this;
        return new Promise(function(resolve, reject) {
            self.fetchAsync(sql, function(response){
                if (response && response.error){
                    if (self.needShowDbError(response.error)) {
                        reject(Error(response.error));
                    } else {
                        resolve(response);
                    }
                } else {
                    self.resetLockedDbErrorCounter();
                    resolve(response);
                }
            }, scope);
        });
    },
    resetLockedDbErrorCounter: function() {
        this._lockedDbCounter = 0;
    },
    needShowDbError: function(error) {
        if (error === 'LuaSQL: database is locked') {
            return (this._lockedDbCounter > this._lockedDbMaxAttempts);
        }
        return true;
    },
    executeAsync: function(sql, callback, scope, id) {
        scope = scope || this;
        callback = callback || function(){};
        this.getWildixIntegration().send({'message' : 'M_CDR_VIEW','msgdata' : {'serial':Serial,'dbVersion':this.dbVersion,'command' : 'exec', query:sql}}, function(response){
            callback.call(scope, response);
        });
    },
    fetchAsync: function(sql, callback, scope) {
        scope = scope || this;
        callback = callback || function(){};
        this.getWildixIntegration().send({'message' : 'M_CDR_VIEW','msgdata' : {'serial':Serial,'dbVersion':this.dbVersion,'command' : 'query', query:sql}}, function(response){
            if ((response instanceof Object) && !Ext.Object.getKeys(response).length){
                response = [];
            }
            callback.call(scope, response);
        });
    },
    fetchRowAsync: function(sql, callback, scope) {
        var callbackCover = function(response){
            if (response instanceof Array){
                //take first row (if no rows undeined will returned)
                response = response[0];
            }
            callback.call(scope, response);
        }
        this.fetchAsync(sql, callbackCover, scope);

    },
    fetchOneAsync: function(sql, callback, scope, id, options) {
        var callbackCover = function(response){
            var firstColValue = undefined;
            if (response instanceof Array){
                //take first row (if no rows undeined will returned)
                response = response[0];
                if (response != undefined){
                    for (var prop in response){
                        if (response.hasOwnProperty(prop)){
                            firstColValue = response[prop];
                        }
                    }
                }
            }
            callback.call(scope, firstColValue);
        }
        this.fetchAsync(sql, callbackCover, scope, id, options);
    },
    batch: function() {
        var dispatcher, executions = new Array(), requests = new Array(), results = new Array(), callback, scope;
        if (!this.rid) this.rid = 1;
        // collect requests
        for( i=0; i < arguments.length; i++ ) {
            if( Ext.isArray(arguments[i]) ) {
                requests[i] = arguments[i];
                requests[i][3] = this.rid;
                executions[i] = false;

                this.rid++;
                continue;
            }

            break;
        }

        // collect callback & scope
        for( i = arguments.length - 1; i >= 0; i-- ) {
            if( !Ext.isFunction(arguments[i]) && !Ext.isPrimitive(arguments[i]) && i == arguments.length - 1 ) {
                scope = arguments[i];
                continue;
            }
            if( Ext.isFunction(arguments[i]) && (i == arguments.length - 1 || scope ) ) {
                callback = arguments[i];
                continue;
            }
            if( i+1 != requests.length ) {
                if( !callback ) {
                    throw new Error("Invalid callback argument");
                }

                throw new Error("Invalid "+ (i + 1) +" argument");
            }

            break;
        }

        if( !callback ) {
            throw new Error("Invalid callback argument");
        }
        if( !scope ) {
            scope = this;
        }

        dispatcher = function(rid, result) {
            var i, finish = true;

            for( i=0; i < requests.length; i++ ) {
                if( requests[i][3] == rid ) {
                    results[i] = result;
                    executions[i] = true;
                }
            }

            for( i=0; i < executions.length; i++ ) {
                if( !executions[i] ) {
                    finish = false;
                }
            }


            if( finish ) {
                callback.apply(scope, results);
            }
        }

        // execute
        for( var i=0; i < requests.length; i++ ) {
            switch( requests[i][0] ) {
                case this.METHOD_EXECUTE:
                    this.executeAsync(requests[i][1],  Ext.pass(dispatcher, [requests[i][3]], this));
                break;
                case this.METHOD_FETCH:
                    this.fetchAsync(requests[i][1],    Ext.pass(dispatcher, [requests[i][3]], this));
                break;
                case this.METHOD_FETCHROW:
                    this.fetchRowAsync(requests[i][1], Ext.pass(dispatcher, [requests[i][3]], this));
                break;
                case this.METHOD_FETCHONE:
                    this.fetchOneAsync(requests[i][1], Ext.pass(dispatcher, [requests[i][3]], this));
                break;
                default:
                     this.executeAsync(requests[i][1], Ext.pass(dispatcher, [requests[i][3]], this));
                break;
            }
        }
    },
    pushUsers: function(data, isFirstTimeSync, callback, scope) {
        scope = scope || this;
        callback = callback || function(){};
        this.proxyUsers.pushUsers(data, isFirstTimeSync, Ext.bind(callback,scope));
    },
    pushExtra: function(data, callback, scope) {
        var self = this;
        scope = scope || this;
        callback = callback || function(){};




        Promise.resolve().then(function(){
            return new Promise(function(resolve){
                self.proxyGroups.pushGroups(data.groups,resolve);
            });
        }).then(function(){
            return new Promise(function(resolve){
                self.proxyTrunks.pushTrunks(data.trunks,resolve);
            });
        }).then(function(){
            return new Promise(function(resolve){
                self.proxyPbxes.pushPbxes(data.pbxes,resolve);
            });
        }).then(function(){
            callback.apply(scope);
        })['catch'](function(e){
            console.error('error during push extra',e);
        });
    },
    pushEvents: function(data, callback, scope) {
        scope = scope || this;
        callback = callback || function(){};
        this.proxyEvents.pushEvents(data,Ext.bind(callback,scope));
    },
    pushXMLGeneration: function (data, callback, scope) {
        var fileName = this.generateReportName(data, '.xlsx');
        App.utility.File.downloadAsXLSX(data, fileName);
        callback.call(scope);
    },
    pushCSVGeneration: function (data, callback, scope) {
        var fileName = this.generateReportName(data, '.csv');
        App.utility.File.downloadAsCSV(data, fileName);
        callback.call(scope);
    },
    generateReportName: function (reportData, format) {
        var reportPrefix = "cdr-view-";
        var reportName = reportData.name || '';
        if (reportName) {
            reportPrefix = reportName.replace(/\W/g, '_') + '_';
        }

        var reportFilterName = reportData.periodFilterName || '';
        if (reportFilterName) {
            reportPrefix = reportPrefix + reportFilterName.toLowerCase().replace(/\W/g, '_') + '_';
        }

        return reportPrefix + Ext.Date.format(new Date(), 'Y-m-d') + format;
    },
    pushOpenFile: function (data, callback, scope, id) {
    },
    dropIndexPromise: function(){
        var self = this;
        return new Promise(function(resolve, reject) {
            self.getWildixIntegration().send({'message' : 'M_CDR_VIEW','msgdata' : {'serial':Serial,'dbVersion':self.dbVersion,'command' : 'dropindex'}}, function(){
               setTimeout(resolve,2000);
            },120000);
        });
    },
    createIndexPromise: function(){
        var self = this;
        return new Promise(function(resolve, reject) {
            self.getWildixIntegration().send({'message' : 'M_CDR_VIEW','msgdata' : {'serial':Serial,'dbVersion':self.dbVersion,'command' : 'createindex'}}, function(){
                resolve();
            },300000);
        });
    },
    chunkData: function(data, byLength) {
      var chunks = [],i = 0,n = data.length;
      if (!byLength)
          byLength = n;
      while (i < n)
        chunks.push(data.slice(i, i += byLength));
      return chunks;
    },
    getBuilder: function() {
        if (isRemoteMode()) {
            return App.storage.QueryConstructorClickHouse;
        }
        return App.storage.QueryConstructor;
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/storage/Synchronizer.js
String.prototype.decodeEscapeSequence = function() {
  try {
    return decodeURIComponent(this.replace(/[0-9a-f]{2}/gi, '%$&'));
  } catch(e){
    var decoded = '';
    //at least part of the string will be decoded
    if (this) {
    	var splited = this.match(/.{2}/g);
        if (splited && splited.length>0){
            for (var i = 0; i<splited.length; i++){
		try{
		   decoded += decodeURIComponent('%'+splited[i]+'');
                } catch(e){}
            }
        }
    }
    return decoded;
  }
};

Ext.define('App.storage.Synchronizer', {
    singleton: true,
    requires: ['App.storage.Storage'],
    mixins: {
        observable: 'Ext.util.Observable'
    },
    contactsLimit: 1000,
    backendEventsLimit: 3000,

    constructor: function() {
        this.storage = App.storage.Storage;
        this.proxy = App.proxy.Synchronization;

        this.addEvents(
            'syncUsers',
            'syncUsersChange',
            'syncUsersComplete',
            'syncBackend',
            'syncBackendComplete',
            'syncExtra',
            'syncExtraComplete',
            'syncEvents',
            'syncEventsAuto',
            'syncEventsChange',
            'syncEventsComplete',
            'syncTerminate',
            'syncTerminated',

            'connectionError', // Should be fired when connection problem occurs
            'connectionRestored', // Should be fired when connection was restored
            'exceptionError'   // Should be fires when exception occurs
        );
        this.on('syncUsers', this.syncUsers, this);
        this.on('syncExtra', this.syncExtra, this);
        this.on('syncBackend', this.syncBackEnd, this);
        this.on('syncEvents', this.syncEvents, this);
        this.on('syncEventsAuto', this.syncEventsAuto, this);
        this.on('syncTerminate', this.syncTerminate, this);

        this.on('connectionError', this.onConnectionError, this);

        this.callParent(arguments);
    },

    isWorking: function() {
        return this.synchronizing;
    },

    // Function for Users sync
    syncUsers: function() {
        if (this.synchronizing) {
            return;
        }

        this.synchronizing = true;
        this.syncUsersIgnoreTimes = 0;
        this.syncUsersUpdateStep = null;
        this.syncUsersUpdateDate = null;
        this._startUserSyncTime = Date.now();

        this.proxy.getUsersSettings(this.onSyncUsersSettingsFetched, this);
    },

    isFirstTimeUsersSunc: function(){
        return this.syncUsersUpdateDate == '2000-01-01 00:00';
    },

    /**
     * Removes users from database that was deleted in WMS but exist in local cache.
     * Should be called only in syncUsers procedure sequence.
     */
    syncRemovedUsers: function() {
        this.proxy.getUsersIdentifiers(this.onSyncRemovedUsersFetchedIdentifiers, this);
    },

    getContacts: function (params, success, failure, scope) {
        params = params || {};
        params.start = parseInt(params.start) || 0;
        params.count = this.contactsLimit;
        if (params.start>0)
            params['withTotal'] = 'false';

        //Put filter to fetch just PBX users, not contacts in phonebooks
        //because our query for removing has filter  ... "SELECT `id` FROM `USERS` WHERE `type` = 1";
        //look in getUsersIdentifiers function
        for (var id in this._phonebooksMapping ){
            if (App.storage.Synchronizer._phonebooksMapping.hasOwnProperty(id)){
                if (App.storage.Synchronizer._phonebooksMapping[id] == 3){
                    params['filter[phonebook_id]'] = id;
                }
            }
        }

        Ext.Ajax.request({
            url: '../../api/v1/Contacts/',
            sort: 'id',
            timeout: 120*1000,
            method: 'GET',
            params: params,
            success: success,
            failure: failure,
            scope: scope
        });
    },
    onSyncRemovedUsersFetchedIdentifiers: function(result) {
        this.syncUsersLocalIdentifiers = result;

        var total = 0,
            contacts = [],
            params = { fields : 'id' },
            success = function (response) {
                var data = Ext.JSON.decode(response.responseText);

                if (!(data && data.type && data.type == 'result')) {
                    failure.apply(this, arguments);
                    return;
                }

                var result = data.result || {},
                    records = result.records || [];

                total = total || parseInt(result.total) || 0;
                records.forEach(function (record) { contacts.push(record.id); });

                // Fire change event
                if (total) {
                    var left = total - contacts.length;
                    var time = this.getEventsTimeLeft(left, 0.4/*8*/, 1000);
                    var percent  = this.getEventsLoadPercent(total, left);

                    this.fireEvent('syncUsersChange', percent, time);
                }

                if (records.length /*&& contacts.length < total*/) {
                    this.getContacts(Ext.Object.merge(params, { start: contacts.length }), success, failure, this);
                } else {
                    this.onSyncRemovedUsersFetchedIdentifiersSuccess(contacts);
                }
            },
            failure = this.onServerUsersFetchedFailure;

        this.getContacts(params, success, failure, this);
        // Retrieve all identifiers of users from server (e.g. colleagues).
        /*Ext.Ajax.request({
            url: '../../api/v1/Contacts/',
            method: 'GET',
            params: {
                fields: 'id'
            },
            success: this.onSyncRemovedUsersFetchedIdentifiersSuccess,
            failure: this.onServerUsersFetchedFailure,
            scope: this
        });*/
    },

    onSyncRemovedUsersFetchedIdentifiersSuccess: function(serverIdentifiers) {
        var localIdentifiers = this.syncUsersLocalIdentifiers;
        var mismatches = new Array();
        this.syncUsersLocalIdentifiers = null;

        for (var i=0; i < localIdentifiers.length; i++) {
            var present = false;
            for (var j = 0; j< serverIdentifiers.length; j++){
                if (localIdentifiers[i] == serverIdentifiers[j]){
                    present = true;
                }
            }
            if (!present){
                mismatches.push(localIdentifiers[i]);
            }
        }

        if (mismatches.length > 0) {


            this.proxy.removeUsers(mismatches,function(){
                this.synchronizing = false;
                this.fireEvent('syncUsersComplete');
            },this);
        } else {
            this.synchronizing = false;
            this.fireEvent('syncUsersComplete');
        }


    },

    /**
     *
     */
    onSyncUsersSettingsFetched: function(result) {
        for (var i in result) {
            if (result[i]['KEY'] === 'LAST_USR_SYNC') {
                this.syncUsersUpdateDate = result[i]['VALUE'];
            } else if (result[i]['KEY'] === 'LAST_USR_SYNC_PART') {
                this.syncUsersUpdateStep = parseInt(result[i]['VALUE'], 10);
            }
        }

        this.fetchServerUsersByPart(this.syncUsersUpdateDate, this.syncUsersUpdateStep);
    },

    /**
     * Fetches users part from a server
     */
    fetchServerUsersByPart: function() {
        var fetchContacts = function () {
            var params = {
                fields: 'id,name,extension,mobile,fax,office,home,home_mobile,phone,organization,phonebook_id',
                sort: 'id',
                start: this.syncUsersUpdateStep * this.contactsLimit,
                count: this.contactsLimit
            };
            if (!this.isFirstTimeUsersSunc()){
                params['filter[last_update][from]'] = this.syncUsersUpdateDate;
            }

            if (this._userToFetchTotal > 0)
                params['withTotal'] = 'false';





            Ext.Ajax.request({
                url: '../../api/v1/Contacts/',
                timeout: 120*1000,
                method: 'GET',
                params: params,
                success: this.onServerUsersFetchedSuccess,
                failure: this.onServerUsersFetchedFailure,
                scope: this
            });
        }.bind(this);

        if (!this._phonebooksMapping) {
            Ext.Ajax.request({
                url: '../../api/v1/Phonebooks/',
                method: 'GET',
                params: {
                    fields: 'id,type',
                    count: 200
                },
                success: function (response) {
                    var data = Ext.JSON.decode(response.responseText);

                    if (!(data && data.type && data.type == 'result')) {
                        this.fireEvent('exceptionError', response.responseText);
                    }

                    this._phonebooksMapping = {};
                    data.result.records.forEach(function (el) {
                        this._phonebooksMapping[el['id']] = el['type'];
                    }.bind(this));

                    fetchContacts();
                },
                failure: function (response) {
                    this.fireEvent('exceptionError', response.responseText);
                },
                scope: this
            });
        } else {
            fetchContacts();
        }
    },

    /**
     * Fires when users was successfully fetched from server, we should insert them to database, and repeat request
     * for another users part.
     */
    onServerUsersFetchedSuccess: function(response) {
        var self = this, i;
        var user, users = new Array();
        var contacts, data;

        try {
            if (JSON && JSON.parse){
                data = JSON.parse(response.responseText);
            } else {
                data = Ext.JSON.decode(response.responseText);
            }
        } catch(e){
            console.error('Ext.JSON.decode cannot decode string!');
        }

        // Verification for invalid data, we should repeat request after 2 seconds
        if (!(data && data.type && data.type == 'result')) {
            this.syncUsersIgnoreTimes++;

            if (this.syncUsersIgnoreTimes > 5) {
                this.fireEvent('exceptionError', response.responseText);
            } else {
                setTimeout(function() { self.fetchServerUsersByPart.call(self); }, 2000);
            }

            return;
        }

        if (data.result.total)
            this._userToFetchTotal = data.result.total;

        contacts = data.result.records;

        // Verify if server returns empty contacts
        if (contacts.length === 0) {
            this._userToFetchTotal = 0;
            this.onSyncUsersCompleted();
            return;
        }

        for (i=0; i < contacts.length; i++) {
            var contact = contacts[i];

            user = Object.create(null);
            user['id'] = contact.id; // id
            user['name'] = contact.name; // name
            user['type'] = this._phonebooksMapping[contact.phonebook_id] == 3 ? 1 : 2; // type
            user['number'] = contact.extension; // number
            user['mobile_number'] = contact.mobile; // mobile_number
            user['fax_number'] = contact.fax; // fax_number

            user['office'] = contact.office;
            user['home'] = contact.home;
            user['home_mobile'] = contact.home_mobile;
            user['phone'] = contact.phone;

            user['organization'] = contact.organization; // organization
            users.push(user);
        }

        // Fire change event
        if (this._userToFetchTotal) {
            var left = this._userToFetchTotal - this.syncUsersUpdateStep * this.contactsLimit;
            var time = this.getEventsTimeLeft(left, 0.4/*8*/, 1000);
            var percent  = this.getEventsLoadPercent(this._userToFetchTotal, left);

            this.fireEvent('syncUsersChange', percent, time);
        }

        this.storage.pushUsers(users, this.isFirstTimeUsersSunc(), this.onSyncUsersPushed, this);

        if (this.connProblems) {
            this.connProblems = false;
            this.fireEvent('connectionRestored');
        }
    },

    /**
     * Fires when connection problems was found while fetching users
     */
    onServerUsersFetchedFailure: function() {
        this.fireEvent('connectionError', this.onServerUsersFetchedFailureRetry, this);
    },

    /**
     * Fires when we should try to fetch users after a connection problem
     */
    onServerUsersFetchedFailureRetry: function() {
        this.fetchServerUsersByPart();
    },

    /**
     * Fires when Applet has been inserted users to database, we should repeat request to server for another part of users
     */
    onSyncUsersPushed: function() {
        this.syncUsersUpdateStep++;
        // Fetch another part of users after set users part will be updated
        this.proxy.setUserSettingsPart(this.syncUsersUpdateStep, Ext.bind(this.fetchServerUsersByPart,this));
    },

    /**
     * Fires when synchronization was completed successfylly, we should save update step, date and fire complete event.
     */
    onSyncUsersCompleted: function() {


        //Set part 0 for next sync
        this.syncUsersUpdateStep = 0;
        this.proxy.setUserSettingsPart(this.syncUsersUpdateStep,Ext.bind(function(){
            var isCheckForRemovedNeeded = !this.isFirstTimeUsersSunc();
            //Set currect date as last update date
            this.syncUsersUpdateDate = Ext.Date.format(get_current_date(), 'Y-m-d H:i');
            this.proxy.setUserSettingsLastUpdateDate(this.syncUsersUpdateDate, Ext.bind(function(){
                if (isCheckForRemovedNeeded){
                    this.syncRemovedUsers();
                } else {
                    //Not check for deleted users for the first time
                    this.synchronizing = false;
                    this.fireEvent('syncUsersComplete');
                }
            } ,this));
        },this));

    },

    // Function for Extra synch

    syncExtra: function() {
        if (this.synchronizing) {
            return;
        }

        this.synchronizing = true;
        this.fetchServerExtra();
    },

    fetchServerExtra: function(necessary) {
        Ext.Ajax.request({
            url: '../../api/v1/CDRView/ExtraProperties/',
            method: 'get',
            success: this.onExtraFetchedSuccess,
            failure: this.onExtraFetchedFailure,
            scope: this
        });
    },

    /**
     * Fires when request was successfull, we should process response for exceptions.
     */
    onExtraFetchedSuccess: function(response) {

        var result = Ext.decode(response.responseText).result;

        this.storage.pushExtra(result, this.onExtraPushed, this);
        // this.storage.pushExtra(text, this.onExtraPushed, this);
        // this.process(response.responseText, this.onExtraDecoded, this.onExtraRetry)
    },

    /**
     * Fires when request was failure, another than 200 http code was returned.
     */
    onExtraFetchedFailure: function(response) {
        this.fireEvent('connectionError', this.onExtraRetry, this);
    },

    /**
     * Fires when request is normal, we should repeat request to a server.
     * TODO: Using that logic
     */
    onExtraDecoded: function(result, text) {

    },

    /**
     * Fires when request has been skipped, we should repeat request to a server.
     * TODO: Using that logic
     */
    onExtraRetry: function(necessary) {
        this.fetchServerExtra(necessary);
    },

    /**
     * Fires when applet has been successfylly stored extra to database
     */
    onExtraPushed: function() {
        this.synchronizing = false;
        this.fireEvent('syncExtraComplete');
    },

    // Synch Backend methods

    /**
     * Sync Local and Server backend, if they are different we should truncate events and update backend property in database.
     */
    syncBackEnd: function() {
        if (this.synchronizing) {
            return;
        }

        this.synchronizing = true;
        this.proxy.readBackend(this.onLocalBackEndFetched, this);
    },

    /**
     * Fires when database has been fetched a backend property from database.
     */
    onLocalBackEndFetched: function(backend) {
        this.backendName = backend;
        this.fetchServerBackEnd(backend);
    },

    /**
     * Makes a request to a server to fetch backend.
     */
    fetchServerBackEnd: function(necessary) {
        Ext.Ajax.request({
            url: '../../api/v1/CDRView/InfoProperties/',
            method: 'get',
            success: this.onBackEndFetched,
            failure: this.onBackEndFetchedFailure,
            scope: this
        });
    },

    /**
     * Fires when request was successfull, we should process response for exceptions.
     */
    onBackEndFetched: function(response) {
        var result = Ext.encode(Ext.decode(response.responseText).result);
        this.process(result, this.onBackEndDecoded, this.onBackEndRetry, this)
    },

    /**
     * Fires when request has been fail, another than 200 http code was respond.
     */
    onBackEndFetchedFailure: function() {
        this.fireEvent('connectionError', this.onBackEndRetry, this);
    },

    /**
     * Fires when response is valid.
     */
    onBackEndDecoded: function(result, text) {
        this.backendMinId = result['min_id'];
        this.backendMaxId = result['max_id'];
        this.backendMinDate = result['min_date'];
        this.backendMaxDate = result['max_date'];
        this.backendEventsLimit = result['events_limit'];

        if (this.backendName != result['backend']) {
            // Server and Local Backend is different, we should update Local Backend.
            this.backendName = result['backend'];
            this.proxy.updateBackend(this.backendName, this.onServerBackendUpdated, this);
            return;
        }

        this.synchronizing = false;
        this.fireEvent('syncBackendComplete');
    },

    /**
     * Fires when response has try_again_later exception, we should repeat request to a server.
     */
    onBackEndRetry: function(necessary) {
        this.fetchServerBackEnd(necessary);
    },

    /**
     * Fires when backend has been successfully stored in database.
     */
    onServerBackendUpdated: function() {
        this.synchronizing = false;
        this.fireEvent('syncBackendComplete');
    },

    // Misc events methods

    getEventsStatistics: function(callback, scope){
        scope = scope || this;
        var me = this;

        var controller = function(stats) {
            var i, j, curMinId, curMaxId,
                curMinDate, curMaxDate,
                statistics = new Array();
            for (var i=0; i < stats.length; i++) {
                statistics.push( { id: parseInt(stats[i]['ID']), date: stats[i]['DATE'], min_id: parseInt(stats[i]['MIN_ID']), max_id: parseInt(stats[i]['MAX_ID']), complete:  parseInt(stats[i]['COMPLETE']) } );
            }

            // -------
            var range = me.getEventsExcludeRanges(statistics);

            for(i=0; i < range.length; i++) {
                curMinId = range[i][0];
                curMaxId = range[i][1];

                curMinDate = ''; curMaxDate = '';
                for(j=0; j < statistics.length; j++) {
                    if(statistics[j]['min_id'] == curMinId){
                        curMinDate = statistics[j]['date'];
                    }
                    if(statistics[j]['max_id'] ==  curMaxId){
                        curMaxDate = statistics[j]['date'];
                    }
                }
                range[i] = {
                    minId: curMinId,
                    minDate: curMinDate,
                    maxId: curMaxId,
                    maxDate: curMaxDate
                };
            }

            Ext.callback(callback, scope, [range]);
        };

        this.proxy.readAllStatistics(controller, scope);
    },

    // Events methods

    /**
     * Synchronize events from server for specified period.
     */
    syncEvents: function(minDate, maxDate, ignoreCurrDay) {
        if (this.synchronizing) {
            return;
        }

        this.synchronizing = true;
        this.terminated = false;
        this.syncEventsAutoFlag = false;
        this.syncEventsMinId = false;
        this.syncEventsMaxId = false;
        this.syncEventsMinDate = minDate;
        this.syncEventsMaxDate = maxDate;
        this.syncEventsSuccessRequests = 0;
        this.syncEventsSkippedRequests = 0;
        this.syncEventsFailureRequests = 0;
        this.syncEventsDelay = false;
        this.syncEventsTotalWant = false;
        this.syncEventsDays = new Array();
        this.syncEventsIgnoreCurrDay = ignoreCurrDay;
        this.syncEventsNecessary =  false;

        var i = false;
        var day = Ext.Date.parse(minDate, "Y-m-d");
        var date = minDate;

        while (true) {
            if (i) {
                day = Ext.Date.add(day, Ext.Date.DAY, 1);
                date = Ext.Date.format(day, "Y-m-d");
            } else {
                i = true;
            }

            this.syncEventsDays.push(date);

            if (date == maxDate) {
                break;
            }
        }

        this.syncEventsPartly();
    },

    /**
     * Synchronize new events from server (if they has been added since last sync).
     */
    syncEventsAuto: function() {
        if (this.synchronizing) {
            return;
        }

        this.synchronizing = true;
        this.terminated = false;
        this.syncEventsAutoFlag = true;
        this.syncEventsMinId = false;
        this.syncEventsMaxId = false;
        this.syncEventsMinDate = false;
        this.syncEventsMaxDate = false;
        this.syncEventsDelay = false;
        this.syncEventsNecessary =  false;

        //
        this.syncEventsPartly();
    },

    /**
     * Synchronize events by part.
     */
    syncEventsPartly: function() {
        var minDate = this.syncEventsMinDate;
        var maxDate = this.syncEventsMaxDate;

        if (this.syncEventsAutoFlag) {
            this.proxy.readLastStatisticsRow(this.onLocalStatisticsMaxIdFetched, this);
        } else {
            this.proxy.readStatistics(minDate, maxDate, this.onLocalStatisticsFetched, this);
        }
    },

    /**
     * Fires when local statistics was fetched from database, we should generate a params for request.
     */
    onLocalStatisticsFetched: function(stats) {
        var self = this;
        var i, c;
        var statistics = [];
        var minId = this.syncEventsMinId;
        var maxId = this.syncEventsMaxId;
        var minDate = this.syncEventsMinDate;
        var maxDate = this.syncEventsMaxDate;

        // Concatenate ranges of ids for exclusion
        for (i=0; i < stats.length; i++) {
            statistics.push( { id: parseInt(stats[i]['ID']), date: stats[i]['DATE'], min_id: parseInt(stats[i]['MIN_ID']), max_id: parseInt(stats[i]['MAX_ID']), complete:  parseInt(stats[i]['COMPLETE']) } );
        }

        var exclude = this.getEventsExcludeRanges(statistics);

        // Prepare maximum id for period that available in database
        var maxExcludeId = 0;

        for (i=0; i < exclude.length; i++) {
            if (exclude[i][1] > maxExcludeId) {
                maxExcludeId = exclude[i][1];
            }
        }

        // Verify statistics by days
        var complete = false;
        var days = this.syncEventsDays;
        var currDay = get_current_day();

        for (i=0; i < days.length; i++) {
            complete = false;

            for (c=0; c < statistics.length; c++) {
                if (statistics[c]['date'] == days[i]) {
                    if (statistics[c]['complete'] == 1) {
                        complete = true;
                    }

                    if (statistics[c]['date'] == currDay && this.syncEventsIgnoreCurrDay == false) {
                        complete = false;
                    }

                    break;
                }
            }

            if (!complete) {
                break;
            }
        }

        if (complete) {
            this.synchronizing = false;
            this.fireEvent('syncEventsComplete');
            return;
        }

        var params = {};
        var filter = {};
        params['count'] = this.backendEventsLimit;
        params['sort'] = 'rowid';
        params['dir'] = 'ASC';
        var left = false;

        if (minId > 0 && maxId > 0) {
            params['filter[id][from]'] = minId;
            params['filter[id][to]'] = maxId;

            left = this.getEventsTotalLeft(minId, maxId, exclude);

            if (left == 0) {
                this.storage.pushEvents({events:[], minDate:minDate, maxDate:maxDate, minId:minId, maxId:maxId}, this.onEventsPushedComplete, this);
                return;
            }
        } else {
            params['filter[date][from]'] = minDate;
            params['filter[date][to]'] = maxDate;
        }
        for (i=0; i < exclude.length; i++) {
            params['filter[exclude]['+ i +'][from]'] = exclude[i][0];
            params['filter[exclude]['+ i +'][to]']   = exclude[i][1];
        }


        if (this.terminated) {



            this.synchronizing = false;

            if (this.connProblems) {
                this.connProblems = false;
                this.fireEvent('connectionRestored');
            }



            this.fireEvent('syncTerminated');
            return;
        }

        // Fire change event
        if (left) {
            if (this.syncEventsTotalWant === false) {
                this.syncEventsTotalWant = left;
            }

            var time = this.getEventsTimeLeft(left, 1.3/*8*/, 1000);
            var percent  = this.getEventsLoadPercent(this.syncEventsTotalWant, left);

            this.fireEvent('syncEventsChange', percent, time);
        }

        // Wait n seconds to next request
        if (this.syncEventsDelay > 0) {
            setTimeout(function() { self.fetchServerEvents.call(self, params); }, this.syncEventsDelay);

            this.syncEventsDelay = false;
            return;
        }

        this.fetchServerEvents(params);
    },

    /**
     * Fires when max id of local statistics was fetched from database, we should generate a params for request.
     */
    onLocalStatisticsMaxIdFetched: function(stat) {
        if (stat === undefined){
            this.terminated = true;
        } else {
            // Set a valid data
            this.syncEventsMinId = parseInt(stat['MAX_ID']);
            this.syncEventsMinDate = stat['DATE'];
        }

        if (this.terminated) {
            this.synchronizing = false;

            if (this.connProblems) {
                this.connProblems = false;
                this.fireEvent('connectionRestored');
            }

            this.fireEvent('syncTerminated');
            return;
        }

        // Make a query
        var params = new Object();

        params['count'] = this.backendEventsLimit;
        params['sort'] = 'rowid';
        params['dir'] = 'ASC';
        params['filter[id][from]'] = this.syncEventsMinId + 1;
        params['filter[id][to]'] = this.syncEventsMinId + 1001;
        params['backend'] = this.backendName;
        delete params['filter[exclude]'];

        this.fetchServerEvents(params);
    },


    /**
     * Fetches an events from a server.
     */
    fetchServerEvents: function(params) {
        if (isRemoteMode()) {
            return;
        }




        Ext.Ajax.request({
            url: '../../api/v1/CDRView/CallsHistory/',
            method: 'get',
            params: params,
            success: this.onEventsFetched,
            failure: this.onEventsFetchedFailure,
            scope: this
        });
    },

    /**
     * Fires when request was successfull, we should process response for exceptions.
     */
    onEventsFetched: function(response) {
        var result = Ext.encode(Ext.decode(response.responseText).result)
        this.process(result, this.onEventsDecoded, this.onEventsRetry, this)
    },

    /**
     * Fires when response is valid and we should handle a result.
     */
    onEventsDecoded: function(result, text) {
        var self = this;
        var events = result['events'];
        var limit = result['limit'];
        var timeout = parseInt(result['timeout']);
        var minId = this.syncEventsMinId;
        var minDate = this.syncEventsMinDate;
        var maxId = this.syncEventsMaxId;
        var maxDate = this.syncEventsMaxDate;

        if (result['min_id'] != undefined && result['max_id'] != undefined) {
            this.syncEventsMinId = parseInt(result['min_id']);
            this.syncEventsMaxId = parseInt(result['max_id']);
        }

        if (!minId || !maxId) {
            minId = 0;
            maxId = 0;
        }


        if (this.syncEventsAutoFlag) {
            if (events.length == 0) {



                this.synchronizing = false;
                this.fireEvent('syncEventsComplete');
                return;
            }

            this.backendMaxId = parseInt(events[events.length - 1]['id']);
            this.backendMaxDate = events[events.length - 1]['date'];

            minId = this.syncEventsMinId;
            minDate = this.syncEventsMinDate;
            maxId = this.backendMaxId;
            maxDate = get_current_day();
        }

        // Push Events to Database
        this.syncEventsSuccessRequests++;
        this.syncEventsTimeout = timeout;



        if (!events.length)
            this.syncEventsAutoFlag = true;
        this.storage.pushEvents({events:events, minDate:minDate, maxDate:maxDate, minId:minId, maxId:maxId}, this.onEventsPushed, this);
    },

    removeKeysFromEvents: function(events){
        var eventsWithoutKeys = [];
        for (var i=0; i<events.length; i++){
            eventsWithoutKeys.push([
                events[i].id,
                events[i].from,
                events[i].fromChannel,
                events[i].to,
                events[i].toChannel,
                events[i].type,
                events[i]['class'],
                events[i].direction,
                events[i].date,
                events[i].duration,
                events[i].billsec,
                events[i].cost,
                events[i].tags
            ]);
        }
        return eventsWithoutKeys;
    },

    /**
     * Fires when request has been fail, another than 200 http code was respond.
     */
    onEventsFetchedFailure: function() {
        this.fireEvent('connectionError', this.onEventsRetry, this);
    },

    /**
     * Fires when response has try_again_later exception, we should repeat request to a server.
     */
    onEventsRetry: function(necessary) {
        this.syncEventsNecessary = necessary;
        this.syncEventsPartly();
    },

    /**
     * Fires when we successfully stored events to a database.
     */
    onEventsPushed: function() {
        this.syncEventsDelay = this.syncEventsTimeout * 1000;
        this.syncEventsPartly();
    },

    onEventsPushedComplete: function() {


        this.synchronizing = false;
        this.fireEvent('syncEventsComplete');
    },

    /**
     * Gets an exclude ranges by a statistics
     */
    getEventsExcludeRanges: function(statistics) {
        var i;
        var min_id, max_id;
        var ranges = [];
        var excludes = [];

        for (i=0; i < statistics.length; i++) {
            min_id = parseInt(statistics[i]['min_id']);
            max_id = parseInt(statistics[i]['max_id']);

            if (min_id > 0 && max_id > 0) {
                ranges.push([min_id, max_id]);
            }
        }

        min_id = false;
        max_id = false;

        for (i=0; i < ranges.length; i++) {
            if (i == 0) {
                if (ranges.length == 1) {
                    excludes.push([ranges[i][0], ranges[i][1]]);
                }

                min_id = ranges[i][0];
                max_id = ranges[i][1];

                continue;
            }

            if (ranges[i][0] != max_id + 1) {
                excludes.push([min_id, max_id]);

                min_id = ranges[i][0];
                max_id = ranges[i][1];
            }

            max_id = ranges[i][1];

            if (ranges.length == i + 1) {
                excludes.push([min_id, max_id]);
            }
        }

        return excludes;
    },

    /**
     * Gets a number of need to load events by exclude ranges and min, max id.
     */
    getEventsTotalLeft: function(minId, maxId, ranges) {
        var i;
        var total = maxId - minId;

        for (i=0; i < ranges.length; i++) {
            total = total - (ranges[i][1] - ranges[i][0]);
        }

        return total;
    },

    /**
     * Gets ~ time to finish synchronization.
     */
    getEventsTimeLeft: function(total, time, limit) {
        var offset = total % limit;
        var requests = 0;

        if (offset > 0) {
            requests = (total + (limit - offset)) / limit;
        } else {
            requests = total / limit;
        }

        var timeleft = requests * time;

        return timeleft;
    },

    /**
     * Gets a percent of loaded events.
     */
    getEventsLoadPercent: function(total, left) {
        // TODO: Use another final logic here.
        var pointer = total / 100;
        var percent = Math.ceil(Math.abs(left - total) / pointer);


        return percent;
    },

    /**
     * Fires when user want's to terminate a synchronization.
     */
    syncTerminate: function() {
        this.terminated = true;
    },

    // Misc methods

    getBackendMinId: function() {
        return this.backendMinId;
    },
    getBackendMaxId: function() {
        return this.backendMaxId;
    },
    getBackendMinDate: function() {
        return this.backendMinDate;
    },
    getBackendMaxDate: function() {
        return this.backendMaxDate;
    },

    /**
     * Fires when connection problem occur.
     */
    onConnectionError: function() {
        this.connProblems = true;
    },

    /**
     * Verifies response and executes a Successs, Retry or nothing when response is skipped or invalid.
     */
    process: function(text, callbackSuccess, callbackRetry, scope) {
        var result;
        var timeout;
        var exception = _t('Unknown error');

        scope = scope || this;

        try {
            result = Ext.decode(text);
        } catch (e) {
            // Server returns an unsupported format
            this.fireEvent('exceptionError', text);
            return;
        }

        timeout = parseInt(result['timeout']);

        if (result.hasOwnProperty('skipped') && parseInt(result['skipped']) === 1) {
            // Request was skipped by a server
            if (result.hasOwnProperty('exception')) {
                exception = result['exception'];
            }

            if (exception == 'TRY_AGAIN_LATER') {
                // Request was correctly skipped by a server and we should wait for a timeout and fire Retry callback
                if (this.attempts === undefined) {
                    this.attempts = 0;
                }

                if (this.attempts >= 5) {
                    setTimeout(function() { callbackRetry.call(scope, true); }, timeout * 1000);
                } else {
                    setTimeout(function() { callbackRetry.call(scope, false); }, timeout * 1000);
                }

                this.attempts++;
                return;
            }

            // Unknow exception we should stop any execution and show an error
            this.fireEvent('exceptionError', exception);
            return;
        }

        if (this.connProblems) {
            this.connProblems = false;
            this.fireEvent('connectionRestored');
        }

        // Normal request
        callbackSuccess.call(this, result, text);
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/storage/Bootstrap.js
Ext.define('App.storage.Bootstrap', {
    requires: [
        'App.proxy.AbstractProxy',
        'App.proxy.Synchronization',
        'App.storage.Storage',
        'App.storage.Synchronizer',
        'App.storage.QueryConstructor',
        'App.storage.QueryConstructorClickHouse',
        'App.view.bootstrap.Notification',
        'App.view.bootstrap.Sync',
        'App.view.bootstrap.ErrorLocked',
        'App.view.bootstrap.ErrorConnected',
        'App.view.bootstrap.ErrorConnection',
        'App.view.bootstrap.ErrorUnSupportedBrowser',
        'App.view.bootstrap.ErrorNotAllowed',
        'App.utility.Date',
        'App.utility.NamesFormatter',
        'App.utility.ImageExporter',
        'App.view.bootstrap.ErrorWISNotAppropriateVersion',
        'App.view.bootstrap.ErrorOSNotSupported',
        'App.view.bootstrap.ErrorDownloadStarted',
        'App.view.bootstrap.ErrorWISNotResponding',
        'App.view.bootstrap.ErrorWISNotInstalled'
    ],
    mixins: {
        observable: 'Ext.util.Observable'
    },
    constructor: function() {
        this.bootMask = Ext.get('boot-mask');
        this.bootLoader = Ext.get('boot-loader');



        if (!User.haveLicense){
            return Ext.create('App.view.bootstrap.ErrorNotAllowed', { renderTo: this.bootMask, reason: 'No CDRView license' });
        }
        if (!User.canUse){
            return Ext.create('App.view.bootstrap.ErrorNotAllowed', { renderTo: this.bootMask, reason: 'Access denied' });
        }

        this.storage = App.storage.Storage;
        this.storage.addListener('init', this.onInit, this);

        this.synchronizer = App.storage.Synchronizer;
        this.bindSynchronizerEvents();

        if (!this.storage.isOSSupported()) {
            // Shows a error message and stops any execution
            Ext.create('App.view.bootstrap.ErrorOSNotSupported', { renderTo: this.bootMask });
            this.hideLoader();
            return;
        } else if (!this.storage.isBrowserSupported() && Ext.util.Cookies.get('iWantThisBrowser')!=='1') {
            this.unSupportedErrorDialog = Ext.create('App.view.bootstrap.ErrorUnSupportedBrowser', { renderTo: this.bootMask });
            this.unSupportedErrorDialog.on('try', this.onTryBrowser, this);
            this.hideLoader();
        } else {
            //this.initDialog = Ext.create('App.view.bootstrap.Init', { renderTo: this.bootMask });
            this.storage.lookup();
        }

        this.callParent(arguments);
    },

    bindSynchronizerEvents: function(){
        this.synchronizer.on('syncUsersChange', this.onSyncUsersChange, this);
        this.synchronizer.on('syncUsersComplete', this.onSyncUsersComplete, this);
        this.synchronizer.on('syncExtraComplete', this.onSyncExtraComplete, this);
        this.synchronizer.on('syncBackendComplete', this.onSyncBackendComplete, this);
        this.synchronizer.on('syncEventsChange', this.onSyncEventsChange, this);
        this.synchronizer.on('syncEventsComplete', this.onSyncEventsComplete, this);
        this.synchronizer.on('syncTerminated', this.onSyncTerminated, this);
        this.synchronizer.on('syncTerminate', this.onSyncTerminate, this);

        this.synchronizer.on('exceptionError', this.onSyncExceptionError, this);
        this.synchronizer.on('connectionError', this.onSyncConnectionError, this);
        this.synchronizer.on('connectionRestored', this.onSyncConnectionRestored, this);
    },
    unBindSynchronizerEvents: function(){
        this.synchronizer.un('syncUsersChange', this.onSyncUsersChange, this);
        this.synchronizer.un('syncUsersComplete', this.onSyncUsersComplete, this);
        this.synchronizer.un('syncExtraComplete', this.onSyncExtraComplete, this);
        this.synchronizer.un('syncEventsChange', this.onSyncEventsChange, this);
        this.synchronizer.un('syncEventsComplete', this.onSyncEventsComplete, this);
        this.synchronizer.un('syncTerminated', this.onSyncTerminated, this);
        this.synchronizer.un('syncTerminate', this.onSyncTerminate, this);
        this.synchronizer.un('syncBackendComplete', this.onSyncBackendComplete, this);

        this.synchronizer.un('exceptionError', this.onSyncExceptionError, this);
        this.synchronizer.un('connectionError', this.onSyncConnectionError, this);
        this.synchronizer.un('connectionRestored', this.onSyncConnectionRestored, this);
    },
    /**
     * Fetches new data from PBX and redraw chart and tables
     */
    incrementalSynchronization: function(){

        var view = this.application.controllers.get('Viewport').view.down('#viewport');
        if (!view.mask){
            view.mask = new Ext.LoadMask(Ext.getBody(), {msg:false});
            view.mask.show();
        }
        //this.initDialog = Ext.create('App.view.bootstrap.Init', { renderTo: this.bootMask });
        this.bindSynchronizerEvents();
        this.storage.lookup();
        //
        this.synchronizer.on('syncEventsComplete', this.incrementalSynchronizationComplete, this);
    },
    incrementalSynchronizationComplete: function(){
        this.application.controllers.get('Viewer').fireEvent('incrementalSynchronization');
        this.synchronizer.un('syncEventsComplete', this.incrementalSynchronizationComplete, this);
    },
    /**
     * Fires when user clicked to Try Current Browser (Unsupported) button.
     */
    onTryBrowser: function() {
        Ext.destroy(this.unSupportedErrorDialog);

        //this.initDialog = Ext.create('App.view.bootstrap.Init', { renderTo: this.bootMask });
        this.storage.lookup();
    },
    onInit: function() {
        //Ext.destroy(this.initDialog);
        this.hideLoader();

        if (!this.storage.isInstalled()) {
            // Shows a error message and stops any execution
            this.errorDialog = Ext.create('App.view.bootstrap.ErrorWISNotInstalled', { renderTo: this.bootMask, installUrl:this.storage.getWIServiceUrl(),
                onDownloadStarted: Ext.bind(this.onDownloadStarted, this)
            });
            this.storage.close();
            return;
        } else if (!this.storage.isVersionReceived()) {
            // Shows a error message and stops any execution
            this.errorDialog = Ext.create('App.view.bootstrap.ErrorWISNotResponding', { renderTo: this.bootMask, installUrl:this.storage.getWIServiceUrl(),
                onDownloadStarted: Ext.bind(this.onDownloadStarted, this)
            });
            this.storage.close();
            return;
        } else if (!this.storage.isAppropriateVersion()) {
            // Shows a error message and stops any execution
            this.errorDialog = Ext.create('App.view.bootstrap.ErrorWISNotAppropriateVersion', { renderTo: this.bootMask, installUrl:this.storage.getWIServiceUrl(),
                onDownloadStarted: Ext.bind(this.onDownloadStarted, this)
            });
            this.storage.close();
            return;
        } else if (!this.storage.isConnected()) {
            // Shows a error message and stops any execution
            this.errorDialog = Ext.create('App.view.bootstrap.ErrorConnected', { renderTo: this.bootMask });
            this.storage.close();
            return;
        } else if (this.storage.isLocked()) {
            // Shows a error message and stops any execution
            this.errorDialog = Ext.create('App.view.bootstrap.ErrorLocked', { renderTo: this.bootMask });
            this.storage.close();
            return;
        } else {
            this.syncDialog = Ext.create('App.view.bootstrap.Sync', { renderTo: this.bootMask });
        }

        this.syncDialog.on('сancelButtonClick', this.onCancelButtonClick, this);
        if (isRemoteMode()) {


            this.synchronizer.fireEvent('syncEventsComplete');
        } else {


            this.syncDialog.markUsersSync();
            this.synchronizer.fireEvent('syncUsers');
        }
    },

    onDownloadStarted: function(){
        this.closeErrorDialog();
        this.errorDialog = Ext.create('App.view.bootstrap.ErrorDownloadStarted', { renderTo: this.bootMask });
    },
    closeErrorDialog: function(){
        if (this.errorDialog)
            this.errorDialog.hide();
            this.errorDialog.destroy();
            this.errorDialog = null;
    },

    onSyncUsersChange: function(percent, timeleft) {
        this.syncDialog.markUsersSync(percent, timeleft);
    },
    /**
     * Fires when sync of users was completed successfully.
     */
    onSyncUsersComplete: function() {



        this.syncDialog.markExtraSync();
        this.synchronizer.fireEvent('syncExtra');
    },

    /**
     * Fires when sync of extra information was completed successfully.
     */
    onSyncExtraComplete: function() {



        this.syncDialog.markBackendSync();
        this.synchronizer.fireEvent('syncBackend');
    },

    /**
     * Fires when sync of backend information was completed successfully, we should go to events sync step.
     */
    onSyncBackendComplete: function() {



        // Define a period for events synchronization.
        var period = 0;

        if (User.hasOwnProperty('period')) {
            period = User['period'];
        }

        var ranges = this.getEventsPeriodByType(period);
        var dateFrom = ranges[0];
        var dateTo = ranges[1];

        this.syncDialog.markEventsSync();
        this.synchronizer.fireEvent('syncEvents', dateFrom, dateTo, false);
    },

    /**
     * Fires when sync of users has been changed.
     */
    onSyncEventsChange: function(percent, timeleft) {
        this.syncDialog.markEventsSync(percent, timeleft);
    },

    /**
     * Fires when sync of users was completed successfully,
     */
    onSyncEventsComplete: function() {
        this.syncDialog.markEventsSync(100, 0);
        this.onSyncComplete();
    },

    /**
     * Fires when sync was completed successfully, we should initialize application.
     */
    onSyncComplete: function() {
        var self = this;
        var viewport;

        this.bootMask.setStyle('z-index', 10000);
        this.bootLoader.setStyle('z-index', 10010);
        this.syncDialog.hide(true);
        this.bootLoader.show(true);

        this.unBindSynchronizerEvents();
        if (!this.application)
            this.application = Ext.create('Application');


        var checker = function() {
            viewport = self.application.controllers.get('Viewport');

            if( self.application.controllers.get('Viewport') == undefined ) {
                setTimeout(checker, 200 );
                return false;
            }

            if( viewport.view == undefined || viewport.view.rendered == false ) {
                setTimeout(checker, 200 );
                return false;
            }

            self.bootLoader.hide(true);
            self.bootMask.hide(true);
            self.syncDialog.hide();

            Ext.destroy(self.syncDialog);
            var view = viewport.view.down('#viewport');
            if (view.mask){
                Ext.destroy(view.mask);
                view.mask = null;
            }

        }

        setTimeout( checker, 100 );
    },

    /**
     * Fires when synchronizer found an exception (stop working), we should
     * show this exception.
     */
    onSyncExceptionError: function(message) {
        if (this.syncDialog) {
            this.syncDialog.hide();
        }

        if (this.connErrorDialog) {
            this.connErrorDialog.hide();
        }

        this.errorDialog = Ext.create('App.view.bootstrap.ErrorCritical', {
            response: message
        });
        this.errorDialog.show();
    },

    /**
     * Fires when synchronizer found a connection problem, we should show notification
     * about this at top of page.
     */
    onSyncConnectionError: function(callback, scope) {
        if (!this.connErrorDialog) {
            this.connErrorDialog = Ext.create('App.view.bootstrap.ErrorConnection');
        }

        this.connErrorCallback = callback;
        this.connErrorScope = scope || this;

        this.connErrorDialog.handle(30, this.onSyncConnectionErrorCallback, this);
    },

    /**
     * Fires when synchronizer was been normally restored a connection to pbx, we should show a notification
     * about connection problems.
     */
    onSyncConnectionRestored: function() {
        if (this.connErrorDialog) {
            this.connErrorDialog.hide();
        }
    },

    /**
     * Fires when we should repeat failure request to a server
     */
    onSyncConnectionErrorCallback: function() {
        this.connErrorCallback.call(this.connErrorScope);
    },

    onSyncTerminate: function() {
        this.syncDialog.markTerminating();
    },

    onSyncTerminated: function() {
        this.syncDialog.markTerminated();
        this.onSyncComplete();
    },

    onCancelButtonClick: function() {
        this.synchronizer.fireEvent('syncTerminate');
    },
    /**
     * Gets a period ranges as array by specified type.
     */
    getEventsPeriodByType: function(type) {
        var dateTo = Ext.Date.format(Ext.Date.add(get_current_date(), Ext.Date.DAY,1), "Y-m-d");
        var dateFrom;

        switch(parseInt(type)) {
            case App.utility.Date.MONTH:     // 1 month
                dateFrom = App.utility.Date.getThisMonth();
                //dateFrom = Ext.Date.format(Ext.Date.add(get_current_date(), Ext.Date.MONTH, -1), "Y-m-d");
                break;
            case App.utility.Date.LAST_3_MONTH:      // 3 months
                dateFrom = App.utility.Date.getPrevNMonth(3);
                //dateFrom = Ext.Date.format(Ext.Date.add(get_current_date(), Ext.Date.MONTH, -3), "Y-m-d");
                break;
            case App.utility.Date.LAST_6_MONTH:      // 6 months
                dateFrom = App.utility.Date.getPrevNMonth(6);
                //dateFrom = Ext.Date.format(Ext.Date.add(get_current_date(), Ext.Date.MONTH, -6), "Y-m-d");
                break;
            case App.utility.Date.LAST_12_MONTH:      // 1 year
                dateFrom = App.utility.Date.getPrevNMonth(12);
                //dateFrom = Ext.Date.format(Ext.Date.add(get_current_date(), Ext.Date.MONTH, -12), "Y-m-d");
                break;
            default: // App.utility.Date.LAST_2_WEEKS        // 2 weeks
                dateFrom = App.utility.Date.getPrevWeek();
                //dateFrom = Ext.Date.format(Ext.Date.add(get_current_date(), Ext.Date.DAY, -14), "Y-m-d");
            break;
        }
        dateFrom = dateFrom.split(' ')[0];
        return [dateFrom, dateTo];
    },
    hideLoader: function() {
        Ext.get('boot-loader').hide(false);
    },
    showLoader: function() {
        Ext.get('boot-loader').show(false);
    },
    hideMask: function() {
        Ext.get('boot-mask').hide(false);
    },
    showMask: function() {
        Ext.get('boot-mask').show(false);
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/GroupedEvent.js
Ext.define( 'App.model.GroupedEvent', {
    extend: 'Ext.data.Model',
    fields: [
        'HOUR',
        'HOUR_OF_DAY',
        'DAY',
        'DAY_OF_WEEK',
        'WEEK',
        'MONTH',
        'MONTH_OF_YEAR',
        'YEAR',
        'USER',
        'USER_NAME',
        'USER_GROUP',
        'USER_GROUP_NAME',
        'CLIENT',
        'CLIENT_NAME',
        'COMPANY',
        'COMPANY_NAME',
        'NUMBER',
        'SERVICE',
        'DIRECTION',
        'TRUNK',
        'TRUNK_NAME',
        'TAG',
        'TAG_NAME',
        'PBX',
        'PBX_NAME',
        'COUNTRY',
        'COUNTRY_NAME',
        'CLASS',
        'USER_FROM',
        'USER_FROM_NAME',
        'USER_TO',
        'USER_TO_NAME',
        'GROUP_FROM',
        'GROUP_FROM_NAME',
        'GROUP_TO',
        'GROUP_TO_NAME',
        'TOTAL_EVENTS',
        'TOTAL_LOCAL_EVENTS',
        'TOTAL_INCOMING_EVENTS',
        'TOTAL_OUTGOING_EVENTS',
        'TOTAL_ANSWERED_EVENTS',
        'TOTAL_ANSWERED_WITHIN_XX_EVENTS',
        'TOTAL_ANSWERED_OVER_XX_EVENTS',
        'TOTAL_NOT_ANSWERED_EVENTS',
        'TOTAL_CALL_EVENTS',
        'TOTAL_FAX_EVENTS',
        'TOTAL_VOICEMAIL_EVENTS',
        'TOTAL_DURATION',
        'AVG_DURATION',
        'TOTAL_LOCAL_DURATION',
        'AVG_LOCAL_DURATION',
        'TOTAL_INCOMING_DURATION',
        'AVG_INCOMING_DURATION',
        'TOTAL_OUTGOING_DURATION',
        'TOTAL_BILL',
        'AVG_BILL',
        'TOTAL_LOCAL_BILL',
        'AVG_LOCAL_BILL',
        'TOTAL_INCOMING_BILL',
        'AVG_INCOMING_BILL',
        'TOTAL_OUTGOING_BILL',
        'AVG_OUTGOING_BILL',
        'TOTAL_RING',
        'AVG_RING',
        'TOTAL_COST',
        'TOTAL_CALL_COST',
        'TOTAL_FAX_COST',
        'AVG_COST',
        'AVG_CALL_COST',
        'AVG_FAX_COST'
    ],
    proxy: {
        type: 'groupedEvents'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/Destination.js
/**
 * Available destinations type:
 * 
 * 1 - Manually selected phone number
 * 2 - Call Classes
 * 3 - Groups
 * 4 - Users (Local)
 * 5 - Users (PhoneBook)
 * 
 * Number field contains:
 * 
 * {local phone} | {mobile phone} | {fax phone}
 * 
 */
Ext.define('App.model.Destination', {
    extend: 'Ext.data.Model',
    fields: [
        'id',
        'uid',
        'type',
        'name',
        'number'
    ],
    proxy: {
        type: 'destinationsExt'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/User.js
Ext.define('App.model.User', {
    extend: 'Ext.data.Model',
    fields: ['id', 'name'],
    proxy: {
        type: 'users'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/Group.js
Ext.define('App.model.Group', {
    extend: 'Ext.data.Model',
    fields: ['id', 'name'],
    proxy: {
        type: 'groups'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/Filter.js
Ext.define('App.model.Filter', {
    extend: 'Ext.data.Model',
    fields: [
        'id',
        'name',
        'state'
    ],
    proxy: {
        type: 'filters'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/DestinationInt.js
Ext.define( 'App.model.DestinationInt', {
    extend: 'App.model.Destination',
    proxy: {
        type: 'destinationsInt'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/Trunk.js
Ext.define('App.model.Trunk', {
    extend: 'Ext.data.Model',
    fields: [
        'id',
        'name'
    ],
    proxy: {
        type: 'trunks'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/SimpleEvent.js
Ext.define( 'App.model.SimpleEvent', {
    extend: 'Ext.data.Model',
    fields: [
        'ID',
        'DATE',
        'DURATION',
        'FROM',
        'FROM_USER',
        'FROM_NAME',
        'FROM_GROUP',
        'TO',
        'TO_USER',
        'TO_NAME',
        'TO_GROUP',
        'COUNTRY',
        'COUNTRY_AREA',
        'CLASS',
        'COST',
        'DIRECTION',
        'DURATION',
        'BILL',
        'RING',
        'TRUNK',
        'PBX',
        'TAG',
        'SERVICE',
        'USERFIELD',
        'FAXDATA'
    ],
    proxy: {
        type: 'simpleEvents'
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/DestinationExt.js
Ext.define( 'App.model.DestinationExt', {
    extend: 'App.model.Destination',
    proxy: {
        type: 'destinationsExt'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/Pbx.js
Ext.define('App.model.Pbx', {
    extend: 'Ext.data.Model',
    fields: [
        'id',
        'serial',
        'name'
    ],
    proxy: {
        type: 'pbxes'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/model/Tag.js
Ext.define('App.model.Tag', {
    extend: 'Ext.data.Model',
    fields: [
        'id',
        'name'
    ],
    proxy: {
        type: 'tags'
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/AbstractStore.js
Ext.define('App.store.AbstractStore', {
    extend: 'Ext.data.Store',
    constructor: function() {
        this.addEvents('sortchange');
        this.callParent(arguments);
    },
    onGuaranteedRange: function() {
        var me = this,
            totalCount = me.getTotalCount(),
            start = me.requestStart,
            end = ((totalCount - 1) < me.requestEnd) ? totalCount - 1 : me.requestEnd,
            range = [],
            record,
            i = start;

        end = Math.max(0, end);

        if (start !== me.guaranteedStart && end !== me.guaranteedEnd) {
            me.guaranteedStart = start;
            me.guaranteedEnd = end;

            for (; i <= end; i++) {
                record = me.prefetchData.getByKey(i);
                
                if (record) {
                    range.push(record);
                }
            }
            me.fireEvent('guaranteedrange', range, start, end);
            if (me.cb) {
                me.cb.call(me.scope || me, range);
            }
        }

        me.unmask();
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/Destinations.js
Ext.define('App.store.Destinations', {
    extend: 'Ext.data.Store',
    remoteSort: true,
    remoteFilter: true,
    pageSize: 100,
    purgePageCount: 0,
    buffered: true,
    onGuaranteedRange: function() {
        var me = this,
            totalCount = me.getTotalCount(),
            start = me.requestStart,
            end = ((totalCount - 1) < me.requestEnd) ? totalCount - 1 : me.requestEnd,
            range = [],
            record,
            i = start;

        end = Math.max(0, end);

        if (start !== me.guaranteedStart && end !== me.guaranteedEnd) {
            me.guaranteedStart = start;
            me.guaranteedEnd = end;

            for (; i <= end; i++) {
                record = me.prefetchData.getByKey(i);
                
                if (record) {
                    range.push(record);
                }
            }
            me.fireEvent('guaranteedrange', range, start, end);
            if (me.cb) {
                me.cb.call(me.scope || me, range);
            }
        }

        me.unmask();
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/DestinationsExt.js
Ext.define('App.store.DestinationsExt', {
    extend: 'App.store.Destinations',
    model: 'App.model.DestinationExt'
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/DestinationsInt.js
Ext.define('App.store.DestinationsInt', {
    extend: 'App.store.Destinations',
    model: 'App.model.DestinationInt'
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/Trunks.js
Ext.define('App.store.Trunks', {
    extend: 'App.store.Destinations',
    model: 'App.model.Trunk'
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/SimpleEvents.js
Ext.define('App.store.SimpleEvents', {
    extend: 'App.store.AbstractStore',
    model: 'App.model.SimpleEvent',
    storeId: 'SimpleEvents',
    remoteSort: true,
    remoteFilter: true,
    pageSize: 100,
    purgePageCount: 0,
    buffered: true,
    sort: function(sort) {
        if (!sort['direction'] || !sort['property']) {
            return;
        }
        
        var sorters = {
            field: sort['property'],
            dest: sort['direction']
        }
        
        this.setBuilderSorters(sorters);
        this.fireEvent('sortchange', sorters);
        this.callParent(arguments);
    },
    setReportId: function(id) {
        this.reportId = id;
    },
    getReportId: function() {
        return this.reportId;
    },
    getBuilderType: function() {
        return 1;
    },
    setBuilderFilters: function(filters) {
        this.builderFilters = filters;
    },
    getBuilderFilters: function() {
        return this.builderFilters;
    },
    setBuilderGroupings: function(groupings) {
        this.builderGroupings = groupings;
    },
    getBuilderGroupings: function() {
        return this.builderGroupings;
    },
    getBuilderSorters: function() {
        return this.builderSorters;
    },
    setBuilderSorters: function(sorters) {
        this.builderSorters = sorters;
    },
    setBuilderColumns: function(columns) {
        this.builderColumns = columns;
    },
    getBuilderColumns: function() {
        return this.builderColumns;
    },
    setBuilderSummaries: function(summaries) {
        this.builderSummaries = summaries;
    },
    getBuilderSummaries: function() {
        return this.builderSummaries;
    },
    setSummaries: function(summaries) {
        this.summaries = summaries;
    },
    getSummaries: function() {
        return this.summaries;
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/GroupedEvents.js
Ext.define('App.store.GroupedEvents', {
    extend: 'App.store.AbstractStore',
    model: 'App.model.GroupedEvent',
    storeId: 'GroupedEvents',
    remoteSort: true,
    remoteFilter: true,
    pageSize: 100,
    purgePageCount: 0,
    buffered: true,
    sort: function(sort) {
        if (!sort['direction'] || !sort['property']) {
            return;
        }
        
        var sorters = {
            field: sort['property'],
            dest: sort['direction']
        }
        
        this.setBuilderSorters(sorters);
        this.fireEvent('sortchange', sorters);
        this.callParent(arguments);
    },
    setReportId: function(id) {
        this.reportId = id;
    },
    getReportId: function() {
        return this.reportId;
    },
    getBuilderType: function() {
        return 2;
    },
    setBuilderFilters: function(filters) {
        this.builderFilters = filters;
    },
    getBuilderFilters: function() {
        return this.builderFilters;
    },
    setBuilderGroupings: function(groupings) {
        this.builderGroupings = groupings;
    },
    getBuilderGroupings: function() {
        return this.builderGroupings;
    },
    getBuilderSorters: function() {
        return this.builderSorters;
    },
    setBuilderSorters: function(sorters) {
        this.builderSorters = sorters;
    },
    setBuilderColumns: function(columns) {
        this.builderColumns = columns;
    },
    getBuilderColumns: function() {
        return this.builderColumns;
    },
    setBuilderSummaries: function(summaries) {
        this.builderSummaries = summaries;
    },
    getBuilderSummaries: function() {
        return this.builderSummaries;
    },
    setBuilderSummariesType: function(type) {
        this.builderSummariesType = type;
    },
    getBuilderSummariesType: function() {
        return this.builderSummariesType;
    },
    setSummaries: function(summaries) {
        this.summaries = summaries;
    },
    getSummaries: function() {
        return this.summaries;
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/Filters.js
Ext.define('App.store.Filters', {
    extend: 'Ext.data.Store',
    model: 'App.model.Filter',
    remoteSort: false,
    autoLoad: true
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/Pbxes.js
Ext.define('App.store.Pbxes', {
    extend: 'App.store.Destinations',
    model: 'App.model.Pbx'
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/store/Tags.js
Ext.define('App.store.Tags', {
    extend: 'App.store.Destinations',
    model: 'App.model.Tag'
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewport/error/ErrorCritical.js
Ext.define('App.view.viewport.error.ErrorCritical', {
    extend: 'Ext.Container',
    cls: 'w-boot-dialog w-viewport-critical',
    floating: true,
    width: 560,
    ariaRole: 'dialog',
    response: '-',
    title: _t('Error'),
    initComponent: function() {
        this.renderTo = Ext.getBody();
        Ext.getBody().query('.w-boot-dialog').forEach(function(el){
            if (el && el.id && Ext.ComponentManager.get(el.id)){
                Ext.ComponentManager.get(el.id).destroy();
            }
        });
        this.renderTpl = [
            '<div class="w-boot-title">{title}</div>',
            '<div class="w-boot-contents" style="padding: 5px 0 0 0;">',
                '<div class="w-boot-critical">{response}</div>',
                '<div>',
                    sprintf('%(criticalErr)s', { criticalErr : _t('Please <a href="javascript:location.reload(true)">reload</a> the page. If the problem persists contact your system administrator.') }),
                '</div>',
            '</div>'
        ];
        this.renderData = {
            title: this.title,
            response: this.response
        }
                
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.show();
    },
    destroy: function() {
        Ext.EventManager.removeResizeListener(this.align, this);
        this.callParent(arguments);
    },
    show: function() {
        Ext.EventManager.onWindowResize(this.align, this);

        // Mask body
        this.bodyMask = Ext.getBody().mask();
        this.bodyMask.setStyle('z-index', 99000);

        this.align();
        this.callParent(arguments);

        // Define a maximal z-index
        this.getEl().setStyle('z-index', 100000);
    },
    hide: function() {
        Ext.EventManager.removeResizeListener(this.align, this);
        Ext.getBody().unmask();

        this.callParent(arguments);
    },
    align: function() {
        var width = Ext.getBody().getWidth();
        var height = Ext.getBody().getHeight();
        var left = parseInt(width / 2) - parseInt(this.getWidth() / 2);
        var top = parseInt(height / 2) - parseInt(this.getHeight() / 2);

        this.setPosition( left, top, false);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewport/error/ErrorConnection.js
Ext.define('App.view.viewport.error.ErrorConnection', {
    extend: 'App.view.bootstrap.ErrorConnection'
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewport/Button.js
Ext.define('App.view.viewport.Button', {
    extend: 'Ext.Container',
    alias : 'widget.viewportButton',
    cls: 'w-button',
    text: 'Viewport Button',
    hideMode: 'display',
    constructor: function() {
        this.addEvents('click');
        this.callParent(arguments);
    },
    initComponent: function() {
        this.renderTpl = [
            '<div class="w-button-left"><div class="w-button-right">',
                '{text}',
            '</div></div>'
        ];
        this.renderData = {
            text: this.text
        }
        this.renderSelectors = {
            textEl: 'div.w-button-right'
        }
        this.callParent(arguments);
    },
    setText: function(text) {
        this.text = text;
        this.textEl.update(text);
    },
    getText: function() {
        return this.text;
    },
    afterRender: function() {
        this.callParent(arguments);
        this.getEl().on('click', this.onClick, this);
    },
    onClick: function() {
        this.fireEvent('click');
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewport/Switcher.js
Ext.define('App.view.viewport.Switcher', {
    extend: 'Ext.view.View',
    alias : 'widget.viewportSwitcher',
    cls: 'w-switcher',
    switchable: false,
    initComponent: function() {
        this.addEvents('change');
        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                'id',
                'text',
                'active',
                'side'
            ],
            data: this.verifyMenus(this.menu)
        });
        this.tpl = this.getTplInstance();
        this.itemSelector = 'div.item';
        this.callParent(arguments);
    },
    getTplInstance: function() {
         return new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="item <tpl if="side == 1">item-first</tpl> <tpl if="side == 2">item-last</tpl> <tpl if="side == 3">item-first item-last</tpl>  <tpl if="active == 1">item-active</tpl>"><div class="item-left"><div class="item-right">',
                    '{text}',
                '</div></div></div>',
            '</tpl>'
        );
    },
    verifyMenus: function(menus) {
        var i;
        
        if(menus == undefined)
            return [];
        for (i=0; i < menus.length; i++) {
            if (i == 0) {
                menus[i]['side'] = 1;
            } else if(i == menus.length - 1) {
                menus[i]['side'] = 2;
            } else {
                menus[i]['side'] = 0;
            }
            if (menus.length == 1){
                menus[i]['side'] = 3;
            }
        }
        
        return menus;
    },
    onItemClick: function(record, item, index) {

        if (this.switchable){
            if (record.get('active') == 1)
                record.set('active', 0);
            else
                record.set('active', 1);

            this.fireEvent('change', record.get('id'), record.get('active') == 1);
            return true;
        }

        var i, r;
        
        if (record.get('active') == 1){
            return;
        }
        
        for (i=0; i < this.store.getCount(); i++) {
            r = this.store.getAt(i);
            
            if (r.get('active') == 1) {
                r.set('active', 0);
            }
        }
        
        record.set('active', 1);
        this.fireEvent('change', record.get('id'));
    },
    
    setMenu: function(items) {
        this.store.loadData(this.verifyMenus(items));
    },
    
    /**
     * Sets active item for switcher, if id is false any item will be unactive.
     */
    setActiveItem: function(id) {
        this.clearSelection();
        
        if (id) {
            var item = this.store.getById(id);

            if (item) {
                item.set('active', true);
            }
        }
    },
    
    getActiveItem: function() {
        var active = this.store.queryBy(function(rec){
            return rec.get('active');
        }).first();

        if (active) {
            return active.get('id');
        }

        return false;
    },
    
    /**
     * @private
     */
    clearSelection: function(){
        this.store.each(function(itm){
            if(itm.get('active'))
                itm.set('active', false);
        });
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewport/LinkSwitcher.js
Ext.define('App.view.viewport.LinkSwitcher', {
    extend: 'App.view.viewport.Switcher',
    alias : 'widget.viewportLinkSwitcher',
    cls: 'w-link-switcher',
    getTplInstance: function() {
        return new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="item <tpl if="active == 1">item-active</tpl>">',
                    '{text}',
                '</div>',
            '</tpl>'
        );
    }
})
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewport/PickerButton.js
Ext.define('App.view.viewport.PickerButton', {
    extend: 'Ext.Container',
    alias : 'widget.viewportPickerButton',
    cls: 'w-button w-button-picker',
    text: 'Viewport Picker Button',
    constructor: function() {
        this.addEvents('click');
        this.callParent(arguments);
    },
    initComponent: function() {
        this.renderTpl = [
            '<div class="w-button-left"><div class="w-button-right">',
                '<div class="w-button-picker-arrow">{text}</div>',
            '</div></div>'
        ];
        this.renderData = {
            text: this.text
        }
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.getEl().on('click', this.onClick, this);
    },
    onClick: function() {
        this.fireEvent('click');
    },
    setText: function(text){
        this.renderData ={
            text: text
        };
        var renderTpl = this.initRenderTpl();
        if (renderTpl) {
            var renderData = this.initRenderData();
            renderTpl.overwrite(this.getTargetEl(), renderData);
        }
        this.doComponentLayout();
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/Viewport.js
Ext.define('App.view.Viewport', {
    extend: 'Ext.container.Viewport',
    layout: 'anchor',
    style: "background: url('misc/images/navigation-bg.jpg?2') top repeat-x;",
    items: [
        {
            xtype: 'navigation',
            style: 'margin: 0px auto;',
            minWidth: 1240,
            maxWidth: 1536
        },
        {
            xtype: 'container',
            itemId: 'viewport',
            anchor: '100% -70',
            padding: '15px 20px 15px 20px',
            style: 'margin: 0px auto;',
            minWidth: 1240,
            maxWidth: 1536,
            layout: {                        
                type: 'vbox',
                align: 'stretch'
            },
            items: [
                {
                    xtype: 'reports'
                },
                {
                    xtype: 'filter'
                },
                {
                    xtype: 'container',
                    itemId: 'viewerToolbarHolder',
                    layout: 'fit',
                    padding: '15 0 0 0',
                    items: [
                        {
                            xtype: 'container',
                            itemId: 'viewerToolbar',
                            layout: 'column',
                            style: 'overflow: hidden;',
                            items: [
                                {
                                    xtype: 'container',
                                    columnWidth: 1,
                                    layout: 'column',
                                    items: [
                                        {
                                            xtype: 'viewportSwitcher',
                                            itemId: 'viewerTypeSwitcher',
                                            menu: [
                                                {
                                                    id: 'TABLE',
                                                    text: _t('Data grid'),
                                                    active: 1
                                                },
                                                {
                                                    id: 'CHART_LINE',
                                                    text: _t('Line Chart'),
                                                    active: 0
                                                },
                                                {
                                                    id: 'CHART_AREA',
                                                    text: _t('Area Chart'),
                                                    active: 0
                                                },
                                                {
                                                    id: 'CHART_PIE',
                                                    text: _t('Pie Chart'),
                                                    active: 0
                                                },
                                                {
                                                    id: 'CHART_BAR',
                                                    text: _t('Bar Chart'),
                                                    active: 0
                                                },
                                                {
                                                    id: 'CHART_COLUMN',
                                                    text: _t('Column Chart'),
                                                    active: 0
                                                }
                                            ]
                                        },
                                        {
                                            xtype: 'viewportSwitcher',
                                            itemId: 'viewerChartLabelSwitcher',
                                            margin: '0 0 0 10',
                                            switchable: true,
                                            menu: [
                                                {
                                                    id: 'CHART_LABELS',
                                                    text: _t('Chart Labels'),
                                                    active: 0
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    itemId: 'viewerColumnsContainer',
                                    layout: 'column',
                                    items: [
                                        {
                                            xtype: 'viewerGrouping'
                                        },
                                        {
                                            xtype: 'viewerMetric'
                                        },
                                        {
                                            xtype: 'viewerFullPage'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                },
                {
                    xtype: 'container',
                    itemId: 'viewerHolder',
                    layout: 'fit',
                    flex: 1,
                    padding: '10 0 0 0',
                    items: [
                        {
                            xtype: 'viewer'
                        }
                    ]
                }
            ]
        }
        
    ]
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/FullPage.js
Ext.define('App.view.viewer.FullPage', {
    extend: 'App.view.viewport.Button',
    alias : 'widget.viewerFullPage',
    margin: '0 0 0 10',
    width: 20,
    text: '<div class="w-viewer-fullscreen-button"></div>',
    initComponent: function() {
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        
        this.tip = Ext.create('Ext.tip.ToolTip', {
            target: this.getId(),
            trackMouse: true,
            html: _t('Enable/Disable full screen mode')
        });
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/ExportButton.js
Ext.define('App.view.viewer.ExportButton', {
    extend: 'App.view.viewport.Button',
    alias : 'widget.viewerExportButton',
    cls: 'w-button',
    margin: '0 0 0 10',
    width: 140,
    text: _t('Export'),
    initComponent: function() {
        this.callParent(arguments);
    },
    setEnabled: function(enabled) {
        if (enabled) {
            this.getEl().unmask();
        } else {
            this.getEl().mask();
        }
        this.disabled = !enabled;
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/ExportDialog.js
Ext.define('App.view.viewer.ExportDialog', {
    extend: 'Ext.window.Window',
    title: _t('Export datagrid'),
    width: 360,
    modal: true,
    resizable: false,
    closable: false,
    bodyStyle: 'background: transparent; border: 0;',
    constructor: function() {
        this.addEvents('complete', 'terminated');
        this.callParent(arguments);
    },
    initComponent: function() {

        this.addEvents('export', 'open');

        this.xlsRadioField = Ext.create('Ext.form.field.Radio', {
            name: 'exportFormatRadio',
            value: 'xls',
            boxLabel: _t('.xls (Microsoft Excel)')
        });

        this.csvRadioField = Ext.create('Ext.form.field.Radio', {
            name: 'exportFormatRadio',
            value: 'csv',
            checked: true,
            boxLabel: _t('.csv (Comma-separated values)')
        });

        this.formatCt = Ext.create('Ext.container.Container', {
            cls: 'w-sync-description',
            style: 'padding-bottom: 5px;',
            items: [
                {
                    xtype: 'container',
                    padding: '0 0 5 0',
                    html: _t('Please select a format for export:')
                },
                this.xlsRadioField,
                this.csvRadioField
            ]
        });


        this.croppedDescriptionCt = Ext.create('Ext.container.Container', {
            padding: '0 0 5 0'
        });

        this.croppedCt = Ext.create('Ext.container.Container', {
            cls: 'w-sync-description',
            style: 'padding-bottom: 5px;',
            hidden: true,
            items: [
                {
                    xtype: 'container'
                }
            ]
        });

        this.generatedDescriptionCt = Ext.create('Ext.container.Container', {
            padding: '0 0 5 0'
        });

        this.generatedCt = Ext.create('Ext.container.Container', {
            cls: 'w-sync-description',
            style: 'padding-bottom: 5px;',
            hidden: true,
            items: [
                this.generatedDescriptionCt
            ]
        });

        this.exportButton = Ext.create('Ext.button.Button', {
            text: _t('Export')
        });
        this.exportButton.on("click", this.onExportButtonClick, this)

        this.nextButton = Ext.create('Ext.button.Button', {
            text: _t('Next'),
            hidden: true
        });
        this.nextButton.on("click", this.onNextButtonClick, this);

        this.cancelButton = Ext.create('Ext.button.Button', {
            text: _t('Cancel')
        });
        this.cancelButton.on("click", this.onCloseOrCancelButtonClick, this);

        this.openButton = Ext.create('Ext.button.Button', {
            text: _t('Open'),
            hidden: true
        });
        this.openButton.on("click", this.onOpenButtonClick, this);

        this.closeButton = Ext.create('Ext.button.Button', {
            text: _t('Close'),
            hidden: true
        });
        this.closeButton.on("click", this.onCloseOrCancelButtonClick, this);

        this.items = [
            this.croppedCt,
            this.formatCt,
            this.generatedCt
        ];

        this.buttons = [
            this.nextButton,
            this.exportButton,
            this.cancelButton,
            this.openButton,
            this.closeButton
        ]

        this.callParent(arguments);
    },

    showCroppedNotification: function() {
        this.croppedCt.show();
        this.formatCt.hide();
        this.generatedCt.hide();
        this.nextButton.show();
        this.exportButton.hide();
        this.cancelButton.hide();
        this.openButton.hide();
        this.closeButton.show();
        this.show();
    },

    switchToDownloadState: function(path) {
        var separator = "/";

        if (Ext.isWindows) {
            separator = "\\";
        }

        var paths = path.split(separator);
        var file = paths.pop();
        var directory = paths.join(separator);
        var description = sprintf('File <b>"%(file)s"</b> successfully generated and saved in <b>"%(directory)s"</b>, press "Open" to open it immediately', {
            file: file,
            directory: directory
        });

        this.generatedDescriptionCt.getEl().update(description);

        this.exportButton.hide();
        this.cancelButton.hide();
        this.closeButton.show();
        this.openButton.show();

        this.formatCt.hide();
        this.generatedCt.show();
    },
    onExportButtonClick: function() {
        var format = 'xls';





        if (this.csvRadioField.getValue()) {
            format = 'csv';
        }

        this.fireEvent("export", format);
    },
    onNextButtonClick: function() {
        this.croppedCt.hide();
        this.formatCt.show();
        this.generatedCt.hide();
        this.nextButton.hide();
        this.exportButton.show();
        this.cancelButton.show();
        this.openButton.hide();
        this.closeButton.hide();
    },
    onOpenButtonClick: function() {
        this.fireEvent("open");
    },
    onCloseOrCancelButtonClick: function() {
        Ext.destroy(this);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/Metric.js
Ext.define('App.view.viewer.Metric', {
    extend: 'App.view.viewport.PickerButton',
    alias : 'widget.viewerMetric',
    text: _t('Metric'),
    width: 140,
    margin: '0 0 0 10',
    disabled: true,
    initComponent: function() {
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);

        // Attach picker
        this.picker = Ext.create('App.view.metric.Picker', {
            target: this.getEl()
        });
        this.picker.on('change', this.onMetricPickerChange, this);
        this.picker.on('grpElClick', this.onGrpElClick, this);
    },
    onMetricPickerChange: function(state) {
        this.fireEvent('change', state);
    },
    getPicker: function() {
        return this.picker;
    },
    onClick: function() {
        if (this.getPicker().allowList){
            this.picker.show();
        }
    },
    changeStatus: function(allow) {
        this.getPicker().allowList = allow;
        this[allow?'enable':'disable'](!allow);
        this.getPicker().refresh();
    },
    onGrpElClick: function() {
        this.fireEvent('grpElClick');
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/Grouping.js
Ext.define('App.view.viewer.Grouping', {
    extend: 'App.view.viewport.PickerButton',
    alias : 'widget.viewerGrouping',
    text: _t('Grouping by'),
    width: 160,
    margin: '0 0 0 10',
    initComponent: function() {
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);

        // Attach picker
        this.picker = Ext.create('App.view.grouping.Picker', {
            target: this.getEl()
        });
        this.picker.on('change', this.onGroupingsPickerChange, this);
    },
    onGroupingsPickerChange: function(state) {
        this.fireEvent('change', state);
        this.updateText(state);
    },
    updateText: function(state){
        //Set additional button title
        var title = _t('Grouping by');
        this.picker.store.each(function(rec) {
            if(state.indexOf(rec.get('name')) != -1 ){
                title += ' ' + rec.get('text');
            }
        });
        this.setText(title);

    },
    setState: function(state){        
        this.picker.setState(state);
        this.updateText(state);
    },
    getPicker: function() {
        return this.picker;
    },
    onClick: function() {
        this.picker.show();
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/error/EmptyResults.js
Ext.define('App.view.viewer.error.EmptyResults', {
    extend: 'Ext.container.Container',
    layout: {
        type: 'vbox',
        align : 'center'
    },
    initComponent: function() {
        this.items = [
            {
                xtype: 'container',
                flex: 1
            },
            {
                xtype: 'container',
                style: 'text-align:center;',
                html: _t('No result')
            },
            {
                xtype: 'container',
                flex: 1
            }
        ]
        
        this.callParent(arguments);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/error/NotSupportedGrouping.js
Ext.define('App.view.viewer.error.NotSupportedGrouping', {
    extend: 'Ext.container.Container',
    layout: {
        type: 'vbox',
        align : 'center'
    },
    groupingStateName:'',
    width:500,
    constructor: function() {
        this.callParent(arguments);
        this.addEvents('action');
        this.enableBubble('action');
    },
    initComponent: function() {

        this.tpl = new Ext.XTemplate(
            '<ul class="e-offers-list">',
                '<tpl for=".">',
                    '<li>',
                        '<a class="e-offers-list-link" name="{name}">{text}</a>',
                    '</li>',
                '</tpl>',
            '</ul>'
        );

        this.items = [
            {
                xtype: 'container',
                flex: 1
            },
            {
                xtype: 'container',
                layout: 'column',
                width:500,
                items: [
                    {
                        xtype: 'container',
                        cls: 'w-error-title',
                        style: 'text-align: right;',
                        columnWidth: 0.5,
                        html: _t('Please select a grouping from this list:')
                    },
                    {
                        xtype: 'container',
                        padding: '0 0 0 10',
                        columnWidth: 0.5,
                        cls: 'w-error-grouping-list'
                    }
                ]
            },
            {
                xtype: 'container',
                flex: 1
            }
        ];
        this.groupColumns = [
               { id: '1', name: 'HOUR', text: _t('Hour'), group: 'default' },
               { id: '1', name: 'HOUR_OF_DAY', text: _t('Hour of day'), group: 'default' },
               { id: '2', name: 'DAY', text: _t('Day'), group: 'default' },
               { id: '3', name: 'DAY_OF_WEEK', text: _t('Day of week'), group: 'default' },
               { id: '16',name: 'WEEK', text: _t('Week'), group: 'default' },
               { id: '4', name: 'MONTH', text: _t('Month'), group: 'default' },
               { id: '4', name: 'MONTH_OF_YEAR', text: _t('Month of year'), group: 'default' },
               { id: '5', name: 'YEAR', text: _t('Year'), group: 'default' },
               { id: '6', name: 'USER', text: _t('User'), group: 'default' },
               { id: '7', name: 'GROUP', text: _t('Group'), group: 'default' },
               { id: '8', name: 'CLIENT', text: _t('Business partner'), group: 'default' },
               { id: '9', name: 'COMPANY', text: _t('Company'), group: 'default' },
               { id: '10', name: 'NUMBER', text: _t('Number'), group: 'default' },
               { id: '11', name: 'TRUNK', text: _t('Trunk'), group: 'default' },
               { id: '12', name: 'COUNTRY', text: _t('Country'), group: 'default' },
               { id: '13', name: 'CLASS', text: _t('Class'), group: 'default' }
           ]

        this.callParent(arguments);
    },

    afterRender: function() {
        this.callParent(arguments);

        this.periodEl = this.getEl().down('.w-error-grouping-list');
        this.printOffersList(this.groupColumns);
        this.linkEl = this.getEl().down('.e-offers-list');
        this.linkEl.on('click', this.onLinkClick, this);

    },

    onLinkClick: function(e) {
        var targetName = e.getTarget().getAttribute('name');
        if(targetName) {
            this.fireEvent('action', this, 'groupingclick', [targetName]);
        }
    },

    printOffersList: function(offers) {
        this.tpl.overwrite(this.periodEl, offers);
    },

    setGroupingStateName: function(groupingStateName) {
        this.groupingStateName = groupingStateName;
        this.getEl().down('.w-error-title').update(this.getTitleMessage());
    },
    getTitleMessage: function() {
        return sprintf('<span class="">%(notification)s</span>', {
            notification : _t('This chart does not support the selected grouping.')
        });
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/error/TooMuchData.js
Ext.define('App.view.viewer.error.TooMuchData', {
    extend: 'Ext.container.Container',
    layout: {
        type: 'vbox',
        align : 'center'
    },
    initComponent: function() {
        this.items = [
            {
                xtype: 'container',
                flex: 1
            },
            {
                xtype: 'container',
                style: 'text-align:center;',
                html: _t('Too much data, try to make a more detailed search!')
            },
            {
                xtype: 'container',
                flex: 1
            }
        ]
        
        this.callParent(arguments);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/error/NotChosenGrouping.js
Ext.define('App.view.viewer.error.NotChosenGrouping', {
    extend: 'Ext.container.Container',
    layout: {
        type: 'vbox',
        align : 'stretch'
    },
    constructor: function() {
        this.callParent(arguments);
        this.addEvents('action');
        this.enableBubble('action');
    },
    initComponent: function() {

        this.tpl = new Ext.XTemplate(
            '<ul class="e-offers-list">',
                '<tpl for=".">',
                    '<li>',
                        '<a class="e-offers-list-link" name="{name}">{text}</a>',
                    '</li>',
                '</tpl>',
            '</ul>'
        );

        this.items = [
            {
                xtype: 'container',
                flex: 1
            },
            {
                xtype: 'container',
                layout: 'column',
                items: [
                    {
                        xtype: 'container',
                        cls: 'w-error-title',
                        style: 'text-align: right;',
                        columnWidth: 0.5,
                        html: _t('Please select a grouping from this list:')
                    },
                    {
                        xtype: 'container',
                        padding: '0 0 0 10',
                        columnWidth: 0.5,
                        cls: 'w-error-grouping-list'
                    }
                ]
            },
            {
                xtype: 'container',
                flex: 1
            }
        ];
        this.groupColumns = [
               { id: '1', name: 'HOUR', text: _t('Hour'), group: 'default' },
               { id: '1', name: 'HOUR_OF_DAY', text: _t('Hour of day'), group: 'default' },
               { id: '2', name: 'DAY', text: _t('Day'), group: 'default' },
               { id: '3', name: 'DAY_OF_WEEK', text: _t('Day of week'), group: 'default' },
               { id: '16',name: 'WEEK', text: _t('Week'), group: 'default' },
               { id: '4', name: 'MONTH', text: _t('Month'), group: 'default' },
               { id: '4', name: 'MONTH_OF_YEAR', text: _t('Month of year'), group: 'default' },
               { id: '5', name: 'YEAR', text: _t('Year'), group: 'default' },
               { id: '6', name: 'USER', text: _t('User'), group: 'default' },
               { id: '7', name: 'GROUP', text: _t('Group'), group: 'default' },
               { id: '8', name: 'CLIENT', text: _t('Business partner'), group: 'default' },
               { id: '9', name: 'COMPANY', text: _t('Company'), group: 'default' },
               { id: '10', name: 'NUMBER', text: _t('Number'), group: 'default' },
               { id: '11', name: 'TRUNK', text: _t('Trunk'), group: 'default' },
               { id: '14', name: 'TAG', text: _t('Tag'), group: 'default' },
               { id: '12', name: 'COUNTRY', text: _t('Country'), group: 'default' },
               { id: '13', name: 'CLASS', text: _t('Class'), group: 'default' }
           ]

        this.callParent(arguments);
    },

    afterRender: function() {
        this.callParent(arguments);

        this.periodEl = this.getEl().down('div.w-error-grouping-list');
        this.printOffersList(this.groupColumns);
        this.linkEl = this.getEl().down('.e-offers-list');
        this.linkEl.on('click', this.onLinkClick, this);

    },

    onLinkClick: function(e) {
        var targetName = e.getTarget().getAttribute('name');
        if(targetName) {
            this.fireEvent('action', this, 'groupingclick', [targetName]);
        }
    },

    printOffersList: function(offers) {
        this.tpl.overwrite(this.periodEl, offers);
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/error/NotEnoughData.js
Ext.define('App.view.viewer.error.NotEnoughData', {
    extend: 'Ext.container.Container',
    layout: {
        type: 'vbox',
        align : 'center'
    },
    initComponent: function() {
        this.items = [
            {
                xtype: 'container',
                flex: 1
            },
            {
                xtype: 'container',
                style: 'text-align:center;',
                html: _t('No result')
            },
            {
                xtype: 'container',
                flex: 1
            }
        ]
        
        this.callParent(arguments);
    }
});


// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/error/NoData.js
Ext.define('App.view.viewer.error.NoData', {
    extend: 'Ext.container.Container',
    layout: {
        type: 'vbox',
        align : 'center'
    },
    initComponent: function() {
        this.items = [
            {
                xtype: 'container',
                flex: 1
            },
            {
                xtype: 'container',
                style: 'text-align:center;',
                html: _t('No result')
            },
            {
                xtype: 'container',
                flex: 1
            }
        ]
        
        this.callParent(arguments);
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/error/NotSupportedMetric.js
Ext.define('App.view.viewer.error.NotSupportedMetric', {
    extend: 'Ext.container.Container',
    layout: {
        type: 'vbox',
        align : 'stretch'
    },
    constructor: function() {
        this.callParent(arguments);
        this.addEvents('action');
        this.enableBubble('action');
    },
    initComponent: function() {

        this.tpl = new Ext.XTemplate(
            '<ul class="e-offers-list">',
                '<tpl for=".">',
                    '<li>',
                        '<a class="e-offers-list-link" name="{name}">{text}</a>',
                    '</li>',
                '</tpl>',
            '</ul>'
        );

        this.items = [
            {
                xtype: 'container',
                flex: 1
            },
            {
                xtype: 'container',
                layout: 'column',
                items: [
                    {
                        xtype: 'container',
                        cls: 'w-error-title',
                        style: 'text-align: right;',
                        columnWidth: 0.5,
                        html: _t('Please select metric supported by this chart:')
                    },
                    {
                        xtype: 'container',
                        padding: '0 0 0 10',
                        columnWidth: 0.5,
                        cls: 'w-error-metric-list'
                    }
                ]
            },
            {
                xtype: 'container',
                flex: 1
            }
        ]
            
        this.groupColumns = [
            { id: '1', name: 'COUNT', text: _t('Count'), group: 'count', active: true },
            { id: '5', name: 'COST', text: _t('Cost'), group: 'cost', active: true },
            { id: '8', name: 'BILL', text: _t('Talk time'), group: 'bill', active: true }
        ]

        this.callParent(arguments);
    },

    afterRender: function() {
        this.callParent(arguments);

        this.periodEl = this.getEl().down('div.w-error-metric-list');
        this.printOffersList(this.groupColumns);
        this.linkEl = this.getEl().down('.e-offers-list');
        this.linkEl.on('click', this.onLinkClick, this);

    },

    onLinkClick: function(e) {
        var targetName = e.getTarget().getAttribute('name');
        if(targetName) {
            this.fireEvent('action', this, 'metricclick', [targetName]);
        }
    },

    printOffersList: function(offers) {
        this.tpl.overwrite(this.periodEl, offers);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/Error.js
Ext.define('App.view.viewer.Error', {
    extend: 'Ext.panel.Panel',
    alias : 'widget.viewerError',
    frame: true,
    layout: {
        type: 'card',
        align : 'stretch'
    },
    activeItem: 0,
    initComponent: function() {
        this.emptyResultsCt = Ext.create('App.view.viewer.error.EmptyResults');
        //Chart errors
        this.noData = Ext.create('App.view.viewer.error.NoData');
        this.notChosenGrouping = Ext.create('App.view.viewer.error.NotChosenGrouping');
        this.notSupportedGrouping = Ext.create('App.view.viewer.error.NotSupportedGrouping');
        this.tooMuchData = Ext.create('App.view.viewer.error.TooMuchData');
        this.notEnoughData = Ext.create('App.view.viewer.error.NotEnoughData');
        this.notSupportedMetric = Ext.create('App.view.viewer.error.NotSupportedMetric');

        this.items = [
            this.emptyResultsCt,            
            /*  Chart errors */
            this.noData,
            this.notChosenGrouping,
            this.notSupportedGrouping,
            this.tooMuchData,
            this.notEnoughData,
            this.notSupportedMetric
        ];

        this.callParent(arguments);
    },
    setError: function(type, config) {
        switch (type) {
            case 'ERR_EMPTYRESULTS':
                this.getLayout().setActiveItem(this.emptyResultsCt);
                break;
            case 'NO_DATA':
                this.getLayout().setActiveItem(this.noData);
                break;
            case 'NO_GROUPING':
                this.getLayout().setActiveItem(this.notChosenGrouping);
                break;
            case 'NOT_SUPPORTED_GROUPING':
                this.getLayout().setActiveItem(this.notSupportedGrouping);
                if (config && config.groupingStateName)
                this.notSupportedGrouping.setGroupingStateName(config ? config.groupingStateName||'':'');
                this.getLayout().setActiveItem(this.notSupportedGrouping);
                break;
            case 'TOO_MANY_RECORDS':
                this.getLayout().setActiveItem(this.tooMuchData);
                break;
            case 'NOT_SUPPORTED_METRIC':
                this.getLayout().setActiveItem(this.notSupportedMetric);
                break;
        }
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/Sync.js
Ext.define('App.view.viewer.Sync', {
    extend: 'Ext.window.Window',
    title: '',
    width: 360,
    height: 95,
    modal: true,
    resizable: false,
    closable: false,
    bodyStyle: 'background: transparent; border: 0;',
    constructor: function() {
        this.addEvents('complete', 'terminated');
        this.callParent(arguments);
    },
    initComponent: function() {
        this.synchronizer = App.storage.Synchronizer;
        
        this.descriptionCt = Ext.create('Ext.container.Container', {
            cls: 'w-sync-description'
        });
        
        this.progressActiveCt = Ext.create('Ext.container.Container', {
            cls: 'w-boot-progress-active',
            width: 0
        });
        
        this.description = _t('Remaining time: Unknown');
        this.progressDescriptionCt = Ext.create('Ext.container.Container', {
            cls: 'w-sync-progress-description',
            html: this.description
        });
        
        this.progressCt = Ext.create('Ext.container.Container', {
            cls: 'w-sync-progress',
            items: [
                this.progressActiveCt
            ]
        });
        
        this.progressContainerCt = Ext.create('Ext.container.Container', {
            layout: 'hbox',
            margin: '5 10 0 10',
            items: [
                {
                    xtype: 'container',
                    width: 330,
                    items: [
                        this.progressCt,
                        this.progressDescriptionCt
                    ]
                }
            ]
        });
        
        this.cancelButton = Ext.create('Ext.button.Button', {
            text: _t('Cancel')
        });
        
        this.items = [
            this.progressContainerCt
        ]

        this.buttonAlign = 'center';

        this.buttons = [
            this.cancelButton
        ]
        
        this.cancelButton.on('click', this.onCancelButtonClick, this);
        this.callParent(arguments);
    },
    setProgress: function(percent) {
        var width = (330 / 100) * percent;
        var animation = {
            to: {
                width: width
            }
        }
        
        this.progressActiveCt.stopAnimation();
        this.progressActiveCt.animate(animation);
    },
    setDescription: function(text) {
        this.progressDescriptionCt.getEl().update(text);
    },
    bindSynchronizer: function() {
        this.synchronizer.on('syncEventsChange', this.onSyncEventsChange, this);
        this.synchronizer.on('syncEventsComplete', this.onSyncEventsComplete, this);
        this.synchronizer.on('syncTerminated', this.onSyncTerminated, this);
    },
    unbindSynchronizer: function() {
        this.synchronizer.un('syncEventsChange', this.onSyncEventsChange, this);
        this.synchronizer.un('syncEventsComplete', this.onSyncEventsComplete, this);
        this.synchronizer.un('syncTerminated', this.onSyncTerminated, this);
    },
    sync: function(dateFrom, dateTo) {
        dateFrom = dateFrom.substr(0, 10);
        dateTo = dateTo.substr(0, 10);

        this.processTimer();

        if (this.synchronizer.isWorking()) {
            this.workDateFrom = dateFrom;
            this.workDateTo = dateTo;
            this.synchronizer.on('syncTerminated', this.onSyncWorkTerminated, this);
            this.synchronizer.fireEvent('syncTerminate');
            return;
        }

        this.bindSynchronizer();
        this.synchronizer.fireEvent('syncEvents', dateFrom, dateTo);
    },
    onSyncWorkTerminated: function() {



        this.sync(this.workDateFrom, this.workDateTo);
    },
    onSyncEventsChange: function(percent, timeleft) {
        if (!percent && !timeleft) {
            this.setRelateProgress(0, 24);
            this.description = _t('Remaining time: Unknown');
            this.setDescription(this.description);
            return;
        }
        
        if (percent > 0) {
            this.setProgress(percent);
        }
        
        timeleft = App.utility.NamesFormatter.formatSeconds(Math.round(timeleft));
        
        this.description = sprintf(_t('Remaining time: ~ %(timeleft)s'), { timeleft : timeleft });
        this.setDescription(this.description);
    },
    onSyncEventsComplete: function() {
        this.terminateTimer();
        this.unbindSynchronizer();
        this.fireEvent('complete');
        this.close();
    },
    onCancelButtonClick: function(btn) {
        btn.disable();
        //terminated
        this.description = _t('Terminating');
        this.setDescription(this.description);
        
        this.synchronizer.fireEvent('syncTerminate');
    },
    onSyncTerminated: function() {
        this.terminateTimer();
        this.unbindSynchronizer();
        this.fireEvent('terminated');
        this.close();
    },
    processTimer: function() {
        var self = this;
        
        if (this.timerTerminate) {
            return;
        }
        
        if (!this.timerTurn) {
            this.timerTurn = 0;
        }
        
        if (!this.timerText) {
            this.timerText = '';
        }
        
        if (this.timerTurn == 5) {
            this.timerTurn = 0;
            this.timerText = '';
        }
        
        this.timerTurn++;
        this.timerText += '.';
        this.setDescription( this.description + this.timerText );
        
        setTimeout(function() { self.processTimer.call(self) }, 500);
    },
    terminateTimer: function() {
        this.timerTerminate = true;
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/chart/series/Pie.js
Ext.define('App.view.viewer.chart.series.Pie', {
    extend: 'Ext.chart.series.Pie',
    alias: 'series.custompie',
    onPlaceLabel: function(label, storeItem, item, i, display, animate, index) {
        if (item.startAngle - item.endAngle < 10) {
            label.hide();
        } else {
            this.callParent(arguments);
            label.show();
        }
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/chart/type/DefaultChart.js
/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.DefaultChart', {
    extend: 'Ext.chart.Chart',

    legend: {
        position: 'right'
    },

    options: false,

    constructor: function(options) {




        this.options = options || {};
        this.callParent([{theme: 'Category1'}]);
    },

    initComponent: function() {
        var fields = this.createFieldsToStore();
        this.options.fields = fields;



        this.series = this.createSeries(fields, this.options.records.length);
        var axes = this.createAxes(fields);
        if (axes !== false) {
            this.axes = axes;
        }
        this.checkPossibilityToDraw();

        this.store = Ext.create('Ext.data.JsonStore', {
            fields: fields.totalFields,
            data: this.options.records
        });
        this.callParent(arguments);
    },

    createFieldsToStore: function() {
        var xGroupField = false;
        var yFields = [];
        var totalFields = [];
        for (var key in this.options.records[0]) {
            if (key.match(/_CHART_GROUPING$/)) {
                if (this.options.records[0].hasOwnProperty(key + "_NAME")) {
                    xGroupField = key + "_NAME";
                    totalFields.push(key + "_NAME");
                } else {
                    xGroupField = key;
                    totalFields.push(key);
                }
            } else if (key.match(/_CHART_VAL$/)) {
                yFields.push(key);
                totalFields.push({
                    name: key,
                    type: 'float'
                });
            }
        }
        return {
            xGroupField: xGroupField,
            yFields: yFields,
            totalFields: totalFields
        };
    },

    createTip: function() {
        var self = this;
        var tip = {
            trackMouse: true,
            minWidth: 250,
            renderer: function(storeItem, item) {


                var label = item._yField || '';
                var countSame = 0;
                if (!label){
                    for (var key in storeItem.data) {
                        if (storeItem.data[key] === item.value[1]) {
                            label = key;
                            countSame++;
                        }
                    }
                } else {
                    countSame = 1;
                }
                var fieldHeader = self.getFormattedField(storeItem.get(self.options.fields.xGroupField));
                var itemVal = self._formatTipData(item.value[1]);
                if (countSame === 1) {
                    var tooltip = fieldHeader + " <br/> " + itemVal;
                    var title = App.utility.NamesFormatter.formatText(label);
                } else {
                    tooltip = fieldHeader + " <br/> " + itemVal;
                    title = _t('Chart');
                }
                this.setTitle(title);
                this.update(tooltip);
            }
        };
        return tip;
    },

    _formatTipData: function(value) {
        var type = 'NONE';
        for (var key in this.options.records[0]) {
            if (key.match(/_BILL_/) || key.match(/_RING_/)) {
                type = 'TIME';
                break;
            }
            if (key.match(/_COST_/)) {
                type = 'COST';
                break;
            }
        }
        switch (type) {
            case 'COST':
                var result = App.utility.NamesFormatter.formatFloat(value) + ' \u20ac';
                break;
            case 'TIME':
                result = App.utility.NamesFormatter.formatSecondsShort(value);
                break;
            default:
                result = value;
        }
        return result;
    },

    canDraw: function() {
        return this.options.draw;
    },

    getReason: function() {
        return this.options.drawReason;
    },

    checkPossibilityToDraw: function() {
        this.options.draw = true;
        this.options.drawReason = "";
    },

    getFormattedField: function(value) {
        if (value == '' || value == null || value == undefined) {
            return _t('Other');
        }
        var formattedName = value;
        switch (this.options.fields.xGroupField) {
            case 'GROUP_HOUR_CHART_GROUPING':
                formattedName = App.utility.NamesFormatter.formatGroupingByHour(value);
                break;
            case 'GROUP_DAY_CHART_GROUPING':
                formattedName = App.utility.NamesFormatter.formatGroupingByDay(value);
                break;
            case 'GROUP_HOUR_OF_DAY_CHART_GROUPING':
                formattedName = App.utility.NamesFormatter.formatHourOfDay(value);
                break;
            case 'GROUP_DAY_OF_WEEK_CHART_GROUPING':
                formattedName = App.utility.NamesFormatter.formatDayOfWeek(value);
                break;
            case 'GROUP_WEEK_CHART_GROUPING':
                formattedName = App.utility.NamesFormatter.formatGroupingByWeek(value);
                break;
            case 'GROUP_MONTH_CHART_GROUPING':
                formattedName = App.utility.NamesFormatter.formatByMonth(value);
                break;
            case 'GROUP_MONTH_OF_YEAR_CHART_GROUPING':
                formattedName = App.utility.NamesFormatter.formatMonthOfYear(value);
                break;
            case 'GROUP_CLASS_CHART_GROUPING':
                formattedName = App.utility.NamesFormatter.formatCallClass(value);
                break;
            case 'GROUP_NUMBER_CHART_GROUPING':
                formattedName = hide_acl_digits(value);
                break;

        }
        return formattedName;
    },

    getFormattedLegend: function() {
        var formattedLegend = [];
        for (var i in this.options.fields.yFields) {
            formattedLegend.push(App.utility.NamesFormatter.formatText(this.options.fields.yFields[i]));
        }
        return formattedLegend;
    },
    afterComponentLayout: function(width, height) {
        var me = this;
        if (Ext.isNumber(width) && Ext.isNumber(height)) {
            me.curWidth = width;
            me.curHeight = height;
            me.redraw(true);
        }
        this.callParent(arguments);

        if (!me.layoutDone){
            //disable by default Total from graphs
            //the category "Total events" must not be shown by default
            //Total events is not needed usually and confuses customers because it double events in any graph
            var yField = [];
            me.series.each(function(series, index){
                if (Ext.isArray(series.yField))
                    yField = series.yField;
                else
                    yField.push(series.yField);
            });
            var disableFieldsByDefault = [
                "TOTAL_EVENTS_CHART_VAL",
                "TOTAL_COST_CHART_VAL",
                "TOTAL_BILL_CHART_VAL",
                "TOTAL_LOCAL_BILL_CHART_VAL"
            ];

            for (var i=0; i<disableFieldsByDefault.length; i++){
                var indexOfTotals = yField.indexOf(disableFieldsByDefault[i]);
                if (yField.length > 2 && indexOfTotals>=0) {
                    me.legend.items[indexOfTotals].fireEvent('mouseover',me.legend.items[indexOfTotals]);
                    me.legend.items[indexOfTotals].fireEvent('mousedown',me.legend.items[indexOfTotals]);
                    me.legend.items[indexOfTotals].fireEvent('mouseout',me.legend.items[indexOfTotals]);
                }
            }
            me.layoutDone = true;
        }
    }

});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/chart/type/AreaChart.js
/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.AreaChart', {
    extend: 'App.view.viewer.chart.type.DefaultChart',

    requires: [
        'App.view.viewer.chart.type.DefaultChart'
    ],

    legend: {
        position: 'right'
    },

    options: false,

    checkPossibilityToDraw: function() {
        var draw = true;
        var drawReason = "";
        if (this.options.records.length < 2) {
            draw = false;
            drawReason = "NO_DATA";
        }

        this.options.draw = draw;
        this.options.drawReason = drawReason;
    },

    createSeries: function(fields, pointsCount) {
        var series = [],
            self = this;
        var elem = {
            type: 'area',
            axis: 'left',
            highlight: true,
            xField: fields.xGroupField,
            yField: fields.yFields,
            tips: this.createTip(),
            title: this.getFormattedLegend(),
            /*  -------Override ------ */
         renderLabels: function() {
                var me = this,
                    chart = me.chart,
                    gradients = chart.gradients,
                    items = me.items? ( me.items[0]? me.items[0].pointsUp:[] ) : [],
                    animate = chart.animate,
                    config = me.label,
                    display = config.display,
                    color = config.color,
                    field = [].concat(config.field),
                    group = me.labelsGroup,
                    store = me.chart.store,
                    len = store.getCount(),
                    itemLength = (items || 0) && items.length,
                    ratio = me.items.length,
                    gradientsCount = (gradients || 0) && gradients.length,
                    Color = Ext.draw.Color,
                    gradient, i, count, index, j, k, colorStopTotal, colorStopIndex, colorStop, item, label,
                    storeItem, sprite, spriteColor, spriteBrightness, labelColor, colorString;

                if (display == 'none') {
                    return;
                }

                for (i = 0, count = 0; i < len; i++) {
                    index = 0;
                    for (j = 0; j < ratio; j++) {
                        if (!me.items[j])
                            continue;
                        item = me.items[j].pointsUp[i];
                        label = group.getAt(count);
                        storeItem = store.getAt(i);

                        //check the excludes
                        while(this.__excludes && this.__excludes[index]) {
                            index++;
                        }

                        if (!item && label) {
                            label.hide(true);
                        }

                        if (item && field[j]) {
                            if (!label) {
                                label = me.onCreateLabel(storeItem, item, i, display, j, index);
                            }
                            me.onPlaceLabel(label, storeItem, item, i, display, animate, j, index);
                            //label.show(true);
                        }
                        count++;
                        index++;
                    }
                }
                me.hideLabels(count);
        },
        onCreateLabel: function(storeItem, item, i, display) {
            var me = this,
            group = me.labelsGroup,
            config = me.label,
            bbox = me.bbox,
            endLabelStyle = Ext.apply(config, me.seriesLabelStyle);

            return me.chart.surface.add(Ext.apply({
                'type': 'text',
                'text-anchor': 'middle',
                'group': group,
                'x': item[0],
                'y': bbox.y + bbox.height / 2
            }, endLabelStyle || {}));
        },
        onPlaceLabel: function(label, storeItem, item, i, display, animate, index) {
                var me = this,
                    chart = me.chart,
                    resizing = chart.resizing,
                    config = me.label,
                    format = config.renderer,
                    field = config.field,
                    bbox = me.bbox,
                    x = item[0],
                    y = item[1],
                    bb, width, height;

                label.setAttributes({
                    text: format(storeItem.get(field[index])),
                    hidden: true
                }, true);

                bb = label.getBBox();
                width = bb.width / 2;
                height = bb.height / 2;

                x = x - width < bbox.x? bbox.x + width : x;
                x = (x + width > bbox.x + bbox.width) ? (x - (x + width - bbox.x - bbox.width)) : x;
                y = y - height < bbox.y? bbox.y + height : y;
                y = (y + height > bbox.y + bbox.height) ? (y - (y + height - bbox.y - bbox.height)) : y;

                //Check for overlap
                if (!this.imposion)
                     this.imposion = [];
                x = parseFloat(x);
                y = parseFloat(y);
                var isOverlap = false;
                for (var i = 0; i<me.imposion.length; i++){
                    if (
                            (x < me.imposion[i][0] + me.imposion[i][2]) && (x+bb.width > me.imposion[i][0])
                            &&
                            (y < me.imposion[i][1] + me.imposion[i][3]) && (y+bb.height > me.imposion[i][1])
                       ){
                        isOverlap = true;
                    }
                }
                
                if (!isOverlap)
                    me.imposion.push([x,y,bb.width,bb.height])

                if (me.chart.animate && !me.chart.resizing) {
                    if (!isOverlap)
                    label.show(true);
                    me.onAnimate(label, {
                        to: {
                            x: x,
                            y: y
                        }
                    });
                } else {
                    label.setAttributes({
                        x: x,
                        y: y
                    }, true);
                    if (!isOverlap)
                    label.show(true);

                }

            },
            hideLabels: function(index) {
                this.imposion = [];

                var labelsGroup = this.labelsGroup, len;
                if (labelsGroup) {
                    len = labelsGroup.getCount();
                    while (len-->index) {
                        labelsGroup.getAt(len).hide(true);
                    }
                }
            },
            hideAll: function() {
                this.imposion = [];
                if (!isNaN(this._index)) {
                    this.__excludes[this._index] = true;
                    this.areas[this._index].hide(true);
                    this.drawSeries();
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    series.renderLabels();
                });
            },
            showAll: function() {
                this.imposion = [];
                if (!isNaN(this._index)) {
                    this.__excludes[this._index] = false;
                    this.areas[this._index].show(true);
                    this.drawSeries();
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    series.renderLabels();
                });
            },
        /*  ------Override------- */
            label: {
                display: self.options.isLabelVisible?'under':'none',
                contrast: false,
                field: fields.yFields,
                renderer: function(v) {
                    if (!v)
                        return '';
                    else
                        return self._formatTipData(v);
                },
                orientation: 'horizontal',
                color: '#333',
                'text-anchor': 'middle',
                font: '8px Helvetica,sans-serif'
            }
        };
        series.push(elem);
        return series;
    },

    createAxes: function(fields) {
        var self = this;
        var axes = [];
        //TODO: set type check: Time, Number or Category
        var axeVals = {
            type: 'Numeric',
            minimum: 0,
            position: 'left',
            fields: fields.yFields,
            title: false
        };
        axes.push(axeVals);

        //TODO: set type check: Time, Number or Category
        var axeGrouping = {
            type: 'Category',
            position: 'bottom',
            fields: fields.xGroupField,
            title: false,
            label: {
                rotate: {
                    degrees: 315
                },
                renderer: function(name) {
                    return self.getFormattedField(name);
                }
            }
        };
        axes.push(axeGrouping);

        return axes;
    },

    createTip: function() {
        var self = this;
        var tip = {
            trackMouse: true,
            minWidth: 250,
            renderer: function(storeItem, item) {
                var title = App.utility.NamesFormatter.formatText(item.storeField);
                var itemVal = self._formatTipData(storeItem.get(item.storeField));
                var tooltip = self.getFormattedField(storeItem.get(self.options.fields.xGroupField)) + ' <br/> ' + itemVal;
                this.setTitle(title);
                this.update(tooltip);
            }
        };
        return tip;
    }

});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/chart/type/PieChart.js
/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.PieChart', {
    extend: 'App.view.viewer.chart.type.DefaultChart',

    requires: [
        'App.view.viewer.chart.type.DefaultChart'
    ],

    animate: true,

    checkPossibilityToDraw: function() {
        var draw = true;
        var drawReason = "";




        if (this.options.totalVal === 0) {
            draw = false;
            drawReason = "NO_DATA";
        }
        var counterFields = 0;
        for (var key in this.options.records[0]) {


            if (this.options.records[0].hasOwnProperty(key) && !key.match(/_GROUPING_NAME$/)) {
                counterFields++;
            }
        }




        if (counterFields > 2) {
            draw = false;
            drawReason = "NOT_SUPPORTED_METRIC";
        }

        this.options.draw = draw;
        this.options.drawReason = drawReason;
    },

    createSeries: function(fields, pointsCount) {
        var me = this,
            labelSize = 12;

        if (pointsCount){
            if (pointsCount <= 10)
                labelSize = 32;
            else if (pointsCount < 20)
                labelSize = 20;
            else if (pointsCount < 40)
                labelSize = 15;
            else
                labelSize = 12;
        }
        this.insetPadding = 20;
        this._reconfigurePieData(fields);
        var series = [];
        var elem = {
            type: 'custompie',
            field: fields.yFields[0],
            showInLegend: true,
            label: {
                field: fields.yFields[0],
                display: 'rotate',
                contrast: true,
                font: labelSize+'px Arial',
                renderer: function(v) {
                    var prc = Math.round((v / me.options.totalVal) * 10000)/100;
                    if (me.options.isLabelVisible){
                        return prc + '%  ('+me._formatTipData(v)+')';
                    } else {
                        return prc + '%';
                    }
                }
            },
            title: this.getFormattedLegend(fields),
            highlight: {
                segment: {
                    margin: 20
                }
            },
            style: {
                'stroke-width': 1,
                'stroke': '#fff'
            },
            tips: this.createTip()
        };
        series.push(elem);
        return series;
    },

    createAxes: function() {
        return false;
    },

    createTip: function() {
        var self = this;
        var tip = {
            trackMouse: true,
            minWidth: 200,
            renderer: function(storeItem, item) {
                var itemVal = self._formatTipData(storeItem.get(self.options.fields.yFields[0]));
                var tooltip = self.getFormattedField(storeItem.get(self.options.fields.xGroupField)) + ' <br/> ' + itemVal;
                this.update(tooltip);
            }
        }
        return tip;
    },

    _reconfigurePieData: function(fields) {
        var keysCount = 0;
        var maxKeys = 13;
        var otherVal = 0;
        var newRecords = [];
        var totalVal = 0;



        this.options.records.sort(function(rec1, rec2) {
            var result = 0;
            if (parseFloat(rec1[fields.yFields[0]], 10) > parseFloat(rec2[fields.yFields[0]], 10)) {
                result = -1;
            } else if (parseFloat(rec1[fields.yFields[0]], 10) < parseFloat(rec2[fields.yFields[0]], 10)) {
                result = 1;
            }
            return result;
        });



        for (var i in this.options.records) {
            var fieldVal = parseFloat(this.options.records[i][fields.yFields[0]], 10);
            if (!isNaN(fieldVal)) {
                totalVal += fieldVal;
            }
            if (this.options.records[i][fields.xGroupField] == null || this.options.records[i][fields.xGroupField] == '' || this.options.records[i][fields.xGroupField] == undefined || keysCount > maxKeys) {
                if (!isNaN(fieldVal)) {
                    otherVal += fieldVal;
                }
            } else {




                newRecords.push(this.options.records[i]);
            }
            keysCount++;
        }
        if (otherVal > 0) {
            var otherRec = {};
            otherRec[fields.xGroupField] = 'other';
            otherRec[fields.yFields[0]] = otherVal;
            newRecords.push(otherRec);
        }
        this.options.totalVal = totalVal;
        this.options.records = newRecords;
    },

    getFormattedLegend: function(fields) {
        var titles = [];
        for (var i in this.options.records) {
            if (this.options.records[i][fields.xGroupField] !== 'other') {
                var title = this.getFormattedField(this.options.records[i][fields.xGroupField]);
            } else {
                title = _t('Other');
            }
            titles.push(title);
        }
        return titles;
    }

});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/chart/type/BarChart.js
/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.BarChart', {
    extend: 'App.view.viewer.chart.type.DefaultChart',

    requires: [
        'App.view.viewer.chart.type.DefaultChart'
    ],

    legend: {
        position: 'right'
    },

    options: false,

    createSeries: function(fields, pointsCount) {
        var series = [],
            me = this,
            labelSize = 8;

        if (pointsCount){
            if (pointsCount <= 10)
                labelSize = 32;
            else if (pointsCount < 20)
                labelSize = 15;
            else if (pointsCount < 40)
                labelSize = 12;
            else
                labelSize = 8;
        }

        var elem = {
            type: 'bar',
            axis: 'bottom',
            stacked: true,
            highlight: true,
            xField: fields.xGroupField,
            yField: fields.yFields,
            tips: this.createTip(),
            title: this.getFormattedLegend(),
            /*  ------Override------- */
            hideLabels: function(index) {
                this.imposion = [];

                var labelsGroup = this.labelsGroup, len;
                if (labelsGroup) {
                    len = labelsGroup.getCount();
                    while (len-->index) {
                        labelsGroup.getAt(len).hide(true);
                    }
                }
            },
            hideAll: function() {
                this.imposion = [];
                var axes = this.chart.axes;
                if (!isNaN(this._index)) {
                    if (!this.__excludes) {
                        this.__excludes = [];
                    }
                    this.__excludes[this._index] = true;
                    this.drawSeries();
                    axes.each(function(axis) {
                        axis.drawAxis();
                    });
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    if (!series.seriesIsHidden)
                        series.renderLabels();
                });
            },

            // @private show all markers
            showAll: function() {
                this.imposion = [];
                var axes = this.chart.axes;
                if (!isNaN(this._index)) {
                    if (!this.__excludes) {
                        this.__excludes = [];
                    }
                    this.__excludes[this._index] = false;
                    this.drawSeries();
                    axes.each(function(axis) {
                        axis.drawAxis();
                    });
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    if (!series.seriesIsHidden)
                        series.renderLabels();
                });
            },
            /*  ------Override------- */
            label: {
                display: me.options.isLabelVisible?'center':'none',
                field: fields.yFields,
                renderer: function(v) {
                    if (!v)
                        return '';
                    else
                        return me._formatTipData(v);
                },
                orientation: 'horizontal',
                color: '#333',
                'text-anchor': 'middle',
                font: labelSize+'px Helvetica,sans-serif'
            }
        };
        series.push(elem);
        return series;
    },

    createAxes: function(fields) {
        var self = this;
        var axes = [];
        //TODO: set type check: Time, Number or Category
        var axeVals = {
            type: 'Category',
            position: 'left',
            fields: [fields.xGroupField],
            title: false,
            minimum: 0,
            grid: true,
            label: {
                renderer: function(name) {
                    return self.getFormattedField(name);
                }
            }
        };
        axes.push(axeVals);

        //TODO: set type check: Time, Number or Category
        var axeGrouping = {
            type: 'Numeric',
            position: 'bottom',
            fields: fields.yFields,
            title: false
        };
        axes.push(axeGrouping);
        return axes;
    }

});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/chart/type/ColumnChart.js
/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.ColumnChart', {
    extend: 'App.view.viewer.chart.type.DefaultChart',

    requires: [
        'App.view.viewer.chart.type.DefaultChart'
    ],

    /*It should be here because otherwise there are mirror columns are shown*/
    shadow: false,

    createSeries: function(fields, pointsCount) {
        var series = [],
            me = this,
            labelSize = 8;

        if (pointsCount){
            if (pointsCount <= 10)
                labelSize = 32;
            else if (pointsCount < 20)
                labelSize = 15;
            else if (pointsCount < 40)
                labelSize = 12;
            else
                labelSize = 8;
        }

        var elem = {
            type: 'column',
            axis: 'left',
            stacked: true,
            highlight: true,
            xField: fields.xGroupField,
            yField: fields.yFields,
            title: this.getFormattedLegend(),
            tips: this.createTip(),
            /*  ------Override------- */
            hideAll: function() {
                this.imposion = [];
                var axes = this.chart.axes;
                if (!isNaN(this._index)) {
                    if (!this.__excludes) {
                        this.__excludes = [];
                    }
                    this.__excludes[this._index] = true;
                    this.drawSeries();
                    axes.each(function(axis) {
                        axis.drawAxis();
                    });
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    if (!series.seriesIsHidden)
                        series.renderLabels();
                });
            },
            
            // @private show all markers
            showAll: function() {
                this.imposion = [];
                var axes = this.chart.axes;
                if (!isNaN(this._index)) {
                    if (!this.__excludes) {
                        this.__excludes = [];
                    }
                    this.__excludes[this._index] = false;
                    this.drawSeries();
                    axes.each(function(axis) {
                        axis.drawAxis();
                    });
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    if (!series.seriesIsHidden)
                        series.renderLabels();
                });
            },
            hideLabels: function(index) {
                this.imposion = [];

                var labelsGroup = this.labelsGroup, len;
                if (labelsGroup) {
                    len = labelsGroup.getCount();
                    while (len-->index) {
                        labelsGroup.getAt(len).hide(true);
                    }
                }
            },
            /*  ------Override------- */
            label: {
                display: me.options.isLabelVisible?'center':'none',
                field: fields.yFields,
                renderer: function(v) {
                    if (!v)
                        return '';
                    else
                        return me._formatTipData(v);
                },
                orientation: 'horizontal',
                color: '#333',
                'text-anchor': 'middle',
                font: labelSize+'px Helvetica,sans-serif'
            }
        };
        series.push(elem);
        return series;
    },

    createAxes: function(fields) {
        var self = this;
        var axes = [];
        //TODO: set type check
        var axeVals = {
            type: 'Numeric',
            position: 'left',
            fields: fields.yFields,
            title: false,
            minimum: 0,
            grid: true
        };
        axes.push(axeVals);

        //TODO: set type check
        var axeGrouping = {
            type: 'Category',
            position: 'bottom',
            fields: [fields.xGroupField],
            title: false,
            label: {
                rotate: {
                    degrees: 315
                },
                renderer: function(name) {
                    return self.getFormattedField(name);
                }
            }
        };
        axes.push(axeGrouping);
        return axes;
    }

});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/chart/type/LineChart.js
/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.LineChart', {
    extend: 'App.view.viewer.chart.type.DefaultChart',

    requires: [
        'App.view.viewer.chart.type.DefaultChart'
    ],

    legend: {
        position: 'right'
    },
    options: false,

    checkPossibilityToDraw: function() {
        var draw = true;
        var drawReason = "";




        if (this.options.records.length < 2) {
            draw = false;
            drawReason = "NO_DATA";
        }

        this.options.draw = draw;
        this.options.drawReason = drawReason;
    },

    createSeries: function(fields, pointsCount) {
        var series = [],
            me = this;
        for (var i in fields.yFields) {
            var elem = {
                type: 'line',
                axis: 'left',
                xField: fields.xGroupField,
                yField: fields.yFields[i],
                markerConfig: {
                    type: 'cross',
                    size: 4,
                    radius: 4,
                    'stroke-width': 0
                },
                tips: this.createTip(fields.yFields[i]),
                title: App.utility.NamesFormatter.formatText(fields.yFields[i]),

                onCreateLabel: function(storeItem, item, i, display) {
                    var me = this,
                    group = me.labelsGroup,
                    config = me.label,
                    bbox = me.bbox,
                    endLabelStyle = Ext.apply(config, me.seriesLabelStyle);
                    return me.chart.surface.add(Ext.apply({
                        'type': 'text',
                        'text-anchor': 'middle',
                        'group': group,
                        'x': item.point[0],
                        'y': bbox.y + bbox.height / 2
                    }, endLabelStyle || {}));
                },
                onPlaceLabel: function(label, storeItem, item, i, display, animate) {
                    var me = this,
                        chart = me.chart,
                        resizing = chart.resizing,
                        config = me.label,
                        format = config.renderer,
                        field = config.field,
                        bbox = me.bbox,
                        x = item.point[0],
                        y = item.point[1],
                        radius = item.sprite.attr.radius,
                        bb, width, height;

                    label.setAttributes({
                        text: format(storeItem.get(field)),
                        hidden: true
                    }, true);
                    if (me.seriesIsHidden)
                        return;
                    
                    label.setAttributes({
                        'text-anchor': 'start',
                        'rotation': {
                            x: x,
                            y: y,
                            degrees: display == 'rotate'?-45:0
                        }
                    }, true);
                    //correct label position to fit into the box
                    bb = label.getBBox();
                    width = bb.width;
                    height = bb.height;
                    x = x < bbox.x? bbox.x : x;
                    x = (x + width > bbox.x + bbox.width)? (x - (x + width - bbox.x - bbox.width) -(-5) ) : x-(-5);
                    y = (y - height < bbox.y)? bbox.y + height : y;

                    //Check for overlap
                    if (!chart.imposion)
                         chart.imposion = [];
                    x = parseFloat(x);
                    y = parseFloat(y);
                    var isOverlap = false;
                    for (var i = 0; i<chart.imposion.length; i++){
                        if (
                                (x < chart.imposion[i][0] + chart.imposion[i][2]) && (x+bb.width > chart.imposion[i][0])
                                &&
                                (y < chart.imposion[i][1] + chart.imposion[i][3]) && (y+bb.height > chart.imposion[i][1])
                           ){
                            isOverlap = true;
                        }
                    }

                    if (!isOverlap)
                        chart.imposion.push([x,y,bb.width,bb.height])

                    if (me.chart.animate && !me.chart.resizing) {
                        if (!isOverlap)
                        label.show(true);
                        me.onAnimate(label, {
                            to: {
                                x: x,
                                y: y
                            }
                        });
                    } else {
                        label.setAttributes({
                            x: x,
                            y: y
                        }, true);
                        if (!isOverlap)
                        label.show(true);

                    }
                    
                },
                showAll: function() {
                    this.toggleAll(true);
                    this.chart.series.each(function(series, index){
                        series.hideLabels(index);
                    });
                    this.chart.imposion = [];
                    this.chart.series.each(function(series, index){
                        if (!series.seriesIsHidden)
                            series.renderLabels();
                    });
                },
                hideAll: function() {
                    this.toggleAll(false);
                    this.chart.series.each(function(series, index){
                        series.hideLabels(index);
                    });
                    this.chart.imposion = [];
                    this.chart.series.each(function(series, index){
                        if (!series.seriesIsHidden)
                            series.renderLabels();
                    });
                },
                hideLabels: function(index) {

                    var labelsGroup = this.labelsGroup, len;
                    if (labelsGroup) {
                        len = labelsGroup.getCount();
                        while (len-->index) {
                            labelsGroup.getAt(len).hide(true);
                        }
                    }
                },
                label: {
                    display: me.options.isLabelVisible?'under':'none',
                    field: fields.yFields[i],
                    renderer: function(v) {
                        if (!v)
                            return '';
                        else
                            return me._formatTipData(v);
                    },
                    orientation: 'horizontal',
                    color: '#333',
                    'text-anchor': 'middle',
                    font: '8px Helvetica,sans-serif'
                }
            };
            series.push(elem);
        }
        return series;
    },
    getMaxGutter: function() {
        var me = this,
            maxGutter = [0, 0];
        me.series.each(function(s) {
            var gutter = s.getGutters && s.getGutters() || [0, 0];
            maxGutter[0] = Math.max(maxGutter[0], gutter[0]);
            maxGutter[1] = Math.max(maxGutter[1], gutter[1]);
        });
        me.maxGutter = maxGutter;
        me.imposion = [];
    },
    refresh: function() {
        var me = this;
        if (me.rendered && me.curWidth != undefined && me.curHeight != undefined) {
            if (me.fireEvent('beforerefresh', me) !== false) {
                me.redraw();
                me.fireEvent('refresh', me);
            }
        } else {
            setTimeout(function(){
                if (me.rendered && me.curWidth != undefined && me.curHeight != undefined){
                    me.redraw();
                }
            },200);
        }
    },
    createAxes: function(fields) {
        var self = this;
        var axes = [];
        //TODO: set type check: Time, Number or Category
        var axeVals = {
            type: 'Numeric',
            minimum: 0,
            position: 'left',
            fields: fields.yFields,
            title: false
        };
        axes.push(axeVals);

        //TODO: set type check: Time, Number or Category
        var axeGrouping = {
            type: 'Category',
            position: 'bottom',
            fields: fields.xGroupField,
            title: false,
            label: {
                rotate: {
                    degrees: 315
                },
                renderer: function(name) {
                    return self.getFormattedField(name);
                }
            }
        };
        axes.push(axeGrouping);

        return axes;
    },

    createTip: function(yField) {
        var self = this;
        var tip = {
            trackMouse: true,
            minWidth: 250,
            renderer: function(storeItem, item) {
                var title = App.utility.NamesFormatter.formatText(yField);
                var itemVal = self._formatTipData(storeItem.get(yField));
                var tooltip = self.getFormattedField(storeItem.get(self.options.fields.xGroupField)) + ' <br/> ' + itemVal;
                this.setTitle(title);
                this.update(tooltip);
            }
        };
        return tip;

    }

});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/chart/ChartView.js
/**
 * Factory for creating Charts instances.
 * API:
 *
 *
 * User: Artyom Trityak
 * Date: 1/4/12
 * Time: 3:19 PM
 */
Ext.define('App.view.viewer.chart.ChartView', {

    singleton: true,

    constructor: function() {

    },

    create: function(options) {
        options = options || {
            chartType: 'CHART_COLUMN',
            data: []
        };

        var chartIns = false;
        switch(options.chartType) {
            case 'CHART_LINE':
                chartIns = Ext.create('App.view.viewer.chart.type.LineChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
            case 'CHART_AREA':
                chartIns = Ext.create('App.view.viewer.chart.type.AreaChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
            case 'CHART_PIE':
                chartIns = Ext.create('App.view.viewer.chart.type.PieChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
            case 'CHART_BAR':
                chartIns = Ext.create('App.view.viewer.chart.type.BarChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
            case 'CHART_COLUMN':
                chartIns = Ext.create('App.view.viewer.chart.type.ColumnChart', {
                    records: options.data,
                    isLabelVisible: options.isLabelVisible
                });
                break;
        }



        return chartIns;
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/Chart.js
Ext.define('App.view.viewer.Chart', {
    extend: 'Ext.Panel',
    alias : 'widget.viewerChart',
    itemId: 'viewerChartContainer',
    frame: true,
    flex: 1,
    layout: {
        type: 'fit'
    },
    items: [
        {
            xtype: 'container',
            itemId: 'viewerChartContainerChart',
            layout: 'fit',
            flex: 1
        }
    ]
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/table/Column.js
Ext.define('App.view.viewer.table.Column', {
    extend: 'Ext.grid.column.Column',
    afterRender: function() {
        this.callParent();
        var store   = this.up('[store]').store,
            sorters = store.builderSorters,
            hd;

        if (sorters && this.dataIndex == sorters.field) {
            this.setSortState(sorters.direction, false, true);
        }
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/table/Chunker.js
Ext.define('App.view.viewer.table.Chunker', {
    singleton: true,
    requires: ['Ext.XTemplate'],
    metaTableTpl: [
        '{[this.openTableWrap()]}',
        '<table class="' + Ext.baseCSSPrefix + 'grid-table ' + Ext.baseCSSPrefix + 'grid-table-resizer" border="0" cellspacing="0" cellpadding="0" {[this.embedFullWidth()]}>',
            '<tbody>',
            '<tr class="' + Ext.baseCSSPrefix + 'grid-header-row">',
            '<tpl for="columns">',
                '<th class="' + Ext.baseCSSPrefix + 'grid-col-resizer-{id}" style="width: {width}px; height: 0px;"></th>',
            '</tpl>',
            '</tr>',
            '{[this.openRows()]}',
                '{row}',
                '<tpl for="features">',
                    '{[this.embedFeature(values, parent, xindex, xcount)]}',
                '</tpl>',
            '{[this.closeRows()]}',
            '</tbody>',
        '</table>',
        '{[this.closeTableWrap()]}'
    ],

    constructor: function() {
        Ext.XTemplate.prototype.recurse = function(values, reference) {
            return this.apply(reference ? values[reference] : values);
        };
    },

    embedFeature: function(values, parent, x, xcount) {
        var tpl = '';
        if (!values.disabled) {
            tpl = values.getFeatureTpl(values, parent, x, xcount);
        }
        return tpl;
    },

    embedFullWidth: function() {
        return 'style="width: {fullWidth}px;"';
    },

    openRows: function() {
        return '<tpl for="rows">';
    },

    closeRows: function() {
        return '</tpl>';
    },

    metaRowTpl: [
        '<tr class="' + Ext.baseCSSPrefix + 'grid-row {addlSelector} {[this.embedRowCls()]}" {[this.embedRowAttr()]}>',
            '<tpl for="columns">',
                '<td class="{cls} ' + Ext.baseCSSPrefix + 'grid-cell ' + Ext.baseCSSPrefix + 'grid-cell-{columnId} {{id}-modified} {{id}-tdCls} {[this.firstOrLastCls(xindex, xcount)]}" {{id}-tdAttr}><div unselectable="on" class="' + Ext.baseCSSPrefix + 'grid-cell-inner ' + Ext.baseCSSPrefix + 'unselectable" style="{{id}-style}; text-align: {align};">{{id}}</div></td>',
            '</tpl>',
        '</tr>'
    ],

    firstOrLastCls: function(xindex, xcount) {
        var cssCls = '';
        if (xindex === 1) {
            cssCls = Ext.baseCSSPrefix + 'grid-cell-first';
        } else if (xindex === xcount) {
            cssCls = Ext.baseCSSPrefix + 'grid-cell-last';
        }
        return cssCls;
    },

    embedRowCls: function() {
        return '{rowCls}';
    },

    embedRowAttr: function() {
        return '{rowAttr}';
    },

    openTableWrap: function() {
        return '';
    },

    closeTableWrap: function() {
        return '';
    },

    getTableTpl: function(cfg) {
        // Remove hidden columns
        var columns = new Array();
        var columnsOrig = cfg.columns;
        var columnsItems = cfg.columnsItems;
        var columnsGrouped = new Array();
        var tpl, headerTpl, rowTpl, i, column, columnOrig;

        for (i=0; i < columnsItems.length; i++) {
            column = columnsItems.get(i);
            columnOrig = columnsOrig[i];

            if (column['hidden']) {
                continue;
            }
            if (column['grouped']) {
                columnOrig['grouped'] = true;
                columnsGrouped.push(columns[i]);
            }

            columns.push(columnOrig);
        }


        headerTpl = '<tr class="x-grid-header-row">';
        for (i=0; i < columns.length; i++) {
            headerTpl += '<th class="x-grid-col-resizer-'+ columns[i]['columnId'] +'" style="width: '+ columns[i]['width'] +'px; height: 0px;"></th>';
        }
        headerTpl += '</tr>';

        rowTpl = '<tr class="x-grid-row">';
        for (i=0; i < columns.length; i++) {
            if (columns[i]['grouped']) {
                rowTpl += '<tpl if="values[\''+ columns[i]['columnId'] +'-rowspan\'] != 0">';
                rowTpl +=     '<td class="x-grid-cell-grouped" rowspan="{'+ columns[i]['columnId'] +'-rowspan}" {'+ columns[i]['columnId'] +'-tdAttr}>';
                rowTpl +=          '<div unselectable="on" class="x-grid-cell-inner x-unselectable" style="{'+ columns[i]['columnId'] +'-style}; text-align: left;">{'+ columns[i]['columnId'] +'}</div>';
                rowTpl +=     '</td>';
                rowTpl += '</tpl>';
            } else {
                rowTpl += '<td class="x-grid-cell x-grid-cell-'+ columns[i]['columnId'] +' {'+ columns[i]['columnId'] +'-modified} {'+ columns[i]['columnId'] +'-tdCls} " {'+ columns[i]['columnId'] +'-tdAttr}>';
                rowTpl +=     '<div unselectable="on" class="x-grid-cell-inner x-unselectable" style="{'+ columns[i]['columnId'] +'-style}; text-align: left;">{'+ columns[i]['columnId'] +'}</div>';
                rowTpl += '</td>';
            }
        }
        rowTpl += '</tr>';

        tpl = '<table class="x-grid-table x-grid-table-resizer" border="0" cellspacing="0" cellpadding="0" style="width: {fullWidth}px;">' +
                  '<tbody>' +
                      headerTpl +
                      '<tpl for="rows">' +
                          rowTpl +
                      '</tpl>' +
                  '</tbody>' +
              '</table>';

        tpl = Ext.create('Ext.XTemplate', tpl);

        return tpl;
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/table/Scroller.js
Ext.define('App.view.viewer.table.Scroller', {
    extend: 'Ext.grid.PagingScroller',
    alias: 'widget.viewerTableScroller',
    onGuaranteedRange: function(range, start, end) {
        var me = this,
            ds = me.store;

        if (range.length && me.visibleStart < range[0].index) {
            return;
        }

        ds.loadRecords(range);

        if (!me.firstLoad) {
            if (me.rendered) {
                me.invalidate();
            } else {
                me.on('afterrender', me.invalidate, me, {single: true});
            }
            me.firstLoad = true;
        } else {
            if (me.scrollEl && me.scrollEl.dom && me.scrollEl.dom.scrollHeight) {
                me.syncTo();
            }
        }
    },
    reconfigure: function(store) {
        if (this.store) {
            this.store.un('guaranteedrange', this.onGuaranteedRange, this);
        }
        
        this.store = store;
        this.store.on('guaranteedrange', this.onGuaranteedRange, this);
    },
    setViewScrollTop: function(scrollTop, useMax) {
        var owner = this.getPanel(),
            items = owner.query('tableview'),
            i = 0,
            len = items.length,
            center,
            centerEl,
            calcScrollTop,
            maxScrollTop,
            scrollerElDom = this.el.dom;

        owner.virtualScrollTop = scrollTop;

        center = items[1] || items[0];
        centerEl = center.el.dom;

        maxScrollTop = ((owner.store.pageSize * this.rowHeight) - centerEl.clientHeight);
        calcScrollTop = (scrollTop % ((owner.store.pageSize * this.rowHeight) + 1));
        if (useMax) {
            calcScrollTop = maxScrollTop;
        }
        if (calcScrollTop > maxScrollTop) {
            return;
        }
        for (; i < len; i++) {
            items[i].el.dom.scrollTop = calcScrollTop||0;
        }
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/table/Summary.js
Ext.define('App.view.viewer.table.Summary', {
    extend: 'Ext.Container',
    dock: 'bottom',
    cls: 'w-viewer-table-summary',
    layout: 'hbox',
    initComponent: function() {
        var self = this;
        
        this.simpleStore.on('guaranteedrange', function() {
            self.onGuaranteedRange.call(self, self.simpleStore);
        }, this);
        this.groupedStore.on('guaranteedrange', function() {
            self.onGuaranteedRange.call(self, self.groupedStore);
        }, this);
        this.callParent(arguments);
    },
    reconfigure: function(columns) {
        var i, item, column;
        
        // suspend relayouting for each change
        this.suspendLayout = true;
        
        // Verify items
        var len = this.items.getCount();
        var offset = columns.length - this.items.getCount();
        
        if (offset != 0) {
            var type = offset > 0 ? 1 : 0;
            var abs = Math.abs(offset);
            
            if (offset > 0) {
                // Create new items
                for (i=0; i < abs; i++) {
                    this.add(this.createColumn());
                }
            } else {
                // Remove items
                for (i=0; i < abs; i++) {
                    this.remove(this.items.getAt(len - i - 1), true);
                }
            }
        }
        
        for (i=0; i < columns.length; i++) {
            column = columns[i];
            item = this.items.getAt(i);
            
            // Verify bindings
            if (!column['summaryBinded']) {
                column.on('resize', this.onHeaderColumnResize, this);
            }
            
            // Clear previosly setted value
            if (item.rendered) {
                item.valueEl.update('');
            }
            
            // Verify visibility
            if (column.isVisible()) {
                item.show();
            } else {
                item.hide();
            }
            
            // Set First & Last cls
            if (i == 0) {
                item.addCls('w-viewer-table-summary-column-first');
            } else if (i == columns.length - 1) {
                item.addCls('w-viewer-table-summary-column-last');
            } else if (item.rendered && (item.getEl().hasCls('w-viewer-table-summary-column-first') || item.getEl().hasCls('w-viewer-table-summary-column-last'))) {
                item.getEl().removeCls('w-viewer-table-summary-column-first');
                item.getEl().removeCls('w-viewer-table-summary-column-last');
            }
            
            // Set Width & Id
            item.columnId = column['id'];
            item.columnRenderer = column['summaryRenderer'];
            item.setWidth(column.getWidth());
        }
        
        // Do layout for visible changes
        this.suspendLayout = false;
        this.doLayout();
    },
    
    createColumn: function() {
        var column = Ext.create('Ext.container.Container', {
            cls: 'w-viewer-table-summary-column',
            renderTpl: [
                '<div class="w-viewer-table-summary-column-inner"></div>'
            ],
            renderSelectors: {
                valueEl: 'div.w-viewer-table-summary-column-inner'
            }
        });
        
        return column;
    },
    
    onGuaranteedRange: function(store) {
        var i, item;
        var len = this.items.getCount();
        var summaries = store.getSummaries();
        
        for (i=0; i < len; i++) {
            item = this.items.getAt(i);
            
            if (Ext.isFunction(item.columnRenderer)) {
                item.valueEl.update(item.columnRenderer(summaries));
            }
        }
    },
    setColumnLoading: function() {
        
    },
    setColumnValue: function() {
        
    },
    onHeaderColumnTransfer: function() {


    },
    onHeaderColumnRemove: function() {


    },
    onHeaderColumnResize: function(column, width) {
        var i = 0, item; 
        
        for( i=0; i < this.items.length; i++ ) {
            item = this.items.get(i);
            
            if( item['columnId'] == column['id'] ) {
                item.setWidth(width);
            }
        }
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/table/View.js
Ext.define('App.view.viewer.table.View', {
    extend: 'Ext.view.Table',
    alias : 'widget.viewerTableView',
    /**
    refresh: function() {
        if (!this.rendered || this.isDestroyed) {
            return;
        }
        
        if (this.store.getCount() == 0) {
            this.el.update(this.emptyText);
            this.el.setStyle();
        }

        this.callParent(arguments);
    },
    **/
    setNewTemplate: function() {
        var columns = this.headerCt.getColumnsForTpl(true);

        this.tpl = this.getTableChunker().getTableTpl({
            columns: columns,
            columnsItems: this.headerCt.items,
            features: this.features
        });
    },
    collectData: function() {
        var result = this.callParent(arguments);
        var columns = this.headerCt.items;
        var groupedColumns = new Array();
        var column;
        var i, c, s;

        for (i=0; i < columns.length; i++) {
            column = columns.get(i);
            if (column['grouped']) {
                groupedColumns.push(column);
            }
        }

        if (groupedColumns.length == 0) {
            return result;
        }

        var rows = result.rows;
        var id, sid, span;

        for (c=0; c < groupedColumns.length; c++) {
            column = groupedColumns[c];
            id = column.getId();
            sid = id + '-rowspan';
            span = 0;

            for (i=0; i < rows.length; i++) {
                if (span == 1) {
                    span = 0;
                }
                if (span > 0) {
                    span--;
                    rows[i][sid] = 0;
                    continue;
                }

                for (s = i; s < rows.length; s++) {
                    if (rows[i][id] != rows[s][id]) {
                        break;
                    }

                    span++;
                }

                rows[i][sid] = span;
            }
        }

        return result;
    },
    onItemMouseEnter: function(record, item, index, event) {
        var target = Ext.get(event.target);

        if (target.hasCls('x-grid-cell-grouped')) {
            if (this.trackOver) {
                this.clearHighlight();
            }
            return false;
        }
        if (target.hasCls('x-grid-cell-inner')) {
            var parent = target.parent('td')

            if (parent.hasCls('x-grid-cell-grouped')) {
                if (this.trackOver) {
                    this.clearHighlight();
                }
                return false;
            }
        }

        return this.callParent(arguments);
    },
    onItemMouseDown: function(record, item, index, event) {
        var target = Ext.get(event.target);

        if (target.hasCls('x-grid-cell-grouped')) {
            if (this.trackOver) {
                this.clearHighlight();
            }
            return false;
        }
        if (target.hasCls('x-grid-cell-inner')) {
            var parent = target.parent('td')

            if (parent.hasCls('x-grid-cell-grouped')) {
                if (this.trackOver) {
                    this.clearHighlight();
                }
                return false;
            }
        }

        return this.callParent(arguments);
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/viewer/Table.js
Ext.define('App.view.viewer.Table', {
    extend: 'Ext.grid.Panel',
    alias : 'widget.viewerTable',
    scroll: 'vertical',
    frame: true,
    verticalScrollerType: 'viewerTableScroller',
    invalidateScrollerOnRefresh: false,
    loadMask: true,
    viewType: 'viewerTableView',
    viewConfig: {
        chunker: App.view.viewer.table.Chunker,
        stripeRows: true
    },
    cls: 'w-viewer-table',
    initComponent: function() {
        // Creates a default store
        this.simpleStore = Ext.data.StoreManager.lookup('SimpleEvents');
        this.simpleStore.on('sortchange', this.onStoreSortChange, this);
        this.groupedStore = Ext.data.StoreManager.lookup('GroupedEvents');
        this.groupedStore.on('sortchange', this.onStoreSortChange, this);

        this.store = this.simpleStore;
        this.storeType = 'simple';

        this.horizontalScroller = false;

        // Creates a default columns
        this.columns = new Array();

        // Creates a summary view
        this.summaryCt = Ext.create('App.view.viewer.table.Summary', {
            simpleStore: this.simpleStore,
            groupedStore: this.groupedStore
        });

        this.dockedItems = [
            this.summaryCt
        ]

        this.callParent(arguments);

        this.on('cellclick', function(tthis, td, cellIndex, record, tr, rowIndex, e, eOpts){
            if (e && e.target && e.target.tagName == 'A' && Ext.fly(e.target).hasCls('morerecords')){
                var recordsStr = Ext.fly(e.target).getAttribute('records');
                if(recordsStr && recordsStr != ''){
                    var records = App.utility.File.parseRecordings(recordsStr);

                    var hrmlRecords = '';
                    var pbxid = record.get('PBX');
                    if (pbxid){
                        pbxid = pbxid.replace(/.*\((\w+)\)/,'$1').trim();
                    }
                    for(var i=0; i < records.length; i++){

                        var date = Ext.Date.format(records[i].date, 'd/m/Y H:i:s');
                        for(var j=0; j < records[i].files; j++){
                            var url = null;
                            var userName = '';
                            if (records[i].source == record.get('FROM')){
                                if (record.get('FROM_USER'))
                                    userName = record.get('FROM_USER')+' ('+record.get('FROM')+')' ;
                                else
                                    userName = record.get('FROM_USER');
                            } else if (records[i].source == record.get('TO')) {
                                if (record.get('TO_USER'))
                                    userName = record.get('TO_USER')+' ('+record.get('TO')+')' ;
                                else
                                    userName = record.get('TO');

                            }
                            if(records[i].filename.indexOf('-{n}') > -1){
                                url = '/spoolview/recordings/'+records[i].filename.replace('{n}', j);
                            }else{
                                url = '/spoolview/recordings/'+records[i].filename+'-'+j+'.wav';
                            }
                            if (pbxid && Serial != pbxid){
                                //Download data from another pbx
                                url = '/collaboration/lua/fileproxy.lua?serial='+pbxid+'&path='+url;
                            }
                            hrmlRecords += "<tr>" +
                                                "<td class='w-recording-username'>"+userName+"</td>" +
                                                "<td class='w-recording-filename'>"+date+" "+_t('Record part')+" "+(j+1)+"</td>" +
                                                "<td class='w-recording-link'>" +
                                                    "<a class='w-download-attach w-recording fa fa-file-audio-o' href='../.." + url + "' target='_blank' title='"+_t('Download recording')+"'></a>" +
                                                "</td>" +
                                            "</tr>";
                        }
                    }
                    var html="<table class='w-recording-table'>" +
                            "" + hrmlRecords + "" +
                            "</table>";

                    Ext.create('Ext.window.Window', {
                        title: _t('Records'),
                        maxHeight: 500,
                        width: 400,
                        layout: 'fit',
                        modal: true,
                        items: {
                            xtype: 'panel',
                            padding: 10,
                            style: 'background-color:white',
                            border: false,
                            html: html
                        }
                    }).show();
                }
            }

        });
    },

    /**
     *
     */
    clearColumns: function(identies, type, sortersColumns) {
        var i;
        var typeChange = false;

        // Verify store
        if (this.type != type) {
            typeChange = true;

            if (type == 'simple') {
                this.type = 'simple';

                this.bindStore(this.simpleStore);
                this.verticalScroller.reconfigure(this.simpleStore);
            } else if (type == 'grouped') {
                this.type = 'grouped';

                this.bindStore(this.groupedStore);
                this.verticalScroller.reconfigure(this.groupedStore);
            }
        }

        // Verify columns
        var columns = new Array(), column;
        var groupingsCount = 0;
        this.headerCt.removeAll();



        if (typeChange) {

            for (i=0; i < identies.length; i++) {
                column = this.createColumnByIdenty(identies[i]);
                columns.push(column);
            }

            // define is results is a simple gropings sort
            for (i=0; i < columns.length; i++) {
                if (columns[i]['grouped']) {
                    groupingsCount++;
                }
            }

            if (groupingsCount > 1) {
                this.sortableColumns = false;
            } else {
                this.sortableColumns = true;
            }

            // reset sort state for available columns
            for (i=0; i < columns.length; i++) {
                columns[i]['sortable'] = this.sortableColumns;
            }

            this.headerCt.suspendLayout = true;
            this.headerCt.removeAll();
            this.headerCt.add(columns);
        } else {
            var a, c;
            var len = this.headerCt.getColumnCount();

            // suspend relayouting for each change
            this.headerCt.suspendLayout = true;

            // define is results is a simple gropings sort
            for (i=0; i < identies.length; i++) {
                for (c=0; c < len; c++) {
                    column = this.headerCt.getHeaderAtIndex(c);

                    if (column['identy'] == identies[i] && column['grouped']) {
                        groupingsCount++;
                        break;
                    }
                }
            }

            if (groupingsCount > 1) {
                this.sortableColumns = false;
            } else {
                this.sortableColumns = true;
            }

            // show, hide and reset sort state for available columns
            for (i=0; i < len; i++) {
                a = false;
                column = this.headerCt.getHeaderAtIndex(i);
                if (sortersColumns && sortersColumns.field == column.dataIndex) {
                    column.setSortState(sortersColumns.dest, false, true);
                } else {
                    column.setSortState(null);
                }
                column.sortable = this.sortableColumns;

                for (c=0; c < identies.length; c++) {
                    if (column['identy'] == identies[c]) {
                        a = true;
                    }
                }

                if (!a) {
                    column.hide();
                } else {
                    if (!column.isVisible()) {
                        column.show();
                    }
                }
            }

            // insert new columns
            var index, prev;

            for (i=0; i < identies.length; i++) {
                a = false;
                len = this.headerCt.getColumnCount();

                for (c=0; c < len; c++) {
                    column = this.headerCt.getHeaderAtIndex(c);

                    if (identies[i] == column['identy']) {
                        a = true;
                        break;
                    }
                }

                if (!a) {
                    index = 0;

                    // verify insert index
                    if (i > 0) {
                        prev = identies[i - 1];

                        for (c=0; c < len; c++) {
                            column = this.headerCt.getHeaderAtIndex(c);

                            if (prev == column['identy']) {
                                index = c + 1;
                                break;
                            }
                        }
                    }

                    column = this.createColumnByIdenty(identies[i]);

                    this.headerCt.add(index, column);
                }
            }

            // order grouped columns
            len = this.headerCt.getColumnCount();

            var orders = new Array();

            for (i=0; i < identies.length; i++) {
                for (c=0; c < len; c++) {
                    column = this.headerCt.getHeaderAtIndex(c);

                    if (column['identy'] == identies[i] && column['grouped']) {
                        orders.push(column['identy']);
                        break;
                    }
                }
            }

            for (i=0; i < orders.length; i++) {
                for (c=0; c < len; c++) {
                    column = this.headerCt.items.getAt(c);

                    if (column['identy'] == orders[i]) {
                        if (c != i) {
                            this.headerCt.move(c, i);
                        }

                        break;
                    }
                }
            }

            // Do layout for visible changes
            this.headerCt.suspendLayout = false;
            this.headerCt.doLayout();
        }

        this.summaryCt.reconfigure(this.headerCt.items.getRange());

        this.headerCt.hide();
        this.summaryCt.hide();
        this.headerCt.doLayout();
        this.summaryCt.doLayout();
        // ...
        this.store.on('guaranteedrange', this.onClearedStoreGuaranteedRange, this, {single: true});
    },

    /**
     *
     */
    clearStore: function() {



        this.store.removeAll();
        this.store.prefetchData.clear();
        this.store.guaranteedStart = undefined;
        this.store.guaranteedEnd = undefined;
        this.store.requestEnd = undefined;
        this.store.requestSeed = undefined;
        this.store.requestStart = undefined;
        this.store.totalCount = this.store.pageSize;
    },

    invalidateScrollerProper: function() {
        var scroller = this.verticalScroller;
        var scrollEl = scroller.scrollEl;

        if (scrollEl) {
            scrollEl.removeAllListeners();
            scroller.mon(scrollEl, 'scroll', scroller.onElScroll, scroller);
        }

        this.invalidateScroller();
    },

    /**
     * Fires when store is loaded first time (avoid paging)
     */
    onClearedStoreGuaranteedRange: function() {


        this.clearView();

        this.headerCt.show();
        this.summaryCt.show();
        this.headerCt.doLayout();
        this.summaryCt.doLayout();
    },

    onStoreSortChange: function() {
        this.clearView();
    },

    /**
     *
     */
    clearView: function() {



        var view = this.getTableView();

        if (view.el) {
            view.el.dom.scrollTop = 0;
        }

        if (!this.verticalScroller.panel) {
            this.verticalScroller.panel = this.verticalScroller.getPanel();
        }

        if (this.verticalScroller.scrollEl) {
            this.verticalScroller.scrollEl.dom.scrollTop = 0;
        }

        this.invalidateScrollerProper();

        return true;
    },

    getSummaryView: function() {
        return this.summaryCt;
    },

    getTableView: function() {
        return this.down('tableview');
    },

    createColumnByIdenty: function(identy) {
        var column;

        switch (identy) {
            // Simple Columns
            case 'NUMBERER':
                column = this.createNumbererColumn();
                break;
            case 'DATE':
                column = this.createDateColumn();
                break;
            case 'FROM':
                column = this.createFromColumn();
                break;
            case 'FROM_GROUP':
                column = this.createFromGroupColumn();
                break;
            case 'TO':
                column = this.createToColumn();
                break;
            case 'TO_GROUP':
                column = this.createToGroupColumn();
                break;
            case 'DURATION':
                column = this.createDurationColumn();
                break;
            case 'BILL':
                column = this.createBillColumn();
                break;
            case 'RING':
                column = this.createRingColumn();
                break;
            case 'COST':
                column = this.createCostColumn();
                break;
            case 'DIRECTION':
                column = this.createDirectionColumn();
                break;
            case 'STATUS':
                column = this.createStatusColumn();
                break;
            case 'AREA':
                column = this.createAreaColumn();
                break;
            case 'CLASS':
                column = this.createClassColumn();
                break;
            case 'TRUNK':
                column = this.createTrunkColumn();
                break;
            case 'PBX':
                column = this.createPbxColumn();
                break;
            case 'TAG':
                column = this.createTagColumn();
                break;
            case 'SERVICE':
                column = this.createServiceColumn();
                break;
            case 'USERFIELD':
                column = this.createUserfieldColumn();
                break;
            case 'FAXDATA':
                column = this.createFaxdataColumn();
                break;

            // Grouped Columns
            case 'TOTAL_EVENTS':
                column = this.createTotalEventsColumn();
                break;
            case 'TOTAL_LOCAL_EVENTS':
                column = this.createTotalLocalEvents();
                break;
            case 'TOTAL_INCOMING_EVENTS':
                column = this.createTotalIncomingEvents();
                break;
            case 'TOTAL_OUTGOING_EVENTS':
                column = this.createTotalOutgoingEvents();
                break;
            case 'TOTAL_ANSWERED_EVENTS':
                column = this.createTotalAnsweredEvents();
                break;
            case 'TOTAL_ANSWERED_WITHIN_XX_EVENTS':
                column = this.createTotalAnsweredWithinXXEvents();
                break;
            case 'TOTAL_ANSWERED_OVER_XX_EVENTS':
                column = this.createTotalAnsweredOverXXEvents();
                break;
            case 'TOTAL_NOT_ANSWERED_EVENTS':
                column = this.createTotalNotAnsweredEvents();
                break;
            case 'TOTAL_CALL_EVENTS':
                column = this.createTotalCallEvents();
                break;
            case 'TOTAL_FAX_EVENTS':
                column = this.createTotalFaxEvents();
                break;
            case 'TOTAL_VOICEMAIL_EVENTS':
                column = this.createTotalVoiceMailEvents();
                break;
            case 'TOTAL_BILL':
                column = this.createTotalBill();
                break;
            case 'AVG_BILL':
                column = this.createAvgBill();
                break;
            case 'TOTAL_LOCAL_BILL':
                column = this.createTotalLocalBill();
                break;
            case 'AVG_LOCAL_BILL':
                column = this.createAvgLocalBill();
                break;
            case 'TOTAL_INCOMING_BILL':
                column = this.createTotalIncomingBill();
                break;
            case 'AVG_INCOMING_BILL':
                column = this.createAvgIncomingBill();
                break;
            case 'TOTAL_OUTGOING_BILL':
                column = this.createTotalOutgoingBill();
                break;
            case 'AVG_OUTGOING_BILL':
                column = this.createAvgOutgoingBill();
                break;

            case 'TOTAL_RING':
                column = this.createTotalRingColumn();
                break;
            case 'AVG_RING':
                column = this.createAvgRingColumn();
                break;

            case 'TOTAL_COST':
                column = this.createTotalCostColumn();
                break;
            case 'TOTAL_CALL_COST':
                column = this.createTotalCallCostColumn();
                break;
            case 'TOTAL_FAX_COST':
                column = this.createTotalFaxCostColumn();
                break;
            case 'AVG_COST':
                column = this.createAvgCostColumn();
                break;
            case 'AVG_CALL_COST':
                column = this.createAvgCallCostColumn();
                break;
            case 'AVG_FAX_COST':
                column = this.createAvgFaxCostColumn();
                break;

            // Grouped Columns
            case 'GROUP_HOUR':
                column = this.createGroupHourColumn();
                break;
            case 'GROUP_HOUR_OF_DAY':
                column = this.createGroupHourOfDayColumn();
                break;
            case 'GROUP_DAY':
                column = this.createGroupDayColumn();
                break;
            case 'GROUP_DAY_OF_WEEK':
                column = this.createGroupDayOfWeekColumn();
                break;
            case 'GROUP_WEEK':
                column = this.createGroupWeekColumn();
                break;
            case 'GROUP_MONTH':
                column = this.createGroupMonthColumn();
                break;
            case 'GROUP_MONTH_OF_YEAR':
                column = this.createGroupMonthOfYearColumn();
                break;
            case 'GROUP_YEAR':
                column = this.createGroupYearColumn();
                break;
            case 'GROUP_USER':
                column = this.createGroupUserColumn();
                break;
            case 'GROUP_CLIENT':
                column = this.createGroupClientColumn();
                break;
            case 'GROUP_COMPANY':
                column = this.createGroupCompanyColumn();
                break;
            case 'GROUP_GROUP':
                column = this.createGroupGroupColumn();
                break;
            case 'GROUP_NUMBER':
                column = this.createGroupNumberColumn();
                break;
            case 'GROUP_SERVICE':
                column = this.createGroupServiceColumn();
                break;
            case 'GROUP_DIRECTION':
                column = this.createGroupDirectionColumn();
                break;
            case 'GROUP_TRUNK':
                column = this.createGroupTrunkColumn();
                break;
            case 'GROUP_TAG':
                column = this.createGroupTagColumn();
                break;
            case 'GROUP_PBX':
                column = this.createGroupPbxColumn();
                break;
            case 'GROUP_COUNTRY':
                column = this.createGroupCountryColumn();
                break;
            case 'GROUP_CLASS':
                column = this.createGroupClassColumn();
                break;

            case 'GROUP_USER_COMM_FROM':
                column = this.createGroupUserCommFromColumn();
                break;
            case 'GROUP_USER_COMM_TO':
                column = this.createGroupUserCommToColumn();
                break;
            case 'GROUP_GROUP_COMM_FROM':
                column = this.createGroupGroupCommFromColumn();
                break;
            case 'GROUP_GROUP_COMM_TO':
                column = this.createGroupGroupCommToColumn();
                break;
        }


        return column;
    },

    createNumbererColumn: function() {
        var self = this;
        var column = Ext.create('Ext.grid.RowNumberer', {
            identy: 'NUMBERER',
            width: 50,
            menuDisabled: true,
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_EVENTS']);
            }
        });

        return column;
    },

    createDateColumn: function() {
        return Ext.create('App.view.viewer.table.Column', {
            identy: 'DATE',
            header: _t('Date'),
            dataIndex: 'DATE',
            width: 125,
            menuDisabled: true,
            renderer: function(value) {
                return Ext.Date.format(Ext.Date.parse(value.substr(0, 19), "Y-m-d H:i:s"), User.getDateTimeFormat());
            }
        });
    },
    createDurationColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'DURATION',
            header: _t('Duration'),
            dataIndex: 'DURATION',
            width: 60,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(parseInt(summaries['TOTAL_DURATION']));
            }
        });

        return column;
    },
    createFromColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'FROM',
            header: _t('From'),
            dataIndex: 'FROM',
            // width: 125,
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                var name = record.get('FROM_USER');
                var fromName = record.get('FROM_NAME');
                if (fromName) {
                    name = fromName;
                }

                name = hide_acl_name(name, value);
                value = hide_acl_digits(value);

                if (name) {
                    if ( !this.skipTags )
                        return name +' (<span style="color:#424242;">'+ Ext.util.Format.htmlEncode(value) +'</span>)';
                    else
                        return name +' ('+ Ext.util.Format.htmlEncode(value) +')';

                }
                return value;
            }
        });

        return column;
    },
    createFromGroupColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'FROM_GROUP',
            header: _t('Group'),
            dataIndex: 'FROM_GROUP',
            width: 75,
            menuDisabled: true,
            renderer: function( value, row, record ) {
                if (value) {
                    return Ext.util.Format.htmlEncode(value);
                }
                return _t('Other');
            }
        });

        return column;
    },
    createToColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TO',
            header: _t('To'),
            dataIndex: 'TO',
            // width: 125,
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                var name = record.get('TO_USER');
                var toName = record.get('TO_NAME');
                if (toName) {
                    name = toName;
                }

                name = hide_acl_name(name, value);
                value = hide_acl_digits(value);

                if (name) {
                    if ( !this.skipTags )
                        return name +' (<span style="color:#424242;">'+ Ext.util.Format.htmlEncode(value) +'</span>)';
                    else
                        return name +' ('+ value +')';
                }
                return value;
            }
        });

        return column;
    },
    createToGroupColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TO_GROUP',
            header: _t('Group'),
            dataIndex: 'TO_GROUP',
            width: 75,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (value) {
                    return Ext.util.Format.htmlEncode(value);
                }
                return _t('Other');
            }
        });

        return column;
    },
    createAreaColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'AREA',
            header: _t('Country'),
            dataIndex: 'COUNTRY',
            width: 80,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (value) {
                    var area = record.get('COUNTRY_AREA');
                    return value +", "+ area;
                }
                return _t('Other');
            }
        });

        return column;
    },
    createClassColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'CLASS',
            header: _t('Call Class'),
            dataIndex: 'CLASS',
            width: 80,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatCallClass(value, this.skipTags);
            }
        });

        return column;
    },
    createCostColumn: function() {
        var grade = User.grade_of_accuracy || 2;
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'COST',
            header: _t('Cost'),
            dataIndex: 'COST',
            width: 65,
            menuDisabled: true,
            renderer: function(value) {
                return App.utility.NamesFormatter.formatWithAccuracyGrade(value, grade) /*+  (this.skipTags?'' : ' &euro;')*/;
            },
            exportRenderer: function(value, row, record) {
                return parseFloat(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatWithAccuracyGrade(summaries['TOTAL_COST'], grade) /*+ (summaries.skipTags?'' : ' &euro;')*/;
            }
        });

        return column;
    },
    createDirectionColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'DIRECTION',
            header: _t('Direction'),
            dataIndex: 'DIRECTION',
            width: 60,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatDirection(value, this.skipTags);
            }
        });

        return column;
    },
    createStatusColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'STATUS',
            header: _t('Status'),
            dataIndex: 'BILL',
            width: 60,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatStatus(value, this.skipTags);
            }
        });

        return column;
    },
    createBillColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'BILL',
            header: _t('Talk time') + ' ('+_t('Seconds short')+')',
            dataIndex: 'BILL',
            width: 90,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatBill(value);
            },
            exportRenderer: function(value, row, record) {
                return parseInt(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(parseInt(summaries['TOTAL_BILL']));
            }
        });

        return column;
    },
    createRingColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'RING',
            header: _t('Ring Time') + ' ('+_t('Seconds short')+')',
            dataIndex: 'RING',
            width: 90,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatBill(value);
            },
            exportRenderer: function(value, row, record) {
                return parseInt(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(parseInt(summaries['TOTAL_RING']));
            }
        });

        return column;
    },
    createTrunkColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TRUNK',
            header: _t('Trunk'),
            dataIndex: 'TRUNK',
            width: 80,
            menuDisabled: true,
            renderer: function( value, row, record ) {
                if (value) {
                    return Ext.util.Format.htmlEncode(value);
                }
                return _t('Other');
            }
        });

        return column;
    },
    createPbxColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'PBX',
            header: _t('Pbx'),
            dataIndex: 'PBX',
            width: 125,
            menuDisabled: true,
            renderer: function( value, row, record ) {
                if (value) {
                    return value;
                }
                return _t('Other');
            }
        });

        return column;
    },
    createTagColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TAG',
            header: _t('Tag'),
            dataIndex: 'TAG',
            width: 80,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (value) {
                    return Ext.util.Format.htmlEncode(value);
                }
                return '-';
            }
        });

        return column;
    },
    createServiceColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'SERVICE',
            header: _t('Service'),
            dataIndex: 'SERVICE',
            width: 80,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return (this.skipTags ? '' :
                         App.utility.File.userDataLink(record) + App.utility.File.faxDataLink(record)
                       ) + App.utility.NamesFormatter.formatService(value, this.skipTags);
            }
        });

        return column;
    },
    createUserfieldColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'USERFIELD',
            header: '',
            hidden: true,
            dataIndex: 'USERFIELD',
            width: 80,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return Ext.util.Format.htmlEncode(value);
            }
        });

        return column;
    },
    createFaxdataColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'FAXDATA',
            header: '',
            hidden: true,
            dataIndex: 'FAXDATA',
            width: 80,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return Ext.util.Format.htmlEncode(value);
            }
        });

        return column;
    },
    createTotalEventsColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_EVENTS',
            header: _t('Events'),
            dataIndex: 'TOTAL_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_EVENTS']);
            }
        });

        return column;
    },
    createTotalLocalEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_LOCAL_EVENTS',
            header: _t('Local events'),
            dataIndex: 'TOTAL_LOCAL_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_LOCAL_EVENTS']);
            }
        });

        return column;
    },
    createTotalIncomingEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_INCOMING_EVENTS',
            header: _t('Inc. events'),
            dataIndex: 'TOTAL_INCOMING_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_INCOMING_EVENTS']);
            }
        });

        return column;
    },
    createTotalOutgoingEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_OUTGOING_EVENTS',
            header: _t('Out. events'),
            dataIndex: 'TOTAL_OUTGOING_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_OUTGOING_EVENTS']);
            }
        });

        return column;
    },
    createTotalAnsweredEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_ANSWERED_EVENTS',
            header: _t('Answ. events'),
            dataIndex: 'TOTAL_ANSWERED_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_ANSWERED_EVENTS']);
            }
        });

        return column;
    },
    createTotalAnsweredWithinXXEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_ANSWERED_WITHIN_XX_EVENTS',
            header: sprintf(_t('Answ. events within %(seconds)s'),{seconds:User.sla_period}),
            dataIndex: 'TOTAL_ANSWERED_WITHIN_XX_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_ANSWERED_WITHIN_XX_EVENTS']);
            }
        });

        return column;
    },
    createTotalAnsweredOverXXEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_ANSWERED_OVER_XX_EVENTS',
            header: sprintf(_t('Answ. events over %(seconds)s'),{seconds:User.sla_period}),
            dataIndex: 'TOTAL_ANSWERED_OVER_XX_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_ANSWERED_OVER_XX_EVENTS']);
            }
        });

        return column;
    },
    createTotalNotAnsweredEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_NOT_ANSWERED_EVENTS',
            header: _t('Unansw. events'),
            dataIndex: 'TOTAL_NOT_ANSWERED_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_NOT_ANSWERED_EVENTS']);
            }
        });

        return column;
    },

    createTotalCallEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_CALL_EVENTS',
            header: _t('Call events'),
            dataIndex: 'TOTAL_CALL_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_CALL_EVENTS']);
            }
        });

        return column;
    },
    createTotalFaxEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_FAX_EVENTS',
            header: _t('Fax events'),
            dataIndex: 'TOTAL_FAX_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_FAX_EVENTS']);
            }
        });

        return column;
    },
    createTotalVoiceMailEvents: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_VOICEMAIL_EVENTS',
            header: _t('Voicemail events'),
            dataIndex: 'TOTAL_VOICEMAIL_EVENTS',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatNumber(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatNumber(summaries['TOTAL_VOICEMAIL_EVENTS']);
            }
        });

        return column;
    },
    createTotalBill: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_BILL',
            header: _t('Talk time'),
            dataIndex: 'TOTAL_BILL',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['TOTAL_BILL']);
            }
        });

        return column;
    },
    createAvgBill: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'AVG_BILL',
            header: _t('Avg. Talk time'),
            dataIndex: 'AVG_BILL',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['AVG_BILL']);
            }
        });

        return column;
    },
    createTotalLocalBill: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_LOCAL_BILL',
            header: _t('Local Talk time'),
            dataIndex: 'TOTAL_LOCAL_BILL',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['TOTAL_LOCAL_BILL']);
            }
        });

        return column;
    },
    createAvgLocalBill: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'AVG_LOCAL_BILL',
            header: _t('Avg. Local Talk time'),
            dataIndex: 'AVG_LOCAL_BILL',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['AVG_LOCAL_BILL']);
            }
        });

        return column;
    },
    createTotalIncomingBill: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_INCOMING_BILL',
            header: _t('Inc. Talk time'),
            dataIndex: 'TOTAL_INCOMING_BILL',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['TOTAL_INCOMING_BILL']);
            }
        });

        return column;
    },
    createAvgIncomingBill: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'AVG_INCOMING_BILL',
            header: _t('Avg. Inc. Talk time'),
            dataIndex: 'AVG_INCOMING_BILL',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['AVG_INCOMING_BILL']);
            }
        });

        return column;
    },
    createTotalOutgoingBill: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_OUTGOING_BILL',
            header: _t('Out. Talk time'),
            dataIndex: 'TOTAL_OUTGOING_BILL',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['TOTAL_OUTGOING_BILL']);
            }
        });

        return column;
    },
    createAvgOutgoingBill: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'AVG_OUTGOING_BILL',
            header: _t('Avg. Out. Talk time'),
            dataIndex: 'AVG_OUTGOING_BILL',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['AVG_OUTGOING_BILL']);
            }
        });

        return column;
    },

    createTotalRingColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_RING',
            header: _t('Ring Time'),
            dataIndex: 'TOTAL_RING',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['TOTAL_RING']);
            }
        });

        return column;
    },
    createAvgRingColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'AVG_RING',
            header: _t('Avg. Ring Time'),
            dataIndex: 'AVG_RING',
            flex: 1,
            menuDisabled: true,
            renderer: function(value) {
                return App.utility.NamesFormatter.formatHoursTime(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatHoursTime(summaries['AVG_RING']);
            }
        });

        return column;
    },
    createTotalCostColumn: function() {
        var grade = User.grade_of_accuracy || 2;
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_COST',
            header: _t('Cost'),
            dataIndex: 'TOTAL_COST',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatWithAccuracyGrade(value, grade);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatWithAccuracyGrade(summaries['TOTAL_COST'], grade);
            }
        });

        return column;
    },
    createTotalCallCostColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_CALL_COST',
            header: _t('Call cost'),
            dataIndex: 'TOTAL_CALL_COST',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatFloat(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatFloat(summaries['TOTAL_CALL_COST']);
            }
        });

        return column;
    },
    createTotalFaxCostColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'TOTAL_FAX_COST',
            header: _t('Fax cost'),
            dataIndex: 'TOTAL_FAX_COST',
            flex: 1,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatFloat(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatFloat(summaries['TOTAL_FAX_COST']);
            }
        });

        return column;
    },
    createAvgCostColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'AVG_COST',
            header: _t('Avg. Cost'),
            dataIndex: 'AVG_COST',
            flex: 1,
            menuDisabled: true,
            renderer: function(value) {
                return App.utility.NamesFormatter.formatFloat(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatFloat(summaries['AVG_COST']);
            }
        });

        return column;
    },
    createAvgCallCostColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'AVG_CALL_COST',
            header: _t('Avg. Call Cost'),
            dataIndex: 'AVG_CALL_COST',
            flex: 1,
            menuDisabled: true,
            renderer: function(value) {
                return App.utility.NamesFormatter.formatFloat(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatFloat(summaries['AVG_CALL_COST']);
            }
        });

        return column;
    },
    createAvgFaxCostColumn: function() {
        var self = this;
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'AVG_FAX_COST',
            header: _t('Avg. Fax Cost'),
            dataIndex: 'AVG_FAX_COST',
            flex: 1,
            menuDisabled: true,
            renderer: function(value) {
                return App.utility.NamesFormatter.formatFloat(value);
            },
            summaryRenderer: function(summaries) {
                return App.utility.NamesFormatter.formatFloat(summaries['AVG_FAX_COST']);
            }
        });

        return column;
    },
    createGroupHourColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_HOUR',
            header: _t('Hour'),
            dataIndex: 'HOUR',
            width: 115,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatGroupingByHour(value);
            }
        });

        return column;
    },
    createGroupHourOfDayColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_HOUR_OF_DAY',
            header: _t('Hour of day'),
            dataIndex: 'HOUR_OF_DAY',
            width: 115,
            grouped: true,
            menuDisabled: true,
            renderer: function(value) {
                return App.utility.NamesFormatter.formatHourOfDay(value);
            }
        });

        return column;
    },
    createGroupDayColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_DAY',
            header: _t('Day'),
            dataIndex: 'DAY',
            width: 80,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatGroupingByDay(value);
            }
        });

        return column;
    },
    createGroupDayOfWeekColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_DAY_OF_WEEK',
            header: _t('Day of week'),
            dataIndex: 'DAY_OF_WEEK',
            width: 130,
            grouped: true,
            menuDisabled: true,
            renderer: function(value) {
                return App.utility.NamesFormatter.formatDayOfWeek(value);
            }
        });

        return column;
    },
    createGroupWeekColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_WEEK',
            header: _t('Week'),
            dataIndex: 'WEEK',
            width: 150,
            grouped: true,
            menuDisabled: true,
            renderer: function(value) {
                return App.utility.NamesFormatter.formatGroupingByWeek(value);
            }
        });

        return column;
    },
    createGroupMonthColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_MONTH',
            header: _t('Month'),
            dataIndex: 'MONTH',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatByMonth(value);
            }
        });

        return column;
    },
    createGroupMonthOfYearColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_MONTH_OF_YEAR',
            header: _t('Month of year'),
            dataIndex: 'MONTH_OF_YEAR',
            width: 130,
            grouped: true,
            menuDisabled: true,
            renderer: function(value) {
                return App.utility.NamesFormatter.formatMonthOfYear(value);
            }
        });

        return column;
    },
    createGroupYearColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_YEAR',
            header: _t('Year'),
            dataIndex: 'YEAR',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return value;
            }
        });

        return column;
    },
    createGroupUserColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_USER',
            header: _t('User'),
            dataIndex: 'USER',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (!value) {
                    return _t('Other');
                }
                var name = record.get('USER_NAME');
                return Ext.util.Format.htmlEncode(name);
            }
        });

        return column;
    },
    createGroupClientColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_CLIENT',
            header: _t('Business partner'),
            dataIndex: 'CLIENT',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (!value) {
                    return _t('Other');
                }
                var name = record.get('CLIENT_NAME');
                return Ext.util.Format.htmlEncode(name);
            }
        });

        return column;
    },
    createGroupCompanyColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_COMPANY',
            header: _t('Company'),
            dataIndex: 'COMPANY',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (!value) {
                    return _t('Other');
                }
                var name = record.get('COMPANY_NAME');
                return Ext.util.Format.htmlEncode(name);
            }
        });

        return column;
    },
    createGroupGroupColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_GROUP',
            header: _t('Group'),
            dataIndex: 'USER_GROUP',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (!value) {
                    return _t('Other');
                }
                var name = record.get('USER_GROUP_NAME');
                return Ext.util.Format.htmlEncode(name);
            }
        });

        return column;
    },
    createGroupNumberColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_NUMBER',
            header: _t('Number'),
            dataIndex: 'NUMBER',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                value = hide_acl_digits(value);

                if (!value) {
                    return _t('Other');
                }
                return value;
            }
        });

        return column;
    },
    createGroupServiceColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_SERVICE',
            header: _t('Service'),
            dataIndex: 'SERVICE',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatService(value, this.skipTags);
            }
        });

        return column;
    },
    createGroupDirectionColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_DIRECTION',
            header: _t('Direction'),
            dataIndex: 'DIRECTION',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatGroupDirection(value);
            }
        });

        return column;
    },
    createGroupTrunkColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_TRUNK',
            header: _t('Trunk'),
            dataIndex: 'TRUNK',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (!value) {
                    return _t('Other');
                }
                var name = record.get('TRUNK_NAME');
                return Ext.util.Format.htmlEncode(name);
            }
        });

        return column;
    },
    createGroupTagColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_TAG',
            header: _t('Tag'),
            dataIndex: 'TAG',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (!value) {
                    return '-';
                }
                var name = record.get('TAG_NAME');
                return Ext.util.Format.htmlEncode(name);
            }
        });

        return column;
    },
    createGroupPbxColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_PBX',
            header: _t('Pbx'),
            dataIndex: 'PBX',
            width: 120,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return value;
            }
        });

        return column;
    },
    createGroupCountryColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_COUNTRY',
            header: _t('Country'),
            dataIndex: 'COUNTRY_NAME',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                if (!value) {
                    return _t('Other');
                }
                return value;
            }
        });

        return column;
    },
    createGroupClassColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_CLASS',
            header: _t('Class'),
            dataIndex: 'CLASS',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value, row, record) {
                return App.utility.NamesFormatter.formatCallClass(value);
            }
        });

        return column;
    },
    createGroupUserCommFromColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_USER_COMM_FROM',
            header: _t('From'),
            dataIndex: 'USER_FROM_NAME',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value) {
                if (!value) {
                    return _t('Other');
                }
                return Ext.util.Format.htmlEncode(value);
            }
        });

        return column;
    },
    createGroupUserCommToColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_USER_COMM_TO',
            header: _t('To'),
            dataIndex: 'USER_TO_NAME',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value) {
                if (!value) {
                    return _t('Other');
                }
                return Ext.util.Format.htmlEncode(value);
            }
        });

        return column;
    },
    createGroupGroupCommFromColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_GROUP_COMM_FROM',
            header: _t('From'),
            dataIndex: 'GROUP_FROM_NAME',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value) {
                if (!value) {
                    return _t('Other');
                }
                return Ext.util.Format.htmlEncode(value);
            }
        });

        return column;
    },
    createGroupGroupCommToColumn: function() {
        var column = Ext.create('App.view.viewer.table.Column', {
            identy: 'GROUP_GROUP_COMM_TO',
            header: _t('To'),
            dataIndex: 'GROUP_TO_NAME',
            width: 100,
            grouped: true,
            menuDisabled: true,
            renderer: function(value) {
                if (!value) {
                    return _t('Other');
                }
                return Ext.util.Format.htmlEncode(value);
            }
        });

        return column;
    },
    formatMinutesTime: function(secs) {
        var divisor_for_minutes = secs % (60 * 60);
        var minutes = Math.floor(divisor_for_minutes / 60);
        var divisor_for_seconds = divisor_for_minutes % 60;
        var seconds = Math.ceil(divisor_for_seconds);

        if (minutes < 10) {
            minutes = "0" + minutes;
        }
        if (seconds < 10) {
            seconds = "0" + seconds;
        }

        return minutes +':'+ seconds;
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/reports/Save.js
Ext.define('App.view.reports.Save', {
    extend: 'Ext.window.Window',
    title: '',
    width: 460,
    //height: 230,
    modal: true,
    resizable: false,
    closable: false,
    bodyStyle: 'background: transparent; border: 0px;',
    layout: {
        type: 'card',
        align: 'stretch'
    },
    activeItem: 0,
    padding: '5 10',
    constructor: function() {
        this.addEvents('submit', 'cancel');
        this.callParent(arguments);
    },
    initComponent: function() {
        
        // Prepare body components
        this.tipCt = Ext.create('Ext.container.Container', {
            //padding: '0 0 20 0',
        });
        
        this.formCmp = Ext.create('Ext.form.Panel', {
            labelAlign: 'top',
            layout: 'anchor',
            defaults: {
                anchor: '100%'
            },
            border: false,
            style: 'background: transparent;',
            bodyStyle: 'background: transparent;',
            items: [
                //this.tipCt,
                {
                    xtype: 'textfield',
                    itemId: 'nameField',
                    fieldLabel: _t('Name'),
                    allowBlank: false
                },
                {
                    xtype: 'textarea',
                    itemId: 'descriptionField',
                    fieldLabel: _t('Description'),
                    height: 60,
                    allowBlank: false
                },
                {
                    xtype: 'checkbox',
                    itemId: 'shareCheckbox',
                    fieldLabel: _t('Share')
                }
                /*{
                    xtype: 'container',
                    layout: 'hbox',
                    items: [
                        {
                            xtype: 'container',
                            width: 105
                        },
                        {
                            xtype: 'checkbox',
                            itemId: 'shareCheckbox'
                        },
                        {
                            xtype: 'container',
                            style: 'line-height: 19px; padding: 0 0 0 5px;'
                        }
                    ]
                }*/
            ]
        });
        
        this.savedCt = Ext.create('Ext.container.Container', {
            padding: '0 0 20 0',
            html: _t('You report has been successfully saved on a server. <br /> To use this report in future you should go to "Available Reports" > "Personal Reports".')
        });
        
        this.items = [
            this.formCmp,
            this.savedCt
        ]
        
        // Prepare action buttons
        this.submitButton = Ext.create('Ext.button.Button', {
            text: _t('Submit')
        });
        
        this.cancelButton = Ext.create('Ext.button.Button', {
            text: _t('Cancel')
        });
        
        this.buttons = [
            this.submitButton,
            this.cancelButton
        ]
        
        this.submitButton.on('click', this.onSubmitButtonClick, this);
        this.cancelButton.on('click', this.onCancelButtonClick, this);
        this.on('show', this.onSettingsWindowShow, this);
        this.on('hide', this.onSettingsWindowHide, this);

        this.callParent(arguments);
    },
    onSubmitButtonClick: function() {
        // Verify if input data is valid
        if (!this.formCmp.getForm().isValid()) {
            return;
        }
        
        // Prepare data for submit event
        var nameField = this.query('#nameField').pop();
        var descriptionField = this.query('#descriptionField').pop();
        var shareCheckbox = this.query('#shareCheckbox').pop();
        var config = {
            name: nameField.getValue(),
            description: descriptionField.getValue(),
            share: shareCheckbox.getValue()
        }
        
        this.fireEvent('submit', config);
    },
    onCancelButtonClick: function() {
        this.fireEvent('cancel');
    },

    onSettingsWindowShow: function() {
        if(!this.KeyMapOnEsc) {
            this.KeyMapOnEsc = new Ext.util.KeyMap(Ext.getBody(), [{
               key: Ext.EventObject.ESC,
               defaultEventAction: 'preventDefault',
               scope: this,
               fn: this.onCancelButtonClick
            }]);
        } else {
            this.KeyMapOnEsc.enable();
        }
    },

    onSettingsWindowHide: function() {
        this.KeyMapOnEsc.disable();
    },

    showSavingState: function() {
        this.getEl().mask(_t('Please wait...')+' '+_t('Saving...'));
    },
    /**
    showSavedState: function() {
        this.getEl().unmask();
        this.getLayout().setActiveItem(1);
        this.submitButton.hide();
        this.cancelButton.setText('close');
        this.setHeight(160);
        this.center();
    },
    **/
    showErrorState: function(message){
        this.getEl().unmask();
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/reports/picker/Selection.js
Ext.define('App.view.reports.picker.Selection', {
    extend: 'Ext.view.View',
    itemId: 'loadReportSelection',
    floating: true,
    hidden: true,
    hideMode: 'display',
    deferEmptyText: true,
    cls: 'w-reports-picker-selection',
    constructor: function() {
        this.addEvents('selectReport', 'deleteReport', 'showSharedReports', 'showPersonalReports');
        this.on('showSharedReports', this.onShowSharedReports);
        this.on('showPersonalReports', this.onShowPersonalReports);
        this.callParent(arguments);
    },
    initComponent: function() {
        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                { name:'id' },
                { name:'name' },
                { name:'description' },
                { name:'state' },
                { name:'step' },
                { name: 'deletable', defaultValue: false }
            ]
        });
        
        this.tpl = new Ext.XTemplate(
            '<div class="w-reports-picker-selection-container">',
            '<tpl for=".">',
                '<div class="item <tpl if="step == 1">item-even</tpl>">',
                    '<div class="item-name">{name}</div>',
                    '<div class="item-description">{description}</div>',
                    '{[this.getDeleteLink(values)]}',
                '</div>',
            '</tpl>',
            '</div>',
            {
                getDeleteLink: function(values) {
                    return values.deletable && values.user == User.uid ? '<div class="item-delete-button"></div>' : '';
                }
            }
        );
            
        this.itemSelector = 'div.item';
        this.callParent(arguments);
    },
    verify: function(reports) {
        var i;
        
        for (i=0; i < reports.length; i++) {
            if (i % 2) {
                reports[i]['step'] = 1;
            } else {
                reports[i]['step'] = 0;
            }
        }
        
        return reports;
    },
    show: function(left, top, reports, type) {
        // If reports not found for shared or personal types, we should display a non found notification.
        if (type == 'shared') {
            this.callParent(arguments);
            this.showSharedReports(left, top);
            return;
        } else if (type == 'personal') {
            this.callParent(arguments);
            this.showPersonalReports(left, top);
            return;
        }
        
        // Place a needed reports to store
        this.store.loadData(this.verify(reports));
        
        // Align and show component
        this.align(left, top);
        this.callParent(arguments);
        
        // Invalidate scrolling in component
        this.invalidateScroller();
    },
    hide: function() {
        this.callParent(arguments);
    },
    align: function(left, top) {
        this.setPosition(left, top, false);
    },
    showSharedReports: function(left, top) {
        // Empty previosly setted reports (by another category)
        this.store.loadData(new Array());
        this.setHeight('auto');
        
        // Show & align loader
        this.getEl().update('<div class="w-reports-picker-selection-loader"></div>');
        this.align(left, top);
    },
    onShowSharedReports: function(reports) {
        if (reports.length == 0) {
            this.getEl().update(sprintf('<div class="w-reports-picker-selection-empty">%(noSharedReports)s</div>', { noSharedReports : _t('No result') }));
            return;
        }
        
        // Place fetched reports to store
        this.store.loadData(this.verify(reports));
        
        // Invalidate scrolling in component
        this.invalidateScroller();
    },
    showPersonalReports: function(left, top) {
        // Empty previosly setted reports (by another category)
        this.store.loadData(new Array());
        this.setHeight('auto');
        
        // Show & align loader
        this.getEl().update('<div class="w-reports-picker-selection-loader"></div>');
        this.align(left, top);
    },
    onShowPersonalReports: function(reports) {
        if (reports.length == 0) {
            this.getEl().update(sprintf('<div class="w-reports-picker-selection-empty">%(noSavedReports)s</div>', { noSavedReports : _t('No result') }));
            return;
        }
        
        // Place fetched reports to store
        this.store.loadData(this.verify(reports));
        
        // Invalidate scrolling in component
        this.invalidateScroller();
    },
    
    invalidateScroller: function() {
        var pos = this.getPosition();
        var offset = Ext.getBody().getHeight() - (pos[1] + this.getHeight());
        var height = Ext.getBody().getHeight() - pos[1] - 20;
        var container = this.getEl().first('div.w-reports-picker-selection-container');
        
        if (offset < 20) {
            this.setHeight(height);
            
            container.setHeight(height - 2);
            container.addCls('w-reports-picker-selection-overflow');
        } else {
            this.setHeight('auto');
            
            container.setHeight('auto');
            if (container.hasCls('w-reports-picker-selection-overflow')) {
                container.removeCls('w-reports-picker-selection-overflow');
            }
        }
    },
    onItemClick: function(record, item, index, event) {
        var eventTarget = Ext.get(event.target);

        if (eventTarget.hasCls('item-delete-button')) {
            this.fireEvent('deleteReport', record);
            return;
        }

        this.fireEvent('selectReport', record);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/reports/Picker.js
Ext.define('App.view.reports.Picker', {
    extend: 'Ext.view.View',
    itemId: 'viewerReportPicker',
    hidden: true,
    hideMode: 'display',
    floating: true,
    cls: 'w-reports-picker',
    constructor: function() {
        this.addEvents('expand', 'collapse', 'selectReport', 'deleteReport', 'fetchPersonalReports', 'fetchedPersonalReports', 'fetchSharedReports', 'fetchedSharedReports');
        this.on('fetchedPersonalReports', this.onFetchedPersonalReports, this);
        this.on('fetchedSharedReports', this.onFetchedSharedReports, this)

        this.callParent(arguments);
    },
    initComponent: function() {
        
        this.categories = [
            { id: '1', name: _t('Call list'), active: 0 },
            { id: '2', name: _t('By time'), active: 0 },
            { id: '3', name: _t('By group'), active: 0 },
            { id: '11', name: _t('By trunk'), active: 0 },
            { id: '4', name: _t('External calls'), active: 0 },
            { id: '5', name: _t('Outgoing calls by'), active: 0 },
            { id: '12', name: _t('Incoming calls by'), active: 0 },
            { id: '6', name: _t('Cost by'), active: 0 },
            { id: '7', name: _t('Trunk usage by group'), active: 0 },
//            { id: '8', name: _t('Ranks analysis'), active: 0 },
            { id: '9', name: _t('Shared reports'), active: 0 },
            { id: '10', name: _t('Personal reports'), active: 0 }
        ]
        
        this.reports = [
            { id: '1-1', parentId: '1', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":[],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":1,"sorters":{"field":"DATE","dest":"ASC"}}} },
            { id: '1-2', parentId: '1', name: _t('This week'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":[],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":1,"sorters":{"field":"DATE","dest":"ASC"}}} },
            { id: '1-3', parentId: '1', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":[],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":1,"sorters":{"field":"DATE","dest":"ASC"}}} },
            { id: '2-1', parentId: '2', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["HOUR"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"HOUR","dest":"ASC"}]}} },
            { id: '2-2', parentId: '2', name: _t('This week'),  state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["DAY"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"DAY","dest":"ASC"}]}} },
            { id: '2-3', parentId: '2', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["DAY"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"DAY","dest":"ASC"}]}} },
            { id: '2-4', parentId: '2', name: _t('This year'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":15,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["MONTH"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"MONTH","dest":"ASC"}]}} },
            { id: '3-1', parentId: '3', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '3-2', parentId: '3', name: _t('This week'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"TOTAL_EVENTS","dest":"ASC"}]}} },
            { id: '3-3', parentId: '3', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '11-4', parentId: '11', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["TRUNK"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '11-5', parentId: '11', name: _t('This week'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["TRUNK"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '11-6', parentId: '11', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["TRUNK"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '4-1', parentId: '4', name: _t('Failed outgoing'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":0,"rightEnabled":true},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":true,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '4-2', parentId: '4', name: _t('Missed incoming'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":0,"rightEnabled":true},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":true,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '4-3', parentId: '4', name: _t('Faxes sent'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":true},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"USER_GROUP_NAME","dest":"ASC"}]}} },
            { id: '4-4', parentId: '4', name: _t('Faxes received'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":true},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"USER_GROUP_NAME","dest":"ASC"}]}} },
            { id: '4-5', parentId: '4', name: _t('Voicemail'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":true,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"USER_GROUP_NAME","dest":"ASC"}]}} },
            { id: '5-1', parentId: '5', name: _t('Country'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["COUNTRY"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"COUNTRY","dest":"ASC"}]}} },
            { id: '5-2', parentId: '5', name: _t('Call Class'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["CLASS"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"CLASS","dest":"ASC"}]}} },
            { id: '12-3', parentId: '12', name: _t('Country'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["COUNTRY"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"COUNTRY","dest":"ASC"}]}} },
            { id: '12-4', parentId: '12', name: _t('Call Class'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["CLASS"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"CLASS","dest":"ASC"}]}} },
            { id: '6-1', parentId: '6', name: _t('User'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["USER"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"USER_NAME","dest":"ASC"}]}} },
            { id: '6-2', parentId: '6', name: _t('Group'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_COST","dest":"ASC"}}} },
            { id: '6-3', parentId: '6', name: _t('Trunk'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["TRUNK"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_COST","dest":"ASC"}}} },
            { id: '6-4', parentId: '6', name: _t('Call Class'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["CLASS"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_COST","dest":"ASC"}}} },
            { id: '6-5', parentId: '6', name: _t('Destination'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["COUNTRY"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_COST","dest":"ASC"}}} },
            { id: '7-1', parentId: '7', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '7-2', parentId: '7', name: _t('This week'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '7-3', parentId: '7', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '8-1', parentId: '8', name: _t('Most called numbers'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["NUMBER"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '8-2', parentId: '8', name: _t('Most received call numbers'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["NUMBER"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '8-3', parentId: '8', name: _t('Most called countries'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["COUNTRY"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} }
        ]
        
        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                'id',
                'name',
                'active',
                'side'
            ],
            data: this.verify(this.categories)
        });
        
        this.tpl = new Ext.XTemplate(
            '<div class="w-reports-picker-tl"><div class="w-reports-picker-tr"><div class="w-reports-picker-tt">',
                sprintf('<div class="w-reports-picker-arrow">%(reportSelect)s</div>', { reportSelect : _t('Predefined Filters') }),
            '</div></div></div>',
            '<div class="w-reports-picker-cl"><div class="w-reports-picker-cr">',
            '<tpl for=".">',
                '<div class="category <tpl if="active == 1">category-active</tpl>">',
                    '<div class="category-arrow">{name}</div>',
                '</div>',
            '</tpl>',
            '</div></div>',
            '<div class="w-reports-picker-bl"><div class="w-reports-picker-br"><div class="w-reports-picker-bb"></div></div></div>'
        );
                
        this.selection = Ext.create('App.view.reports.picker.Selection');
        this.selection.on('selectReport', this.onSelectReport, this);
        this.selection.on('deleteReport', this.onDeleteReport, this);
        
        this.itemSelector = 'div.category';
        this.callParent(arguments);
        
        this.bind = true;
    },
    show: function() {
        // Show component
        if (this.isVisible()) {
            return;
        }
        
        Ext.getDoc().on('mousedown', this.collapseWheel, this);
        Ext.EventManager.onWindowResize(this.align, this);
        
        this.align();
        this.callParent(arguments);
        
        // Verify previos state
        var i, r;
        
        for (i=0; i < this.store.getCount(); i++) {
            r = this.store.getAt(i);
            
            if (r.get('active') == 1) {
                r.set('active', 0);
            }
        }
        
        if (this.bind)  {
            this.bindView();
            this.bind = false;
        }

        if(!this.KeyMapOnEsc) {
            this.KeyMapOnEsc = new Ext.util.KeyMap(Ext.getBody(), [{
               key: Ext.EventObject.ESC,
               defaultEventAction: 'preventDefault',
               scope: this,
               fn: this.hide
            }]);
        } else {
            this.KeyMapOnEsc.enable();
        }

    },
    
    hide: function() {
        Ext.getDoc().un('mousedown', this.collapseWheel, this);
        Ext.EventManager.removeResizeListener(this.align, this);
        
        if (this.selection.isVisible()) {
            this.selection.hide();
        }
        
        this.callParent(arguments);

        this.KeyMapOnEsc.disable();
        this.fireEvent('collapse');
    },
    align: function() {
        var trgPos = this.target.getPosition();
        var trgLeft = trgPos[0] - 10;
        var trgTop = trgPos[1] - 5;
        var trgWidth = this.target.getWidth();
        
        if (trgWidth < 160) {
            trgWidth = 160;
        }
        
        this.setWidth(trgWidth);
        this.setPosition(trgLeft, trgTop, false);
        
        if (this.selection.isVisible()) {
            var target = Ext.get(this.getNode(this.selectionRecord));
            var left = target.getLeft();
            var top = target.getTop();
            var width = target.getWidth();
            
            this.selection.align(left + width + 2, top - 2, []);
        }
    },
    verify: function(categories) {
        var i;
        
        for (i=0; i < categories.length; i++) {
            if (i == 0) {
                categories[i]['side'] = 1;
            } else if(i == categories.length - 1) {
                categories[i]['side'] = 2;
            } else {
                categories[i]['side'] = 0;
            }
        }
        
        return categories;
    },
    
    bindView: function(){
        this.headEl = this.getEl().down('div.w-reports-picker-arrow');
        this.headEl.on('click', this.onHeadElClick, this);            
    },
    
    collapseWheel: function(event, element) {
        if (!event.within(this.el, false, true)) {
            if (this.selection.isVisible() && event.within(this.selection.el, false, true)) {
                return;
            }
            
            this.hide();
        }
    },
    onItemClick: function(record, item) {
        if (record.get('active') == 1) {
            record.set('active', 0);
            this.selection.hide();
            return;
        }
        
        var target = Ext.get(item);
        var left = target.getLeft();
        var top = target.getTop();
        var width = target.getWidth();
        var type = 'prepared';

        // Unactive other items
        var i, r;        
        for (i=0; i < this.store.getCount(); i++) {
            r = this.store.getAt(i);
            
            if (r.get('active') == 1) {
                r.set('active', 0);
            }
        }
        
        record.set('active', 1);

        // Collect selections that matched to current item
        var id = record.get('id');
        var reports = new Array();

        for (i=0; i < this.reports.length; i++) {
            if (id == this.reports[i]['parentId']) {
                reports.push(this.reports[i]);
            }
        }

        // Define reports type (that need to show correctly a message when reports is empty)
        if (id == '9') {
            type = 'shared';
        } else if (id == '10') {
            type = 'personal';
        }

        this.selectionTarget = target;
        this.selectionRecord = record;

        // Show selection container, with needed reports
        this.selection.show(left + width + 2, top - 2, reports, type);

        if (type != 'prepared') {
            // We should fetch reports form a server.
            if (type == 'shared') {
                this.fireEvent('fetchSharedReports', this.onFetchedSharedReports, this);
            } else if (type == 'personal') {
                this.fireEvent('fetchPersonalReports', this.onFetchedPersonalReports, this);
            }
        }
    },
    
    onHeadElClick: function() {
        this.hide();
    },

    /**
     * Fires when user clicks to a single report at selection view, we should invoke selectReport event to subscribers.
     */
    onSelectReport: function(report) {
        this.selection.hide();
        this.hide();
        
        this.fireEvent('selectReport', report);
    },

    /**
     * Fires when user clicks to a delete button on single report at selection view, we should invoke deleteReport event
     * to subscribers.
     */
    onDeleteReport: function(report) {
        this.selection.hide();
        this.hide();
        
        this.fireEvent('deleteReport', report);
    },

    /**
     * Fires when Shared reports has been successfully requested from the server, we should show that reports.
     */
    onFetchedSharedReports: function(reports) {
        this.selection.fireEvent('showSharedReports', reports);
    },

    /**
     * Fires when Personal reports has been successfully requested from the server, we should show that reports.
     */
    onFetchedPersonalReports: function(reports) {
        this.selection.fireEvent('showPersonalReports', reports);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/metric/Picker.js
Ext.define('App.view.metric.Picker', {
    extend: 'Ext.view.View',
    hidden: true,
    hideMode: 'display',
    floating: true,
    cls: 'w-viewport-picker',
    dirty: false,
    allowList: false,
    initComponent: function() {
        var me = this;
        this.groupColumns = [
            { id: '1', name: 'COUNT', text: _t('Count'), group: 'count', active: true },
            { id: '2', name: 'COUNT_BY_SERVICE', text: _t('Count by service'), group: 'count' },
            { id: '3', name: 'COUNT_BY_STATUS', text: _t('Count by status'), group: 'count' },
            { id: '4', name: 'COUNT_BY_DIRECTION', text: _t('Count by direction'), group: 'count' },
            { id: '11', name: 'COUNT_BY_SLA', text: _t('Count by SLA'), group: 'count' },
            { id: '5', name: 'COST', text: _t('Cost'), group: 'cost', active: true },
            { id: '6', name: 'COST_BY_SERVICE', text: _t('Cost by service'), group: 'cost' },
            { id: '7', name: 'COST_AVG_BY_SERVICE', text: _t('Avg. Cost by service') },
            { id: '8', name: 'BILL', text: _t('Talk time'), group: 'bill', active: true },
            { id: '9', name: 'BILL_BY_DIRECTION', text: _t('Talk time by direction'), group: 'bill' },
            { id: '10', name: 'BILL_AVG_BY_DIRECTION', text: _t('Avg. talk time by direction') }
        ];

        this.addEvents('expand', 'collapse', 'change');

        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                { name: 'id' },
                { name: 'name' },
                { name: 'text' },
                { name: 'group' },
                { name: 'active', defaultValue: false }
            ],
            data: this.groupColumns
        });

        this.tpl = new Ext.XTemplate(
            '<div class="w-viewport-picker-tl"><div class="w-viewport-picker-tr"><div class="w-viewport-picker-tt">',
                '<div class="w-viewport-picker-arrow">', 
                    _t('Metric'), 
                '</div>',
            '</div></div></div>',
            '<div class="w-viewport-picker-cl"><div class="w-viewport-picker-cr">',
                '<div class="x-box-scroller-top w-viewport-picker-list-scroll-top">',
                    '<div class="x-menu-scroll-top"></div>',
                '</div>',
                '<div class="w-viewport-picker-list">',

                /* Error state */
                '<div style="padding: 1px 5px 7px 8px;" <tpl if="this.checkGrouping()">class="helper-hide"</tpl>>',
                    '<span>', 
                    '</span>',
                '</div>',

                /* Original state */
                '<div <tpl if="!this.checkGrouping()">class="helper-hide"</tpl> >',
                    '<div class="w-viewport-picker-list-scroll">',
                    '<div class="w-viewport-picker-list-scroll-wrap">',
                    '<tpl for=".">',
                        '<tpl if="id == 1"><div class="items-splitter">',
                            _t('Count of events'),
                        '</div></tpl>',
                        '<tpl if="id == 5"><div class="items-splitter">',
                            _t('Cost of events'),
                        '</div></tpl>',
                        '<tpl if="id == 8"><div class="items-splitter">',
                            _t('Talk time of events'),
                        '</div></tpl>',
                        '<div class="item <tpl if="active == true">item-active</tpl> <tpl if="permanent == true">item-permanent</tpl>">',
                            '<div class="item-left"><div class="item-right">',
                                '<span class="item-name">{text}</span>',
                            '</div></div>',
                        '</div>',
                    '</tpl>',
                    '</div>',
                    '</div>',
                '</div>',

                '</div>',
                '<div class="x-box-scroller-bottom w-viewport-picker-list-scroll-bottom">',
                    '<div class="x-menu-scroll-bottom"></div>',
                '</div>',
                '<tpl if="this.checkGrouping()">',
                    '<div class="w-viewer-table-columns-clear"><a class="w-viewer-table-columns-clear-text">', 
                        _t('Reset'), 
                    '</a></div>',
                '</tpl>',
            '</div></div>',
            '<div class="w-viewport-picker-bl"><div class="w-viewport-picker-br"><div class="w-viewport-picker-bb"></div></div></div>',
            {
                checkGrouping: function() {
                    return me.allowList;
                }
            }
        );

        this.itemSelector = 'div.item';
        this.callParent(arguments);
        this.on('refresh', this.onRefresh, this);

        this.bind = true;
    },

    onRefresh: function(){
        this.bindView();
    },

    setState: function(state) {
        this.store.each(function(rec) {
            if(state.indexOf(rec.get('name')) != -1 ){
                rec.set('active', true);
                rec.set('enable', true);
                if(this.getMode() == 'SINGLE') {
                    this.setLastActiveRecord(rec)
                }
            } else {
                rec.set('active', false);
                rec.set('enable', true);
            }
        }, this);
    },

    getState: function() {
        var results = new Array(), columns;

        columns = this.store.queryBy(function(rec) {
            return rec.get('active') == true;
        });
        columns.each(function(rec) {
            results.push(rec.get('name'));
        });

        return results;
    },

    /**
     *
     * @param mode String ('SINGLE' | 'MULTI')
     */
    setMode: function(mode){
        this.mode = mode;
    },

    getMode: function(){
        return this.mode;
    },

    setLastActiveRecord: function(rec){
        this.lastActiveRecord = rec;
    },

    getLastActiveRecordName: function() {
        if(this.lastActiveRecord) {
            return this.lastActiveRecord.get('name');
        } else {
            return this.groupColumns[0].name;
        }
    },

    onHeadElClick: function() {
        this.hide();
    },

    onResetElClick: function() {
        var i, r, rx, first = false;
        var len = this.store.getCount();

        for (i=0; i < len; i++) {
            r = this.store.getAt(i);
            rx = this.groupColumns[i];

            if (rx['active']) {
                if(this.getMode() == 'SINGLE' && first) {
                    r.set('active', false);
                    continue;
                }
                first = true;
                r.set('active', true);
            } else {
                r.set('active', false);
            }
        }

        this.hide();
    },

    onGroupElClick: function() {
        this.hide();
        this.fireEvent('grpElClick');
    },

    bindView: function() {
        this.headEl = this.getEl().down('div.w-viewport-picker-arrow');
        this.headEl.on('click', this.onHeadElClick, this);

        this.resetEl = this.getEl().down('a.w-viewer-table-columns-clear-text');
        if (this.resetEl) {
            this.resetEl.on('click', this.onResetElClick, this);
        }

        this.groupEl = this.getEl().down('a.w-viewer-grouping-on');
        if (this.groupEl) {
            this.groupEl.on('click', this.onGroupElClick, this);
        }

        this.listEl = this.getEl().down('div.w-viewport-picker-list');
        this.listScrollTopEl = this.getEl().down('div.w-viewport-picker-list-scroll-top');
        this.listScrollTopEl.setVisibilityMode(Ext.core.Element.DISPLAY);
        this.listScrollTopEl.on('click', this.onListScrollTopElClick, this);
        this.listScrollBottomEl = this.getEl().down('div.w-viewport-picker-list-scroll-bottom');
        this.listScrollBottomEl.setVisibilityMode(Ext.core.Element.DISPLAY);
        this.listScrollBottomEl.on('click', this.onListScrollBottomElClick, this);
        this.listScrollEl = this.getEl().down('div.w-viewport-picker-list-scroll');
        this.listScrollWrapEl = this.getEl().down('div.w-viewport-picker-list-scroll-wrap');
    },

    onListScrollTopElClick: function() {
        this.listScrollEl.scroll('top', 26, true)
    },

    onListScrollBottomElClick: function() {
        this.listScrollEl.scroll('bottom', 26, true)
    },


    show: function() {
        // Show component
        if (this.isVisible()) {
            return;
        }

        Ext.getDoc().on('mousedown', this.collapseWheel, this);
        Ext.EventManager.onWindowResize(this.align, this);

        this.callParent(arguments);

        if (this.bind)  {
            this.bindView();
            this.bind = false;
        }

        this.shownState = this.getState();
        this.align();

        if(!this.KeyMapOnEsc) {
            this.KeyMapOnEsc = new Ext.util.KeyMap(Ext.getBody(), [{
               key: Ext.EventObject.ESC,
               defaultEventAction: 'preventDefault',
               scope: this,
               fn: this.hide
            }]);
        } else {
            this.KeyMapOnEsc.enable();
        }
    },
    hide: function() {
        Ext.getDoc().un('mousedown', this.collapseWheel, this);
        Ext.EventManager.removeResizeListener(this.align, this);

        this.callParent(arguments);

        // Calculating changes
        var i, missmatch = false;

        this.currentState = this.getState();

        if (this.shownState.length != this.currentState.length) {
            missmatch = true;
        }

        if (!missmatch) {
            for (i=0; i < this.currentState.length; i++) {
                if (this.shownState[i] != this.currentState[i]) {
                    missmatch = true;
                    break;
                }
            }
        }

        if (missmatch) {
            this.fireEvent('change', this.currentState);
        }
        this.KeyMapOnEsc.disable();
    },
    align: function() {
        var trgLeft = this.target.getLeft();
            trgLeft = trgLeft - 10;
        var trgTop = this.target.getTop();
            trgTop = trgTop - 5;
        var trgWidth = this.target.getWidth();

        if (trgWidth < 160) {
            trgWidth = 160;
        }

        if(this.allowList) {
            this.listEl.setHeight('auto');
            this.listScrollEl.setHeight('auto');
        }

        var offset = Ext.getBody().getHeight() - (trgTop + this.getHeight());
        var height = Ext.getBody().getHeight() - trgTop;

        if (offset < 0) {
            var offsetBt = this.getHeight() - this.listEl.getHeight();
            var heightList = height - offsetBt;

            this.listScrollTopEl.show();
            this.listScrollBottomEl.show();

            this.listEl.setHeight(heightList - this.listScrollTopEl.getHeight() - this.listScrollBottomEl.getHeight());
            this.listScrollEl.setHeight(this.listEl.getHeight());
            this.listScrollEl.setWidth(trgWidth - 4 + 20);
            this.listScrollWrapEl.setWidth(trgWidth - 4);
        } else {
            this.listScrollTopEl.hide();
            this.listScrollBottomEl.hide();
        }

        this.setWidth(trgWidth);
        this.setPosition(trgLeft, trgTop, false);
    },

    collapseWheel: function(event, element) {
        if (!event.within(this.el, false, true)) {
            this.hide();
        }
    },
    onItemClick: function(record, item, index, event) {
        // Handling item
        var eventTarget = Ext.get(event.target);
        var group = record.get('group');
        var i, r, isActive;
        var len = this.store.getCount();

        if(this.getMode() == 'SINGLE') {
            if (record.get('active')) {
                return;
            } else {
                for (var j=0; j < this.store.getCount(); j++) {
                    var r = this.store.getAt(j);
                    if ( r.get('active')) {
                        r.set('active', false);
                    }
                }
                record.set('active', true);
                this.setLastActiveRecord(record);
                this.hide();
                return;
            }
        }

        // Special behavior for groups and users groupings
        if (group) {
            if (record.get('active')) {
                for (i=0; i < len; i++) {
                    r = this.store.getAt(i);
                    if (r.get('active') && r != record) {
                        isActive = true;
                        break;
                    }
                }
                if (isActive) {
                    record.set('active', false);
                }
                return;
            }

            for (i=0; i < len; i++) {
                r = this.store.getAt(i);

                if (r.get('group') == group && r.get('active')) {
                    r.set('active', false);
                    break;
                }
            }

            record.set('active', true);
            this.setLastActiveRecord(record);
            return;
        }

        // Default behavior (items that can be singly)
        if (record.get('active')) {
            for (i=0; i < len; i++) {
                r = this.store.getAt(i);
                if (r.get('active') && r != record) {
                    isActive = true;
                    break;
                }
            }
            if (isActive) {
                record.set('active', false);
            }
            return;
        }

        record.set('active', true);
        this.setLastActiveRecord(record);
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/grouping/picker/Columns.js
Ext.define('App.view.grouping.picker.Columns', {
    extend: 'Ext.view.View',
    floating: true,
    hidden: true,
    hideMode: 'display',
    cls: 'w-grouping-picker-selection',
    initComponent: function() {
        
        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                'id',
                'text',
                'active'
            ]
        });
        
        this.tpl = new Ext.XTemplate(
            '<div class="w-grouping-picker-selection-container">',
            '<tpl for=".">',
                '<div class="item ">',
                    '<div class="item-name <tpl if="active == true">grouping-item-active</tpl>">{text}</div>',
                '</div>',
            '</tpl>',
            '</div>'
        );
            
        this.itemSelector = 'div.item';
        this.callParent(arguments);
    },

    show: function(left, top, parentRecord, count) {
        var container,
            columns_data = new Array;
            
        this.parentRecord = parentRecord;
        
        // Clear pre settings
        this.setHeight('auto');
        
        if (this.getEl()) {
            container = this.getEl().first('div.w-grouping-picker-selection-container');
            container.setHeight('auto');
            container.setWidth(95);
            container.setWidth(96);
            
            if (container.hasCls('w-grouping-picker-selection-overflow')) {
                container.removeCls('w-grouping-picker-selection-overflow');
            }
        }
        
        for(var i = 1; i <= count; i++){
            columns_data.push({ id: i, text: i + ' '+_t('Column'), active: this.parentRecord.get('order') == i ? true : false });
        }
        
        this.store.loadData(columns_data);
        
        // Align
        this.align(left, top);
        this.callParent(arguments);
        
        var pos = this.getPosition();
        var offset = Ext.getBody().getHeight() - (pos[1] + this.getHeight());
        var height = Ext.getBody().getHeight() - pos[1] - 20;
        
        if (offset < 20) {
            this.setHeight(height);
            
            if (!container) {
                container = this.getEl().first('div.w-grouping-picker-selection-container');
            }
            
            container.setHeight(height - 2);
            container.addCls('w-grouping-picker-selection-overflow');
        }
    },
    hide: function() {
        this.callParent(arguments);
    },
    align: function(left, top) {
        this.setPosition(left, top, false);
    },
    onItemClick: function(record) {
        this.own.setItemOrder(this.parentRecord, record.get('id'));
        this.hide();
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/grouping/Picker.js
Ext.define('App.view.grouping.Picker', {
    extend: 'Ext.view.View',
    hidden: true,
    hideMode: 'display',
    floating: true,
    cls: 'w-viewport-picker',
    dirty: false,
    initComponent: function() {
        this.groupColumns = [
            { id: '1', name: 'HOUR', text: _t('Hour'), group: 'default' },
            { id: '1', name: 'HOUR_OF_DAY', text: _t('Hour of day'), group: 'default' },
            { id: '2', name: 'DAY', text: _t('Day'), group: 'default' },
            { id: '3', name: 'DAY_OF_WEEK', text: _t('Day of week'), group: 'default' },
            { id: '16',name: 'WEEK', text: _t('Week'), group: 'default' },
            { id: '4', name: 'MONTH', text: _t('Month'), group: 'default' },
            { id: '4', name: 'MONTH_OF_YEAR', text: _t('Month of year'), group: 'default' },
            { id: '5', name: 'YEAR', text: _t('Year'), group: 'default' },
            { id: '6', name: 'USER', text: _t('User'), group: 'default' },
            { id: '7', name: 'GROUP', text: _t('Group'), group: 'default' },
            { id: '8', name: 'CLIENT', text: _t('Business partner'), group: 'default' },
            { id: '9', name: 'COMPANY', text: _t('Company'), group: 'default' },
            { id: '10', name: 'NUMBER', text: _t('Number'), group: 'default' },
            { id: '11', name: 'TRUNK', text: _t('Trunk'), group: 'default' },
            { id: '16', name: 'TAG', text: _t('Tag'), group: 'default'},
            { id: '12', name: 'COUNTRY', text: _t('Country'), group: 'default' },
            { id: '13', name: 'CLASS', text: _t('Class'), group: 'default' },
            { id: '14', name: 'USERS', text: _t('Users communication'), group: 'default' },
            { id: '15', name: 'GROUPS', text: _t('Groups communication'), group: 'default' }
        ];

        this.addEvents('expand', 'collapse', 'change');

        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                { name: 'id' },
                { name: 'name' },
                { name: 'text' },
                { name: 'group' },
                { name: 'active', defaultValue: false },
                { name: 'enable', defaultValue: true },
                { name: 'hidden', defaultValue: false }
            ],
            data: this.groupColumns
        });

        this.tpl = new Ext.XTemplate(
            '<div class="w-viewport-picker-tl"><div class="w-viewport-picker-tr"><div class="w-viewport-picker-tt">',
                '<div class="w-viewport-picker-arrow">',
                    _t('Grouping by'),
                '</div>',
            '</div></div></div>',
            '<div class="w-viewport-picker-cl"><div class="w-viewport-picker-cr">',
                '<div class="x-box-scroller-top w-viewport-picker-list-scroll-top">',
                    '<div class="x-menu-scroll-top"></div>',
                '</div>',
                '<div class="w-viewport-picker-list">',
                    '<div class="w-viewport-picker-list-scroll">',
                    '<div class="w-viewport-picker-list-scroll-wrap">',
                    '<tpl for=".">',
                        '<div class="item <tpl if="hidden == true">x-hidden</tpl> <tpl if="permanent == true">item-permanent</tpl> <tpl if="enable == false">x-menu-item-disabled</tpl>">',
                            '<div class="item-left"><div class="item-right">',
                                '<span class="item-name">{text}</span>',
                            '</div></div>',
                        '</div>',
                    '</tpl>',
                    '</div>',
                    '</div>',
                '</div>',
                '<div class="x-box-scroller-bottom w-viewport-picker-list-scroll-bottom">',
                    '<div class="x-menu-scroll-bottom"></div>',
                '</div>',
                '<div class="w-viewer-table-columns-clear"><a class="w-viewer-table-columns-clear-text">',
                    _t('Reset'),
                '</a></div>',
            '</div></div>',
            '<div class="w-viewport-picker-bl"><div class="w-viewport-picker-br"><div class="w-viewport-picker-bb"></div></div></div>'
        );

        this.itemSelector = 'div.item';
        this.callParent(arguments);
        this.bind = true;
    },

    setState: function(state) {
        this.store.each(function(rec) {
            if(state.indexOf(rec.get('name')) != -1 ){
                rec.set('active', true);
                rec.set('enable', true);
            } else {
                rec.set('active', false);
                rec.set('enable', true);
            }
        });
    },

    getState: function() {
        var results = new Array(), columns;

        columns = this.store.queryBy(function(rec) {
            return rec.get('active') == true && rec.get('enable') == true;
        });
        columns.each(function(rec) {
            results.push(rec.get('name'));
        });

        return results;
    },

    getFirstStateName: function() {
        var results = new Array(), columns;

        columns = this.store.queryBy(function(rec) {
            return rec.get('active') == true && rec.get('enable') == true;
        });
        columns.each(function(rec) {
            results.push(rec.get('text'));
        });

        return results[0]||'';
    },

    onHeadElClick: function() {
        this.hide();
    },

    onResetElClick: function() {
        var i, r;
        var len = this.store.getCount();

        for (i=0; i < len; i++) {
            r = this.store.getAt(i);

            if (r.get('active') || !r.get('enable')) {
                r.set('active', false);
                r.set('enable', true);
            }
        }

        this.hide();
    },

    bindView: function() {
        this.headEl = this.getEl().down('div.w-viewport-picker-arrow');
        this.headEl.on('click', this.onHeadElClick, this);

        this.resetEl = this.getEl().down('a.w-viewer-table-columns-clear-text');
        this.resetEl.on('click', this.onResetElClick, this);

        this.listEl = this.getEl().down('div.w-viewport-picker-list');
        this.listScrollTopEl = this.getEl().down('div.w-viewport-picker-list-scroll-top');
        this.listScrollTopEl.setVisibilityMode(Ext.core.Element.DISPLAY);
        this.listScrollTopEl.on('click', this.onListScrollTopElClick, this);
        this.listScrollBottomEl = this.getEl().down('div.w-viewport-picker-list-scroll-bottom');
        this.listScrollBottomEl.setVisibilityMode(Ext.core.Element.DISPLAY);
        this.listScrollBottomEl.on('click', this.onListScrollBottomElClick, this);
        this.listScrollEl = this.getEl().down('div.w-viewport-picker-list-scroll');
        this.listScrollWrapEl = this.getEl().down('div.w-viewport-picker-list-scroll-wrap');
    },

    onListScrollTopElClick: function() {
        this.listScrollEl.scroll('top', 26, true)
    },

    onListScrollBottomElClick: function() {
        this.listScrollEl.scroll('bottom', 26, true)
    },


    show: function() {
        // Show component
        if (this.isVisible()) {
            return;
        }

        Ext.getDoc().on('mousedown', this.collapseWheel, this);
        Ext.EventManager.onWindowResize(this.align, this);

        this.callParent(arguments);

        if (this.bind)  {
            this.bindView();
            this.bind = false;
        }

        this.shownState = this.getState();
        this.align();

        if(!this.KeyMapOnEsc) {
            this.KeyMapOnEsc = new Ext.util.KeyMap(Ext.getBody(), [{
               key: Ext.EventObject.ESC,
               defaultEventAction: 'preventDefault',
               scope: this,
               fn: this.hide
            }]);
        } else {
            this.KeyMapOnEsc.enable();
        }

    },
    hide: function() {
        Ext.getDoc().un('mousedown', this.collapseWheel, this);
        Ext.EventManager.removeResizeListener(this.align, this);

        this.callParent(arguments);

        // Calculating changes
        var i, missmatch = false;

        this.currentState = this.getState();

        if (this.shownState.length != this.currentState.length) {
            missmatch = true;
        }

        if (!missmatch) {
            for (i=0; i < this.currentState.length; i++) {
                if (this.shownState[i] != this.currentState[i]) {
                    missmatch = true;
                    break;
                }
            }
        }

        if (missmatch) {
            this.fireEvent('change', this.currentState);
        }
        this.KeyMapOnEsc.disable();
    },
    align: function() {
        var trgLeft = this.target.getLeft();
            trgLeft = trgLeft - 10;
        var trgTop = this.target.getTop();
            trgTop = trgTop - 5;
        var trgWidth = this.target.getWidth();

        if (trgWidth < 180) {
            trgWidth = 180;
        }

        this.listEl.setHeight('auto');
        this.listScrollEl.setHeight('auto');

        var offset = Ext.getBody().getHeight() - (trgTop + this.getHeight());
        var height = Ext.getBody().getHeight() - trgTop;

        if (offset < 0) {
            var offsetBt = this.getHeight() - this.listEl.getHeight();
            var heightList = height - offsetBt;

            this.listScrollTopEl.show();
            this.listScrollBottomEl.show();

            this.listEl.setHeight(heightList - this.listScrollTopEl.getHeight() - this.listScrollBottomEl.getHeight());
            this.listScrollEl.setHeight(this.listEl.getHeight());
            this.listScrollEl.setWidth(trgWidth + 4 + 20);
            this.listScrollWrapEl.setWidth(trgWidth - 4);
        } else {
            this.listScrollTopEl.hide();
            this.listScrollBottomEl.hide();
        }

        this.setWidth(trgWidth);
        this.setPosition(trgLeft, trgTop, false);
    },
    collapseWheel: function(event, element) {
        if (!event.within(this.el, false, true)) {
            this.hide();
        }
    },
    onItemClick: function(record, item, index, event) {
        if (!record.get('active')) {
            var group = record.get('group');
            var i, r;
            var len = this.store.getCount();

            for (i=0; i < len; i++) {
                r = this.store.getAt(i);

                if (r.get('group') == group && r.get('active')) {
                    r.set('active', false);
                    break;
                }
            }

            record.set('active', true);
        }

        this.hide();
    },
    clearGroupSelect: function(record){
        var i, r;
        if (record.get('group')) {
            var group_order;

            for (i=0; i < this.store.getCount(); i++) {
                r = this.store.getAt(i);

                if (r.get('group') == record.get('group') && r.get('active')) {
                    group_order = r.get('order');
                    r.set('order', 0);
                    r.set('active', false);
                }
            }
            if(group_order) {
                record.set('order', group_order);
                record.set('active', true);
                return true;
            }
        }
        return false;
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/list/SelectionScroller.js
Ext.define('App.view.filter.field.combo.list.SelectionScroller', {
    extend: 'Ext.grid.PagingScroller',
    alias: 'widget.filterselectionviewscroller',
    onGuaranteedRange: function(range, start, end) {
        var me = this,
            ds = me.store,
            rs;
        // this should never happen
        if (range.length && me.visibleStart < range[0].index) {
            return;
        }

        ds.loadRecords(range);

        if (!me.firstLoad) {
            if (me.rendered) {
                me.invalidate();
            } else {
                me.on('afterrender', me.invalidate, me, {single: true});
            }
            me.firstLoad = true;
        } else {
            // adjust to visible
            // only sync if there is a paging scrollbar element and it has a scroll height (meaning it's currently in the DOM)
            if (me.scrollEl && me.scrollEl.dom && me.scrollEl.dom.scrollHeight) {
                me.syncTo();
            }
        }
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/list/SelectionView.js
Ext.define('App.view.filter.field.combo.list.SelectionView', {
    extend: 'Ext.grid.Panel',
    displayField: 'name',
    style: 'border: 0px;',
    scroll: 'vertical',
    verticalScrollerType: 'filterselectionviewscroller',
    invalidateScrollerOnRefresh: false,
    hideHeaders: true,
    loadMask: true,
    border: 0,
    bodyBorder: 0,
    enableColumnHide: false,
    enableColumnMove: false,
    enableColumnResize: false,
    initComponent: function() {
        this.addEvents('search', 'afterSearch');
        this.on('search', this.onSearch, this);
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.emptyEl = Ext.create('Ext.container.Container', {
            hidden: true,
            hideMode: 'display',
            height: 50,
            dock: 'top',
            style: 'padding: 5px 10px; text-align: justify; background: #FFE57C;'
        });
        this.addDocked(this.emptyEl);
    },
    onSearch: function(query) {


        
        // mask
        this.store.mask();

        // clear store
        this.clearStore();
        
        // clear view
        this.clearView();
        
        // create filters
        var filters = new Array();
        
        if (query) {
            filters.push({property: 'name', value: query});
        }
        
        var decoded = this.store.decodeFilters(filters);
        
        // setup filters
        var i;
        for(i = 0; i < decoded.length; i++) {
            this.store.filters.replace(decoded[i]);
        }
        
        // fetch data
        this.store.on('guaranteedrange', this.onSearched, this, {single: true, query: query});
        this.store.guaranteeRange(0, this.store.pageSize - 1);
    },
    
    /**
     * Fires when data fetched from database
     */
    onSearched: function(range, start, end, options) {


        
        var scroller = this.verticalScroller;
        var scrollEl = scroller.scrollEl;
        
        scrollEl.removeAllListeners();
        scroller.mon(scrollEl, 'scroll', scroller.onElScroll, scroller);
        
        if (this.store.getTotalCount() == 0) {
            this.emptyEl.update('');
            //this.emptyEl.show();
            this.hideVerticalScroller();
        } else {
            this.emptyEl.hide();
        }
        
        this.invalidateScroller();
        this.fireEvent('afterSearch');
    },
    
    /**
     * 
     */
    clearStore: function() {


        
        this.store.removeAll();
        this.store.filters.clear();
        this.store.prefetchData.clear();
        this.store.guaranteedStart = undefined;
        this.store.guaranteedEnd = undefined;
        this.store.requestEnd = undefined;
        this.store.requestSeed = undefined;
        this.store.requestStart = undefined;
        this.store.totalCount = this.store.pageSize;
    },
    /**
     * 
     */
    clearView: function() {


        
        var view = this.getTableView();
        
        if (view.el) {
            view.el.dom.scrollTop = 0;
        }

        if (!this.verticalScroller.panel) {
            this.verticalScroller.panel = this.verticalScroller.getPanel();
        }
        
        window.asdfsadf = this.verticalScroller;
        
        if (this.verticalScroller.scrollEl) {
            this.verticalScroller.scrollEl.dom.scrollTop = 0;
        }
        
        return true;
    },
    
    clearEmptyView: function() {
        if (this.emptyEl) {
            this.emptyEl.hide();
        }
    },
    
    getTableView: function() {
        return this.down('tableview');
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/list/SelectionModel.js
Ext.define('App.view.filter.field.combo.list.SelectionModel', {
    extend: 'Ext.selection.CheckboxModel',
    mode: 'SIMPLE',
    enableKeyNav: false,
    constructor: function() {
        this.callParent(arguments);
        


        
        this.fieldSelectedStore.on('remove', this.onFieldSelectedRemove, this);
        this.fieldSelectedStore.on('clear', this.onFieldSelectedClear, this);
    },
    onFieldSelectedRemove: function(store, record, index) {


        
        var rec = this.store.getById(record.getId());
        
        if (rec) {
            this.deselect(rec);
        }
    },
    onFieldSelectedClear: function() {


        
        this.clearSelections();
        this.doSelect(this.getSelection(), false, true);
    },
    onGuaranteedRange: function() {


        
        this.refresh();
    },
    onRowMouseDown: function(view, record, item, index, e) {


        
        var selected = this.isSelected(record);
        
        this.callParent(arguments);
        
        if (selected) {
            var rec = this.fieldSelectedStore.getById(record.getId());
            
            if (rec) {
                this.fieldSelectedStore.remove(rec);
            }
        } else {
            if (!this.fieldSelectedStore.getById(record.getId())) {
                this.fieldSelectedStore.add(record.copy());
            }
        }
    },
    refresh: function() {


        
        this.clearSelections();
        
        var i, id, rec, count = this.fieldSelectedStore.getCount();
        
        for (i=0; i < count; i++) {
            id = this.fieldSelectedStore.getAt(i).getId();
            rec = this.store.getById(id);
            
            if (rec) {
                this.selected.add(rec);
            }
        }
        
        return this.doSelect(this.getSelection(), false, true);
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/AbstractPicker.js
Ext.define('App.view.filter.field.combo.AbstractPicker', {
    extend: 'Ext.container.Container',
    cls: 'w-dst-picker',
    layout: 'anchor',
    renderTo: Ext.getBody(),
    floating: true,
    height: 300,
    maxResultsHeight: 450,
    minResultsHeight: 150,
    expand: function() {
        if (this.rendered && !this.expanded) {
            
            Ext.EventManager.onWindowResize(this.alignPicker, this);
            
            this.show();
            this.alignPicker();
            this.expanded = true;

            this.listCmp.refresh();
        }
    },
    collapse:function() {
        Ext.EventManager.removeResizeListener(this.alignPicker, this);
        
        this.hide();
        this.expanded = false;
    },
    realign: function() {
        var left = this.fieldEl.getLeft();
        var top = this.fieldEl.getTop() + this.fieldEl.getHeight();
        
        this.setWidth(this.fieldEl.getWidth());
        this.setPosition(left, top);
    },
    alignPicker: function() {
        var left = this.fieldEl.getLeft();
        var top = this.fieldEl.getTop() + this.fieldEl.getHeight();
        
        this.setWidth(this.fieldEl.getWidth());
        this.setHeight(this.getPickerHeight());
        this.setPosition(left, top);
    },
    alignPickerHeight: function() {
        this.setHeight(this.getPickerHeight());
    },
    getPickerHeight: function() {
        var height = 0;
        
        if (this.store.getTotalCount() == 0) {
            height += this.searchCmp.getHeight();
            height += this.listCmp.getNotifyHeight();
        } else {
            height += this.searchCmp.getHeight();
            height += this.listCmp.getResultsHeight();
            
            if (height > this.maxResultsHeight) {
                var bodedHeight = Ext.getBody().getHeight() - (this.fieldEl.getTop() + this.fieldEl.getHeight()) - this.getBodyBottomOffet();
                
                if (this.maxResultsHeight < bodedHeight) {
                    height = this.maxResultsHeight;
                } else if(this.minResultsHeight > bodedHeight) {
                    height = this.minResultsHeight;
                } else {
                    height = bodedHeight;
                }
            }
        }
        
        return height;
    },
    getBodyBottomOffet: function() {
        return 55;
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/AbstractList.js
Ext.define('App.view.filter.field.combo.AbstractList', {
    extend: 'Ext.container.Container',
    anchor: '100% -26',
    cls: 'w-dst-picker-selection', 
    layout: 'fit',
    refresh: function() {


        
        this.selectionView.clearStore();
        this.store.on('guaranteedrange', this.onRefreshed, this, {single: true});
        this.store.guaranteeRange(0, 99);
    },
    onRefreshed: function() {


        
        this.selectionView.clearView();
        this.selectionView.clearEmptyView();
        this.pickerCmp.alignPickerHeight();
    },
    onSearch: function(query) {
        this.selectionView.fireEvent('search', query);
    },
    onSearched: function() {
        this.pickerCmp.alignPickerHeight();
    },
    getNotifyHeight: function() {
        return 50;
    },
    getResultsHeight: function() {
        return this.store.getTotalCount() * 24 + 3;
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/Picker.js
Ext.define('App.view.filter.field.combo.Picker', {
    extend: 'App.view.filter.field.combo.AbstractPicker',
    initComponent: function() {
        this.searchCmp = Ext.create('App.view.filter.field.combo.Search', {
            selectedStore: this.selectedStore,
            selectedView: this.selectedView,
            pickerCmp: this
        } );
        this.listCmp = Ext.create('App.view.filter.field.combo.List', {
            store: this.store,
            selectedStore: this.selectedStore,
            selectedView: this.selectedView,
            selectionViewConfig: {
                columns: [
                    {
                        header: 'Name',
                        dataIndex: 'name',
                        flex: 1,
                        renderer: function(value, meta, record) {
                            var type = record.get('type');

                            if (type == 2) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(callClass)s</span>', { callClass : '('+ _t('Call Class') +')' });
                            } else if (type == 3) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(group)s</span>', { group : '('+ _t('Group') +')' });
                            } else if (type == 4) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(user)s</span>', { user : '('+ _t('User') +')' });
                            } else if (type == 5) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(businessPartner)s</span>', { businessPartner : '('+ _t('Business partner') +')' });
                            } else if (type == 6) {
                                value += sprintf('<span style="padding: 0 0 0 5px; color:#999;">%(company)s</span>', { company : '('+ _t('Company') +')' });
                            }
                            return value;
                        }
                    }
                ]
            },
            searchCmp: this.searchCmp,
            pickerCmp: this
        });
        
        this.items = [
            this.searchCmp,
            this.listCmp
        ]
        
        this.callParent(arguments);
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/List.js
Ext.define('App.view.filter.field.combo.List', {
    extend: 'App.view.filter.field.combo.AbstractList',
    initComponent: function() {
        this.selectionModel = Ext.create('App.view.filter.field.combo.list.SelectionModel', {
            fieldSelectedStore: this.selectedStore
        });
        
        this.selectionViewConfig = Ext.applyIf({
            store: this.store,
            selModel: this.selectionModel,
            pickerCmp: this.pickerCmp
        }, this.selectionViewConfig);
                
        this.selectionView = Ext.create('App.view.filter.field.combo.list.SelectionView', this.selectionViewConfig);
        


        
        this.items = [
            this.selectionView
        ]
        
        this.callParent(arguments);
        this.searchCmp.on('search', this.onSearch, this);
        this.selectionView.on('afterSearch', this.onSearched, this);
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/SimplePicker.js
Ext.define('App.view.filter.field.combo.SimplePicker', {
    extend: 'App.view.filter.field.combo.AbstractPicker',
    initComponent: function() {
        this.listCmp = Ext.create('App.view.filter.field.combo.SimpleList', {
            store: this.store,
            selectedStore: this.selectedStore,
            selectedView: this.selectedView,
            selectionViewConfig: this.selectionViewConfig,
            pickerCmp: this
        });
        
        this.items = [
            this.listCmp
        ]
        
        this.callParent(arguments);
    },
    getPickerHeight: function() {
        var height = 0;
        
        if (this.store.getTotalCount() == 0) {
            height += this.listCmp.getNotifyHeight();
        } else {
            height += this.listCmp.getResultsHeight();
            
            if (height > this.maxResultsHeight) {
                var bodedHeight = Ext.getBody().getHeight() - (this.fieldEl.getTop() + this.fieldEl.getHeight()) - this.getBodyBottomOffet();
                
                if (this.maxResultsHeight < bodedHeight) {
                    height = this.maxResultsHeight;
                } else if(this.minResultsHeight > bodedHeight) {
                    height = this.minResultsHeight;
                } else {
                    height = bodedHeight;
                }
            }
        }
        
        return height;
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/SimpleList.js
Ext.define('App.view.filter.field.combo.SimpleList', {
    extend: 'App.view.filter.field.combo.AbstractList',
    anchor: '100% 0',
    initComponent: function() {
        this.selectionModel = Ext.create('App.view.filter.field.combo.list.SelectionModel', {
            fieldSelectedStore: this.selectedStore
        });
        
        this.selectionViewConfig = Ext.applyIf({
            store: this.store,
            selModel: this.selectionModel,
            pickerCmp: this.pickerCmp
        }, this.selectionViewConfig);
        


        
        this.selectionView = Ext.create('App.view.filter.field.combo.list.SelectionView', this.selectionViewConfig);
        
        this.items = [
            this.selectionView
        ]
        
        this.callParent(arguments);
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/combo/Search.js
Ext.define('App.view.filter.field.combo.Search', {
    extend: 'Ext.container.Container',
    cls: 'w-dst-picker-search',
    anchor: '100%',
    layout: 'fit',
    padding: 3,
    initComponent: function() {
        var self = this;
                
        this.triggerField = Ext.create('Ext.form.field.Trigger', {
            xtype: 'trigger',
            anchor: '100%',
            cls: 'w-dst-picker-search-trigger',
            emptyText: '',
            enableKeyEvents: true,
            trigger1Cls: Ext.baseCSSPrefix + 'form-clear-trigger',
            trigger2Cls: Ext.baseCSSPrefix + 'form-search-trigger',
            onTrigger1Click: function() {
                self.onTriggerCreateClick.call(self, arguments);
            },
            onTrigger2Click: function() {
                self.onTriggerSearchClick.call(self, arguments);
            }
        });
        this.triggerField.on('specialkey', this.onTriggerFieldSpecialKey, this);
        this.triggerField.on('keyup', this.onTriggerFieldKeyUp, this);

        this.addEvents('search');
        
        this.items = [
            this.triggerField
        ]
        
        this.callParent(arguments);
    },
    getTriggerField: function() {
        return this.triggerField;
    },
    onTriggerCreateClick: function() {
        var number = this.triggerField.getValue();
        var valide_num = /^([\d%#*A-Za-z]{1,22})$|^\+([\d%#*A-Za-z]{1,13})$/;
        
        if (!number || number=='') {
            return;
        } else if (!(number.match(valide_num))) {
            this.triggerField.markInvalid(_t('Phone number that you entered is invalid!'));
            return;
        }
        
        this.selectedStore.add(this.createDestination(number));
        this.triggerField.setValue(null);
    },
    onTriggerSearchClick: function() {
        var number = this.triggerField.getValue();
        this.fireEvent('search', number);
    },
    onTriggerFieldSpecialKey: function(field, e) {
        if (e.getKey() == e.ENTER) {
            var number = this.triggerField.getValue();
            this.fireEvent('search', number);
        }
    },
    onTriggerFieldKeyUp: function(field, e) {
        var self = this;
        var number = this.triggerField.getValue();
        var callback = function() {
            if (self.triggerField.getValue() == number) {
                self.fireEvent('search', number);
            }
        }

        setTimeout(callback, 500);
    },
    createDestination: function(number) {
        var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
        var hash = '';
        var i, num;
        for (i=0; i < 8; i++) {
            num = Math.floor(Math.random() * chars.length);
            hash += chars.substring(num,num + 1);
        }
        var id = Date.now() +'-'+ hash;
        var uid = null
        var type = 1;
        var name = number;
        var model = Ext.create('App.model.Destination', {
            id: id,
            uid: uid,
            type: type,
            name: name,
            number: number + '||'
        });
        return model;
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/Combo.js
Ext.define('App.view.filter.field.Combo', {
    extend: 'Ext.form.field.Display',
    cls: 'w-dst',
    arrayValue: new Array(),
    initComponent: function() {
        this.addEvents('pickerShow', 'pickerHide');
        this.enableBubble('pickerShow', 'pickerHide');

        this.value = this.getPlainValue(this.arrayValue);
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.bodyEl = this.inputEl.parent();
        this.inputEl.setVisibilityMode(Ext.Element.DISPLAY);
        this.bodyEl.on('click', this.onClick, this);
    },
    onClick: function(e) {
        if(!this.isDisabled())
            this.showPicker();
    },
    onSelectedViewItemAdd: function() {
        this.picker.alignPicker();
    },
    onSelectedViewItemRemove: function() {
        this.picker.alignPicker();
    },
    onSelectedViewItemClick: function(view, record, item, index, e) {
        var target = Ext.get(e.target);

        if (target.hasCls('close')) {
            this.selectedStore.remove(record);
        }
        
        e.stopEvent();
    },  
    onCollapseWheel: function(e) {
        if (!this.isDestroyed && !e.within(this.bodyEl, false, true) && !e.within(this.picker.getEl(), false, true)) {
            this.hidePicker();
        }
    },
    showPicker: function() {
        if (!this.selectedStore) {
            this.selectedStore = this.createSelectedStore(this.arrayValue);
        }
        
        if (!this.selectedView) {
            this.selectedView = this.createSelectedView(this.bodyEl, this.selectedStore);
            this.selectedView.on('itemclick', this.onSelectedViewItemClick, this);
            this.selectedView.on('itemadd', this.onSelectedViewItemAdd, this);
            this.selectedView.on('itemremove', this.onSelectedViewItemRemove, this);
            this.selectedView.refresh();
        }
        
        if (!this.store) {
            this.store = this.createStore();
        }
        
        if (!this.picker) {
            this.picker = this.createPicker(this.bodyEl, this.store, this.selectedStore, this.selectedView);
        }
        
        this.inputEl.hide();
        this.selectedView.show();
        this.fireEvent('pickerShow', this);
        if (!this.pickerExanded) {
            this.bodyEl.addCls('x-form-display-field-active');
            
            this.picker.expand();
            this.pickerExanded = true;

            this.mon(Ext.getDoc(), {
                mousedown: this.onCollapseWheel,
                scope: this
            });
        }
    },
    hidePicker: function() {
        this.bodyEl.removeCls('x-form-display-field-active');
        
        this.inputEl.show();
        this.selectedView.hide();
        this.fireEvent('pickerHide', this);
        this.setValue(this.getPlainValue(this.getArrayValue()));
        this.picker.collapse();
        this.pickerExanded = false;

        Ext.getDoc().un('mousedown', this.collapseWheel, this);
        
        this.selectedView.un('itemadd', this.onSelectedViewAdd, this);
        this.selectedView.un('itemremove', this.onSelectedViewRemove, this);
    },
    setArrayValue: function(destinations) {
        this.setValue(this.getPlainValue(destinations));
        
        if (!this.selectedStore) {
            this.arrayValue = destinations;
        } else {
            this.selectedStore.removeAll();
        
            if (Ext.isArray(destinations)) {
                this.selectedStore.add(Ext.clone(destinations));
            }
        }
    },
    getArrayValue: function() {
        var result = new Array(), i, range;
        
        if (!this.selectedStore) {
            return this.arrayValue;
        }
        
        if (this.selectedStore) {
            range = this.selectedStore.getRange();
            
            for (i = 0; i < range.length; i++) {
                result.push(range[i].data);
            }
        }
        
        return result;
    },
    getPlainValue: function(range) {
        var i, plain = new Array();

        if (range) {
            for (i=0; i < range.length; i++) {
                plain.push(range[i]['name']);
            }

            if (plain.length > 0) {
                return plain.join(', ');
            }
        }
        
        return _t('Any')
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/SimpleCombo.js
Ext.define('App.view.filter.field.SimpleCombo', {
    extend: 'App.view.filter.field.Combo',
    createSelectedView: function(containerEl, store) {
        var tpl = new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="w-dst-selection-item">',
                    '<div class="name">{name}</div>',
                    '<div class="close"></div>',
                '</div>',
            '</tpl>'
        );

        var selectionView = Ext.create('Ext.view.View', {
            store: store,
            tpl: tpl,
            cls: 'w-dst-selection',
            itemSelector: 'div.w-dst-selection-item',
            overItemCls: 'w-dst-selection-item-over',
            emptyText: sprintf('<div class="w-dst-selection-empty">%(any)s</div>', { any : _t('Any')}),
            deferEmptyText: false,
            hidden: true,
            hideMode: 'display',
            renderTo: containerEl
        });
        
        return selectionView;
    },
    createPicker: function(fieldEl, store, selectedStore, selectedView) {
        var picker = Ext.create('App.view.filter.field.combo.SimplePicker', {
            fieldEl: fieldEl,
            store: store,
            selectedStore: selectedStore,
            selectedView: selectedView,
            selectionViewConfig: {
                columns: [
                    {
                        header: 'Name',
                        dataIndex: 'name',
                        flex: 1
                    }
                ]
            }
        });
        
        return picker;
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/Destination.js
Ext.define('App.view.filter.field.Destination', {
    extend: 'App.view.filter.field.Combo',
    createPicker: function(fieldEl, store, selectedStore, selectedView) {
        var picker = Ext.create('App.view.filter.field.combo.Picker', {
            fieldEl: fieldEl,
            store: store,
            selectedStore: selectedStore,
            selectedView: selectedView
        });
        
        return picker;
    },
    createSelectedStore: function(data) {
        var selectionStore = Ext.create('Ext.data.Store', {
            model: 'App.model.Destination',
            data: data,
            proxy: {
                type: 'memory',
                reader: {
                    type: 'json'
                }
            }
        });
        
        return selectionStore;
    },
    createSelectedView: function(containerEl, store) {
        var tpl = new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="w-dst-selection-item">',
                    '<div class="name">{name}</div>',
                    '<div class="close"></div>',
                '</div>',
            '</tpl>'
        );

        var selectionView = Ext.create('Ext.view.View', {
            store: store,
            tpl: tpl,
            cls: 'w-dst-selection',
            itemSelector: 'div.w-dst-selection-item',
            overItemCls: 'w-dst-selection-item-over',
            emptyText: sprintf('<div class="w-dst-selection-empty">%(any)s</div>', { any : _t('Any')}),
            deferEmptyText: false,
            hidden: true,
            hideMode: 'display',
            renderTo: containerEl
        });
        
        return selectionView;
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/DestinationInt.js
Ext.define('App.view.filter.field.DestinationInt', {
    extend: 'App.view.filter.field.Destination',
    createStore: function() {
        return Ext.create('App.store.DestinationsInt');
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/Trunk.js
Ext.define('App.view.filter.field.Trunk', {
    extend: 'App.view.filter.field.SimpleCombo',
    createStore: function() {
        return Ext.create('App.store.Trunks');
    },
    createSelectedStore: function(data) {
        var selectionStore = Ext.create('Ext.data.Store', {
            model: 'App.model.Trunk',
            data: data,
            proxy: {
                type: 'memory',
                reader: {
                    type: 'json'
                }
            }
        });
        
        return selectionStore;
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/DestinationExt.js
Ext.define('App.view.filter.field.DestinationExt', {
    extend: 'App.view.filter.field.Destination',
    createStore: function() {
        return Ext.create('App.store.DestinationsExt');
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/Pbx.js
Ext.define('App.view.filter.field.Pbx', {
    extend: 'App.view.filter.field.SimpleCombo',
    createStore: function() {
        return Ext.create('App.store.Pbxes');
    },
    createSelectedStore: function(data) {
        var selectionStore = Ext.create('Ext.data.Store', {
            model: 'App.model.Pbx',
            data: data,
            proxy: {
                type: 'memory',
                reader: {
                    type: 'json'
                }
            }
        });
        
        return selectionStore;
    },
    createSelectedView: function(containerEl, store) {
        var tpl = new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="w-dst-selection-item">',
                    '<div class="name">{serial}</div>',
                    '<div class="close"></div>',
                '</div>',
            '</tpl>'
        );

        var selectionView = Ext.create('Ext.view.View', {
            store: store,
            tpl: tpl,
            cls: 'w-dst-selection',
            itemSelector: 'div.w-dst-selection-item',
            overItemCls: 'w-dst-selection-item-over',
            emptyText: sprintf('<div class="w-dst-selection-empty">%(any)s</div>', { any : _t('Any')}),
            deferEmptyText: false,
            hidden: true,
            hideMode: 'display',
            renderTo: containerEl
        });
        
        return selectionView;
    },
    createPicker: function(fieldEl, store, selectedStore, selectedView) {
        var picker = Ext.create('App.view.filter.field.combo.SimplePicker', {
            fieldEl: fieldEl,
            store: store,
            selectedStore: selectedStore,
            selectedView: selectedView,
            selectionViewConfig: {
                columns: [
                    {
                        header: 'Serial',
                        dataIndex: 'name',
                        flex: 1
                    }
                ]
            }
        });
        
        return picker;
    },
    getPlainValue: function(range) {
        var i, plain = new Array();

        if (range) {
            for (i=0; i < range.length; i++) {
                plain.push(range[i]['serial']);
            }

            if (plain.length > 0) {
                return plain.join(', ');
            }
        }
        
        return _t('Any')
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/Observer.js
Ext.define('App.view.filter.Observer', {
	singleton: true,
    editors: new Array(),
    focused: false,
    focusedEditor: false,
    focusedField: false,
    constructor: function() {
        this.callParent(arguments);
        Ext.getBody().addListener( 'click', this.onClick, this );
    },
    focus: function(editor) {
        for( var i=0; i < this.editors.length; i++ ) {
            if( this.editors[i].getId() != editor.getId() && this.editors[i].isVisible() ) {
                this.editors[i].hide();
            }
        }
        
        this.focused = true;
        this.focusedEditor = editor;
        this.focusedField = editor.getTarget();
    },
    push: function(editor) {
        this.editors.push(editor);
    },
    onClick: function( event, element ) {
        if( !this.focused ) {
            return false;
        }
        
        var target = Ext.get(element);
        var parent = false;
        var prevent = false;
        var index;
        
        while(true) {
            if( !parent ) {
                // parent not available
                if( target.id == this.focusedEditor.getId() || target.id == this.focusedField.getId() ) {
                    prevent = true;
                    break;
                }
                if( target.id == Ext.getBody().id ) {
                    break;
                }
                
                index = parseInt(target.getStyle('z-index'));
                
                if( index > 1 ) {
                    prevent = true;
                    break;
                }
                
                parent = target.parent();
            } else {
                // parent available
                if( parent.id == this.focusedEditor.getId() || parent.id == this.focusedField.getId() ) {
                    prevent = true;
                    break;
                }
                
                if( parent.id == Ext.getBody().id ) {
                    break;
                }
                
                index = parseInt(parent.getStyle('z-index'));
                
                if( index > 1 ) {
                    prevent = true;
                    break;
                }
                
                parent = parent.parent();
            }
        }
        
        if( !prevent || (target && target.hasCls('x-form-item-label'))) {
            this.focused = false;
            this.focusedEditor.hide();
            this.focusedEditor = false;
            this.focusedField = false;
        }
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/Editor.js
Ext.define('App.view.filter.Editor', {
    extend: 'Ext.Container',
    hidden: true,
    hideMode: 'display',
    floating: true,
    cls: 'w-editor',
    initComponent: function() {
        this.renderTo = Ext.getBody();
        this.renderTpl = [
            '<div class="w-editor-arrow"></div>',
            '<div class="w-editor-body">',
                '<div class="x-editor-top-right"><div class="x-editor-top-left"><div class="x-editor-top"></div></div></div>',
                '<div class="x-editor-center-right"><div class="x-editor-center-left"><div class="x-editor-center">',
                    '<div class="x-editor-collapse"></div>',
                    '<div class="x-editor-title">{title}</div>',
                    '<tpl if="description">',
                        '<div class="x-editor-description">{description}</div>',
                    '</tpl>',
                    '<div class="x-clear"></div>',
                    '<div class="x-editor-form"></div>',
                    sprintf('<div class="x-editor-condition" style="display: none;"><span class="label">%(condRes)s </span><span class="x-editor-condition-result"><span class="any">%(any)s</span></span></div>', { condRes : '', any : _t('Any')}),
                '</div></div></div>',
                '<div class="x-editor-bottom-right"><div class="x-editor-bottom-left"><div class="x-editor-bottom"></div></div></div>',
            '</div>'
        ];
        
        this.renderSelectors = {
            arrowEl: 'div.w-editor-arrow',
            collapseEl: 'div.x-editor-collapse',
            formEl: 'div.x-editor-form',
            conditionEl: 'span.x-editor-condition-result'
        }

        this.renderData = {
            title: this.title,
            description: this.description
        }
        
        this.callParent(arguments);
        
        // Events
        this.addEvents('change');
        this.on('change', this.onChange, this);
        
        // ...
        this.observer = App.view.filter.Observer;
        this.observer.push(this);
        this.state = this.getDefaultState();


    },


    onRender: function() {
        this.callParent(arguments);
    },
    onChange: function(state) {
        this.conditionEl.update(this.getDescription(state));
    },
    afterRender : function() {
        this.callParent(arguments);
        this.collapseEl.on('click', this.onCollapse, this);
    },
    onRenderContent: function() {
        this.contentRendered = true;
    },
    onCollapse: function() {
        this.hide();
    },
    focus: function() {
        this.observer.focus(this);
        this.show();
    },
    show: function() {
        if (this.isVisible()) {
            return false;
        }
        if (!this.targetParent) {
            this.targetParent = this.target.findParentByType('form');
        }
        
        Ext.EventManager.onWindowResize(this.alignEditor, this);
        
        this.alignEditor();
        this.callParent(arguments);
        
        if (!this.contentRendered) {
            this.onRenderContent(this.getState());
        }

        if(!this.KeyMapOnEsc) {
            this.KeyMapOnEsc = new Ext.util.KeyMap(Ext.getBody(), [{
               key: Ext.EventObject.ESC,
               defaultEventAction: 'preventDefault',
               scope: this,
               fn: this.hide
            }]);
        } else {
            this.KeyMapOnEsc.enable();
        }

        return true;
    },
    hide: function() {
        Ext.EventManager.removeResizeListener(this.alignEditor, this);
        
        this.callParent(arguments);

        this.KeyMapOnEsc.disable();
        this.fireEvent('afterhide');
    },
    alignEditor: function() {
        var trgPos = this.target.getPosition();
        var trgLeft = trgPos[0];
        var trgTop = trgPos[1];
        var trgWidth = this.target.getWidth();
        var trgHeight = this.target.getHeight();
        var trgBottom = trgTop + trgHeight;
        var trgCenter = trgLeft + (trgWidth / 2);
        var prnPos = this.targetParent.getPosition();
        var prnLeft = prnPos[0];
        var prnTop = prnPos[1];
        var prnWidth = this.targetParent.getEl().getWidth();
        var prnOffset = 20;
        var scopeLeft = prnLeft + (prnOffset / 2);
        var scopeRight = scopeLeft + prnWidth - prnOffset;
        var selfTop = trgBottom;
        var selfWidth = this.width;
        var selfLeft = trgCenter - (selfWidth / 2 );

        if( selfLeft + selfWidth > scopeRight ) {
            selfLeft = trgLeft + trgWidth - this.width;
        }
        if( selfLeft < scopeLeft ) {
            selfLeft = scopeLeft;
        }
        
        var arrWidth = 19;
        var arrLeft = parseInt(trgCenter - selfLeft - (arrWidth / 2));
        
        this.arrowEl.setLeft(arrLeft);
        this.setPosition(selfLeft, selfTop, false);
    },
    getTarget: function() {
        return this.target;
    },
    getState: function() {
        if (!this.state) {
            this.state = this.getDefaultState();
        }
        
        return this.state;
    },
    getAnyDescription: function() {
        return '';
    },
    getAnyFieldDescription: function() {
        return _t('Any');
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/Field.js
Ext.define('App.view.filter.Field', {
    extend: 'Ext.form.field.Display',
    cls: 'filter-field',
    value: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.getEditor().on('afterhide', this.onEditorHide, this)
        this.getEditor().on('change', this.onEditorChange, this)
        this.getEl().on('click', this.onClick, this);
    },
    disableField: function() {
        var el = this.getEl().down('div.x-form-item-body');
        el.mask();
    },
    enableField: function() {
        var el = this.getEl().down('div.x-form-item-body');
        el.unmask();
    },
    onClick: function(event, el) {
        el = Ext.get(el);
        
        if (el.hasCls('x-form-item-body') || el.hasCls('x-form-display-field')) {
            if (!this.disabled) {
                this.editor.focus();
            }
        }
    },
    onEditorHide: function() {
        var state = this.editor.getState();
        var desc = this.editor.getFieldDescription(state);
        
        this.setValue(desc);
    },
    onEditorChange: function() {
        var state = this.editor.getState();
        var desc = this.editor.getFieldDescription(state);

        this.setValue(desc);
    },
    setState: function(state) {
        this.editor.setState(state);
        this.setValue(this.editor.getFieldDescription(state));
    },
    getState: function() {
        return this.editor.getState();
    },
    getDefaultState: function() {
        return this.editor.getDefaultState();
    },
    getEditor: function() {
        return this.editor;
    },
    getFilterDescription: function() {
        return this.editor.getFilterDescription();
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/field/Tag.js
Ext.define('App.view.filter.field.Tag', {
    extend: 'App.view.filter.field.SimpleCombo',
    createStore: function() {
        return Ext.create('App.store.Tags');
    },
    createSelectedStore: function(data) {
        var selectionStore = Ext.create('Ext.data.Store', {
            model: 'App.model.Tag',
            data: data,
            proxy: {
                type: 'memory',
                reader: {
                    type: 'json'
                }
            }
        });

        return selectionStore;
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/TagsField.js
Ext.define('App.view.filter.TagsField', {
    extend: 'App.view.filter.Field',
    alias : 'widget.filterTagsField',
    anchor: '100%',
    labelAlign: 'top',
    fieldLabel: _t('Tags'),
    emptyText: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
        this.editor = Ext.create('App.view.filter.TagsEditor', { target: this });
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/TagsEditor.js
Ext.define('App.view.filter.TagsEditor', {
    extend: 'App.view.filter.Editor',
    width: 400,
    onRenderContent: function(state) {
        this.tagsField = Ext.create('App.view.filter.field.Tag', {
            fieldLabel: _t('Tags'),
            labelAlign: 'left',
            labelWidth: 100,
            arrayValue: state['tags'],
            anchor: '100%'
        });
        
        this.containerEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            layout: 'anchor',
            items: [
                this.tagsField
            ]
        });
        
        this.tagsField.on('change', this.onTagsFieldChange, this);
        this.callParent(arguments);
    },
    onTagsFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['tags'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    hide: function(){
        if(this.tagsField.selectedView != undefined && this.tagsField.selectedView.isVisible()) {
            this.tagsField.hidePicker();
            return;
        } else {
            this.callParent();
        }
    },
    setState: function(s) {
        this.state = s;
        this.conditionEl.update(this.getDescription(s));
        
        if (!this.contentRendered) {
            return;
        }
        
        this.ignoreStateEvents = true;
        this.tagsField.setArrayValue(s['tags']);
        this.ignoreStateEvents = false;
    },
    getDefaultState: function() {
        var s = {
            'tags': new Array()
        }
        
        return s;
    },
    
    getTagsDescription: function(tags) {
        var i, result = new Array();
        
        if( tags.length == 0 ) {
            return undefined;
        }
        
        for( i=0; i < tags.length; i++ ) {
            result.push(tags[i]['name']);
        }
        
        if ( result.length > 0 ) {
            return result.join(', ');
        } else {
            return undefined;
        }      
    },
    
    getDescription: function(state) {
        if (state) {
            var desc = this.getTagsDescription(state['tags']);

            if (desc) {
                return sprintf('%(tagDesc)s', { tagDesc : desc });
            }
        }

        return this.getAnyDescription();
    },
    
    getFieldDescription: function(state) {
	if (state) {
            var desc = this.getTagsDescription(state['tags']);

            if (desc) {
                return sprintf('%(tagDesc)s', { tagDesc : desc });
            }
        }
        
        return this.getAnyFieldDescription();
    },
    
    getFilterDescription: function() {
        var desc = this.getTagsDescription(this.state['tags']);
        
        if (desc) {
            return _t('Tags')+': '+desc;
        }
        
        return null;
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/minMaxEditor/Spinner.js
Ext.define('App.view.filter.minMaxEditor.Spinner', {
    extend: 'Ext.form.field.Number',
    minValue: -1,
    emptyText: _t('Any'),
    beforeBlur: function() {


        var me = this,
            v = me.parseValue(me.getRawValue());

        if (!Ext.isEmpty(v)) {
            me.setValue(v);
        }
    },
    onSpinUp: function() {


        if (this.getValue() == null) {
            this.setValue(0);
            this.fireEvent('change', this, this.getValue());
            return;
        }

        this.callParent(arguments);
    },
    onSpinDown: function() {
        if (this.getValue() <= 0) {
            this.setRawValue();
            this.fireEvent('change', this, this.getValue());
            return;
        }

        this.callParent(arguments);
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/MinMaxEditor.js
Ext.define('App.view.filter.MinMaxEditor', {
    extend: 'App.view.filter.Editor',
    //title: 'Filter by Duration',
    width: 400,
    mark: 'Duration',
    //description: 'Please select a range of event durations from a moment when extension was dialed not depending on was call answered or not.<br /> Example: 5 < duration <= 10 means calls which are longer than 5 seconds and less or equal to 10 seconds (10 is not included).',
    defaultFieldConfig: {
        allowDecimals: false,
        step: 1
    },
    onRenderContent: function(state) {
        var self = this;

        this.leftField = Ext.create('App.view.filter.minMaxEditor.Spinner', Ext.applyIf({
            width: 90,
            value: state['leftValue']
        }, this.defaultFieldConfig));

        this.rightField = Ext.create('App.view.filter.minMaxEditor.Spinner', Ext.applyIf({
            width: 90,
            value: state['rightValue']
        }, this.defaultFieldConfig));

        this.containerEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            layout: 'column',
            items: [
                {
                    xtype: 'container',
                    columnWidth: 0.5,
                    layout: 'column',
                    items: [
                        this.leftField,
                        {
                            xtype: 'container',
                            columnWidth: 1,
                            style: 'line-height: 22px; text-align: center; font-size: 14px;',
                            html: '<'
                        }
                    ]
                },
                {
                    xtype: 'container',
                    width: 90,
                    items: [
                        {
                            xtype: 'container',
                            cls: 'w-dst-mark-left',
                            renderTpl: [
                                '<div class="w-dst-mark-right">',
                                    '<div class="w-dst-mark">{title}</div>',
                                '</div>'
                            ],
                            renderData: {
                                title: this.mark
                            }
                        }
                    ]
                },
                {
                    xtype: 'container',
                    columnWidth: 0.5,
                    layout: 'column',
                    items: [
                        {
                            xtype: 'container',
                            columnWidth: 1,
                            style: 'line-height: 22px; text-align: center; font-size: 14px;',
                            html: '<'
                        },
                        this.rightField
                    ]
                }
            ]
        });

        this.leftField.addListener('change', this.onLeftFieldChange, this);
        this.rightField.addListener('change', this.onRightFieldChange, this);

        this.callParent(arguments);
    },
    onLeftFieldChange: function(field, value) {


        if (this.ignoreStateEvents) {
            return;
        }
        if (value == null) {
            this.state['leftEnabled'] = false;
            this.state['leftValue'] = null;
        } else {
            this.state['leftEnabled'] = true;
            this.state['leftValue'] = value;
        }

        this.fireEvent('change', this.state);
    },
    onRightFieldChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        if (value == null) {
            this.state['rightEnabled'] = false;
            this.state['rightValue'] = null;
        } else {
            this.state['rightEnabled'] = true;
            this.state['rightValue'] = value;
        }

        this.fireEvent('change', this.state);
    },
    setState: function(s) {



        this.state = s;
        this.conditionEl.update(this.getDescription(s));

        if (!this.contentRendered) {
            return;
        }

        this.ignoreStateEvents = true;

        this.leftField.setValue(s['leftValue']);
        this.rightField.setValue(s['rightValue']);

        this.ignoreStateEvents = false;
    },
    getDefaultState: function() {
        var s = {
            'leftEnabled': false,
            'leftValue': null,
            'rightValue': null,
            'rightEnabled': false
        }

        return s;
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/DestinationField.js
Ext.define('App.view.filter.DestinationField', {
    extend: 'App.view.filter.Field',
    alias : 'widget.filterDestinationField',
    anchor: '100%',
    labelAlign: 'top',
    fieldLabel: _t('Direction'),
    emptyText: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
        this.editor = Ext.create('App.view.filter.DestinationEditor', { target: this });
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/DestinationEditor.js
Ext.define('App.view.filter.DestinationEditor', {
    extend: 'App.view.filter.Editor',
    width: 900,
    onRenderContent: function(state) {
        // Rendering Internal to External elements
        this.intToExtCheckBox = Ext.create('Ext.form.field.Checkbox', {
            style: 'padding: 2px 0 0 0; margin: 0px; line-height: 0px;',
            checked: state['intToExtEnabled']
        } );
        
        this.intToExtFromField = Ext.create('App.view.filter.field.DestinationInt', {
            fieldLabel: _t('From'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 10 0 5',
            columnWidth: 0.5,
            arrayValue: state['intToExtFrom'],
            disabled: state['intToExtEnabled'] ? false : true
        } );
        
        this.intToExtToField = Ext.create('App.view.filter.field.DestinationExt', {
            fieldLabel: _t('To'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 5 0 10',
            columnWidth: 0.5,
            arrayValue: state['intToExtTo'],
            disabled: state['intToExtEnabled'] ? false : true
        } );
       
        this.intToExtCnt = Ext.create('Ext.container.Container', {
            layout: 'column',
            renderTo: this.formEl,
            items: [
                this.intToExtCheckBox,
                {
                    xtype: 'container',
                    style: 'white-space: nowrap; padding: 3px 0 0 10px; font-weight: 700; color:#333;',
                    width: 150,
                    html: _t('Internal to External')
                },
                {
                    xtype: 'container',
                    margin: '0 0 0 10',
                    layout: 'column',
                    columnWidth: 1,
                    items: [
                        this.intToExtFromField,
                        this.intToExtToField
                    ],
                    listeners: {
                        'pickerShow': this.onPickerShow,
                        'pickerHide': this.onPickerHide,
                        scope: this
                    }
                }
            ]
        } );
        
        // Rendering External to Internal elements
        this.extToIntCheckBox = Ext.create('Ext.form.field.Checkbox', {
            style: 'padding: 2px 0 0 0; margin: 0px; line-height: 0px;',
            checked: state['extToIntEnabled']
        } );
        this.extToIntFromField = Ext.create('App.view.filter.field.DestinationExt', {
            fieldLabel: _t('From'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 10 0 5',
            columnWidth: 0.5,
            arrayValue: state['extToIntFrom'],
            disabled: state['extToIntEnabled'] ? false : true
        } );
        this.extToIntToField = Ext.create('App.view.filter.field.DestinationInt', {
            fieldLabel: _t('To'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 5 0 10',
            columnWidth: 0.5,
            arrayValue: state['extToIntTo'],
            disabled: state['extToIntEnabled'] ? false : true
        } );
       
        this.extToIntCnt = Ext.create('Ext.container.Container', {
            layout: 'column',
            renderTo: this.formEl,
            padding: '10 0 0 0',
            items: [
                this.extToIntCheckBox,
                {
                    xtype: 'container',
                    style: 'white-space: nowrap; padding: 3px 0 0 10px; font-weight: 700; color:#333;',
                    width: 150,
                    html: _t('External to Internal')
                },
                {
                    xtype: 'container',
                    margin: '0 0 0 10',
                    layout: 'column',
                    columnWidth: 1,
                    items: [
                        this.extToIntFromField,
                        this.extToIntToField
                    ],
                    listeners: {
                        'pickerShow': this.onPickerShow,
                        'pickerHide': this.onPickerHide,
                         scope: this
                    }
                }
            ]
        } );
        
        // Rendering Internal to Internal elements
        this.intToIntCheckBox = Ext.create('Ext.form.field.Checkbox', {
            style: 'padding: 2px 0 0 0; margin: 0px; line-height: 0px;',
            checked: state['intToIntEnabled']
        } );
        
        this.intToIntFromField = Ext.create('App.view.filter.field.DestinationInt', {
            fieldLabel: _t('From'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 10 0 5',
            columnWidth: 0.5,
            arrayValue: state['intToIntFrom'],
            disabled: state['intToIntEnabled'] ? false : true
        } );
        
        this.intToIntToField = Ext.create('App.view.filter.field.DestinationInt', {
            fieldLabel: _t('To'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 5 0 10',
            columnWidth: 0.5,
            arrayValue: state['intToIntTo'],
            disabled: state['intToIntEnabled'] ? false : true
        } );
       
        this.intToIntCnt = Ext.create('Ext.container.Container', {
            layout: 'column',
            renderTo: this.formEl,
            padding: '10 0 0 0',
            items: [
                this.intToIntCheckBox,
                {
                    xtype: 'container',
                    style: 'white-space: nowrap; padding: 3px 0 0 10px; font-weight: 700; color:#333;',
                    width: 150,
                    html: _t('Internal to Internal')
                },
                {
                    xtype: 'container',
                    margin: '0 0 0 10',
                    layout: 'column',
                    columnWidth: 1,
                    items: [
                        this.intToIntFromField,
                        this.intToIntToField
                    ],
                    listeners: {
                        'pickerShow': this.onPickerShow,
                        'pickerHide': this.onPickerHide,
                        scope: this
                    }
                }
            ]
        } );

        this.intToExtCheckBox.addListener('change', this.intToExtCheckBoxChange, this);
        this.intToExtFromField.addListener('change', this.onIntToExtFromFieldChange, this);
        this.intToExtToField.addListener('change', this.onIntToExtToFieldChange, this);
        
        this.extToIntFromField.addListener('change', this.onExtToIntFromFieldChange, this);
        this.extToIntToField.addListener('change', this.onExtToIntToFieldChange, this);
        this.extToIntCheckBox.addListener('change', this.onExtToIntChangeChange, this);
        
        this.intToIntFromField.addListener('change', this.onIntToIntFromFieldChange, this);
        this.intToIntToField.addListener('change', this.onIntToIntToFieldChange, this);
        this.intToIntCheckBox.addListener('change', this.onIntToIntChangeChange, this);

        this.callParent(arguments);
    },
    onPickerShow: function(picker) {
        // TODO Uncomment this if need.
//        if(this.activePicker != undefined) {
//            this.activePicker.hidePicker();
//        }
        this.activePicker = picker;
    },
    onPickerHide: function(picker){
        if(this.activePicker != undefined && this.activePicker == picker) {
            this.activePicker = undefined;
        }
    },
    intToExtCheckBoxChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        if( !value ) {
            this.intToExtFromField.setDisabled(true);
            this.intToExtToField.setDisabled(true);
        } else {
            this.intToExtFromField.setDisabled(false);
            this.intToExtToField.setDisabled(false);
        }
        
        this.state['intToExtEnabled'] = value;
        this.fireEvent('change', this.state);
    },
    onExtToIntChangeChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        if( !value ) {
            this.extToIntFromField.setDisabled(true);
            this.extToIntToField.setDisabled(true);
        } else {
            this.extToIntFromField.setDisabled(false);
            this.extToIntToField.setDisabled(false);
        }
        
        this.state['extToIntEnabled'] = value;
        this.fireEvent('change', this.state);
    },
    onIntToIntChangeChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        if( !value ) {
            this.intToIntFromField.setDisabled(true);
            this.intToIntToField.setDisabled(true);
        } else {
            this.intToIntFromField.setDisabled(false);
            this.intToIntToField.setDisabled(false);
        }   
        
        this.state['intToIntEnabled'] = value;
        this.fireEvent('change', this.state);
    },
    onIntToExtFromFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['intToExtFrom'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onIntToExtToFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['intToExtTo'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onExtToIntFromFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['extToIntFrom'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onExtToIntToFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['extToIntTo'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onIntToIntFromFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['intToIntFrom'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onIntToIntToFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['intToIntTo'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    hide: function(){
        if(this.activePicker != undefined) {
            this.activePicker.hidePicker();
            return;
        } else {
            this.callParent();
        }
    },
    setState: function(s) {
        this.state = s;
        this.conditionEl.update(this.getDescription(s));
        
        if (!this.contentRendered) {
            return;
        }
        
        this.ignoreStateEvents = true;
        
        // Int to Ext
        this.intToExtCheckBox.setValue(s['intToExtEnabled']);
        
        if( s['intToExtEnabled'] ) {
            this.intToExtFromField.setDisabled(false);
            this.intToExtToField.setDisabled(false);
        } else {
            this.intToExtFromField.setDisabled(true);
            this.intToExtToField.setDisabled(true);
        }
        
        this.intToExtFromField.setArrayValue(s['intToExtFrom']);
        this.intToExtToField.setArrayValue(s['intToExtTo']);
        
        // Ext to Int
        this.extToIntCheckBox.setValue(s['extToIntEnabled']);
        
        if( s['extToIntEnabled'] ) {
            this.extToIntFromField.setDisabled(false);
            this.extToIntToField.setDisabled(false);
        } else {
            this.extToIntFromField.setDisabled(true);
            this.extToIntToField.setDisabled(true);
        }
        
        this.extToIntFromField.setArrayValue(s['extToIntFrom']);
        this.extToIntToField.setArrayValue(s['extToIntTo']);
        
        // Int to Int
        this.intToIntCheckBox.setValue(s['intToIntEnabled']);
        
        if( s['intToIntEnabled'] ) {
            this.intToIntFromField.setDisabled(false);
            this.intToIntToField.setDisabled(false);
        } else {
            this.intToIntFromField.setDisabled(true);
            this.intToIntToField.setDisabled(true);
        }
        
        this.intToIntFromField.setArrayValue(s['intToIntFrom']);
        this.intToIntToField.setArrayValue(s['intToIntTo']);
        
        this.ignoreStateEvents = false;
    },
    getDefaultState: function() {
        var s = {
            'intToExtEnabled': false,
            'intToExtFrom': new Array(),
            'intToExtTo': new Array(),
            'extToIntEnabled': false,
            'extToIntFrom': new Array(),
            'extToIntTo': new Array(),
            'intToIntEnabled': false,
            'intToIntFrom': new Array(),
            'intToIntTo': new Array()
        }
        
        return s;
    },
    getDescription: function(state) {
        var desc = this.getDestinationsDescription(state);
        
        if (desc) {
            return sprintf('%(description)s', { description : desc });
        }
        
        return this.getAnyDescription();
    },
    getFieldDescription: function(state) {
        var desc = this.getDestinationsDescription(state);
        
        if (desc) {
            return sprintf('%(description)s', { description : desc });
        }
        
        return this.getAnyFieldDescription();
    },
    
    getFilterDescription: function() {
        var desc = this.getDestinationsDescription(this.state);
        
        if (desc) {
            return _t('Direction')+': '+desc;
        }
        
        return null;
    },
    
    getDestinationsDescription: function(state) {
        var s = state, r = new Array(), rf, rt, rs;
        
        if( s['intToExtEnabled'] && s['intToExtFrom'].length == 0 &&  s['intToExtTo'].length == 0 &&
            s['extToIntEnabled'] && s['extToIntFrom'].length == 0 &&  s['extToIntTo'].length == 0 &&
            s['intToIntEnabled'] && s['intToIntFrom'].length == 0 &&  s['intToIntTo'].length == 0 ) {
            return undefined;
        }
        
        if( s['intToExtEnabled'] ) {
            rs = undefined;
            rf = this.getDestinationDescription(s['intToExtFrom']);
            rt = this.getDestinationDescription(s['intToExtTo']);
            
            if( rf && rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to : rt });
            } else if ( rf ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to: _t('Any')+' '+_t('External number') });
            } else if ( rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('Internal number'), to: rt });
            } else {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('Internal number'), to: _t('Any')+' '+_t('External number') });
            }
            
            if( rs ) {
                r.push(rs);
            }
        }
        
        if( s['extToIntEnabled'] ) {
            rs = undefined;
            rf = this.getDestinationDescription(s['extToIntFrom']);
            rt = this.getDestinationDescription(s['extToIntTo']);
            
            if( rf && rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to : rt });
            } else if ( rf ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to: _t('Any')+' '+_t('Internal number') });
            } else if ( rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('External number'), to: rt });
            } else {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('External number'), to: _t('Any')+' '+_t('Internal number') });
            }
            
            if( rs ) {
                r.push(rs);
            }
        }
        
        if( s['intToIntEnabled'] ) {
            rs = undefined;
            rf = this.getDestinationDescription(s['intToIntFrom']);
            rt = this.getDestinationDescription(s['intToIntTo']);
            
            if( rf && rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to : rt });
            } else if ( rf ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to: _t('Any')+' '+_t('Internal number') });
            } else if ( rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('Internal number'), to: rt });
            } else {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any'), to: _t('Any')+' '+_t('Internal number') });
            }
            
            if( rs ) {
                r.push(rs);
            }
        }
        
        return r.join(_t(' and '));
    },
    getDestinationDescription: function(users) {
        var i, result = new Array();
        
        if( users.length == 0 ) {
            return undefined;
        }
        
        for( i=0; i < users.length; i++ ) {
            result.push(users[i]['name']);
        }
        
        if ( result.length > 0 ) {
            return result.join(', ');
        } else {
            return undefined;
        }
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/PeriodField.js
Ext.define('App.view.filter.PeriodField', {
    extend: 'App.view.filter.Field',
    alias : 'widget.filterPeriodField',
    anchor: '100%',
    labelAlign: 'top',
    fieldLabel: _t('Period'),
    emptyText: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
        this.editor = Ext.create('App.view.filter.PeriodEditor', { target: this });
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/PeriodEditor.js
Ext.define('App.view.filter.PeriodEditor', {
    extend: 'App.view.filter.Editor',
    width: 450,
    onRenderContent: function(state) {
        var fromDate = state['fromDate'] && state['fromTime'] ? Ext.Date.parse(state['fromDate'] +' '+ state['fromTime'], "Y-m-d H:i:s") : null;
        var toDate = state['toDate'] && state['toTime'] ? Ext.Date.parse(state['toDate'] +' '+ state['toTime'], "Y-m-d H:i:s") : null;

        var types = Ext.create('Ext.data.Store', {
            fields: ['value', 'name'],
            data : [
                { value: App.utility.Date.TODAY, name: _t('Today') },
                { value: App.utility.Date.YESTERDAY, name: _t('Yesterday') },
                { value: App.utility.Date.WEEK, name: _t('This week') },
                { value: App.utility.Date.LAST_2_DAYS, name: _t('Last 2 days') },
                { value: App.utility.Date.LAST_7_DAYS, name: _t('Last 7 days') },
                { value: App.utility.Date.PREV_WEEK, name: _t('Previous week') },
                { value: App.utility.Date.LAST_2_WEEKS, name: _t('Last 2 weeks') },
                { value: App.utility.Date.MONTH, name: _t('This month') },
                { value: App.utility.Date.LAST_30_DAYS, name: _t('Last 30 days') },
                { value: App.utility.Date.PREV_MONTH, name: _t('Previous month') },
                { value: App.utility.Date.LAST_60_DAYS, name: _t('Last 60 days') },
                { value: App.utility.Date.LAST_3_MONTH, name: _t('Last 3 month') },
                { value: App.utility.Date.LAST_6_MONTH, name: _t('Last 6 month') },
                { value: App.utility.Date.LAST_12_MONTH, name: _t('Last 12 month') },
                { value: App.utility.Date.YEAR, name: _t('This year') },
                { value: App.utility.Date.PREV_YEAR, name: _t('Previous year') },
                { value: App.utility.Date.CUSTOM, name: _t('Related to a Time interval') }
            ]
        });

        this.typesField = Ext.create('Ext.form.ComboBox', {
            store: types,
            anchor: '100%',
            queryMode: 'local',
            displayField: 'name',
            valueField: 'value',
            value: state['type'],
            editable: false,
            listeners: {
                'specialkey': {
                    fn: function(el, e) {
                        if(!el.isExpanded && e.ESC == e.keyCode) {
                            this.hide();
                        }
                    },
                    scope: this
                }
            }
        });

        this.fromDateField = Ext.create('Ext.form.field.Date', {
            margin: '0 2 0 0',
            format: User.getDateFormat(),
            flex: 1,
            value: fromDate ? fromDate : null
        });

        this.fromTimeField = Ext.create('Ext.form.field.Time', {
            format: User.getTimeFormat(),
            width: 75,
            increment: 30,
            value: fromDate ? fromDate : null
        });

        this.toDateField = Ext.create('Ext.form.field.Date', {
            margin: '0 2 0 0',
            format: User.getDateFormat(),
            flex: 1,
            value: toDate ? toDate : null
        });

        this.toTimeField = Ext.create('Ext.form.field.Time', {
            format: User.getTimeFormat(),
            width: 75,
            increment: 30,
            value: toDate ? toDate : null
        });

        this.containerRange = Ext.create('Ext.container.Container', {
            anchor: '100%',
            layout: 'hbox',
            hidden: state['type'] == App.utility.Date.CUSTOM ? false : true,
            hideMode: 'display',
            items : [
                {
                    xtype: 'fieldcontainer',
                    flex: 0.5,
                    fieldLabel: _t('From'),
                    labelAlign: 'top',
                    layout: 'hbox',
                    items: [
                        this.fromDateField,
                        this.fromTimeField
                    ]
                },
                {
                    xtype: 'container',
                    width: 20
                },
                {
                    xtype: 'fieldcontainer',
                    flex: 0.5,
                    fieldLabel: _t('To'),
                    labelAlign: 'top',
                    layout: 'hbox',
                    items: [
                        this.toDateField,
                        this.toTimeField
                    ]
                }
            ]
        });

        this.containerEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            layout: 'anchor',
            items: [
                {
                    xtype: 'fieldcontainer',
                    anchor: '100%',
                    fieldLabel: _t('Period'),
                    labelAlign: 'left',
                    labelWidth: 60,
                    layout: 'anchor',
                    items: [
                        this.typesField,
                        this.containerRange
                    ]
                }
            ]
        });

        this.typesField.on('change', this.onTypesFieldChange, this);
        this.fromDateField.on('change', this.onFromDateFieldChange, this);
        this.fromTimeField.on('change', this.onFromTimeFieldChange, this);
        this.toDateField.on('change', this.onToDateFieldChange, this);
        this.toTimeField.on('change', this.onToTimeFieldChange, this);

        this.callParent(arguments);
    },

    onTypesFieldChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }

        if (value == App.utility.Date.CUSTOM) {
            this.containerRange.show();
            var toDate = App.storage.Synchronizer.getBackendMaxDate() || Ext.Date.format(new Date(), "Y-m-d H:i:s");
                toDate = Ext.Date.parse(toDate, 'Y-m-d H:i:s');
            var fromDate = new Date(toDate);
                fromDate.setDate(toDate.getDate() - 14);
            var fromDateAbs = Ext.Date.parse(Ext.Date.format(fromDate, "Y-m-d 00:00:00"), "Y-m-d H:i:s");

            this.fromDateField.setValue(fromDateAbs);
            this.fromTimeField.setValue(fromDateAbs);
            this.toDateField.setValue(toDate);
            this.toTimeField.setValue(toDate);

            this.state['type'] = value;
            this.state['fromDate'] = Ext.Date.format(fromDateAbs, 'Y-m-d');
            this.state['fromTime'] = Ext.Date.format(fromDateAbs, 'H:i:s');
            this.state['toDate'] = Ext.Date.format(toDate, 'Y-m-d');
            this.state['toTime'] = Ext.Date.format(toDate, 'H:i:s');

            this.fireEvent('change', this.state);
            return;
        }

        this.state['type'] = value;
        this.state['fromDate'] = null;
        this.state['fromTime'] = null;
        this.state['toDate'] = null;
        this.state['toTime'] = null;
        this.fireEvent('change', this.state);
        this.containerRange.hide();
    },
    onFromDateFieldChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }

        if( value ) {
            this.fromTimeField.setDisabled(false);

            try {
                this.state['fromDate'] = Ext.Date.format(value, 'Y-m-d');
            } catch (e) {
                this.state['fromDate'] = null;
                this.fromTimeField.setDisabled(true);
            }
            this.fireEvent('change', this.state);
        } else {
            this.fromTimeField.setValue(null);
            this.fromTimeField.setDisabled(true);
        }
    },
    onFromTimeFieldChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }

        try {
            this.state['fromTime'] = Ext.Date.format(value, 'H:i:s');
        } catch (e) {
            this.state['fromTime'] = null;
        }

        this.fireEvent('change', this.state);
    },
    onToDateFieldChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }

        if( value ) {
            this.toTimeField.setDisabled(false);

            try {
                this.state['toDate'] = Ext.Date.format(value, 'Y-m-d');
            } catch (e) {
                this.state['toDate'] = null;
                this.toTimeField.setDisabled(true);
            }
            this.fireEvent('change', this.state);
        } else {
            this.toTimeField.setValue(null);
            this.toTimeField.setDisabled(true);
        }
    },
    onToTimeFieldChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }

        try {
            this.state['toTime'] = Ext.Date.format(value, 'H:i:s');
        } catch (e) {
            this.state['toTime'] = null;
        }

        this.fireEvent('change', this.state);
    },
    setState: function(s) {
        this.state = s;
        this.conditionEl.update(this.getDescription(s));

        if (!this.contentRendered) {
            return;
        }

        this.ignoreStateEvents = true;

        var fromDate = s['fromDate'] ? Ext.Date.parse(s['fromDate'] +' '+ s['fromTime'], "Y-m-d H:i:s") : null;
        var fromTime = s['fromTime'] ? Ext.Date.parse(s['fromDate'] +' '+ s['fromTime'], "Y-m-d H:i:s") : null;
        var toDate = s['toDate'] ? Ext.Date.parse(s['toDate'] +' '+ s['toTime'], "Y-m-d H:i:s") : null;
        var toTime = s['toTime'] ? Ext.Date.parse(s['toDate'] +' '+ s['toTime'], "Y-m-d H:i:s") : null;

        this.typesField.setValue(s['type']);

        if (App.utility.Date.CUSTOM == s['type']) {
            this.containerRange.show();
        } else {
            this.containerRange.hide();
        }

        this.fromDateField.setValue(fromDate);
        this.fromTimeField.setValue(fromTime);
        this.toDateField.setValue(toDate);
        this.toTimeField.setValue(toTime);

        this.ignoreStateEvents = false;
    },
    getDefaultState: function() {
        var s = {
            'type': parseInt(User['period']) || 3,
            'fromDate': null,
            'fromTime': null,
            'toDate': null,
            'toTime': null
        }

        return s;
    },

    /**
     * Get's an array of From Date and To Date
     *
     */
    getPeriodDescription: function(state) {
        var fromDate = false;
        var toDate = false;

        fromDate = Ext.Date.parse(state['fromDate'] +' '+ state['fromTime'], "Y-m-d H:i:s");
        fromDate = Ext.util.Format.date(fromDate, User.getDateTimeFormat());
        toDate = Ext.Date.parse(state['toDate'] +' '+ state['toTime'], "Y-m-d H:i:s");
        toDate = Ext.util.Format.date(toDate, User.getDateTimeFormat());

        return sprintf(_t('From_%(from)s_to_%(to)s'), { from : fromDate, to : toDate });
    },

    getTypeDescription: function(state) {
        switch(state['type']) {
            case App.utility.Date.TODAY:
                return _t('Today');
                break;
            case App.utility.Date.YESTERDAY:
                return _t('Yesterday');
                break;
            case App.utility.Date.WEEK:
                return _t('This week');
                break;
            case App.utility.Date.LAST_2_DAYS:
                return _t('Last 2 days');
                break;
            case App.utility.Date.LAST_7_DAYS:
                return _t('Last 7 days');
                break;
            case App.utility.Date.PREV_WEEK:
                return _t('Previous week');
                break;
            case App.utility.Date.LAST_2_WEEKS:
                return _t('Last 2 weeks');
                break;
            case App.utility.Date.MONTH:
                return _t('This month');
                break;
            case App.utility.Date.LAST_30_DAYS:
                return _t('Last 30 days');
                break;
            case App.utility.Date.PREV_MONTH:
                return _t('Previous month');
                break;
            case App.utility.Date.LAST_60_DAYS:
                return _t('Last 60 days');
                break;
            case App.utility.Date.LAST_3_MONTH:
                return _t('Last 3 month');
                break;
            case App.utility.Date.LAST_6_MONTH:
                return _t('Last 6 month');
                break;
            case App.utility.Date.LAST_12_MONTH:
                return _t('Last 12 month');
                break;
            case App.utility.Date.YEAR:
                return _t('This year');
                break;
            case App.utility.Date.PREV_YEAR:
                return _t('Previous year');
                break;
        }
    },

    getDescription: function(s) {
        if (s['type'] == App.utility.Date.CUSTOM) {
            return sprintf('%(periodDesc)s', { periodDesc : this.getPeriodDescription(s)});
        } else {
            return sprintf('%(typeDesc)s', { typeDesc : this.getTypeDescription(s) });
        }
    },

    getFieldDescription: function(s) {
        if (s['type'] == App.utility.Date.CUSTOM) {
            return sprintf('%(periodDesc)s', { periodDesc : this.getPeriodDescription(s) });
        } else {
            return sprintf('%(typeDesc)s', { typeDesc : this.getTypeDescription(s) });
        }
    },

    getFilterDescription: function() {
        var s = this.state;

        if (s['type'] == App.utility.Date.CUSTOM) {
            return _t('Period')+': '+ this.getPeriodDescription(s);
        } else {
            return _t('Period')+': '+ this.getTypeDescription(s);
        }

        return null;
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/PbxesEditor.js
Ext.define('App.view.filter.PbxesEditor', {
    extend: 'App.view.filter.Editor',
    width: 400,
    onRenderContent: function(state) {
        this.pbxesField = Ext.create('App.view.filter.field.Pbx', {
            fieldLabel: _t('Pbxes'),
            labelAlign: 'left',
            labelWidth: 100,
            arrayValue: state['pbxes'],
            anchor: '100%'
        });
        
        this.containerEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            layout: 'anchor',
            items: [
                this.pbxesField
            ]
        });
        
        this.pbxesField.on('change', this.onTrunksFieldChange, this);
        this.callParent(arguments);
    },
    onTrunksFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['pbxes'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    setState: function(s) {
        this.state = s;
        this.conditionEl.update(this.getDescription(s));
        
        if (!this.contentRendered) {
            return;
        }
        
        this.ignoreStateEvents = true;
        this.pbxesField.setArrayValue(s['pbxes']);
        this.ignoreStateEvents = false;
    },
    getDefaultState: function() {
        var s = {
            'pbxes': new Array()
        }
        
        return s;
    },
    
    getPbxesDescription: function(pbxes) {
        var i, result = new Array();
        
        if( pbxes.length == 0 ) {
            return undefined;
        }
        
        for( i=0; i < pbxes.length; i++ ) {
            result.push(pbxes[i]['serial']);
        }
        
        if ( result.length > 0 ) {
            return result.join(', ');
        } else {
            return undefined;
        }      
    },
    
    getDescription: function(state) {
        var desc = this.getPbxesDescription(state['pbxes']);
        
        if (desc) {
            return desc;
        }
        
        return this.getAnyDescription();
    },
    
    getFieldDescription: function(state) {
        var desc = this.getPbxesDescription(state['pbxes']);
        
        if (desc) {
            return desc;
        }
        
        return this.getAnyFieldDescription();
    },
    
    getFilterDescription: function() {
        var desc = this.getPbxesDescription(this.state);
        
        if (desc) {
            return desc;
        }
        
        return null;
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/PbxesField.js
Ext.define('App.view.filter.PbxesField', {
    extend: 'App.view.filter.Field',
    alias : 'widget.filterPbxesField',
    anchor: '100%',
    labelAlign: 'top',
    fieldLabel: _t('Pbxes'),
    emptyText: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
        this.editor = Ext.create('App.view.filter.PbxesEditor', { target: this });
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/TrunksField.js
Ext.define('App.view.filter.TrunksField', {
    extend: 'App.view.filter.Field',
    alias : 'widget.filterTrunksField',
    anchor: '100%',
    labelAlign: 'top',
    fieldLabel: _t('Trunks'),
    emptyText: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
        this.editor = Ext.create('App.view.filter.TrunksEditor', { target: this });
    }
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/TrunksEditor.js
Ext.define('App.view.filter.TrunksEditor', {
    extend: 'App.view.filter.Editor',
    width: 400,
    onRenderContent: function(state) {
        this.trunksField = Ext.create('App.view.filter.field.Trunk', {
            fieldLabel: _t('Trunks'),
            labelAlign: 'left',
            labelWidth: 100,
            arrayValue: state['trunks'],
            anchor: '100%'
        });
        
        this.containerEl = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            layout: 'anchor',
            items: [
                this.trunksField
            ]
        });
        
        this.trunksField.on('change', this.onTrunksFieldChange, this);
        this.callParent(arguments);
    },
    onTrunksFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['trunks'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    hide: function(){
        if(this.trunksField.selectedView != undefined && this.trunksField.selectedView.isVisible()) {
            this.trunksField.hidePicker();
            return;
        } else {
            this.callParent();
        }
    },
    setState: function(s) {
        this.state = s;
        this.conditionEl.update(this.getDescription(s));
        
        if (!this.contentRendered) {
            return;
        }
        
        this.ignoreStateEvents = true;
        this.trunksField.setArrayValue(s['trunks']);
        this.ignoreStateEvents = false;
    },
    getDefaultState: function() {
        var s = {
            'trunks': new Array()
        }
        
        return s;
    },
    
    getTrunksDescription: function(trunks) {
        var i, result = new Array();
        
        if( trunks.length == 0 ) {
            return undefined;
        }
        
        for( i=0; i < trunks.length; i++ ) {
            result.push(trunks[i]['name']);
        }
        
        if ( result.length > 0 ) {
            return result.join(', ');
        } else {
            return undefined;
        }      
    },
    
    getDescription: function(state) {
        var desc = this.getTrunksDescription(state['trunks']);
        
        if (desc) {
            return sprintf('%(trunkDesc)s', { trunkDesc : desc });
        }
        
        return this.getAnyDescription();
    },
    
    getFieldDescription: function(state) {
        var desc = this.getTrunksDescription(state['trunks']);
        
        if (desc) {
            return sprintf('%(trunkDesc)s', { trunkDesc : desc });
        }
        
        return this.getAnyFieldDescription();
    },
    
    getFilterDescription: function() {
        var desc = this.getTrunksDescription(this.state['trunks']);
        
        if (desc) {
            return _t('Trunks')+': '+ desc;
        }
        
        return null;
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/BillField.js
Ext.define('App.view.filter.BillField', {
    extend: 'App.view.filter.Field',
    alias : 'widget.filterBillField',
    anchor: '100%',
    labelAlign: 'top',
    fieldLabel: _t('Talk time'),
    emptyText: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
        this.editor = Ext.create('App.view.filter.BillEditor', { target: this });
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/BillEditor.js
Ext.define('App.view.filter.BillEditor', {
    extend: 'App.view.filter.MinMaxEditor',
    mark: _t('Talk time'),
    getBillDescription: function(state) {
        var s = state;

        if( s['leftEnabled'] && s['rightEnabled'] ) {
            return sprintf(_t('%(lvalue)s < Talk time < %(rvalue)s'), { lvalue : s['leftValue'], rvalue: s['rightValue']});
        } else if ( s['leftEnabled'] ) {
            return sprintf(_t('Talk time > %(value)s'), { value : s['leftValue'] });
        } else if ( s['rightEnabled'] ) {
            return sprintf(_t('Talk time < %(value)s'), { value : s['rightValue'] });
        }

        return null;
    },
    getDescription: function(state) {
        var desc = this.getBillDescription(state);
        
        if (desc) {
            return sprintf('%(billDesc)s', {billDesc : desc});
        }
        
        return this.getAnyDescription();
    },
    
    getFieldDescription: function(state) {
        var desc = this.getBillDescription(state);
        
        if (desc) {
            return sprintf('%(billDesc)s', {billDesc : desc});
        }
        
        return this.getAnyFieldDescription();
    },
    
    getFilterDescription: function() {
        var desc = this.getBillDescription(this.state);
        
        if (desc) {
            return desc;
        }
        
        return null;
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/TypesField.js
Ext.define('App.view.filter.TypesField', {
    extend: 'App.view.filter.Field',
    alias : 'widget.filterTypesField',
    anchor: '100%',
    labelAlign: 'top',
    fieldLabel: _t('Services'),
    emptyText: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
        this.editor = Ext.create('App.view.filter.TypesEditor', { target: this });
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/TypesEditor.js
Ext.define('App.view.filter.TypesEditor', {
    extend: 'App.view.filter.Editor',
    width: 400,
    onRenderContent: function(state) {
        this.checkboxCallEl = Ext.create('Ext.form.field.Checkbox', {
            boxLabel: _t('Call'),
            checked: state['call']
        });
        this.checkboxVoicemailEl = Ext.create('Ext.form.field.Checkbox', {
            boxLabel: _t('Voicemail'),
            checked: state['voicemail']
        });
        this.checkboxFaxEl = Ext.create('Ext.form.field.Checkbox', {
            boxLabel: _t('Fax'),
            checked: state['fax']
        });
         
       this.checkboxGroup = Ext.create('Ext.form.CheckboxGroup', {
            renderTo: this.formEl,
            fieldLabel: _t('Services'),
            columns: 2,
            width: 376,
            vertical: true,
            margin: '0 0 -10',
            items: [
                this.checkboxCallEl,
                this.checkboxVoicemailEl,
                this.checkboxFaxEl
            ]
        });

        this.checkboxCallEl.on('change', this.onCheckboxCallElChange, this);
        this.checkboxVoicemailEl.on('change', this.onCheckboxVoicemailElChange, this);
        this.checkboxFaxEl.on('change', this.onCheckboxFaxElChange, this);
        this.callParent(arguments);
    },
    onCheckboxCallElChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['call'] = value;
        this.fireEvent('change', this.state);
    },
    onCheckboxVoicemailElChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['voicemail'] = value;
        this.fireEvent('change', this.state);
    },
    onCheckboxFaxElChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['fax'] = value;
        this.fireEvent('change', this.state);
    },
    setState: function(s) {
        this.state = s;
        this.conditionEl.update(this.getDescription(s));
        
        if (!this.contentRendered) {
            return;
        }
        
        this.ignoreStateEvents = true;
        this.checkboxCallEl.setValue(this.state['call']);
        this.checkboxVoicemailEl.setValue(this.state['voicemail']);
        this.checkboxFaxEl.setValue(this.state['fax']);
        this.ignoreStateEvents = false;
    },
    getDefaultState: function() {
        var s = new Object();
            s['call'] = false;
            s['voicemail'] = false;
            s['fax'] = false;

        return s;
    },
    
    /**
     * Get's a selected types.
     */
    getTypesDescription: function(state) {
        var types = new Array();
        
        if (state['call']) {
            types.push(_t('Calls'));
        }
        if (state['voicemail']) {
            types.push(_t('Voicemail'));
        }
        if (state['fax']) {
            types.push(_t('Faxes'));
        }
        
        return types;
    },
    
    getDescription: function(state) {
        var types = this.getTypesDescription(state);
       
        if (state['call'] && state['voicemail'] && state['fax']) {
            return this.getAnyDescription();
        }
        if (types.length > 0) {
            return sprintf("%(type)s", { type : types.join(', ') });
        }
        
        return this.getAnyDescription();
    },
    
    getFieldDescription: function(state) {
        var types = this.getTypesDescription(state);
        
        if (state['call'] && state['voicemail'] && state['fax']) {
            return this.getAnyFieldDescription();
        }
        if (types.length > 0) {
            return sprintf("%(type)s", { type : types.join(', ') });
        }
        
        return this.getAnyFieldDescription();
    },
    
    getFilterDescription: function() {
        var s = this.state;
        var types = this.getTypesDescription(s);
        
        if (s['call'] && s['voicemail'] && s['fax']) {
            return null;
        }
        if (types.length > 0) {
            return _t('Services')+': '+ types.join(', ');
        }
        
        return null;
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/CostField.js
Ext.define('App.view.filter.CostField', {
    extend: 'App.view.filter.Field',
    alias : 'widget.filterCostField',
    anchor: '100%',
    labelAlign: 'top',
    fieldLabel: _t('Cost'),
    emptyText: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
        this.editor = Ext.create('App.view.filter.CostEditor', { target: this });
    }
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/filter/CostEditor.js
Ext.define('App.view.filter.CostEditor', {
    extend: 'App.view.filter.MinMaxEditor',
    mark: _t('Cost'),
    defaultFieldConfig : {
        allowDecimals: true,
        decimalPrecision: 2,
        step: 0.1
    },
    getCostDescription: function(state) {
        var s = state;

        if( s['leftEnabled'] && s['rightEnabled'] ) {
            return sprintf(_t('%(lvalue)s < Cost < %(rvalue)s'), { lvalue : s['leftValue'], rvalue: s['rightValue']});
        } else if ( s['leftEnabled'] ) {
            return sprintf(_t('Cost > %(value)s'), { value : s['leftValue'] });
        } else if ( s['rightEnabled'] ) {
            return sprintf(_t('Cost < %(value)s'), { value : s['rightValue'] });
        }
        
        return null;
    },
    getDescription: function(state) {
        var desc = this.getCostDescription(state);
        
        if (desc) {
            return sprintf('%(description)s', { description : desc });
        }
        
        return this.getAnyDescription();
    },
    getFieldDescription: function(state) {
        var desc = this.getCostDescription(state);
        
        if (desc) {
            return sprintf('%(description)s', { description : desc });
        }
        
        return this.getAnyFieldDescription();
    },
    getFilterDescription: function() {
        var desc = this.getCostDescription(this.state);
        
        if (desc) {
            return desc;
        }
        
        return null;
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/navigation/Settings.js
Ext.define('App.view.navigation.Settings', {
    extend: 'Ext.window.Window',
    width: 300,
    title: _t('Settings'),
    modal: true,
    closable: false,
    resizable: false,
    closeAction: 'hide',
    bodyStyle: 'background: transparent; border: 0px;',
    padding: '5 10',
    period: App.utility.Date.LAST_2_WEEKS,
    slaPeriod: 20,
    missCallSecPeriod: 0,
    gradeOfAccuracy: 2,
    constructor: function() {
        this.addEvents('submit', 'cancel');
        this.callParent(arguments);
    },
    initComponent: function() {
        //Check period attr
        this.period = parseInt(this.period);
        this.slaPeriod = parseInt(this.slaPeriod);
        this.missCallSecPeriod = parseInt(this.missCallSecPeriod);
        this.gradeOfAccuracy = parseInt(this.gradeOfAccuracy);
        if (Ext.Array.indexOf(
                [
                    App.utility.Date.LAST_2_WEEKS, App.utility.Date.MONTH,
                    App.utility.Date.LAST_3_MONTH, App.utility.Date.LAST_6_MONTH,
                    App.utility.Date.LAST_12_MONTH
                ],
                this.period
            ) == -1 ) {
            this.period = App.utility.Date.LAST_2_WEEKS;
        }
        if (Ext.Array.indexOf([10,20,30,60,90,120],this.slaPeriod) == -1 ) {
            this.slaPeriod = 20;
        }
        if (this.missCallSecPeriod < 0 || this.missCallSecPeriod > 60 ) {
            this.missCallSecPeriod = 0;
        }
        this.descriptionCt = Ext.create('Ext.container.Container', {
            html: _t('Period')
        });

        this.periodsStore = Ext.create('Ext.data.Store', {
            fields: ['value', 'name'],
            data : [
                { value: App.utility.Date.LAST_2_WEEKS, name: _t('Last 2 weeks') },
                { value: App.utility.Date.MONTH, name: _t('Last month') },
                { value: App.utility.Date.LAST_3_MONTH, name: _t('Last 3 month') },
                { value: App.utility.Date.LAST_6_MONTH, name: _t('Last 6 month') },
                { value: App.utility.Date.LAST_12_MONTH, name: _t('Last 12 month') }
            ]
        });

        this.typesField = Ext.create('Ext.form.ComboBox', {
            store: this.periodsStore,
            queryMode: 'local',
            displayField: 'name',
            valueField: 'value',
            editable: false,
            margin: '10 0 10 0',
            value: this.period
        });

        this.slaDescriptionCt = Ext.create('Ext.container.Container', {
            html: _t('SLA, sec:')
        });

        this.slaTypesField = Ext.create('Ext.form.ComboBox', {
            store: Ext.create('Ext.data.Store', {
                fields: ['value', 'name'],
                data : [
                    { value: 10, name: "10" },
                    { value: 20, name: "20" },
                    { value: 30, name: "30" },
                    { value: 60, name: "60" },
                    { value: 90, name: "90" },
                    { value: 120, name: "120" }
                ]
            }),
            queryMode: 'local',
            displayField: 'name',
            valueField: 'value',
            editable: false,
            margin: '10 0 10 0',
            value: this.slaPeriod
        });

        this.missCallSecPeriodDescriptionCt = Ext.create('Ext.container.Container', {
            html: _t('Missed calls min seconds:')
        });
        this.missCallSecPeriodField = Ext.create('Ext.form.Number', {
            editable: true,
            allowDecimals: false,
            margin: '10 0 10 0',
            value: this.missCallSecPeriod,
            maxValue: 60,
            minValue: 0
        });

        this.gradeOfAccuracyDescriptionCt = Ext.create('Ext.container.Container', {
            html: _t('Decimal places number in Cost')
        });
        this.gradeOfAccuracyField = Ext.create('Ext.form.Number', {
            editable: true,
            allowDecimals: false,
            margin: '10 0 0 0',
            value: this.gradeOfAccuracy,
            maxValue: 4,
            minValue: 1
        });

        this.formCmp = Ext.create('Ext.form.Panel', {
            labelAlign: 'top',
            layout: 'anchor',
            defaults: {
                anchor: '100%'
            },
            border: false,
            style: 'background: transparent;',
            bodyStyle: 'background: transparent;',
            items: [
                this.descriptionCt,
                this.typesField,
                this.slaDescriptionCt,
                this.slaTypesField,
                this.missCallSecPeriodDescriptionCt,
                this.missCallSecPeriodField,
                this.gradeOfAccuracyDescriptionCt,
                this.gradeOfAccuracyField
            ]
        });


        this.submitButton = Ext.create('Ext.button.Button', {
            text: _t('Save')
        });

        this.cancelButton = Ext.create('Ext.button.Button', {
            text: _t('Cancel')
        });

        //Add elements
        this.items = [
            this.formCmp
        ];

        this.buttons = [
            this.submitButton,
            this.cancelButton
        ];

        this.submitButton.on('click', this.onSubmitButtonClick, this);
        this.cancelButton.on('click', this.onCancelButtonClick, this);
        this.on('show', this.onSettingsWindowShow, this);
        this.on('hide', this.onSettingsWindowHide, this);

        this.callParent(arguments);
    },

    onSettingsWindowShow: function() {
        if(!this.KeyMapOnEsc) {
            this.KeyMapOnEsc = new Ext.util.KeyMap(Ext.getBody(), [{
               key: Ext.EventObject.ESC,
               defaultEventAction: 'preventDefault',
               scope: this,
               fn: this.onCancelButtonClick
            }]);
        } else {
            this.KeyMapOnEsc.enable();
        }
    },

    onSettingsWindowHide: function() {
        this.KeyMapOnEsc.disable();
    },

    close: function() {
        // Verifies that mask has been removed.
        this.getEl().unmask();

        this.callParent(arguments);
    },

    /**
     * Fires when user clicks to a Submit button, we should invoke an submit event and show loading mask.
     */
    onSubmitButtonClick: function() {
        this.period = this.typesField.getValue();
        this.slaPeriod = this.slaTypesField.getValue();

        //Prevent wrong values [0..60]
        if(this.missCallSecPeriodField.getValue()==null)
            this.missCallSecPeriodField.setValue(0);
        if (this.missCallSecPeriodField.getValue()>60)
            this.missCallSecPeriodField.setValue(60);

        this.missCallSecPeriod = this.missCallSecPeriodField.getValue();
        this.gradeOfAccuracy = this.gradeOfAccuracyField.getValue();

        this.getEl().mask(_t('Please wait...')+' '+_t('Saving...'));
        this.fireEvent('submit', this.typesField.getValue(), this.slaTypesField.getValue(), this.missCallSecPeriodField.getValue(), this.gradeOfAccuracyField.getValue());
    },

    /**
     * Fires when user clicks to a Cancel button, we should just close a window.
     */
    onCancelButtonClick: function() {
        this.typesField.setValue(this.period);
        this.close();
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/navigation/Informer.js
Ext.define('App.view.navigation.Informer', {
    extend: 'Ext.view.View',
    alias: 'widget.navigationInformer',
    cls: 'w-navigation-informer',
    width: 277,
    initComponent: function() {

        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                'indent',
                'width'
            ]
        });

        this.tpl = new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="inf-bar-item"  style="margin-left:{indent}px; width: {width}px; background-position-x:-{indent}px;" >',
                '</div>',
            '</tpl>'
        );

        this.itemSelector = 'div.inf-bar-item';


        this.callParent(arguments);
    },
    afterRender: function() {
        var me = this;
        this.tip = Ext.create('Ext.tip.ToolTip', {
            target: this.el,
            delegate: this.itemSelector,
            trackMouse: true,
            renderTo: Ext.getBody(),
            listeners: {
                beforeshow: function updateTipBody(tip) {
                    tip.update(
                        me.getRecord(tip.triggerElement).get('minDate')+ 
                        ' '  +
                        me.getRecord(tip.triggerElement).get('maxDate')
                    );
                }
            }
        });
        this.callParent(arguments);
    },

    drawBar: function(range, min, max) {
        var coef = this.width / (max - min),
            data = new Array;




        for(var i=0; i < range.length; i++) {
            var width = Math.ceil( (range[i].maxId - range[i].minId) * coef );
            var indent = Math.ceil( (range[i].minId - min) * coef );
            data.push({
                indent: indent,
                width: width,
                minDate: Ext.Date.dateFormat(Ext.Date.parse(range[i].minDate, 'Y-m-d'), 'd/m/Y'),
                maxDate: Ext.Date.dateFormat(Ext.Date.parse(range[i].maxDate, 'Y-m-d'), 'd/m/Y')
            });
        }

        this.store.loadData(data);
    }
    
} );
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/Navigation.js
Ext.define('App.view.Navigation', {
    extend: 'Ext.Container',
    alias : 'widget.navigation',
    layout: {
        type: 'hbox',
        align: 'stretch'
    },
    height: 70,
    items: [
        {
            xtype: 'container',
            style: "background: url('misc/images/navigation-logo.png') 15px 5px no-repeat; height: 70px; width: 400px;",
            html: '&nbsp;'
        },
        {
            xtype: 'container',
            flex: 1,
            layout: {
                type: 'vbox',
                align: 'stretch'
            },
            padding: '0 15px 0 0',
            items: [
                {
                    xtype: 'container',
                    layout: 'hbox',
                    height: 40,
                    padding: '10px 0 0 0',
                    items: [
                        {
                            xtype: 'container',
                            flex: 1
                        },
                        {
                            xtype: 'container',
                            itemId: 'navigationUserName',
                            cls: 'w-navigation-name',
                            html: User.name
                        },
                        {
                            xtype: 'container',
                            cls: 'w-navigation-updatedb',
                            items: [
                                {
                                    xtype: 'container',
                                    itemId: 'navigationUserUpdatedb',
                                    autoEl: {
                                        tag: 'a',
                                        html: _t('Update')
                                    }
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            cls: 'w-navigation-settings',
                            items: [
                                {
                                    xtype: 'container',
                                    itemId: 'navigationUserSettings',
                                    autoEl: {
                                        tag: 'a',
                                        html: _t('Settings')
                                    }
                                }
                            ]
                        }
                    ]
                },
                {
                    xtype: 'container',
                    layout: 'hbox',
                    height: 30,
                    hidden: isRemoteMode(),
                    items: [
                        {
                            xtype: 'container',
                            flex: 1
                        },
                        {
                            xtype: 'container',
                            itemId: 'navigationProgressLeftDate',
                            cls: 'w-navigation-progress-date',
                            html: ''
                        },
                        {
                            xtype: 'navigationInformer'
                        },
                        {
                            xtype: 'container',
                            itemId: 'navigationProgressRightDate',
                            cls: 'w-navigation-progress-date',
                            html: ''
                        }
                    ]
                }
            ]
        }
    ]
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/Viewer.js
Ext.define('App.view.Viewer', {
    extend: 'Ext.Container',
    alias : 'widget.viewer',
    layout: {
        type: 'card',
        align : 'stretch'
    },
    activeItem: 0,
    items: [
        {
            xtype: 'viewerTable'
        },
        {
            xtype: 'viewerChart'
        },
        {
            xtype: 'viewerError'
        }
    ]
});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/Filter.js
Ext.define('App.view.Filter', {
    extend: 'Ext.Container',
    alias : 'widget.filter',
    margin: '5 0 0 0',
    layout: 'fit',
    items: [
        {
            xtype: 'form',
            itemId: "filterForm",
            id: 'filter-form',
            frame: true,
            title: _t('Filter'),
            animCollapse: false,
            collapsible: true,
            items: [
                {
                    xtype: 'container',
                    layout: 'column',
                    items: [
                        {
                            xtype: 'container',
                            columnWidth: 0.25,
                            layout: 'anchor',
                            style: 'padding: 5px 5px 0px 5px;',
                            items: [
                                {
                                    xtype: 'filterDestinationField',
                                    itemId: 'filterDestinationField'
                                },
                                {
                                    xtype: 'filterTypesField',
                                    itemId: 'filterTypesField'
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            columnWidth: 0.25,
                            layout: 'anchor',
                            style: 'padding: 5px 10px 0px 5px;',
                            items: [
                                {
                                    xtype: 'filterCostField',
                                    itemId: 'filterCostField'
                                },
                                {
                                    xtype: 'filterTagsField',
                                    itemId: 'filterTagsField'
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            columnWidth: 0.25,
                            layout: 'anchor',
                            style: 'padding: 5px 10px 0px 5px;',
                            items: [
                                {
                                    xtype: 'filterBillField',
                                    itemId: 'filterBillField'
                                },
                                {
                                    xtype: 'filterPeriodField',
                                    itemId: 'filterPeriodField'
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            columnWidth: 0.25,
                            layout: 'anchor',
                            style: 'padding: 5px 5px 0px 5px;',
                            items: [
                                {
                                    xtype: 'filterTrunksField',
                                    itemId: 'filterTrunksField',
                                    disabled: true
                                },
                                {
                                    xtype: 'filterPbxesField',
                                    itemId: 'filterPbxesField',
                                    disabled: true
                                }
                            ]
                        }

                    ]
                }
            ],
            bbar: {
                xtype: 'container',
                height: 37,
                items: [
                    {
                        xtype: 'button',
                        itemId: 'filterResetButton',
                        style: 'margin: 10px 0px 0px 5px; padding: 2px 10px;',
                        text: _t('Reset')
                    },
                    {
                        xtype: 'button',
                        itemId: 'filterApplyButton',
                        style: 'margin: 10px 0px 0px 5px; padding: 2px 10px;',
                        text: _t('Apply')
                    }   
                ]
            }
        }
    ]
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/view/Reports.js
Ext.define('App.view.Reports', {
    extend: 'Ext.Container',
    alias : 'widget.reports',
    cls: 'w-reports',
    layout: 'column',
    initComponent: function() {
        this.pickerButton = Ext.create('App.view.viewport.PickerButton', {
            margin: '0 0 0 0',
            width: 140,
            text: _t('Predefined Filters')
        });

        this.items = [
            {
                xtype: 'container',
                cls: 'w-reports-label',
                html: ''
            },
            this.pickerButton,
            {
                xtype: 'viewportButton',
                itemId: 'viewerReportSaveButton',
                width: 140,
                margin: '0 0 0 10',
                text: _t('Save')
            },
            {
                xtype: 'viewerExportButton'
            }
        ]
        
        this.picker = Ext.create('App.view.reports.Picker', {
            target: this.pickerButton
        });

        this.pickerButton.on('click', this.onPickerButtonClick, this);
        this.callParent(arguments);
    },
    onPickerButtonClick: function() {
        this.picker.show();
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/controller/viewer/Table.js
Ext.define('App.controller.viewer.Table', {
    extend: 'Ext.app.Controller',
    refs: [
        {
            ref: 'viewerCnt',
            selector: 'viewer'
        },
        {
            ref: 'tablePanel',
            selector: 'viewerTable'
        }
    ],
    init: function() {
        var self = this;

        this.type = 1;
        this.reportId = 0;
        this.simpleStore = Ext.data.StoreManager.lookup('SimpleEvents');
        this.groupedStore = Ext.data.StoreManager.lookup('GroupedEvents');

        this.simpleStore.on('guaranteedrange', function() {
            self.onStoreGuaranteedRange.call(self, self.simpleStore);
        }, this);
        this.groupedStore.on('guaranteedrange', function() {
            self.onStoreGuaranteedRange.call(self, self.groupedStore);
        }, this);

        this.callParent(arguments);
    },

    setSorters: function(sorters){
        if (this.type == 1)  {
           this.simpleStore.setBuilderSorters(sorters);
        } else if (this.type == 2) {
            this.groupedStore.setBuilderSorters(sorters);
        }
    },
    setState: function(state) {
        this.type = state.type;
        this.setSorters(state.sorters);
    },

    getState: function() {
        var state = new Object();
        state['type'] = this.type;
        state['sorters'] = this.getCurrentSorters();
        return state;
    },

    getCurrentSorters: function(){
        if (this.type == 1)  {
           return this.simpleStore.getBuilderSorters();
        } else if (this.type == 2) {
            return this.groupedStore.getBuilderSorters();
        }
        return undefined;
    },

    getCurrentStore: function() {
        if (this.type == 1)  {
           return this.simpleStore;
        } else if (this.type == 2) {
            return this.groupedStore;
        }
        return undefined;
    },

    /**
     * Methods that ...
     */
    report: function(grouping, metric, filter) {
        var groupingChange = false;

        // TODO: More simple way from Report contoroller with additional arguments to report filterChange & groupingChange
        if (this.previosGrouping) {
            if (this.previosGrouping.length != grouping.length) {
                groupingChange = true;
            } else {
                var i=0;

                for (i=0; i < grouping.length; i++) {
                    if (this.previosGrouping[i] != grouping[i]) {
                        groupingChange = true;
                        break;
                    }
                }
            }
        }

        this.previosFilter = filter;
        this.previosGrouping = grouping;

        if (grouping.length == 0 ) {
            this.type = 1;
        } else {
            this.type = 2;
        }

        if (this.type == 1) {
            return this.reportSimple(filter);
        } else {
            return this.reportGrouped(grouping, metric, filter);
        }
    },

    reportPlainWithCurrentConditions: function(callback, scope) {
        this.plainReportStore = this.getCurrentStore();
        this.plainReportTotal = this.plainReportStore.getTotalCount();
        this.plainReportRows = [];
        this.plainReportCallback = callback;
        this.plainReportScope = scope;

        if (this.plainReportTotal > 500000) {
            this.plainReportTotal = 500000;
        }

        var step = 100000;
        var total = this.plainReportTotal;
        var seq = Promise.resolve();
        var self = this;

        for (var start = 0; start < total; start += step) {
            (function (start) {
                seq = seq.then(function(){
                    return self.loadEvents(start, step);
                });
            })(start);
        }
    },

    loadEvents: function(start, step) {
        var store = this.plainReportStore;
        var self = this;
        var operation = new Ext.data.Operation();
        operation.start = start;
        operation.limit = step;
        if (start + step > this.plainReportTotal) {
            operation.limit = this.plainReportTotal - start;
        }

        return new Promise(function(resolve){
            store.getProxy()[self.type==1?'readSimple':'readGrouped'](operation, function(result){
                self.onReportPlainDataFetched(result);
                resolve(result);
            });
        });
    },

    onReportPlainDataFetched: function(result) {
        this.plainReportRows = this.plainReportRows.concat(result.getRecords());





        if (this.plainReportRows.length >= this.plainReportTotal) {
            var rows = this.plainReportRows;
            var store = this.plainReportStore;
            var columns = this.getTablePanel().columns;

            // Data is ready we should fire needed event











            result = {
                headers: [],
                rows: [],
                summaries: []
            };
            var renderers = [];

            // Generate headers and summaries
            for (var i = 0; i < columns.length; i++) {
                var column = columns[i];

                if (column.identy === 'NUMBERER' || column.hidden) {
                    continue;
                }

                result.headers.push(column.text);

                if (Ext.isFunction(column.exportRenderer)) {
                    renderers.push({index: column.dataIndex, renderer: column.exportRenderer});
                } else if (Ext.isFunction(column.render)) {
                    renderers.push({index: column.dataIndex, renderer: column.renderer, skipTags: true});
                } else {
                    renderers.push({index: column.dataIndex, renderer: function(v) { return v; }});
                }

                if (Ext.isFunction(column.summaryRenderer)) {
                    this.plainReportStore.summaries.skipTags = true;
                    result.summaries.push(column.summaryRenderer(this.plainReportStore.summaries));
                } else {
                    result.summaries.push("");
                }
            }

            var tempRow = {};

            // Generate rows
            for (var c = 0; c < rows.length; c++) {
                var row = new Array(renderers.length);
                for (var r = 0; r < renderers.length; r++) {
                    if (rows[c]['data'].hasOwnProperty(renderers[r].index)) {
                        row[r] = renderers[r].renderer(rows[c]['data'][renderers[r].index], tempRow, rows[c]);
                    }
                }

                result.rows.push(row);
            }

            this.plainReportRows = [];
            var callback = this.plainReportCallback;
            var scope = this.plainReportScope ? this.plainReportScope : this;

            callback.call(scope, result);
        }
    },

    reportSimple: function(filter) {


        this.reportId++;

        var columns = this.getSimpleMetricColumns();
        var builderColumns = this.getBuilderColumnsByIdenties(columns);
        var builderSummaries = this.getBuilderSummariesByIdenties(columns);
        var builderSorters = this.simpleStore.getBuilderSorters() ? this.simpleStore.getBuilderSorters() : this.getBuilderDefaultSorters();

        // Adding default columns
        columns.reverse();
        columns.push('NUMBERER');
        columns.reverse();

        builderSummaries.push( {name: 'COLUMN_TOTAL_EVENTS', as: 'TOTAL_EVENTS'} );

        // Modify store condition
        this.simpleStore.setReportId(this.reportId);
        this.simpleStore.setBuilderFilters(filter);
        this.simpleStore.setBuilderColumns(builderColumns);
        this.simpleStore.setBuilderSummaries(builderSummaries);
        this.simpleStore.setBuilderSorters(builderSorters);

        // Clear store results
        this.getTablePanel().clearStore();

        // Clear view results
        this.getTablePanel().clearView();

        // Modify table columns
        this.getTablePanel().clearColumns(columns, 'simple', this.getCurrentSorters());

        // Refresh store
        this.simpleStore.guaranteeRange(0, this.simpleStore.pageSize - 1);
    },

    reportGrouped: function(grouping, metric, filter) {
        this.reportId++;

        var columns = this.getGroupedMetricColumns(grouping, metric);
        var builderColumns = this.getBuilderColumnsByIdenties(columns);
        var builderGroupings = this.getBuilderGroupingsByIdenties(columns);
        var builderSorters = this.getBuilderGroupingsSortersByIdenties(columns);
        var builderSummaries = this.getBuilderSummariesByIdenties(columns);
        var builderSummariesType = 'simple';

        // Define summaries type
        var i;

        for (i=0; i < columns.length; i++) {
            if (columns[i] == "GROUP_USER_COMM_FROM" || columns[i] == "GROUP_USER_COMM_TO" || columns[i] == "GROUP_GROUP_COMM_FROM" || columns[i] == "GROUP_GROUP_COMM_TO") {
                builderSummariesType = 'extended';
                break;
            }
        }


        // Modify store condition
        this.groupedStore.setReportId(this.reportId);
        this.groupedStore.setBuilderFilters(filter);
        this.groupedStore.setBuilderColumns(builderColumns);
        this.groupedStore.setBuilderGroupings(builderGroupings);
        this.groupedStore.setBuilderSorters(builderSorters);
        this.groupedStore.setBuilderSummaries(builderSummaries);
        this.groupedStore.setBuilderSummariesType(builderSummariesType);

        // Clear store results
        this.getTablePanel().clearStore();

        // Clear view results
        this.getTablePanel().clearView();

        // Modify table columns
        this.getTablePanel().clearColumns(columns, 'grouped');

        // Refresh store
        this.groupedStore.guaranteeRange(0, this.groupedStore.pageSize - 1);
    },

    /**
     * Fires when user change a columns
     */
    onTableColumnsChange: function(columns) {
        if (this.type == 1) {
            return this.reportSimple(this.previosFilter, columns);
        } else {
            return this.reportGrouped(this.previosFilter, this.previosGrouping, columns);
        }
    },
    /**
     * Fires when simple or grouped store was loaded,
     * we should verify for empty results and show notofication.
     */
    onStoreGuaranteedRange: function(store) {
        var viewer;

        if (store.getTotalCount() < 1) {
            viewer = this.getController('Viewer');
            viewer.setErrorState('ERR_EMPTYRESULTS');
            return;
        } else {
            viewer = this.getController('Viewer');
            viewer.setExportButtonEnabled(true);
        }
    },

    getBuilderColumnsByIdenties: function(identies) {
        return this.getViewerController().getBuilderColumnsByIdenties(identies);
    },

    getBuilderGroupingsByIdenties: function(identies) {
        return this.getViewerController().getBuilderGroupingsByIdenties(identies);
    },

    getBuilderDefaultSorters: function() {
        return this.getViewerController().getBuilderDefaultSorters();
    },

    getBuilderGroupingsSortersByIdenties: function(identies) {
        return this.getViewerController().getBuilderGroupingsSortersByIdenties(identies);
    },

    getBuilderSummariesByIdenties: function(identies) {
        return this.getViewerController().getBuilderSummariesByIdenties(identies);
    },

    getGroupedMetricColumns: function(grouping, metric) {
        return this.getViewerController().getGroupedMetricColumns(grouping, metric);
    },

    getSimpleMetricColumns: function() {
        return this.getViewerController().getSimpleMetricColumns();
    },

    getViewerController: function() {
        return this.getController("Viewer");
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/controller/viewer/chart/Transformer.js
/**
 * Class gets data from DB and transforms it to data for charts
 *
 * User: Artyom Trityak
 * Date: 1/4/12
 * Time: 2:45 PM
 */
Ext.define('App.controller.viewer.chart.Transformer', {
    extend: 'Ext.app.Controller',
    mixins: {
        observable: 'Ext.util.Observable'
    },

    options: {
        currentReportId: false,
        transformedChartsData: {
            CHART_LINE: false,
            CHART_AREA: false,
            CHART_PIE: false,
            CHART_BAR: false,
            CHART_COLUMN: false
        }
    },

    init: function() {
        this.addEvents(
            'chartDataTransformed',
            '_chartDataReceived',
            'error'
        );
        this.on('_chartDataReceived', this._transformData, this);

        this.callParent(arguments);
    },

    transform: function(options) {
        if (!options.hasOwnProperty('grouping') || options.grouping.length === 0) {
            this.fireEvent('error', 'NO_GROUPING');
            return false;
        }
        if (options.grouping.length > 1 || options.grouping[0] === 'USERS' || options.grouping[0] === 'GROUPS') {
            this.fireEvent('error', 'NOT_SUPPORTED_GROUPING');
            return false;
        }

        if (this.options.currentReportId !== options.reportId) {
            for (var key in this.options.transformedChartsData) {
                this.options.transformedChartsData[key] = false;
            }
        }
        if (this.options.transformedChartsData[options.activeChart] === false ||
            this.options.transformedChartsData[options.activeChart][options.activeMetric] === undefined) {

            this._getData(options);
        } else {
            this.fireEvent('chartDataTransformed', {
                data: this.options.transformedChartsData[options.activeChart][options.activeMetric],
                chartType: options.activeChart
            });
        }
    },

    _getData: function(options) {
        var query = this._createQuery(options);
        if (query === false) {
            return false;
        }

        App.storage.Storage.fetchAsync(query, function(data, queryId) {


            if (data.length === 0) {
                this.fireEvent('error', 'NO_DATA');
            } else if(data.length < 1000) {
                this.fireEvent('_chartDataReceived', {
                    reportId: options.reportId,
                    data: data,
                    activeChart: options.activeChart,
                    activeMetric: options.activeMetric
                });
            } else {
                this.fireEvent('error', 'TOO_MANY_RECORDS');
            }
        }, this);
    },

    _transformData: function(options) {
        /*...Profit!*/
        var transformedData = [];

        //TODO: transform data to needed format and delete =
        transformedData = options.data;

        if (this.options.transformedChartsData[options.activeChart] === false) {
            this.options.transformedChartsData[options.activeChart] = {};
        }
        this.options.transformedChartsData[options.activeChart][options.activeMetric] = transformedData;
        this.options.currentReportId = options.reportId;

        //TODO: remove testDataToCheck
        this.fireEvent('chartDataTransformed', {
            data: this.options.transformedChartsData[options.activeChart][options.activeMetric],
            chartType: options.activeChart,
            testDataToCheck: this.options.transformedChartsData
        });
    },

    _createQuery: function(options) {
        var currentMetric = options.metric[options.activeMetric];

        var columnsAndGrouping = this.getGroupedMetricColumns(options.grouping, [currentMetric]);

        if (options.activeChart == 'CHART_PIE' && currentMetric == 'BILL') {
            Ext.Array.remove(columnsAndGrouping, 'TOTAL_RING')
        }

        var builderColumns = this.getBuilderColumnsByIdenties(columnsAndGrouping);
        var builderGroupings = this.getBuilderGroupingsByIdenties(columnsAndGrouping);
        var builderSorters = this.getBuilderGroupingsSortersByIdenties(columnsAndGrouping);


        var columns = [];
        for (var i in builderColumns) {
            columns.push({
                name: builderColumns[i]['name'],
                as: builderColumns[i]['as'] + '_CHART_VAL'
            });
        }

        var grouping = [];
        var sort = [];
        for (var i in builderGroupings) {
            grouping.push({
                name: builderGroupings[i]['name'],
                as: 'GROUP_' + builderGroupings[i]['as'] + "_CHART_GROUPING"
            });
            sort.push({
                field: 'GROUP_' + builderGroupings[i]['as'] + "_CHART_GROUPING",
                dest: 'ASC'
            });
        }


        /*for (var index in columnsAndGrouping) {
            if (columnsAndGrouping[index].indexOf('GROUP_') !== -1) {
                grouping.push({
                    name: columnsAndGrouping[index].replace(/^GROUP_/, 'GROUP_BY_'),
                    as: columnsAndGrouping[index] + "_CHART_GROUPING"
                });
                sort.push({
                    field: columnsAndGrouping[index] + "_CHART_GROUPING",
                    dest: 'ASC'
                });
            } else {
                columns.push({
                    name: 'COLUMN_' + columnsAndGrouping[index],
                    as: columnsAndGrouping[index] + '_CHART_VAL'
                });
            }
        }*/

        if (columns.length === 0) {
            columns = undefined;
        }
        if (sort.length === 0) {
            sort = undefined;
        }

        var queryObject ={
            filters: options.filters,
            getTotalRows: false,
            columns: columns,
            grouping: grouping,
            sort: sort
        };



        var query = App.storage.Storage.getBuilder().build(queryObject);



        return query;
    },

    getBuilderColumnsByIdenties: function(identies) {
        return this.getViewerController().getBuilderColumnsByIdenties(identies);
    },

    getBuilderGroupingsByIdenties: function(identies) {
        return this.getViewerController().getBuilderGroupingsByIdenties(identies);
    },

    getBuilderDefaultSorters: function() {
        return this.getViewerController().getBuilderDefaultSorters();
    },

    getBuilderGroupingsSortersByIdenties: function(identies) {
        return this.getViewerController().getBuilderGroupingsSortersByIdenties(identies);
    },

    getBuilderSummariesByIdenties: function(identies) {
        return this.getViewerController().getBuilderSummariesByIdenties(identies);
    },

    getGroupedMetricColumns: function(grouping, metric) {
        return this.getViewerController().getGroupedMetricColumns(grouping, metric);
    },

    getSimpleMetricColumns: function() {
        return this.getViewerController().getSimpleMetricColumns();
    },

    getViewerController: function() {
        return this.getController("Viewer");
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/controller/viewer/Chart.js
/**
 * Charts controller.
 * @method report : executable method for generating charts
 *
 * User: Artyom Trityak
 * Date: 1/4/12
 * Time: 1:39 PM
 */
Ext.define('App.controller.viewer.Chart', {
    mixins: {
        observable: 'Ext.util.Observable'
    },
    requires: [
        'App.controller.viewer.chart.Transformer',
        'App.view.viewer.Chart'
    ],
    refs: [
        {
            ref: 'viewerChartMetricSwitcher',
            selector: '#viewerChartMetricSwitcher'
        },
        {
            ref: 'viewerChartContainerChart',
            selector: '#viewerChartContainerChart'
        }

    ],

    options: {
        mask: false
    },
    isLabelVisible: false,

    extend: 'Ext.app.Controller',

    init: function() {
        this.options.mask = new Ext.LoadMask(this.getViewerChartContainerChart().getEl(), {msg: _t('Please wait...')});
        this.getController("viewer.chart.Transformer").on('chartDataTransformed', this._createView, this);
        this.getController("viewer.chart.Transformer").on('error', this._createErrorView, this);

        this.callParent(arguments);
    },

    report: function(groupingState, metricState, filterState, activeChart, reportId, activeMetric) {
        activeMetric = activeMetric === undefined ? 0 : activeMetric;



        this.options.mask.show();
        var options = {
            reportId: reportId,
            filters: filterState,
            grouping: groupingState,
            metric: metricState,
            activeChart: activeChart,
            activeMetric: activeMetric
        };

        this.getController("viewer.chart.Transformer").transform(options);
    },

    _createView: function(options) {
        options = options || {chartType: 'CHART_COLUMN', data: []};
        options.isLabelVisible = this.isLabelVisible;




        this.getViewerChartContainerChart().removeAll();
        var chartInstance = App.view.viewer.chart.ChartView.create(options);
        if (chartInstance.canDraw() === true) {
            this.getViewerChartContainerChart().add(chartInstance);
            this.getController('Viewer').setExportButtonEnabled(true);
        } else {
            this._createErrorView(chartInstance.getReason());
            delete chartInstance;
        }
        this.options.mask.hide();
    },

    _createErrorView: function(type) {
        this.getController("Viewer").setErrorState(type);
        this.options.mask.hide();
    },
    'export': function(){
        var chartCmp = this.getViewerChartContainerChart().down('chart');
        if (chartCmp && chartCmp.surface){
            App.utility.ImageExporter.self.generate({
                type: 'image/png',
                onerror: function(config){
                    Ext.create('App.view.bootstrap.ErrorConnection',{
                      initComponent: function() {
                            this.renderTo = Ext.getBody();
                            this.renderTpl = [
                                sprintf('<span class="message">%(message)s %(url)s</span>', {
                                  message : _t('Unable to load url'),
                                  url:config.url
                                })
                            ];
                            this.renderSelectors = {
                                messageEl: 'span.message'
                            }
                            this.layoutOnShow = Ext.create('Ext.util.MixedCollection');
                            this.callParent(arguments);
                        },
                        afterRender: function() {
                            var me = this;
                            setTimeout(function(){me.hide();},5000);
                            me.el.on('click',function(){me.hide();});
                        }

                    }).show();
                }
            }, chartCmp.surface);
        }
    }

});
// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/controller/Report.js
Ext.define('App.controller.Report', {
    extend: 'Ext.app.Controller',
    refs: [

        // Filter refs
        {
            ref: 'filterDestinationField',
            selector: '#filterDestinationField'
        },
        {
            ref: 'filterCostField',
            selector: '#filterCostField'
        },
        {
            ref: 'filterBillField',
            selector: '#filterBillField'
        },
        {
            ref: 'filterPeriodField',
            selector: '#filterPeriodField'
        },
        {
            ref: 'filterTypesField',
            selector: '#filterTypesField'
        },
        {
            ref: 'filterTrunksField',
            selector: '#filterTrunksField'
        },
        {
            ref: 'filterPbxesField',
            selector: '#filterPbxesField'
        },
        {
            ref: 'filterTagsField',
            selector: '#filterTagsField'
        },
        {
            ref: 'filterForm',
            selector: '#filterForm'
        },
        {
            ref: 'filterContainer',
            selector: 'filter'
        },
        {
            ref: 'filterResetButton',
            selector: '#filterResetButton'
        },
        {
            ref: 'filterApplyButton',
            selector: '#filterApplyButton'
        },
        {
            ref: 'filterSaveButton',
            selector: '#viewerReportSaveButton'
        },
        {
            ref: 'reportPicker',
            selector: '#viewerReportPicker'
        }
    ],
    init: function() {
        var self = this;

        // Filter validation
        this.trunksProxy = App.storage.Storage.proxyTrunks;
        this.pbxesProxy = App.storage.Storage.proxyPbxes;

        this.getFilterResetButton().on('click', this.onFilterReset, this);
        this.getFilterApplyButton().on('click', this.onFilterApply, this);
        this.getFilterSaveButton().on('click',this.onFilterSave, this);

        this.trunksProxy.readCount(this.onTrunksCountLoaded, this);
        this.pbxesProxy.readCount(this.onPbxesCountLoaded, this);

        this.setFilterState(this.getDefaultFilterState());

        // Define filter view heights
        this.filterHeight = this.getFilterContainer().getHeight();
        this.filterCollapsedHeight = 26;

        this.getFilterForm().getHeader().el
                            .on('click', this.onFilterFormHeaderDblClick, this);
        this.getFilterForm().on('collapse', this.onFilterFormCollapse, this);
        this.getFilterForm().on('expand', this.onFilterFormExpand, this);

        // Reports events
        this.getReportPicker().on('selectReport', this.onSelectReport, this);
        this.getReportPicker().on('deleteReport', this.onDeleteReport, this);
        this.getReportPicker().on('fetchPersonalReports', this.onFetchPersonalReports, this);
        this.getReportPicker().on('fetchSharedReports', this.onFetchSharedReports, this);

        // Automatically load default data
        this.ignoreFilterCollapse = true;
        this.callParent(arguments);
    },

    // ---

    /**
     * Fires when we process results, here we should update a description
     */
    onReport: function(grouping, metric, filter) {
        if (!this.ignoreFilterCollapse && !this.getFilterForm().collapsed) {
            this.collapseFilter();
        }

        this.ignoreFilterCollapse = false;
        this.getFilterForm().setTitle(this.getGroupingDescription(grouping) + " <span style=\"color:#333; font-weight: 400;\">" + this.getFilterDescription() + "</span>");
        this.pbxesProxy.readCount(this.onPbxesCountLoaded, this);
    },

    // ---

    /**
     * Fires when user is clicked to "Save this Report" button.
     */
    onFilterSave: function() {
        this.saveDialog = Ext.create('App.view.reports.Save');
        this.saveDialog.on('submit', this.onSaveDialogSubmit, this);
        this.saveDialog.on('cancel', this.onSaveDialogCancel, this);
        this.saveDialog.show();
    },

    /**
     * Fires when user clicked to Submit button at Save Dialog Window.
     */
    onSaveDialogSubmit: function(report) {
        this.saveDialog.showSavingState();
        report['name'] = report['name'].replace(/</g, "&lt;");
        report['name'] = report['name'].replace(/>/g, "&gt;");
        report['name'] = report['name'].replace(/\"/g, "&quot;");
        report['description'] = report['description'].replace(/</g, "&lt;");
        report['description'] = report['description'].replace(/>/g, "&gt;");
        report['description'] = report['description'].replace(/\"/g, "&quot;");

        // Prepare states
        var state = new Object();

        state['filter'] = this.getFilterState();
        state['grouping'] = this.getGroupingState();
        state['metric'] = this.getMetricState();
        state['view'] = this.getViewState();
        state['chart'] = this.getChartState();
        state['table'] = this.getTableState();

        report['filter'] = Ext.encode(state);
        report['share'] = report['share'] ? 'shared' : 'private';

        this.savingReport = report;
        this.saveReport();
    },

    /**
     * Makes a request to server to save report.
     */
    saveReport: function(necessary) {
        var report = this.savingReport;

        Ext.Ajax.request({
        	url: '../../api/v1/CDRView/Filters/',
            method: 'post',
            params: {
            	name: report['name'],
            	description: report['description'],
            	shared: ((report['share'] == 'private')? 0: 1),
            	filter: report['filter']
            },
            success: this.onSaveReportSuccess,
            failure: this.onSaveReportFailure,
            scope: this
        });
    },

    /**
     * Fires when request was completed successfully, we should handle a response.
     */
    onSaveReportSuccess: function(response) {
        this.getController('Viewport').processResponse(response.responseText, this.onSaveReportDecoded, this.onSaveReportFailure, this);
    },

    /**
     * Fires when response is valid, we should invoke a reports picker that reports has been successfully loaded.
     */
    onSaveReportDecoded: function(result, text) {
        this.saveDialog.close();
    },

    /**
     * Fires when request has been fail, another than 200 http code was respond,
     * we should show a dialog and retry after a timeout.
     */
    onSaveReportFailure: function(response) {
        this.getController('Viewport').fireEvent('connectionError', this.onSaveReportRetry, this);
    },

    /**
     * Fires when response has try_again_later exception, we should repeat request to a server.
     */
    onSaveReportRetry: function(necessary) {
        this.saveReport(necessary);
    },

    /**
     * Fires when user clicks to Cancel button, we should just close a dialog.
     */
    onSaveDialogCancel: function() {
        this.saveDialog.close();
    },

    /**
     * Fires when user select a "Personal reports" category, we should mask application and waits for valid response.
     */
    onFetchPersonalReports: function(callback, scope) {
        this.fetchPersonalCallback = callback;
        this.fetchPersonalScope = scope;
        this.fetchPersonalReports();
    },

    /**
     * Makes a request to server for a personal reports.
     */
    fetchPersonalReports: function(necessary) {
        // Ajax
        Ext.Ajax.request({
            url: '../../api/v1/CDRView/Filters/?filter[shared]=0',
            method: 'get',
            success: this.onFetchPersonalReportsSuccess,
            failure: this.onFetchPersonalReportsFailure,
            scope: this
        });
    },

    /**
     * Fires when request for settings change was completed successfylly, we shouldd handle a response.
     */
    onFetchPersonalReportsSuccess: function(response) {
        this.getController('Viewport').processResponse(response.responseText, this.onFetchPersonalReportsDecoded, this.onFetchPersonalReportsFailure, this);
    },

    /**
     * Fires when response is valid, we should invoke a reports picker that reports has been successfully loaded.
     */
    onFetchPersonalReportsDecoded: function(result, text) {
        this.getReportPicker().fireEvent('fetchedPersonalReports', this.decodeReportsResult(result));
    },

    /**
     * Fires when request has been fail, another than 200 http code was respond,
     * we should show a dialog and retry after a timeout.
     */
    onFetchPersonalReportsFailure: function(response) {
        this.getController('Viewport').fireEvent('connectionError', this.onFetchPersonalReportsRetry, this);
    },

    /**
     * Fires when response has try_again_later exception, we should repeat request to a server.
     */
    onFetchPersonalReportsRetry: function(necessary) {
        this.fetchPersonalReports(necessary);
    },


    /**
     * Fires when user select a "Shared reports" category, we should mask application and waits for valid response.
     */
    onFetchSharedReports: function(callback, scope) {
        this.fetchSharedCallback = callback;
        this.fetchSharedScope = scope;
        this.fetchSharedReports();
    },

    /**
     * Makes a request to server for a Shared reports.
     */
    fetchSharedReports: function(necessary) {
        // Ajax
        Ext.Ajax.request({
        	url: '../../api/v1/CDRView/Filters/?filter[shared]=1',
            method: 'get',
            success: this.onFetchSharedReportsSuccess,
            failure: this.onFetchSharedReportsFailure,
            scope: this
        });
    },

    /**
     * Fires when request for settings change was completed successfylly, we should handle a response.
     */
    onFetchSharedReportsSuccess: function(response) {
        this.getController('Viewport').processResponse(response.responseText, this.onFetchSharedReportsDecoded, this.onFetchSharedReportsFailure, this);
    },

    /**
     * Fires when response is valid, we should invoke a reports picker that reports has been successfully loaded.
     */
    onFetchSharedReportsDecoded: function(result, text) {
        this.getReportPicker().fireEvent('fetchedSharedReports', this.decodeReportsResult(result));
    },

    /**
     * Fires when request has been fail, another than 200 http code was respond,
     * we should show a dialog and retry after a timeout.
     */
    onFetchSharedReportsFailure: function(response) {
        this.getController('Viewport').fireEvent('connectionError', this.onFetchSharedReportsRetry, this);
    },

    /**
     * Fires when response has try_again_later exception, we should repeat request to a server.
     */
    onFetchSharedReportsRetry: function(necessary) {
        this.fetchSharedReports(necessary);
    },

    /**
     * Decodes a reports that was fetched from server
     */
    decodeReportsResult: function(reports) {
        var out = new Array;

        if(reports && reports.type == 'result' && reports.result && reports.result.total > 0 && reports.result.records){
            for(var i = 0; i < reports.result.records.length; i++){
            	var report = reports.result.records[i];
                var obj = new Object;
                obj.id = report['id'];
                obj.user = report['uid'];
                obj.name = report['name'];
                obj.description = report['description'];
                obj.state = Ext.JSON.decode(report['filter']);
                obj.deletable = true;
                out.push(obj);
            }
        }

        return out;
    },

    /**
     * Fires when user select one of a prepared, shared or personal reports.
     */
    onSelectReport: function(report) {
        var s = report.get('state');

        this.setViewState(s['view']);
        this.setFilterState(s['filter']);
        this.setGroupingState(s['grouping']);
        this.setMetricState(s['metric']);

        if (s.view == 'TABLE') {
            this.setTableState(s);
        } else {
            this.setChartState(s);
        }

        this.onFilterApply();

        this.name = report.get('name');
        // not available
        // this.periodFilterName = FilterPeriodField.getTypeDescription(s.filter.period.type);
        this.periodFilterName = this.getFilterPeriodField().value;
    },

    /**
     * Fires when user deletes a shared or personal report, we should mask application and waits for valid response.
     */
    onDeleteReport: function(report) {
        this.deletingReport = report;

        Ext.Msg.confirm('Confirmation', sprintf('Delete %(reportName)s report ?', { reportName: report.get('name') }), this.onDeleteReportConfirmed, this);
    },

    /**
     * Fires when user has confirmed report delete action.
     */
    onDeleteReportConfirmed: function(button) {
        if (button == 'yes') {
            Ext.getBody().mask(_t('Please wait...')+' '+_t('Deleting...'));
            this.deleteReport();
        }
    },

    /**
     * Makes a request to server to delete a report.
     */
    deleteReport: function(necessary) {
        // Ajax
        var id = this.deletingReport.get('id');

        Ext.Ajax.request({
            url: '../../api/v1/CDRView/Filters/' + id + '/',
            method: 'delete',
            success: this.onDeleteReportSuccess,
            failure: this.onDeleteReportFailure,
            scope: this
        });
    },

    /**
     * Fires when request for settings change was completed successfully, we should handle a response.
     */
    onDeleteReportSuccess: function(response) {
        this.getController('Viewport').processResponse(response.responseText, this.onDeleteReportDecoded, this.onDeleteReportFailure, this);
    },

    /**
     * Fires when response is valid, we should hide loader.
     */
    onDeleteReportDecoded: function(result, text) {
        Ext.getBody().unmask();
    },

    /**
     * Fires when request has been fail, another than 200 http code was respond,
     * we should show a dialog and retry after a timeout.
     */
    onDeleteReportFailure: function(response) {
        this.getController('Viewport').fireEvent('connectionError', this.onDeleteReportRetry, this);
    },

    /**
     * Fires when response has try_again_later exception, we should repeat request to a server.
     */
    onDeleteReportRetry: function(necessary) {
        this.deleteReport(necessary);
    },

    // Filter events for layouting
    onFilterFormHeaderDblClick: function() {
        if(this.getFilterForm().collapsed) {
            this.expandFilter();
        } else {
            this.collapseFilter();
        }
    },

    onFilterFormCollapse: function() {
        this.getFilterContainer().setHeight(this.filterCollapsedHeight);

        // Show filters link at Description
        // this.getDescriptionContainer().showFiltersLink();
    },
    onFilterFormExpand: function() {
        this.getFilterContainer().setHeight(this.filterHeight);

        // Hide filters link at Description
        // this.getDescriptionContainer().hideFiltersLink();
    },

    collapseFilter: function() {
        this.getFilterForm().collapse();
        this.getFilterContainer().setHeight(this.filterCollapsedHeight);
    },
    expandFilter: function() {
        this.getFilterForm().expand();
        this.getFilterContainer().setHeight(this.filterHeight);
    },

    // Filter private events

    onTrunksCountLoaded: function(count) {
        if (count > 0) {
            this.getFilterTrunksField().setDisabled(false);
        }
    },

    onPbxesCountLoaded: function(count) {
        if (count > 1) {
            this.getFilterPbxesField().setDisabled(false);
        }
    },

    onFilterReset: function() {
        var mask = new Ext.LoadMask(this.getFilterForm().getEl(), { msg:_t('Please wait...')} );
            mask.show();
        var self = this;
        var callback = function() {
            this.setFilterState(this.getDefaultFilterState());
            mask.hide();
        }

        setTimeout( function() { callback.call(self) }, 500 );
    },

    onFilterApply: function() {
        // reset personal/shared report info
        this.name = '';
        this.periodFilterName = '';
        this.getController('Viewer').onFilterChange.call(this.getController('Viewer'), this.getFilterState());
    },


    // Filter methods

    setFilterState: function(s) {
        this.getFilterDestinationField().setState(s['destination']);
        this.getFilterCostField().setState(s['cost']);
        this.getFilterBillField().setState(s['bill']);
        this.getFilterPeriodField().setState(s['period']);
        this.getFilterTypesField().setState(s['types']);
        this.getFilterTrunksField().setState(s['trunks']);
        this.getFilterTagsField().setState(s['tags']);
        this.getFilterPbxesField().setState(s['pbxes']);
    },

    getDefaultFilterState: function() {
        var s = new Object();

        s['destination'] = this.getFilterDestinationField().getDefaultState();
        s['cost'] = this.getFilterCostField().getDefaultState();
        s['bill'] = this.getFilterBillField().getDefaultState();
        s['period'] = this.getFilterPeriodField().getDefaultState();
        s['types'] = this.getFilterTypesField().getDefaultState();
        s['trunks'] = this.getFilterTrunksField().getDefaultState();
        s['tags'] = this.getFilterTagsField().getDefaultState();
        s['pbxes'] = this.getFilterPbxesField().getDefaultState();

        return s;
    },

    getFilterState: function() {
        var s = new Object();

        s['destination'] = this.getFilterDestinationField().getState();
        s['cost'] = this.getFilterCostField().getState();
        s['bill'] = this.getFilterBillField().getState();
        s['period'] = this.getFilterPeriodField().getState();
        s['types'] = this.getFilterTypesField().getState();
        s['trunks'] = this.getFilterTrunksField().getState();
        s['tags'] = this.getFilterTagsField().getState();
        s['pbxes'] = this.getFilterPbxesField().getState();
        s['miss_call_sec_period'] = User['miss_call_sec_period'];

        return s;
    },

    getFilterDescription: function() {
        var extra = new Array();
        var destination = this.getFilterDestinationField().getFilterDescription();
        var cost = this.getFilterCostField().getFilterDescription();
        var bill = this.getFilterBillField().getFilterDescription();
        var period = this.getFilterPeriodField().getFilterDescription();
        var types = this.getFilterTypesField().getFilterDescription();
        var trunks = this.getFilterTrunksField().getFilterDescription();
        var tags = this.getFilterTagsField().getFilterDescription();
        var pbxes = this.getFilterPbxesField().getFilterDescription();

        if (destination) {
            extra.push(destination);
        }
        if (cost) {
            extra.push(cost);
        }
        /**
        if (duration) {
            extra.push(duration);
        }
        **/
        if (bill) {
            extra.push(bill);
        }
        if (types) {
            extra.push(types);
        }
        if (trunks) {
            extra.push(trunks);
        }
        if (tags) {
            extra.push(tags);
        }
        if (pbxes) {
            extra.push(pbxes);
        }

        if (extra.length > 0) {
            return sprintf("%(period)s; %(extra)s.", { period: period, extra: extra.join('; ') });
        }

        return sprintf("%(period)s.", { period: period });
    },
    getGroupingDescription: function(columns) {
        return _t('Filter');
    },

    // Columns state

    /**
     * Sets a Table state (columns and sorting)
     */
    setTableState: function(state) {
        return this.getController('viewer.Table').setState(state.table);
    },

    /**
     * Gets a Table state (columns and sorting)
     */
    getTableState: function() {
        return this.getController('viewer.Table').getState();
    },

    /**
     * Sets a Chart state (...)
     */
    setChartState: function(state) {
        return;
        // return this.getController('viewer.Chart').setState(state.chart);
    },

    /**
     * Gets a Chart state
     */
    getChartState: function() {
        return {};
        // return this.getController('viewer.Chart').getState();
    },

    /**
     * Sets a current View State, viewer Table or viewer Chart.
     */
    setViewState: function(state) {
        return this.getController('Viewer').setViewState(state);
    },

    /**
     * Gets a current View State, viewer Table (table) or viewer Chart (chart).
     */
    getViewState: function() {
        return this.getController('Viewer').getViewState();
    },

    setGroupingState: function(state) {
        return this.getController('Viewer').setGroupingState(state);
    },

    getGroupingState: function() {
        return this.getController('Viewer').getGroupingState();
    },

    setMetricState: function(state) {
        return this.getController('Viewer').setMetricState(state);
    },

    getMetricState: function() {
        return this.getController('Viewer').getMetricState();
    }
});

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/controller/Navigation.js
Ext.define('App.controller.Navigation', {
    extend: 'Ext.app.Controller',
    refs: [
        {
            ref: 'userNameContainer',
            selector: '#navigationUserName'
        },
        {
            ref: 'userSettingsContainer',
            selector: '#navigationUserSettings'
        },
        {
            ref: 'userCloseContainer',
            selector: '#navigationUserClose'
        },
        {
            ref: 'userUpdatedbContainer',
            selector: '#navigationUserUpdatedb'
        },
        {
            ref: 'progressLeftDateContainer',
            selector: '#navigationProgressLeftDate'
        },
        {
            ref: 'progressRightDateContainer',
            selector: '#navigationProgressRightDate'
        },
        {
            ref: 'navigationInformerContainer',
            selector: 'navigationInformer'
        }
    ],
    init: function() {
        this.addEvents('redrawInformer');
        this.on('redrawInformer', this.onRedrawInformer, this);

        this.synchronizer = App.storage.Synchronizer;

        this.getUserSettingsContainer().getEl().on('click', this.onSettingsClick, this);
        this.getUserUpdatedbContainer().getEl().on('click', this.onUpdatedbClick, this);
        this.redrawInformer();

        this.callParent(arguments);
    },

    /**
     * Fires when user clicks "Update" link, we should start synchronization
     */
    onUpdatedbClick: function() {
        window.bootstrap.incrementalSynchronization();
    },

    /**
     * Fires when user clicks "Settings" link, we should show settings dialog.
     */
    onSettingsClick: function() {
        if (!this.settingsWindow) {
            this.settingsWindow = Ext.create('App.view.navigation.Settings', {
                period: User['period'],
                slaPeriod: User['sla_period'],
                missCallSecPeriod: User['miss_call_sec_period'],
                gradeOfAccuracy: User['grade_of_accuracy']
            });
            this.settingsWindow.on('submit', this.onSettingsSubmit, this);
        }
        this.settingsWindow.show();
    },

    /**
     * Fires when user wants to save a settings, we should show loader and send request to a server.
     */
    onSettingsSubmit: function(period, slaPeriod, missCallSecPeriod, gradeOfAccuracy) {
        this.saveSettingsPeriod = period;
        this.saveSettingsSlaPeriod = slaPeriod;
        this.saveSettingsMissCallSecPeriod = missCallSecPeriod;
        this.saveGradeOfAccuracy = gradeOfAccuracy;
        this.saveSettingsNecessary = false;
        this.saveSettings(this.saveSettingsPeriod, this.saveSettingsSlaPeriod, this.saveSettingsMissCallSecPeriod, this.saveGradeOfAccuracy);
    },

    /**
     * Saves user settings on a server.
     */
    saveSettings: function(period, slaPeriod, missCallSecPeriod, gradeOfAccuracy) {

        var params = {
            period: period,
            sla_period: slaPeriod,
            miss_call_sec_period: missCallSecPeriod,
            grade_of_accuracy: gradeOfAccuracy
        };

        Ext.Ajax.request({
            url: '../../api/v1/CDRView/Settings/',
            method: 'put',
            params: params,
            success: this.onSaveSettingsSuccess,
            failure: this.onSaveSettingsFailure,
            scope: this
        });
    },

    /**
     * Fires when request for settings change was completed successfylly, we should handle a response.
     */
    onSaveSettingsSuccess: function(response) {
        if (User['period'] != this.saveSettingsPeriod || User['sla_period'] != this.saveSettingsSlaPeriod || User['miss_call_sec_period'] != this.saveSettingsMissCallSecPeriod || User.gradeOfAccuracy != this.saveGradeOfAccuracy) {
            User['prev_period'] = User['period'];
            User['period'] = this.saveSettingsPeriod;
            User['sla_period'] = this.saveSettingsSlaPeriod;
            User['miss_call_sec_period'] = this.saveSettingsMissCallSecPeriod;
            User.gradeOfAccuracy = this.saveGradeOfAccuracy;

            window.bootstrap.incrementalSynchronization();
        }
        this.getController('Viewport').processResponse(response.responseText, this.onSaveSettingsDecoded, this.onSaveSettingsRetry, this);
    },

    /**
     * Fires when response is valid and we should handle a result.
     */
    onSaveSettingsDecoded: function(result, text) {
        this.settingsWindow.close();

        // TODO: Verify if data has for selected period if its doesn't we should sync selected period.
    },

    /**
     * Fires when request has been fail, another than 200 http code was respond,
     * we should show a dialog and retry after a timeout.
     */
    onSaveSettingsFailure: function(response) {
        this.getController('Viewport').fireEvent('connectionError', this.onSaveSettingsRetry, this);
    },

    /**
     * Fires when response has try_again_later exception, we should repeat request to a server.
     */
    onSaveSettingsRetry: function(necessary) {
        this.saveSettingsNecessary = necessary;
        this.saveSettings(this.saveSettingsPeriod, this.saveSettingsSlaPeriod, this.saveSettingsMissCallSecPeriod);
    },

    /**
     * Fires when user synchronize some events.
     */
    onRedrawInformer: function() {
        this.redrawInformer();
    },

    redrawInformer: function() {
        this.synchronizer.getEventsStatistics(this.onGetEventsStatisticsComplete, this);
    },

    onGetEventsStatisticsComplete: function(range) {
        if(App.storage.Synchronizer.getBackendMinDate() == null || App.storage.Synchronizer.getBackendMaxDate() == null) {
            return false;
        }

        this.getProgressLeftDateContainer().update(Ext.Date.dateFormat(Ext.Date.parse(App.storage.Synchronizer.getBackendMinDate(), 'Y-m-d H:i:s'), 'd/m/Y H:i'));
        this.getProgressRightDateContainer().update(Ext.Date.dateFormat(Ext.Date.parse(App.storage.Synchronizer.getBackendMaxDate(), 'Y-m-d H:i:s'), 'd/m/Y H:i'));

        this.getNavigationInformerContainer().drawBar(
            range,
            App.storage.Synchronizer.getBackendMinId(),
            App.storage.Synchronizer.getBackendMaxId()
        );
    }

} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/controller/Viewer.js
Ext.define('App.controller.Viewer', {
    extend: 'Ext.app.Controller',
    refs: [
        {
            ref: 'viewportContainer',
            selector: '#viewport'
        },
        {
            ref: 'viewerToolbarContainer',
            selector: '#viewerToolbar'
        },
        {
            ref: 'viewerToolbarHolder',
            selector: '#viewerToolbarHolder'
        },
        {
            ref: 'viewerColumnsContainer',
            selector: '#viewerColumnsContainer'
        },
        {
            ref: 'viewerContainer',
            selector: 'viewer'
        },
        {
            ref: 'viewerHolder',
            selector: '#viewerHolder'
        },
        {
            ref: 'viewerTableContainer',
            selector: 'viewerTable'
        },
        {
            ref: 'viewerChartContainer',
            selector: 'viewerChart'
        },
        {
            ref: 'viewerErrorContainer',
            selector: 'viewerError'
        },
        {
            ref: 'typeSwitcher',
            selector: '#viewerTypeSwitcher'
        },
        {
            ref: 'chartLabelSwitcher',
            selector: '#viewerChartLabelSwitcher'
        },
        {
            ref: 'fullPageButton',
            selector: 'viewerFullPage'
        },
        {
            ref: 'exportButton',
            selector: 'viewerExportButton'
        },
        {
            ref: 'groupingButton',
            selector: 'viewerGrouping'
        },
        {
            ref: 'metricButton',
            selector: 'viewerMetric'
        }
    ],
    init: function() {
        this.panoramState = 'NORMAL';
        this.viewState = 'TABLE';
        this.viewResultsState = 'TABLE';

        this.reportId = 0;
        this.periodId = 0;
        this.periodRange = false;
        this.tableReportId = 0;

        this.filterState = false;
        this.groupingState = this.getGroupingButton().getPicker().getState();
        this.tableMetricState = this.getMetricButton().getPicker().getState();
        this.chartMetricState = [this.getMetricButton().getPicker().getLastActiveRecordName()];

        this.getViewerErrorContainer().on('action', this.onErrorContainerAction, this);
        this.getTypeSwitcher().on('change',this.onViewChange, this);
        this.getChartLabelSwitcher().on('change',this.onChartLabelChange, this);
        this.getGroupingButton().on('change', this.onGroupingChange, this);
        this.getMetricButton().on('grpElClick', this.onGroupingLinkClick, this);
        this.getMetricButton().on('change', this.onMetricChange, this);
        this.getFullPageButton().on('click', this.onPanoramSwitch, this);
        this.getExportButton().on('click', this.onExportButtonClick, this);
        this.setExportButtonEnabled(false);
        this.on('incrementalSynchronization', this.onIncrementalSynchronization, this);
        this.callParent(arguments);
    },

    /**
     * Fires when application is lauched, we should load default results.
     */
    launch: function() {
        this.filterState = this.getController('Report').getFilterState();
        this.onVerifyFilterPeriod(this.filterState);
    },

    unSynchronizedSynchronize: function() {
        this.syncDialog = Ext.create('App.view.viewer.Sync');
        this.syncDialog.on('complete', this.onFilterSyncDialogComplete, this);
        this.syncDialog.on('terminated', this.onFilterSyncDialogTerminated, this);

        this.syncDialog.show();
        this.syncDialog.sync(this.syncPeriodDateFrom, this.syncPeriodDateTo);
    },

    onIncrementalSynchronization: function() {
        this.filterState = this.getController('Report').getFilterState();
        if (!parseInt(this.filterState['period']['type']) || parseInt(this.filterState['period']['type']) == parseInt(User['prev_period'])){
            //Update filter just in case previous user settings same as filter
            //This will no affect in case Update DB button pressed
            this.filterState['period']['type'] = parseInt(User['period']);
        }
        User['prev_period'] = undefined;
        this.getController('Report').setFilterState(this.filterState);
        this.onVerifyFilterPeriod(this.filterState);
    },

    /**
     * Fires when user clicks to a filter apply button.
     */
    onFilterChange: function(filter) {
        this.filterState = filter;
        this.onVerifyFilterPeriod(this.filterState);
    },

    /**
     * Fires when period has been verified, we should display results or show message that data is not fully synced.
     */
    onVerifiedFilterPeriod: function(complete, dayFrom, dayTo, dateFrom, dateTo) {
        // Statistics dont't fully completed, we should notify user
        if (!complete) {
            // Sets a periods properties for using its later when user clicks to sync link
            this.syncPeriodDayFrom = dayFrom;
            this.syncPeriodDayTo = dayTo;
            this.syncPeriodDateFrom = dateFrom;
            this.syncPeriodDateTo = dateTo;

            //non sync period
            this.unSynchronizedSynchronize();
            return;
        }

        this.report();
    },

    /**
     * Fires when user has been changed a grouping.
     */
    onGroupingChange: function(grouping) {
        this.getMetricButton().changeStatus(!!grouping.length);
        this.groupingState = grouping;
        this.report();
    },

    onGroupingLinkClick: function() {
        this.getGroupingButton().getPicker().show();
    },
    /**
     * Fires when user has been changed a metric.
     */
    onMetricChange: function(metric) {
        this.setMetricState(metric, true);
        this.report();
    },

    onViewChange: function(state) {
        this.viewResultsState = state;
        if (state == 'TABLE') {
            this.getMetricButton().getPicker().setMode('MULTI');
            this.setMetricState(this.getMetricState());
        } else {
            this.getMetricButton().getPicker().setMode('SINGLE');
            this.setMetricState([this.getMetricButton().getPicker().getLastActiveRecordName()]);
        }

        this.report();
    },
    onChartLabelChange: function(state , isLabelVisible) {
        this.getController('viewer.Chart').isLabelVisible = isLabelVisible;
        if (this.viewResultsState != 'TABLE'){
            this.report();
        }
    },
    report: function(silent) {
        var grouping = this.groupingState,
            metric = this.getMetricState(),
            filter = this.filterState,
            view = this.viewResultsState;

        if (view == 'TABLE' && this.viewState != view) {
            this.setTableState(view);

            if (this.tableReportId == this.reportId) {
                silent = true;
            }
        } else if (view.substr(0, 5) == 'CHART' && this.viewState != view) {
            var chartErr = this.getChartError(this.groupingState, this.chartMetricState, this.filterState);
            if(chartErr) {
                this.setErrorState(chartErr);
                return;
            }

            this.setChartState(view);
        }

        if (!silent) {
            this.reportId++;
        }

        this.getController("Report").onReport(grouping, metric, filter, view);

        if (this.viewState == 'TABLE') {
            this.tableReportId = this.reportId;
            this.getController('viewer.Table').report(grouping, metric, filter, view, this.reportId);
        } else if (this.viewState.substr(0, 5) == 'CHART') {
            this.getController('viewer.Chart').report(grouping, metric, filter, view, this.reportId);
        } else if (this.viewResultsState == 'TABLE') {
            this.tableReportId = this.reportId;
            this.setTableState();
            this.getController('viewer.Table').report(grouping, metric, filter, view, this.reportId);
        } else if (this.viewResultsState.substr(0, 5) == 'CHART') {
            this.setChartState();
            this.getController('viewer.Chart').report(grouping, metric, filter, view, this.reportId);
        }
    },
    setViewState: function(state) {
        if (this.viewState != state) {
            if (state.substr(0, 5) == 'CHART') {
                this.setChartState(state);
            } else {
                this.setTableState(state);
            }
        }

        if (this.getTypeSwitcher().getActiveItem() != state) {
            this.getTypeSwitcher().setActiveItem(state);
        }

        this.viewState = state;
    },
    getViewState: function() {
        return this.viewState;
    },
    setTableState: function(state) {
        if (state) {
            this.viewState = 'TABLE';
            this.viewResultsState = 'TABLE';
        } else if (this.viewState == this.viewResultsState) {
            return;
        }

        this.getViewerContainer().getLayout().setActiveItem(this.getViewerTableContainer());
        this.setExportButtonEnabled(false);
    },
    setChartState: function(state) {
        if (state) {
            this.viewState = state;
            this.viewResultsState = state;
        } else if (this.viewState == this.viewResultsState) {
            return;
        }

        this.getViewerContainer().getLayout().setActiveItem(this.getViewerChartContainer());
        this.setExportButtonEnabled(false);
    },
    setErrorState: function(type, config) {
        // Switch viewer layout to notification view

        this.viewState = 'error';
        this.getViewerContainer().getLayout().setActiveItem(this.getViewerErrorContainer());

        if (Ext.isFunction(this.getGroupingButton) && this.getGroupingButton().getPicker().getFirstStateName()){
            config = Ext.applyIf(config||{},{groupingStateName:this.getGroupingButton().getPicker().getFirstStateName()});
        }

        this.getViewerErrorContainer().setError(type, config);
        this.setExportButtonEnabled(false);
    },
    setExportButtonEnabled: function(enabled) {


        if (enabled)
        if (this.viewState.substr(0, 5) == 'CHART'){
            this.getExportButton().setText(_t('Export chart'));
        } else {
            this.getExportButton().setText(_t('Export'));
        }
        this.getExportButton().setEnabled(enabled);
    },
    onPanoramSwitch: function() {
        if (this.panoramState == 'FULL') {
            this.onExitTableFullView();
            return;
        }

        this.panoramState = 'FULL';

        var width = Ext.getBody().getWidth();
        var height = Ext.getBody().getHeight();

        if (width < 1240) {
            width = 1240;
        }

        this.panoramToolbar = Ext.create("Ext.container.Container", {
            height: 42,
            padding: '10',
            style: 'background:#ededed;',
            layout: 'fit'
        });

        this.panoramContainer = Ext.create("Ext.container.Container", {
            cls: 'full-view',
            anchor: '100%, -42',
            layout: 'fit'
        });

        this.panoramOverlay = Ext.create("Ext.container.Container", {
            floating: true,
            width: width,
            height: height,
            renderTo: Ext.getBody(),
            style: "background:#fff;z-index: 10000;",
            layout: 'anchor',
            items: [
                this.panoramToolbar,
                this.panoramContainer
            ]
        });

        Ext.EventManager.onWindowResize(this.onPanoramWindowResize, this);

        this.panoramFullPageText = this.getFullPageButton().getText();
        this.getFullPageButton().setText('<div class="w-viewer-fullscreen-collapse-button"></div>');

        this.getViewerToolbarHolder().remove(this.getViewerToolbarContainer(), false);
        this.getViewerHolder().remove(this.getViewerContainer(), false);

        this.panoramToolbar.add(this.getViewerToolbarContainer());
        this.panoramContainer.add(this.getViewerContainer());
    },

    onPanoramWindowResize: function() {
        var width = Ext.getBody().getWidth();
        var height = Ext.getBody().getHeight();

        if (width < 1240) {
            width = 1240;
        }

        if (this.panoramOverlay.getWidth() != width) {
            this.panoramOverlay.setWidth(width);
        }
        if (this.panoramOverlay.getHeight() != height) {
            this.panoramOverlay.setHeight(height);
        }
    },

    onExitTableFullView: function() {
        Ext.EventManager.removeResizeListener(this.alignEditor, this);

        this.panoramState = 'NORMAL';
        this.panoramOverlay.hide();
        this.panoramToolbar.remove(this.getViewerToolbarContainer(), false);
        this.panoramContainer.remove(this.getViewerContainer(), false);

        this.getFullPageButton().setText(this.panoramFullPageText);
        this.getViewerToolbarHolder().add(this.getViewerToolbarContainer());
        this.getViewerHolder().add(this.getViewerContainer());
    },


    onExportButtonClick: function() {
        if (this.getExportButton().disabled)
            return;
        if (this.viewResultsState == 'TABLE') {
            this.exportDialog = Ext.create("App.view.viewer.ExportDialog");
            this.exportDialog.on("export", this.onExportDialogExport, this);
            this.exportDialog.on("open", this.onExportDialogOpen, this);
            this.exportDialog.show();
        } else if (this.viewState != 'error'){
            this.getController('viewer.Chart')['export']();
        }



    },

    /**
     * We should generate data for xls applet generation.
     */
    onExportDialogExport: function(type) {
        this.exportType = type;
        this.exportDialog.setLoading(_t('Please wait...'));
        this.getController('viewer.Table').reportPlainWithCurrentConditions(this.onExportDialogReportGenerated, this);
    },

    onExportDialogReportGenerated: function(report) {
        var reportName = this.getController('Report').name || null;
        var reportPeriodFilterName = this.getController('Report').periodFilterName || null;
        report['name'] = reportName;
        report['periodFilterName'] = reportPeriodFilterName;
        if (this.exportType === 'csv') {
            App.storage.Storage.pushCSVGeneration(report, this.onExportDialogReportFileGenerated, this);
        } else {
            App.storage.Storage.pushXMLGeneration(report, this.onExportDialogReportFileGenerated, this);
        }
    },

    onExportDialogReportFileGenerated: function(result) {
        this.exportDialog.setLoading(false);
        this.exportDialog.close();
        return;
        this.exportDialogFilePath = result.file;
        this.exportDialog.switchToDownloadState(this.exportDialogFilePath);
    },

    onExportDialogOpen: function() {
        this.exportDialog.setLoading(_t('Please wait...'));
        App.storage.Storage.pushOpenFile(this.exportDialogFilePath, this.onExportDialogOpened, this);
    },

    onExportDialogOpened: function() {
        this.exportDialog.setLoading(false);
    },

    /**
     * Fires when user clicks to a apply button on a filter, we should verify statistics in database
     * and if it's complete we should show results.
     */
    onVerifyFilterPeriod: function(filter) {
        var self = this;
        var range = this.getFilterPeriodRange(filter);

        // Backend have events for selected period, we should verify is all statistics is complete
        var dayFrom = range['dayFrom'];
        var dayTo = range['dayTo'];
        var dateFrom = range['dateFrom'];
        var dateTo = range['dateTo'];

        var controller = function(statistics) {
            self.onVerifyFilterPeriodStatisticsFetched(statistics, dayFrom, dayTo, dateFrom, dateTo, self.onVerifiedFilterPeriod, self);
        }

        App.proxy.Synchronization.readStatisticsProper(dayFrom, dayTo, controller);
    },

    /**
     * Fires when statistics for filter period has been fetched from database, we should define if it's is complete.
     */
    onVerifyFilterPeriodStatisticsFetched: function(statistics, dayFrom, dayTo, dateFrom, dateTo, callback, scope) {
        scope = scope || this;

        // Verify if statistics is complete at all
        var i, day, a;
        var complete = true;

        for (day=dayFrom; day <= dayTo; day++) {
            a = false;

            for (i=0; i < statistics.length; i++) {
                if (day == parseInt(statistics[i]['DAY'])) {
                    if (statistics[i]['COMPLETE'] == '1') {
                        a = true;
                    }
                    break;
                }
            }

            if (!a) {
                complete = false;
                break;
            }
        }

        callback.call(scope, complete, dayFrom, dayTo, dateFrom, dateTo);
    },

    /**
     * Fires when user clicks on link in error widget.
     * @param error String
     * @param action String
     * @param param Object
     */
    onErrorContainerAction: function(error, action, param) {
        switch (action){
            case 'groupingclick':
                this.setGroupingState(param);
                this.onGroupingChange(param);
                break;
            case 'metricclick':
                this.setMetricState(param);
                this.onMetricChange(param);
                break;
        }
    },

    /**
     * Fires when synchronization is comleted, we should show results and redraw an informer.
     */
    onFilterSyncDialogComplete: function() {
        this.getController('Navigation').fireEvent('redrawInformer');
        this.report();
    },

    /**
     * Fires when user has terminated a synchronization, we should to redraw an informer.
     */
    onFilterSyncDialogTerminated: function() {
        this.getController('Navigation').fireEvent('redrawInformer');
    },

    getChartError: function(grouping, metric, filter) {
        if (grouping == undefined || grouping.length === 0) {
            //this.setErrorState('NO_GROUPING');
            return 'NO_GROUPING';
        }
        if (grouping.length > 1 || grouping[0] === 'USERS' || grouping[0] === 'GROUPS') {
            //this.setErrorState('NOT_SUPPORTED_GROUPING');
            return 'NOT_SUPPORTED_GROUPING';
        }
        return false;
    },

    setGroupingState: function(state) {
        this.groupingState = state;

        this.getMetricButton().changeStatus(!!this.groupingState.length);
        this.getGroupingButton().setState(state);
    },

    getGroupingState: function() {
        return this.groupingState;
    },

    setMetricState: function(state, silent) {
        if(this.viewResultsState == 'TABLE') {
            this.tableMetricState = state;
        } else {
            this.chartMetricState = state;
        }
        if(!silent) {
            this.getMetricButton().getPicker().setState(state);
        }
    },

    getMetricState: function() {
        if(this.viewResultsState == 'TABLE') {
            return this.tableMetricState;
        } else {
            return this.chartMetricState;
        }
    },

    getFilterPeriodRange: function(filter) {
        var dateFrom = false;
        var dateTo = false;
        var dateUtility = App.utility.Date;

        switch (filter['period']['type']) {
            case App.utility.Date.TODAY:
                //today
                dateFrom = dateUtility.getToday();
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.YESTERDAY:
                //yesterday
                dateFrom = dateUtility.getYesterday();
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.WEEK:
                //This week
                dateFrom = dateUtility.getThisWeek();
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.LAST_2_DAYS:
                //Last 2 days
                dateFrom = dateUtility.getLastNDays(2);
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.LAST_7_DAYS:
                //Last 7 days
                dateFrom = dateUtility.getLastNDays(7);
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.PREV_WEEK:
                //Prev week
                dateFrom = dateUtility.getPrevWeek();
                dateTo = dateUtility.getThisWeek();
                break;
            case App.utility.Date.LAST_2_WEEKS:
                //Last 2 weeks
                dateFrom = dateUtility.getToday();
                dateTo = dateUtility.getPrevWeek();
                break;
            case App.utility.Date.MONTH:
                //This month
                dateFrom = dateUtility.getThisMonth();
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.LAST_30_DAYS:
                //Last 30 days
                dateFrom = dateUtility.getLastNDays(30);
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.PREV_MONTH:
                //Prev month
                dateFrom = dateUtility.getPrevNMonth(1);
                dateTo = dateUtility.getThisMonth();
                break;
            case App.utility.Date.LAST_60_DAYS:
                //Last 60 days
                dateFrom = dateUtility.getLastNDays(60);
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.LAST_3_MONTH:
                //Last 3 months
                dateFrom = dateUtility.getPrevNMonth(3);
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.LAST_6_MONTH:
                //Last 3 months
                dateFrom = dateUtility.getPrevNMonth(6);
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.LAST_12_MONTH:
                //Last 12 months
                dateFrom = dateUtility.getPrevNMonth(12);
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.YEAR:
                //This year
                dateFrom = dateUtility.getThisYear();
                dateTo = dateUtility.getToday();
                break;
            case App.utility.Date.PREV_YEAR:
                //Prev year
                dateFrom = dateUtility.getPrevNYears(1);
                dateTo = dateUtility.getThisYear();
                break;
            case App.utility.Date.CUSTOM:
                //Custom
                dateFrom = filter['period']['fromDate'] + ' ' + filter['period']['fromTime']
                dateTo = filter['period']['toDate'] + ' ' + filter['period']['toTime']
                break;
        }

        var dayFromDate = Ext.Date.parse(dateFrom.substr(0, 10), "Y-m-d");
        var dayToDate = Ext.Date.parse(dateTo.substr(0, 10), "Y-m-d");
        var dayFromTime = parseInt(Ext.Date.format(dayFromDate, "U")) + parseInt(Ext.Date.format(dayFromDate, "Z"));
        var dayToTime = parseInt(Ext.Date.format(dayToDate, "U")) + parseInt(Ext.Date.format(dayToDate, "Z"));
        var dayFrom = dayFromTime / 86400;
        var dayTo = dayToTime / 86400;
        var range = {
            dateFrom: dateFrom,
            dateTo: dateTo,
            dayFromDate: dayFromDate,
            dayToDate: dayToDate,
            dayFrom: dayFrom,
            dayTo: dayTo
        }

        return range;
    },

    getBuilderColumnsByIdenties: function(identies) {
        var columns = new Array();
        var i, c, b;

        for (i=0; i < identies.length; i++) {
            b = this.getBuilderColumnsByIdenty(identies[i]);

            for (c=0; c < b.length; c++) {
                columns.push(b[c]);
            }
        }

        return columns;
    },

    getBuilderColumnsByIdenty: function(identy) {
        var columns = new Array();

        switch (identy) {
            // Simple Columns
            case 'DATE':
                columns.push({name: 'COLUMN_DATE', as: 'DATE'});
                break;
            case 'DURATION':
                columns.push({name: 'COLUMN_DURATION', as: 'DURATION'});
                break;
            case 'FROM':
                columns.push({name: 'COLUMN_FROM', as: 'FROM'}, {name: 'COLUMN_FROM_USER', as: 'FROM_USER'}, {name: 'COLUMN_FROM_NAME', as: 'FROM_NAME'});
                break;
            case 'FROM_GROUP':
                columns.push({name: 'COLUMN_FROM_GROUP', as: 'FROM_GROUP'});
                break;
            case 'TO':
                columns.push({name: 'COLUMN_TO', as: 'TO'}, {name: 'COLUMN_TO_USER', as: 'TO_USER'}, {name: 'COLUMN_TO_NAME', as: 'TO_NAME'});
                break;
            case 'TO_GROUP':
                columns.push({name: 'COLUMN_TO_GROUP', as: 'TO_GROUP'});
                break;
            case 'AREA':
                columns.push({name: 'COLUMN_COUNTRY', as: 'COUNTRY'}, {name: 'COLUMN_COUNTRY_AREA', as: 'COUNTRY_AREA'});
                break;
            case 'CLASS':
                columns.push({name: 'COLUMN_CLASS', as: 'CLASS'});
                break;
            case 'COST':
                columns.push({name: 'COLUMN_COST', as: 'COST'});
                break;
            case 'DIRECTION':
                columns.push({name: 'COLUMN_DIRECTION', as: 'DIRECTION'});
                break;
            case 'STATUS':
                // TODO When support for checks
                // columns.push({name: 'COLUMN_BILL', as: 'BILL'}, {name: 'COLUMN_DURATION', as: 'DURATION'});
                break;
            case 'BILL':
                columns.push({name: 'COLUMN_BILL', as: 'BILL'});
                break;
            case 'RING':
                columns.push({name: 'COLUMN_RING', as: 'RING'});
                break;
            case 'TRUNK':
                columns.push({name: 'COLUMN_TRUNK', as: 'TRUNK'});
                break;
            case 'PBX':
                columns.push({name: 'COLUMN_PBX', as: 'PBX'});
                break;
            case 'TAG':
                columns.push({name: 'COLUMN_TAG', as: 'TAG'});
                break;
            case 'SERVICE':
                columns.push({name: 'COLUMN_SERVICE', as: 'SERVICE'});
                break;
            case 'USERFIELD':
                columns.push({name: 'COLUMN_USERFIELD', as: 'USERFIELD'});
                break;
            case 'FAXDATA':
                columns.push({name: 'COLUMN_FAXDATA', as: 'FAXDATA'});
                break;

            // Grouped Columns
            case 'TOTAL_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_EVENTS', as: 'TOTAL_EVENTS'});
                break;
            case 'TOTAL_CALL_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_EVENTS_CALL', as: 'TOTAL_CALL_EVENTS'});
                break;
            case 'TOTAL_FAX_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_EVENTS_FAX', as: 'TOTAL_FAX_EVENTS'});
                break;
            case 'TOTAL_VOICEMAIL_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_EVENTS_VOICEMAIL', as: 'TOTAL_VOICEMAIL_EVENTS'});
                break;
            case 'TOTAL_LOCAL_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_LOCAL_EVENTS', as: 'TOTAL_LOCAL_EVENTS'});
                break;
            case 'TOTAL_INCOMING_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_INCOMING_EVENTS', as: 'TOTAL_INCOMING_EVENTS'});
                break;
            case 'TOTAL_OUTGOING_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_OUTGOING_EVENTS', as: 'TOTAL_OUTGOING_EVENTS'});
                break;
            case 'TOTAL_ANSWERED_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_ANSWERED_EVENTS', as: 'TOTAL_ANSWERED_EVENTS'});
                break;
            case 'TOTAL_ANSWERED_WITHIN_XX_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_ANSWERED_WITHIN_XX_EVENTS', as: 'TOTAL_ANSWERED_WITHIN_XX_EVENTS'});
                break;
            case 'TOTAL_ANSWERED_OVER_XX_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_ANSWERED_OVER_XX_EVENTS', as: 'TOTAL_ANSWERED_OVER_XX_EVENTS'});
                break;
            case 'TOTAL_NOT_ANSWERED_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_NOT_ANSWERED_EVENTS', as: 'TOTAL_NOT_ANSWERED_EVENTS'});
                break;
            case 'TOTAL_DURATION':
                columns.push({name: 'COLUMN_TOTAL_DURATION', as: 'TOTAL_DURATION'});
                break;
            case 'AVG_DURATION':
                columns.push({name: 'COLUMN_AVG_DURATION', as: 'AVG_DURATION'});
                break;
            case 'TOTAL_LOCAL_DURATION':
                columns.push({name: 'COLUMN_TOTAL_LOCAL_DURATION', as: 'TOTAL_LOCAL_DURATION'});
                break;
            case 'AVG_LOCAL_DURATION':
                columns.push({name: 'COLUMN_AVG_LOCAL_DURATION', as: 'AVG_LOCAL_DURATION'});
                break;
            case 'TOTAL_INCOMING_DURATION':
                columns.push({name: 'COLUMN_TOTAL_INCOMING_DURATION', as: 'TOTAL_INCOMING_DURATION'});
                break;
            case 'AVG_INCOMING_DURATION':
                columns.push({name: 'COLUMN_AVG_INCOMING_DURATION', as: 'AVG_INCOMING_DURATION'});
                break;
            case 'TOTAL_OUTGOING_DURATION':
                columns.push({name: 'COLUMN_TOTAL_OUTGOING_DURATION', as: 'TOTAL_OUTGOING_DURATION'});
                break;
            case 'TOTAL_BILL':
                columns.push({name: 'COLUMN_TOTAL_BILL', as: 'TOTAL_BILL'});
                break;
            case 'AVG_BILL':
                columns.push({name: 'COLUMN_AVG_BILL', as: 'AVG_BILL'});
                break;
            case 'TOTAL_LOCAL_BILL':
                columns.push({name: 'COLUMN_TOTAL_LOCAL_BILL', as: 'TOTAL_LOCAL_BILL'});
                break;
            case 'AVG_LOCAL_BILL':
                columns.push({name: 'COLUMN_AVG_LOCAL_BILL', as: 'AVG_LOCAL_BILL'});
                break;
            case 'TOTAL_INCOMING_BILL':
                columns.push({name: 'COLUMN_TOTAL_INCOMING_BILL', as: 'TOTAL_INCOMING_BILL'});
                break;
            case 'AVG_INCOMING_BILL':
                columns.push({name: 'COLUMN_AVG_INCOMING_BILL', as: 'AVG_INCOMING_BILL'});
                break;
            case 'TOTAL_OUTGOING_BILL':
                columns.push({name: 'COLUMN_TOTAL_OUTGOING_BILL', as: 'TOTAL_OUTGOING_BILL'});
                break;
            case 'AVG_OUTGOING_BILL':
                columns.push({name: 'COLUMN_AVG_OUTGOING_BILL', as: 'AVG_OUTGOING_BILL'});
                break;
            case 'TOTAL_RING':
                columns.push({name: 'COLUMN_TOTAL_RING', as: 'TOTAL_RING'});
                break;
            case 'AVG_RING':
                columns.push({name: 'COLUMN_AVG_RING', as: 'AVG_RING'});
                break;
            case 'TOTAL_COST':
                columns.push({name: 'COLUMN_TOTAL_COST', as: 'TOTAL_COST'});
                break;
            case 'TOTAL_CALL_COST':
                columns.push({name: 'COLUMN_TOTAL_COST_CALL', as: 'TOTAL_CALL_COST'});
                break;
            case 'TOTAL_FAX_COST':
                columns.push({name: 'COLUMN_TOTAL_COST_FAX', as: 'TOTAL_FAX_COST'});
                break;
            case 'AVG_COST':
                columns.push({name: 'COLUMN_AVG_COST', as: 'AVG_COST'});
                break;
            case 'AVG_CALL_COST':
                columns.push({name: 'COLUMN_AVG_COST_CALL', as: 'AVG_CALL_COST'});
                break;
            case 'AVG_FAX_COST':
                columns.push({name: 'COLUMN_AVG_COST_FAX', as: 'AVG_FAX_COST'});
                break;
        }

        return columns;
    },

    getBuilderGroupingsByIdenties: function(identies) {
        var grouping = new Array();
        var i, c, b;

        for (i=0; i < identies.length; i++) {
            b = this.getBuilderGroupingsByIdenty(identies[i]);

            for (c=0; c < b.length; c++) {
                grouping.push(b[c]);
            }
        }

        return grouping;
    },

    getBuilderGroupingsByIdenty: function(identy) {
        var grouping = new Array();

        switch (identy) {
            case 'GROUP_HOUR':
                grouping.push({name: 'GROUP_BY_HOUR', as: 'HOUR'});
                break;
            case 'GROUP_HOUR_OF_DAY':
                grouping.push({name: 'GROUP_BY_HOUR_OF_DAY', as: 'HOUR_OF_DAY'});
                break;
            case 'GROUP_DAY':
                grouping.push({name: 'GROUP_BY_DAY', as: 'DAY'});
                break;
            case 'GROUP_DAY_OF_WEEK':
                grouping.push({name: 'GROUP_BY_DAY_OF_WEEK', as: 'DAY_OF_WEEK'});
                break;
            case 'GROUP_WEEK':
                grouping.push({name: 'GROUP_BY_WEEK', as: 'WEEK'});
                break;
            case 'GROUP_MONTH':
                grouping.push({name: 'GROUP_BY_MONTH', as: 'MONTH'});
                break;
            case 'GROUP_MONTH_OF_YEAR':
                grouping.push({name: 'GROUP_BY_MONTH_OF_YEAR', as: 'MONTH_OF_YEAR'});
                break;
            case 'GROUP_YEAR':
                grouping.push({name: 'GROUP_BY_YEAR', as: 'YEAR'});
                break;
            case 'GROUP_USER':
                grouping.push({name: 'GROUP_BY_USER', as: 'USER'});
                break;
            case 'GROUP_GROUP':
                grouping.push({name: 'GROUP_BY_GROUP', as: 'USER_GROUP'});
                break;
            case 'GROUP_CLIENT':
                grouping.push({name: 'GROUP_BY_CLIENT', as: 'CLIENT'});
                break;
            case 'GROUP_COMPANY':
                grouping.push({name: 'GROUP_BY_COMPANY', as: 'COMPANY'});
                break;
            case 'GROUP_NUMBER':
                grouping.push({name: 'GROUP_BY_NUMBER', as: 'NUMBER'});
                break;
            case 'GROUP_SERVICE':
                grouping.push({name: 'GROUP_BY_SERVICE', as: 'SERVICE'});
                break;
            case 'GROUP_DIRECTION':
                grouping.push({name: 'GROUP_BY_DIRECTION', as: 'DIRECTION'});
                break;
            case 'GROUP_TRUNK':
                grouping.push({name: 'GROUP_BY_TRUNK', as: 'TRUNK'});
                break;
            case 'GROUP_TAG':
                grouping.push({name: 'GROUP_BY_TAG', as: 'TAG'});
                break;
            case 'GROUP_PBX':
                grouping.push({name: 'GROUP_BY_PBX', as: 'PBX'});
                break;
            case 'GROUP_COUNTRY':
                grouping.push({name: 'GROUP_BY_COUNTRY', as: 'COUNTRY'});
                break;
            case 'GROUP_CLASS':
                grouping.push({name: 'GROUP_BY_CLASS', as: 'CLASS'});
                break;
            // Hack from Communication of users (don't care about group_user_comm_from identy)
            case 'GROUP_USER_COMM_FROM':
                grouping.push({name: 'GROUP_BY_COMMUNICATION_OF_USERS', as: { from: 'USER_FROM', to: 'USER_TO'}});
                break;
            // Hack from Communication of groups (don't care about group_group_comm_from identy)
            case 'GROUP_GROUP_COMM_FROM':
                grouping.push({name: 'GROUP_BY_COMMUNICATION_OF_GROUPS', as: { from: 'GROUP_FROM', to: 'GROUP_TO'}});
                break;
        }

        return grouping;
    },

    getBuilderDefaultSorters: function() {
        return [{field: 'DATE', dest: 'DESC'}];
    },

    getBuilderGroupingsSortersByIdenties: function(identies) {
        var sorters = new Array();
        var i, c, b;

        for (i=0; i < identies.length; i++) {
            b = this.getBuilderGroupingsSortersByIdenty(identies[i]);

            for (c=0; c < b.length; c++) {
                sorters.push(b[c]);
            }
        }

        return sorters;
    },

    getBuilderGroupingsSortersByIdenty: function(identy) {
        var sorters = new Array();

        switch (identy) {
            case 'GROUP_HOUR':
                sorters.push({field: 'HOUR', dest: 'ASC'});
                break;
            case 'GROUP_HOUR_OF_DAY':
                sorters.push({field: 'HOUR_OF_DAY', dest: 'ASC'});
                break;
            case 'GROUP_DAY':
                sorters.push({field: 'DAY', dest: 'ASC'});
                break;
            case 'GROUP_DAY_OF_WEEK':
                sorters.push({field: 'DAY_OF_WEEK', dest: 'ASC'});
                break;
            case 'GROUP_WEEK':
                sorters.push({field: 'WEEK', dest: 'ASC'});
                break;
            case 'GROUP_MONTH':
                sorters.push({field: 'MONTH', dest: 'ASC'});
                break;
            case 'GROUP_MONTH_OF_YEAR':
                sorters.push({field: 'MONTH_OF_YEAR', dest: 'ASC'});
                break;
            case 'GROUP_YEAR':
                sorters.push({field: 'YEAR', dest: 'ASC'});
                break;
            case 'GROUP_USER':
                sorters.push({field: 'USER_NAME', dest: 'ASC'});
                break;
            case 'GROUP_GROUP':
                sorters.push({field: 'USER_GROUP_NAME', dest: 'ASC'});
                break;
            case 'GROUP_CLIENT':
                sorters.push({field: 'CLIENT_NAME', dest: 'ASC'});
                break;
            case 'GROUP_COMPANY':
                sorters.push({field: 'COMPANY_NAME', dest: 'ASC'});
                break;
            case 'GROUP_NUMBER':
                sorters.push({field: 'NUMBER', dest: 'ASC'});
                break;
            case 'GROUP_SERVICE':
                sorters.push({field: 'SERVICE', dest: 'ASC'});
                break;
            case 'GROUP_DIRECTION':
                sorters.push({field: 'DIRECTION', dest: 'ASC'});
                break;
            case 'GROUP_TRUNK':
                sorters.push({field: 'TRUNK', dest: 'ASC'});
                break;
            case 'GROUP_TAG':
                sorters.push({field: 'TAG', dest: 'ASC'});
                break;
            case 'GROUP_PBX':
                sorters.push({field: 'PBX', dest: 'ASC'});
                break;
            case 'GROUP_COUNTRY':
                sorters.push({field: 'COUNTRY', dest: 'ASC'});
                break;
            case 'GROUP_CLASS':
                sorters.push({field: 'CLASS', dest: 'ASC'});
                break;
            case 'GROUP_USER_COMM_FROM':
                sorters.push({field: 'USER_FROM_NAME', dest: 'ASC'});
                break;
            case 'GROUP_USER_COMM_TO':
                sorters.push({field: 'USER_TO_NAME', dest: 'ASC'});
                break;
            case 'GROUP_GROUP_COMM_FROM':
                sorters.push({field: 'GROUP_FROM_NAME', dest: 'ASC'});
                break;
            case 'GROUP_GROUP_COMM_TO':
                sorters.push({field: 'GROUP_TO_NAME', dest: 'ASC'});
                break;
        }

        return sorters;
    },


    getBuilderSummariesByIdenties: function(identies) {
        var columns = new Array();
        var i, c, b;

        for (i=0; i < identies.length; i++) {
            b = this.getBuilderSummariesByIdenty(identies[i]);

            for (c=0; c < b.length; c++) {
                columns.push(b[c]);
            }
        }

        return columns;
    },

    getBuilderSummariesByIdenty: function(identy) {
        var columns = new Array();

        switch (identy) {
            // Simple columns
            case 'DURATION':
                columns.push({name: 'COLUMN_TOTAL_DURATION', as: 'TOTAL_DURATION'});
                break;
            case 'COST':
                columns.push({name: 'COLUMN_TOTAL_COST', as: 'TOTAL_COST'});
                break;
            case 'BILL':
                columns.push({name: 'COLUMN_TOTAL_BILL', as: 'TOTAL_BILL'});
                break;
            case 'RING':
                columns.push({name: 'COLUMN_TOTAL_RING', as: 'TOTAL_RING'});
                break;

            // Grouped columns
            case 'TOTAL_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_EVENTS', as: 'TOTAL_EVENTS'});
                break;
            case 'TOTAL_CALL_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_EVENTS_CALL', as: 'TOTAL_CALL_EVENTS'});
                break;
            case 'TOTAL_FAX_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_EVENTS_FAX', as: 'TOTAL_FAX_EVENTS'});
                break;
            case 'TOTAL_VOICEMAIL_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_EVENTS_VOICEMAIL', as: 'TOTAL_VOICEMAIL_EVENTS'});
                break;
            case 'TOTAL_LOCAL_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_LOCAL_EVENTS', as: 'TOTAL_LOCAL_EVENTS'});
                break;
            case 'TOTAL_INCOMING_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_INCOMING_EVENTS', as: 'TOTAL_INCOMING_EVENTS'});
                break;
            case 'TOTAL_OUTGOING_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_OUTGOING_EVENTS', as: 'TOTAL_OUTGOING_EVENTS'});
                break;
            case 'TOTAL_ANSWERED_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_ANSWERED_EVENTS', as: 'TOTAL_ANSWERED_EVENTS'});
                break;
            case 'TOTAL_ANSWERED_WITHIN_XX_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_ANSWERED_WITHIN_XX_EVENTS', as: 'TOTAL_ANSWERED_WITHIN_XX_EVENTS'});
                break;
            case 'TOTAL_ANSWERED_OVER_XX_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_ANSWERED_OVER_XX_EVENTS', as: 'TOTAL_ANSWERED_OVER_XX_EVENTS'});
                break;
            case 'TOTAL_NOT_ANSWERED_EVENTS':
                columns.push({name: 'COLUMN_TOTAL_NOT_ANSWERED_EVENTS', as: 'TOTAL_NOT_ANSWERED_EVENTS'});
                break;
            case 'TOTAL_DURATION':
                columns.push({name: 'COLUMN_TOTAL_DURATION', as: 'TOTAL_DURATION'});
                break;
            case 'AVG_DURATION':
                columns.push({name: 'COLUMN_AVG_DURATION', as: 'AVG_DURATION'});
                break;
            case 'TOTAL_LOCAL_DURATION':
                columns.push({name: 'COLUMN_TOTAL_LOCAL_DURATION', as: 'TOTAL_LOCAL_DURATION'});
                break;
            case 'AVG_LOCAL_DURATION':
                columns.push({name: 'COLUMN_AVG_LOCAL_DURATION', as: 'AVG_LOCAL_DURATION'});
                break;
            case 'TOTAL_INCOMING_DURATION':
                columns.push({name: 'COLUMN_TOTAL_INCOMING_DURATION', as: 'TOTAL_INCOMING_DURATION'});
                break;
            case 'AVG_INCOMING_DURATION':
                columns.push({name: 'COLUMN_AVG_INCOMING_DURATION', as: 'AVG_INCOMING_DURATION'});
                break;
            case 'TOTAL_OUTGOING_DURATION':
                columns.push({name: 'COLUMN_TOTAL_OUTGOING_DURATION', as: 'TOTAL_OUTGOING_DURATION'});
                break;
            case 'TOTAL_BILL':
                columns.push({name: 'COLUMN_TOTAL_BILL', as: 'TOTAL_BILL'});
                break;
            case 'AVG_BILL':
                columns.push({name: 'COLUMN_AVG_BILL', as: 'AVG_BILL'});
                break;
            case 'TOTAL_LOCAL_BILL':
                columns.push({name: 'COLUMN_TOTAL_LOCAL_BILL', as: 'TOTAL_LOCAL_BILL'});
                break;
            case 'AVG_LOCAL_BILL':
                columns.push({name: 'COLUMN_AVG_LOCAL_BILL', as: 'AVG_LOCAL_BILL'});
                break;
            case 'TOTAL_INCOMING_BILL':
                columns.push({name: 'COLUMN_TOTAL_INCOMING_BILL', as: 'TOTAL_INCOMING_BILL'});
                break;
            case 'AVG_INCOMING_BILL':
                columns.push({name: 'COLUMN_AVG_INCOMING_BILL', as: 'AVG_INCOMING_BILL'});
                break;
            case 'TOTAL_OUTGOING_BILL':
                columns.push({name: 'COLUMN_TOTAL_OUTGOING_BILL', as: 'TOTAL_OUTGOING_BILL'});
                break;
            case 'AVG_OUTGOING_BILL':
                columns.push({name: 'COLUMN_AVG_OUTGOING_BILL', as: 'AVG_OUTGOING_BILL'});
                break;
            case 'TOTAL_RING':
                columns.push({name: 'COLUMN_TOTAL_RING', as: 'TOTAL_RING'});
                break;
            case 'AVG_RING':
                columns.push({name: 'COLUMN_AVG_RING', as: 'AVG_RING'});
                break;
            case 'TOTAL_COST':
                columns.push({name: 'COLUMN_TOTAL_COST', as: 'TOTAL_COST'});
                break;
            case 'TOTAL_CALL_COST':
                columns.push({name: 'COLUMN_TOTAL_COST_CALL', as: 'TOTAL_CALL_COST'});
                break;
            case 'TOTAL_FAX_COST':
                columns.push({name: 'COLUMN_TOTAL_COST_FAX', as: 'TOTAL_FAX_COST'});
                break;
            case 'AVG_COST':
                columns.push({name: 'COLUMN_AVG_COST', as: 'AVG_COST'});
                break;
            case 'AVG_CALL_COST':
                columns.push({name: 'COLUMN_AVG_COST_CALL', as: 'AVG_CALL_COST'});
                break;
            case 'AVG_FAX_COST':
                columns.push({name: 'COLUMN_AVG_COST_FAX', as: 'AVG_FAX_COST'});
                break;
        }

        return columns;
    },


    getGroupedMetricColumns: function(grouping, metric) {
        var columns = new Array();

        for (var i=0; i < grouping.length; i++) {
            switch(grouping[i]) {
                case 'HOUR':
                case 'HOUR_OF_DAY':
                case 'DAY':
                case 'DAY_OF_WEEK':
                case 'WEEK':
                case 'MONTH':
                case 'MONTH_OF_YEAR':
                case 'YEAR':
                case 'USER':
                case 'GROUP':
                case 'CLIENT':
                case 'COMPANY':
                case 'NUMBER':
                case 'TRUNK':
                case 'PBX':
                case 'TAG':
                case 'COUNTRY':
                case 'CLASS':
                    columns.push("GROUP_" + grouping[i]);
                    break;
                case 'USERS':
                    columns.push('GROUP_USER_COMM_FROM', 'GROUP_USER_COMM_TO');
                    break;
                case 'GROUPS':
                    columns.push('GROUP_GROUP_COMM_FROM', 'GROUP_GROUP_COMM_TO');
                    break;
            }
        }

        for (var i=0; i < metric.length; i++) {
            switch(metric[i]) {
                case 'COUNT':
                    columns.push('TOTAL_EVENTS');
                    break;
                case 'COUNT_BY_SERVICE':
                    columns.push('TOTAL_EVENTS', 'TOTAL_CALL_EVENTS', 'TOTAL_FAX_EVENTS', 'TOTAL_VOICEMAIL_EVENTS');
                    break;
                case 'COUNT_BY_STATUS':
                    columns.push('TOTAL_EVENTS', 'TOTAL_ANSWERED_EVENTS', 'TOTAL_NOT_ANSWERED_EVENTS');
                    break;
                case 'COUNT_BY_DIRECTION':
                    columns.push('TOTAL_EVENTS', 'TOTAL_LOCAL_EVENTS', 'TOTAL_INCOMING_EVENTS', 'TOTAL_OUTGOING_EVENTS');
                    break;
                case 'COUNT_BY_SLA':
                    columns.push('TOTAL_EVENTS', 'TOTAL_ANSWERED_WITHIN_XX_EVENTS', 'TOTAL_ANSWERED_OVER_XX_EVENTS', 'TOTAL_NOT_ANSWERED_EVENTS');
                    break;
                case 'COST':
                    columns.push('TOTAL_COST');
                    break;
                case 'COST_BY_SERVICE':
                    columns.push('TOTAL_COST', 'TOTAL_CALL_COST', 'TOTAL_FAX_COST');
                    break;
                case 'COST_AVG_BY_SERVICE':
                    columns.push('AVG_COST', 'AVG_CALL_COST', 'AVG_FAX_COST');
                    break;
                case 'BILL':
                    columns.push('TOTAL_BILL', 'TOTAL_RING');
                    break;
                case 'BILL_BY_DIRECTION':
                    columns.push('TOTAL_BILL', 'TOTAL_RING', 'TOTAL_LOCAL_BILL', 'TOTAL_INCOMING_BILL', 'TOTAL_OUTGOING_BILL');
                    break;
                case 'BILL_AVG_BY_DIRECTION':
                    columns.push('AVG_BILL', 'AVG_RING', 'AVG_LOCAL_BILL', 'AVG_INCOMING_BILL', 'AVG_OUTGOING_BILL');
                    break;
            }
        }

        return this.getOrderedColumns(columns);
    },

    getOrderedColumns: function(columns) {
        var orders = [
            'GROUP_HOUR',
            'GROUP_HOUR_OF_DAY',
            'GROUP_DAY',
            'GROUP_DAY_OF_WEEK',
            'GROUP_WEEK',
            'GROUP_MONTH',
            'GROUP_MONTH_OF_YEAR',
            'GROUP_YEAR',
            'GROUP_USER',
            'GROUP_GROUP',
            'GROUP_CLIENT',
            'GROUP_COMPANY',
            'GROUP_NUMBER',
            'GROUP_TRUNK',
            'GROUP_PBX',
            'GROUP_TAG',
            'GROUP_COUNTRY',
            'GROUP_CLASS',
            'GROUP_USER_COMM_FROM', 'GROUP_USER_COMM_TO',
            'GROUP_GROUP_COMM_FROM', 'GROUP_GROUP_COMM_TO',
            'TOTAL_EVENTS',
            'TOTAL_CALL_EVENTS', 'TOTAL_FAX_EVENTS', 'TOTAL_VOICEMAIL_EVENTS',
            'TOTAL_ANSWERED_EVENTS', 'TOTAL_ANSWERED_WITHIN_XX_EVENTS', 'TOTAL_ANSWERED_OVER_XX_EVENTS', 'TOTAL_NOT_ANSWERED_EVENTS',
            'TOTAL_LOCAL_EVENTS', 'TOTAL_INCOMING_EVENTS', 'TOTAL_OUTGOING_EVENTS',
            'TOTAL_COST', 'AVG_COST',
            'TOTAL_CALL_COST', 'AVG_CALL_COST',
            'TOTAL_FAX_COST', 'AVG_FAX_COST',
            'TOTAL_BILL', 'AVG_BILL',
            'TOTAL_LOCAL_BILL', 'AVG_LOCAL_BILL',
            'TOTAL_INCOMING_BILL', 'AVG_INCOMING_BILL',
            'TOTAL_OUTGOING_BILL', 'AVG_OUTGOING_BILL',
            'TOTAL_RING', 'AVG_RING'
        ];
        var sorter = function(a, b) {
            var ai = Ext.Array.indexOf(orders, a);
            var ab = Ext.Array.indexOf(orders, b);

            return ai - ab;
        }

        return columns.sort(sorter);
    },

    getSimpleMetricColumns: function() {
        return [
            'DATE',
            'FROM',
            'FROM_GROUP',
            'TO',
            'TO_GROUP',
            'AREA',
            'CLASS',
            'COST',
            'DIRECTION',
            'STATUS',
            'BILL',
            'RING',
            'PBX',
            'TRUNK',
            'TAG',
            'SERVICE',
            'USERFIELD',
            'FAXDATA'
        ];
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/controller/Viewport.js
Ext.define('App.controller.Viewport', {
    extend: 'Ext.app.Controller',
    controllers: [
        'Report',
        'Navigation',
        'viewer.Chart'
    ],
    views: [
        'viewport.error.ErrorConnection',
        'viewport.error.ErrorCritical',
        'viewport.Button',
        'viewport.PickerButton',
        'viewport.Switcher',
        'viewport.LinkSwitcher',

        'navigation.Settings',
        'navigation.Informer',
        
        'reports.picker.Selection',
        'reports.Picker',
        'reports.Save',
        'Reports',

        'filter.Field',
        'filter.field.combo.list.SelectionScroller',
        'filter.field.combo.list.SelectionModel',
        'filter.field.combo.list.SelectionView',
        'filter.field.combo.AbstractList',
        'filter.field.combo.AbstractPicker',
        'filter.field.combo.List',
        'filter.field.combo.Picker',
        'filter.field.combo.Search',
        'filter.field.combo.SimpleList',
        'filter.field.combo.SimplePicker',
        'filter.field.Combo',
        'filter.field.Destination',
        'filter.field.DestinationExt',
        'filter.field.DestinationInt',
        'filter.field.Trunk',
        'filter.field.Tag',
        'filter.field.Pbx',
        'filter.minMaxEditor.Spinner',
        'filter.Observer',
        'filter.Editor',
        'filter.MinMaxEditor',
        'filter.DestinationField',
        'filter.DestinationEditor',
        'filter.TypesField',
        'filter.TypesEditor',
        'filter.CostField',
        'filter.CostEditor',
        'filter.PeriodField',
        'filter.PeriodEditor',
        'filter.BillField',
        'filter.BillEditor',
        'filter.PbxesField',
        'filter.PbxesEditor',
        'filter.TrunksField',
        'filter.TrunksEditor',
        'filter.TagsField',
        'filter.TagsEditor',
        
        'grouping.Picker',
        'metric.Picker',

        'viewer.FullPage',
        'viewer.ExportButton',
        'viewer.ExportDialog',
        'viewer.Metric',
        'viewer.Grouping',

        'viewer.chart.series.Pie',
        'viewer.chart.ChartView',
        'viewer.Chart',
        'viewer.table.Column',
        'viewer.table.Chunker',
        'viewer.table.Scroller',
        'viewer.table.Summary',
        'viewer.table.View',
        'viewer.Table',
        'viewer.error.EmptyResults',
        'viewer.Error',
        'Filter',
        'Viewer',
        'Navigation',
        'Viewport'
    ],
    models: [
        'SimpleEvent',
        'GroupedEvent',
        'Filter',
        'Destination',
        'DestinationInt',
        'DestinationExt',
        'Trunk',
        'Tag',
        'Pbx'
    ],
    stores: [
        'SimpleEvents',
        'GroupedEvents',
        'Filters',
        'DestinationsInt',
        'DestinationsExt',
        'Pbxes',
        'Trunks',
        'Tags'
    ],
    requires: [
        'App.proxy.AbstractProxy',
        'App.proxy.AbstractEvents',
        'App.proxy.SimpleEvents',
        'App.proxy.GroupedEvents',
        'App.proxy.Destinations',
        'App.proxy.DestinationsInt',
        'App.proxy.DestinationsExt',
        'App.proxy.Trunks',
        'App.proxy.Tags',
        'App.proxy.Pbxes',
        'App.proxy.Filters',
        'App.store.AbstractStore',
        'App.store.Destinations'
    ],
    init: function() {
        var self = this;

        this.addEvents('exceptionError', 'connectionError', 'connectionRestored');

        this.on('exceptionError', this.onExceptionError, this);
        this.on('connectionError', this.onConnectionError, this);
        this.on('connectionRestored', this.onConnectionRestored, this);

        // Bind failure responses for synchronizer
        this.synchronizer = App.storage.Synchronizer;
        this.synchronizer.on('exceptionError', this.onExceptionError, this);
        this.synchronizer.on('connectionError', this.onConnectionError, this);
        this.synchronizer.on('connectionRestored', this.onConnectionRestored, this);

        this.view = Ext.create('App.view.Viewport', { renderTo: Ext.getBody() } );
        this.callParent(arguments);

        this.interval = 10 * 60 * 1000;
        setTimeout(function() { self.onSyncEventsAuto.call(self) }, self.interval);
    },

    // Methods for automatic synchronization

    onSyncEventsAuto: function() {
        var self = this;

        if (this.synchronizer.isWorking()) {
            setTimeout(function() { self.onSyncEventsAuto.call(self) }, self.interval);
            return;
        }

        this.connErrorSilent = true;
        this.bindSynchronizer();
        this.synchronizer.fireEvent('syncEventsAuto');
    },

    onSyncEventsCompleted: function() {



        var self = this;

        this.connErrorSilent = false;
        this.unbindSynchronizer();
        this.getController('Navigation').fireEvent('redrawInformer');
        setTimeout(function() { self.onSyncEventsAuto.call(self) }, self.interval);
    },

    onSyncEventsTerminated: function() {



        var self = this;

        this.connErrorSilent = false;
        this.unbindSynchronizer();
        this.getController('Navigation').fireEvent('redrawInformer');
        setTimeout(function() { self.onSyncEventsAuto.call(self) }, 10000);
    },


    bindSynchronizer: function() {
        this.synchronizer.on('syncEventsComplete', this.onSyncEventsCompleted, this);
        this.synchronizer.on('syncTerminated', this.onSyncEventsTerminated, this);
    },

    unbindSynchronizer: function() {
        this.synchronizer.un('syncEventsComplete', this.onSyncEventsCompleted, this);
        this.synchronizer.un('syncTerminated', this.onSyncEventsTerminated, this);
    },

    // Server response methods

    /**
     * Fires when we found an exception that can be handled, we should show a message with problem
     * and possibility to continue work or refresh a page.
     */
    onExceptionError: function(message) {
        if (this.connErrorDialog) {
            this.connErrorDialog.hide();
        }

        this.errorDialog = Ext.create('App.view.viewport.error.ErrorCritical', {
            response: message
        });
        this.errorDialog.show();
    },

    /**
     * Fires when we found a connection problem, we should show notification
     * about this at top of page.
     */
    onConnectionError: function(callback, scope) {
        if (!this.connErrorDialog) {
            this.connErrorDialog = Ext.create('App.view.viewport.error.ErrorConnection');
        }

        this.connProblems = true;
        this.connErrorCallback = callback;
        this.connErrorScope = scope || this;

        this.connErrorDialog.handle(30, this.onConnectionErrorCallback, this, this.connErrorSilent);
    },

    /**
     * Fires when connection to pbx was successfully restored, we should show a notification
     * about connection problems.
     */
    onConnectionRestored: function() {
        if (this.connErrorDialog) {
            this.connErrorDialog.hide();
        }
    },

    /**
     * Fires when we should repeat failure request to a server
     */
    onConnectionErrorCallback: function() {
        this.connErrorCallback.call(this.connErrorScope);
    },


    /**
     * Process a response from the server, if its not valid we should show a needed notification.
     */
    processResponse: function(text, callbackSuccess, callbackRetry, scope) {
        var result;
        var timeout;
        var exception = _t('Unknown error');

        scope = scope || this;

        try {
            result = Ext.decode(text);
        } catch (e) {
            // Server returns an unsupported format
            this.fireEvent('exceptionError', text);
            return;
        }

        timeout = parseInt(result['timeout']);

        if (result.hasOwnProperty('skipped') && parseInt(result['skipped']) === 1) {
            // Request was skipped by a server
            if (result.hasOwnProperty('exception')) {
                exception = result['exception'];
            }

            if (exception == 'TRY_AGAIN_LATER') {
                // Request was correctly skipped by a server and we should wait for a timeout and fire Retry callback
                if (this.attempts === undefined) {
                    this.attempts = 0;
                }

                if (this.attempts >= 5) {
                    setTimeout(function() { callbackRetry.call(scope, true); }, timeout * 1000);
                } else {
                    setTimeout(function() { callbackRetry.call(scope, false); }, timeout * 1000);
                }

                this.attempts++;
                return;
            }

            // Unknow exception we should stop any execution and show an error
            this.fireEvent('exceptionError', exception);
            return;
        }

        if (this.connProblems) {
            this.connProblems = false;
            this.fireEvent('connectionRestored');
        }

        // Normal request
        callbackSuccess.call(scope, result, text);
    }
} );

// File: /home/gitlab-runner/builds/pNVuDgHE/0/pbx-components/cdrview-front/package_cdrview/var/www/src/app/app.js
// Configuration for default components
Ext.Loader.setConfig( {
    enabled:true,
    paths: {
        'Ext': 'app',
        'App': 'app'
    }
} );

Ext.apply(Ext.Date, { defaultFormat: 'd/m/Y' });
Ext.apply(Ext.Ajax, { timeout: 30000 });

// Application
Ext.define('Application', {
    extend: 'Ext.app.Application',
    name: 'App',
    appFolder: 'app',
    autoCreateViewport: false,
    enableQuickTips: true,
    mixins: {
        observable: 'Ext.util.Observable'
    },
    controllers: [
        'Viewport',
        'Navigation',
        'Report',
        'viewer.Table',
        'viewer.Chart',
        'viewer.chart.Transformer',
        'Viewer'
    ],
    launch: function() {
        this.getController('Viewer').launch();
        this.callParent(arguments);
    }
} );

Ext.data.Connection.override({
    request: function(options){
        var me = this;
        if(options.url.indexOf('/cticonnect/')===0){
            var relativePath = '../';
            if (location.pathname.indexOf('cdrview/development') > -1){
                relativePath += '../';
            }            
            options.url = options.url.replace(/^\/cticonnect\//, relativePath );
        }
        return me.callOverridden(arguments);
    }
});

Ext.override(Ext.view.Table, {
    afterRender: function() {
        var me = this;

        me.callParent();
        me.mon(me.el, {
            scroll: me.fireBodyScroll,
            scope: me
        });

        //me.el.unselectable();
        me.attachEventsForFeatures();
    }
});
